Package: monaLisa
Type: Package
Title: Binned Motif Enrichment Analysis and Visualization
Version: 1.19.0
Authors@R: c(
    person("Dania", "Machlab", email = "dania.machlab@gmail.com", role = c("aut"), 
           comment = c(ORCID = "0000-0002-2578-6930")),
    person("Lukas", "Burger", email = "lukas.burger@fmi.ch", role = c("aut"),
           comment = c(ORCID = "0000-0001-5596-7567")),
    person("Charlotte", "Soneson", email = "charlottesoneson@gmail.com", 
           role = c("aut"),
           comment = c(ORCID = "0000-0003-3833-2169")),
    person("Dany", "Mukesha", role = c("ctb"),
           comment = c(ORCID = "0009-0001-9514-751X")),
    person("Michael", "Stadler", email = "michael.stadler@fmi.ch", 
           role = c("aut", "cre"), comment = c(ORCID = "0000-0002-2269-4934")))
Description: Useful functions to work with sequence motifs in the analysis of 
    genomics data. These include methods to annotate genomic regions or 
    sequences with predicted motif hits and to identify motifs that drive 
    observed changes in accessibility or expression. Functions to produce 
    informative visualizations of the obtained results are also provided. 
Depends: R (>= 4.1)
Imports: BiocGenerics, BiocParallel, Biostrings, BSgenome, circlize,
        ComplexHeatmap (>= 2.11.1), Seqinfo, GenomicRanges, cli,
        ggplot2 (>= 4.0.0), glmnet, grDevices, grid, IRanges, methods,
        rlang, RSQLite, stabs, stats, SummarizedExperiment, S4Vectors,
        TFBSTools, tidyr, tools, utils, XVector
Suggests: BiocManager, BiocStyle, BSgenome.Mmusculus.UCSC.mm10,
        ggrepel, gridExtra, JASPAR2020, JASPAR2024, knitr, rmarkdown,
        testthat, TxDb.Mmusculus.UCSC.mm10.knownGene
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
VignetteBuilder: knitr
biocViews: MotifAnnotation, Visualization, FeatureExtraction,
        Epigenetics
Config/testthat/edition: 3
URL: https://github.com/fmicompbio/monaLisa,
        https://bioconductor.org/packages/monaLisa/,
        https://fmicompbio.github.io/monaLisa/
BugReports: https://github.com/fmicompbio/monaLisa/issues
git_url: https://git.bioconductor.org/packages/monaLisa
git_branch: devel
git_last_commit: dfdf4c3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:55:53 UTC; biocbuild
Author: Dania Machlab [aut] (ORCID: <https://orcid.org/0000-0002-2578-6930>),
  Lukas Burger [aut] (ORCID: <https://orcid.org/0000-0001-5596-7567>),
  Charlotte Soneson [aut] (ORCID:
    <https://orcid.org/0000-0003-3833-2169>),
  Dany Mukesha [ctb] (ORCID: <https://orcid.org/0009-0001-9514-751X>),
  Michael Stadler [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-2269-4934>)
Maintainer: Michael Stadler <michael.stadler@fmi.ch>

<img src="man/figures/monaLisa.png" align="right" alt="monaLisa" width="150"/>

<br>

# `monaLisa`: MOtif aNAlysis with Lisa

<br>

## Overview

`monaLisa` was inspired by her father [Homer](http://homer.ucsd.edu/homer/index.html)
to look for enriched motifs in sets (bins) of genomic regions, compared to all other
regions ("binned motif enrichment analysis").

It uses known motifs representing transcription factor binding preferences,
for example for the `JASPAR2020` Bioconductor package. The regions are for
example promoters or accessible regions, which are grouped into bins according
to a numerical value assigned to each region, such as change of expression
or accessibility. The goal of the analysis is to identify transcription
factors that are associated to that numerical value and thus candidates
to be drivers in the underlying biological process.

In addition to the "binned motif enrichment analysis", `monaLisa` can also be
used to address the above question using stability selection (a form of linear
regression), or to look for motif matches in sequences.

Current contributors include:

- [Michael Stadler](https://github.com/mbstadler)
- [Dania Machlab](https://github.com/machlabd)
- [Lukas Burger](https://github.com/LukasBurger)
- [Charlotte Soneson](https://github.com/csoneson)

## News

- information on the latest changes can be found [here](https://github.com/fmicompbio/monaLisa/blob/master/NEWS.md)
- a preprint is available on [bioRxiv](https://doi.org/10.1101/2021.11.30.470570)
- `monaLisa` is available on [Bioconductor](https://bioconductor.org/packages/monaLisa)
- `monaLisa` is now published in [Bioinformatics](https://doi.org/10.1093/bioinformatics/btac102)

## Citation

To cite `monaLisa` please use the publication found [here](https://doi.org/10.1093/bioinformatics/btac102) or see `citation("monaLisa")`.

## Installation

`monaLisa` can be installed from Bioconductor via the 
`BiocManager` package:

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("monaLisa")
```

## Functionality

Here is a minimal example to run a `monaLisa` analysis:

```
library(monaLisa)

mcparams <- BiocParallel::MulticoreParam(10L)
se <- calcBinnedMotifEnrR(seqs = seqs,   # DNAStringSet (e.g. peak sequences)
                          bins = bins,   # factor that groups 'seqs'
                          pwmL = pwms, # PWMatrixList (know motifs)
                          BPPARAM = mcparams,
                          min.score = 10,
                          verbose = TRUE)
```

The return value `se` is a `SummarizedExperiment` with motifs in rows and bins
in columns, and multiple assays with significance and magnitude of the enrichments.

The inputs for `calcBinnedMotifEnrR` can be easily obtained using other
Bioconductor packages:  
```
# get sequences ('lmrs' is a GRanges object)
library(Biostrings)
library(BSgenome.Mmusculus.UCSC.mm10)
seqs <- getSeq(BSgenome.Mmusculus.UCSC.mm10, lmrs)

# bin sequences ('deltaMeth' is a numerical vector)
bins <- monaLisa::bin(x = deltaMeth, binmode = "equalN", nElement = 800)

# obtain known motifs from Jaspar
library(JASPAR2020)
library(TFBSTools)
pwms <- getMatrixSet(JASPAR2020, list(matrixtype = "PWM", tax_group = "vertebrates"))
```

The results can be conveniently visualized:
```
plotBinDensity(deltaMeth, bins, legendPosition = "none") + 
    labs(x = "Methylation difference")
```
<img src="man/figures/monaLisa_binning_small_ggplot.png" align="center" alt="binning" width="412px"/>

```
plotMotifHeatmaps(se, cluster = TRUE,
                  which.plots = c("enr", "FDR"),
                  show_seqlogo = TRUE)
```
<img src="man/figures/monaLisa_heatmaps_small.png" align="center" alt="heatmaps" width="501px"/>

<!-- badges: start -->
Github Actions (multiple OS): [![R build status](https://github.com/fmicompbio/monaLisa/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/fmicompbio/monaLisa/actions) [![Codecov.io coverage status](https://codecov.io/github/fmicompbio/monaLisa/coverage.svg?branch=devel)](https://codecov.io/github/fmicompbio/monaLisa)
<!-- badges: end -->

#
# Here, we make a synthetic genome to use in the example shown in `calcBinnedMotifEnrHomer`.
#
#

basedir <- "/tungstenfs/groups/gbioinfo/machdani/monaLisa_synthetic_genome_creation_for_example"
setwd(basedir)

library(Seqinfo)
library(GenomicRanges)
library(TFBSTools)
library(JASPAR2020)
library(Biostrings)

## generate random sequences for 3 chromosomes
set.seed(42)
genomedir <- file.path(basedir, "genome")
chrsstr <-
    unlist(lapply(1:3, function(i) paste(sample(x = c("A","C","G","T"),
                                                size = 10000,
                                                replace = TRUE,
                                                prob = c(.3,.2,.2,.3)),
                                         collapse = "")))
names(chrsstr) <- paste0("chr", seq_along(chrsstr))
names(chrsstr)
# [1] "chr1" "chr2" "chr3"

## regions of interest as a GRanges object
gr <- GenomicRanges::tileGenome(seqlengths = nchar(chrsstr),
                                tilewidth = 200, cut.last.tile.in.chrom = TRUE)
gr
# GRanges object with 150 ranges and 0 metadata columns:
#         seqnames     ranges strand
#            <Rle>  <IRanges>  <Rle>
#     [1]     chr1      1-200      *
#     [2]     chr1    201-400      *
#     [3]     chr1    401-600      *
#     [4]     chr1    601-800      *
#     [5]     chr1   801-1000      *
#     ...      ...        ...    ...
#   [146]     chr3  9001-9200      *
#   [147]     chr3  9201-9400      *
#   [148]     chr3  9401-9600      *
#   [149]     chr3  9601-9800      *
#   [150]     chr3 9801-10000      *
#   -------
#   seqinfo: 3 sequences from an unspecified genome

## bins
bins <- factor(GenomicRanges::seqnames(gr))
table(bins)
# bins
# chr1 chr2 chr3 
# 50   50   50 

## motifs (to be planted)
selids <- c("MA0139.1", "MA1102.1", "MA0740.1")
pfm <- TFBSTools::getMatrixSet(JASPAR2020, opts = list(ID = selids))
cons <- unlist(lapply(Matrix(pfm), function(x) paste(rownames(x)[apply(x, 2, which.max)], collapse = "")))
cons
#           MA0139.1              MA1102.1              MA0740.1 
# "TGGCCACCAGGGGGCGCTA"      "CACCAGGGGGCACC"      "GGCCACGCCCCCTT" 

## plant motifs
for (chr1 in names(chrsstr)) {
    i <- which(as.character(Seqinfo::seqnames(gr)) == chr1)
    j <- sample(x = GenomicRanges::start(gr)[i], size = round(length(i) / 3))
    m <- match(chr1, names(chrsstr))
    for (j1 in j)
        substring(chrsstr[chr1], first = j1, last = j1 + nchar(cons[m]) - 1) <- cons[m]
}
chrs <- Biostrings::DNAStringSet(chrsstr)
chrs
# DNAStringSet object of length 3:
#     width seq                                                                                                                             names               
# [1] 10000 CCACGTGAGGTGCATCCATTCACCATTCTCGCTGACAACGTTACTCCGCGTTTGAGGAATGC...GTGAATGAAACCGCCATTTCGCGAACTTACCATCGATAGTGTCCCAGATATTGGAACGGTGG chr1
# [2] 10000 TGCTGGTGTATCCATCTATAACGGCCATTATAAGTGAGTGCAAAACTCCACATGAGGCTTGC...TAAAGGGAGTAAAAACAAGGTAACCTGGATACTAAACTTATTGTGTCTGTCAACACTATGGC chr2
# [3] 10000 CTTCTTTAGTAGGGACCGTACTAGTGTCGTATTCAAGATCGACCTAGATCTTGATATAATCA...CGGCAAGACAAATCAACAGTACGCCAACCTTGGATTAGATCTACTAAATGTGACTATTCGGT chr3

## save created genome
dir.create(genomedir)
genomefile <- file.path(genomedir, "exampleGenome.fa")
Biostrings::writeXStringSet(x = chrs, filepath = genomefile, format = "fasta")

## session
date()
# [1] "Thu Sep 16 18:47:34 2021"
sessionInfo()
# R version 4.1.1 (2021-08-10)
# Platform: x86_64-pc-linux-gnu (64-bit)
# Running under: CentOS Linux 7 (Core)
# 
# Matrix products: default
# BLAS/LAPACK: /tungstenfs/groups/gbioinfo/Appz/easybuild/software/OpenBLAS/0.3.12-GCC-10.2.0/lib/libopenblas_skylakex-r0.3.12.so
# 
# locale:
#     [1] LC_CTYPE=en_US.UTF-8       LC_NUMERIC=C               LC_TIME=en_US.UTF-8        LC_COLLATE=en_US.UTF-8     LC_MONETARY=en_US.UTF-8   
# [6] LC_MESSAGES=en_US.UTF-8    LC_PAPER=en_US.UTF-8       LC_NAME=C                  LC_ADDRESS=C               LC_TELEPHONE=C            
# [11] LC_MEASUREMENT=en_US.UTF-8 LC_IDENTIFICATION=C       
# 
# attached base packages:
#     [1] parallel  stats4    stats     graphics  grDevices utils     datasets  methods   base     
# 
# other attached packages:
#     [1] Biostrings_2.60.2    XVector_0.32.0       JASPAR2020_0.99.10   TFBSTools_1.30.0     GenomicRanges_1.44.0 GenomeInfoDb_1.28.4  IRanges_2.26.0      
# [8] S4Vectors_0.30.0     BiocGenerics_0.38.0 
# 
# loaded via a namespace (and not attached):
#     [1] colorspace_2.0-2            rjson_0.2.20                ellipsis_0.3.2              circlize_0.4.13             GlobalOptions_0.1.2        
# [6] clue_0.3-59                 rstudioapi_0.13             bit64_4.0.5                 AnnotationDbi_1.54.1        fansi_0.5.0                
# [11] splines_4.1.1               codetools_0.2-18            R.methodsS3_1.8.1           doParallel_1.0.16           cachem_1.0.6               
# [16] knitr_1.34                  Rsamtools_2.8.0             Cairo_1.5-12.2              seqLogo_1.58.0              annotate_1.70.0            
# [21] cluster_2.1.2               GO.db_3.13.0                png_0.1-7                   R.oo_1.24.0                 readr_2.0.1                
# [26] compiler_4.1.1              httr_1.4.2                  assertthat_0.2.1            Matrix_1.3-4                fastmap_1.1.0              
# [31] limma_3.48.3                htmltools_0.5.2             tools_4.1.1                 igraph_1.2.6                gtable_0.3.0               
# [36] glue_1.4.2                  TFMPvalue_0.0.8             GenomeInfoDbData_1.2.6      reshape2_1.4.4              dplyr_1.0.7                
# [41] Rcpp_1.0.7                  Biobase_2.52.0              vctrs_0.3.8                 rtracklayer_1.52.1          iterators_1.0.13           
# [46] xfun_0.25                   CNEr_1.28.0                 stringr_1.4.0               lifecycle_1.0.0             restfulr_0.0.13            
# [51] poweRlaw_0.70.6             gtools_3.9.2                stringdist_0.9.8            XML_3.99-0.7                zlibbioc_1.38.0            
# [56] scales_1.1.1                BSgenome_1.60.0             hms_1.1.0                   MatrixGenerics_1.4.3        SummarizedExperiment_1.22.0
# [61] RColorBrewer_1.1-2          ComplexHeatmap_2.8.0        yaml_2.2.1                  memoise_2.0.0               ggplot2_3.3.5              
# [66] stabs_0.6-4                 stringi_1.7.4               RSQLite_2.2.8               BiocIO_1.2.0                foreach_1.5.1              
# [71] caTools_1.18.2              BiocParallel_1.26.2         shape_1.4.6                 rlang_0.4.11                pkgconfig_2.0.3            
# [76] matrixStats_0.60.1          bitops_1.0-7                pracma_2.3.3                evaluate_0.14               lattice_0.20-44            
# [81] purrr_0.3.4                 GenomicAlignments_1.28.0    bit_4.0.4                   tidyselect_1.1.1            plyr_1.8.6                 
# [86] magrittr_2.0.1              R6_2.5.1                    generics_0.1.0              monaLisa_0.1.50             DelayedArray_0.18.0        
# [91] DBI_1.1.1                   pillar_1.6.2                survival_3.2-11             KEGGREST_1.32.0             RCurl_1.98-1.4             
# [96] tibble_3.1.4                crayon_1.4.1                utf8_1.2.2                  tzdb_0.1.2                  rmarkdown_2.10             
# [101] GetoptLong_1.0.5            grid_4.1.1                  blob_1.2.2                  digest_0.6.27               xtable_1.8-4               
# [106] R.utils_2.10.1              munsell_0.5.0               glmnet_4.1-2                DirichletMultinomial_1.34.0

#' @title Create matrix from consensus sequence
#'
#' @description Given a nucleotide sequence of A,C,G,T letter corresponding
#'   to a motif's consensus string, construct a positional frequency matrix.
#'   This matrix can for example be used as the \code{profileMatrix} argument
#'   in the constructor for a \code{TFBSTools::PFMatrix} object.
#'
#' @return A positional frequency matrix.
#'
#' @param x Character scalar with the motif the consensus sequence.
#' @param n Integer scalar giving the columns sums in the constructed
#'   matrix (number of observed bases at each position).
#'
#' @keywords internal
.cons2matrix <- function(x, n = 100L) {
    .assertScalar(x = x, type = "character")
    .assertScalar(x = n, type = "integer", rngIncl = c(1L, Inf))
    m <- matrix(0L, nrow = 4, ncol = nchar(x),
                dimnames = list(c("A","C","G","T"), NULL))
    xx <- strsplit(x, "", fixed = TRUE)[[1]]
    ok <- which(xx %in% rownames(m))
    m[cbind(match(xx[ok], rownames(m)), ok)] <- n
    m
}


#' @title Calculate observed and expected k-mer frequencies
#'
#' @description Given a set of sequences, calculate observed and expected k-mer
#'   frequencies. Expected frequencies are based on a Markov model of order
#'   \code{MMorder}.
#'
#' @param seqs Set of sequences, either a \code{character} vector or a
#'   \code{\link[Biostrings]{DNAStringSet}}.
#' @param kmerLen A \code{numeric} scalar giving the k-mer length.
#' @param MMorder A \code{numeric} scalar giving the order of the Markov model
#'   used to calculate the expected frequencies.
#' @param pseudocount A \code{numeric} scalar - will be added to the observed
#'   counts for each k-mer to avoid zero values.
#' @param zoops A \code{logical} scalar. If \code{TRUE} (the default), only one
#'   or zero occurences of a k-mer are considered per sequence.
#' @param strata A \code{factor} or a \code{numeric} scalar defining the strata
#'   of sequences. A separate Markov model and expected k-mer frequencies are
#'   estimated for the set of sequences in each stratum (level in a
#'   \code{strata} factor). If \code{strata} is a scalar value, it will be
#'   interpreted as the number of strata to split the sequences into according
#'   to their CpG observed-over-expected counts using
#'   \code{kmeans(CpGoe, centers = strata)}.
#' @param p.adjust.method A character scalar selecting the p value adjustment
#'   method (used in \code{\link[stats]{p.adjust}}).
#' @param includeRevComp A \code{logical} scalar. If \code{TRUE} (default),
#'   count k-mer occurrences in both \code{seqs} and their reverse-complement,
#'   by concatenating \code{seqs} and their reverse-complemented versions
#'   before the counting. This is useful if motifs can be expected to occur
#'   on any strand (e.g. DNA sequences of ChIP-seq peaks). If motifs are only
#'   expected on the forward strand (e.g. RNA sequences of CLIP-seq peaks),
#'   \code{includeRevComp = FALSE} should be used. Note that if \code{strata}
#'   is a vector of the same length as \code{seqs}, each reverse-complemented
#'   sequence will be assigned to the same stratum as the forward sequence.
#'
#' @return A \code{list} with observed and expected k-mer frequencies
#'   (\code{freq.obs} and \code{freq.exp}, respectively), and enrichment
#'   statistics for each k-mer.
#'
#' @examples
#' res <- getKmerFreq(seqs = c("AAAAATT", "AAATTTT"), kmerLen = 3)
#' names(res)
#' head(res$freq.obs)
#' head(res$freq.exp)
#'
#' @importFrom Biostrings DNAStringSet oligonucleotideFrequency
#'   reverseComplement
#' @importFrom XVector subseq
#' @importFrom stats ppois kmeans
#'
#' @export
getKmerFreq <- function(seqs,
                        kmerLen = 5,
                        MMorder = 1,
                        pseudocount = 1,
                        zoops = TRUE,
                        strata = rep(1L, length(seqs)),
                        p.adjust.method = "BH",
                        includeRevComp = TRUE) {

    ##comments

    ## When plotting the log2 enrichments or something similar against
    ## observed frequencies, there will be a correlation as several kmers have
    ## the same expected frequency and thus their enrichment and observed
    ## frequencies will naturally correlate. It makes thus more sense to plot
    ## the log2 enrichment against expected frequencies

    ## Generally, higher MMorder will take care of CpG bias and similar effects.
    ## Zoops will take care of higher-order repeats.

    ## pre-flight checks
    if (is.character(seqs))
        seqs <- DNAStringSet(seqs)
    .assertScalar(x = kmerLen, type = "numeric", rngIncl = c(1, Inf))
    .assertScalar(x = MMorder, type = "numeric", rngExcl = c(0, kmerLen - 1L))
    .assertScalar(x = pseudocount, type = "numeric", rngIncl = c(0, Inf))
    .assertScalar(x = zoops, type = "logical")
    .assertScalar(x = p.adjust.method, type = "character",
                  validValues = stats::p.adjust.methods)
    .assertScalar(x = includeRevComp, type = "logical")
    stopifnot(exprs = {
        is(seqs, "DNAStringSet")
        round(kmerLen, 0L) == kmerLen
        round(MMorder, 0L) == MMorder
        length(strata) == length(seqs) || (is.numeric(strata) &&
                                               length(strata) == 1L)
    })

    ## include reverse-complement sequences?
    if (identical(includeRevComp, TRUE)) {
        seqsrc <- Biostrings::reverseComplement(seqs)
        names(seqsrc) <- paste0(names(seqs), "_rc")

        if (length(strata) == length(seqs)) {
            # recycle strata (same stratum for forward and rev-comp sequence)
            strata <- rep(strata, 2L)
        }
        seqs <- c(seqs, seqsrc)
    }

    ## split sequences into strata
    CpGoe <- NA
    if (identical(length(strata), 1L)) {
        n1 <- oligonucleotideFrequency(seqs, width = 1L)
        n2 <- oligonucleotideFrequency(seqs, width = 2L)
        CpGoe <- n2[, "CG"] / (n1[,"C"] / rowSums(n1) * n1[,"G"])
        strata <- kmeans(x = CpGoe, centers = strata)$cluster
    }

    ## for each sequence stratum, calculate...
    res.strata <- lapply(split(seqs, strata), function(seqs.stratum) {
        ## ... observed k-mer frequencies
        kmerFreqRaw.stratum <- oligonucleotideFrequency(seqs.stratum,
                                                        width = kmerLen)
        if (zoops) {
            kmerFreq.stratum <- colSums(kmerFreqRaw.stratum > 0)
            #make new sequences that are simply the kmers detected
            seqs.stratum.zoops <- DNAStringSet(
                rep(names(kmerFreq.stratum), kmerFreq.stratum)
            )
            lp_long  <- colSums(oligonucleotideFrequency(
                seqs.stratum.zoops, width = MMorder + 1L)) + pseudocount
            lp_short <- colSums(oligonucleotideFrequency(
                seqs.stratum.zoops, width = MMorder)) + pseudocount
        } else {
            kmerFreq.stratum <- colSums(kmerFreqRaw.stratum)
            lp_long  <- colSums(oligonucleotideFrequency(
                seqs.stratum, width = MMorder + 1L)) + pseudocount
            lp_short <- colSums(oligonucleotideFrequency(
                seqs.stratum, width = MMorder)) + pseudocount
        }
        lp_long  <- log2(lp_long / sum(lp_long))
        lp_short <- log2(lp_short / sum(lp_short))

        ## ... expected k-mer frequencies (log2-probabilities with a
        ##     pseudocount)
        n <- nchar(names(kmerFreq.stratum)[1]) - MMorder
        log2pMM <- vapply(names(kmerFreq.stratum), function(current.kmer) {
            ii_long <- substr(rep(current.kmer, n),
                              start = seq_len(n), stop = seq_len(n) + MMorder)
            ii_short <- substr(rep(current.kmer, n - 1L),
                               start = seq(2, n), stop = seq_len(n - 1L) +
                                   MMorder)
            sum(lp_long[ii_long]) - sum(lp_short[ii_short])
        }, numeric(1))
        kmerFreqMM.stratum <- (2 ** log2pMM) * sum(kmerFreq.stratum)
        cbind(obs = kmerFreq.stratum, exp = kmerFreqMM.stratum)
    })

    ## sum frequencies over strata
    tmp <- Reduce("+", res.strata)
    kmerFreq   <- tmp[, "obs"]
    kmerFreqMM <- tmp[, "exp"]

    ## calculate enrichment statistics
    ## ... log2 (obs/exp)
    lenr <- log2((kmerFreq + pseudocount) / (kmerFreqMM + pseudocount))
    ## ... z value (Pearson residuals)
    z <- (kmerFreq - kmerFreqMM) / sqrt(kmerFreqMM)
    ## ... use square-root as variance-stablizing function
    sDelta <- sqrt(kmerFreq) - sqrt(kmerFreqMM)
    ## ... P value
    p <- ppois(q = kmerFreq, lambda = kmerFreqMM, lower.tail = FALSE)
    padj <- p.adjust(p, method = p.adjust.method)

    ## return results
    list(freq.obs = kmerFreq, freq.exp = kmerFreqMM,
         log2enr = lenr, sqrtDelta = sDelta, z = z, p = p, padj = padj,
         strata = strata, freq.strata = res.strata, CpGoe = CpGoe)
}


#' @title Calculate k-mer enrichment
#'
#' @description Given sequences, foreground/background labels and
#'   weights, calculate the enrichment of each k-mer
#'   in foreground compared to background. This function is called by
#'   \code{calcBinnedKmerEnr()} for each bin if \code{background != "model"}.
#'
#'   The default type of test is \code{"fisher"}.
#'   Alternatively, a binomial test can be used by \code{test = "binomial"}.
#'   Using Fisher's exact test has the advantage that special cases such as
#'   zero background counts are handled without ad-hoc adjustments to the
#'   k-mer frequencies.
#'
#'   For \code{test = "fisher"}, \code{fisher.test} is used with
#'   \code{alternative = "greater"}, making it a one-sided test for enrichment,
#'   as is the case with the binomial test.
#'
#' @param k Numeric scalar giving the length of k-mers to analyze.
#' @param df A \code{DataFrame} with sequence information as returned by
#'   \code{.iterativeNormForKmers()}.
#' @param test Type of motif enrichment test to perform.
#' @param verbose A logical scalar. If \code{TRUE}, report on progress.
#'
#' @details The function works in ZOOPS mode, which means only one
#'   or zero occurrences of a k-mer are considered per sequence. This is helpful
#'   to reduce the impact of simple sequence repeats occurring in few sequences.
#'
#' @return A \code{data.frame} containing the motifs as rows and the columns:
#'   \describe{
#'     \item{motifName}{: the motif name}
#'     \item{logP}{: the log p-value for enrichment (natural logarithm).
#'        If \code{test="binomial"} (default), this log p-value is identical to
#'        the one returned by Homer.}
#'     \item{sumForegroundWgtWithHits}{: the weighted number of k-mer hits in
#'        foreground sequences.}
#'     \item{sumBackgroundWgtWithHits}{: the weighted number of k-mer hits in
#'        background sequences.}
#'     \item{totalWgtForeground}{: the total sum of weights of foreground
#'        sequences.}
#'     \item{totalWgtBackground}{: the total sum of weights of background
#'        sequences.}
#'   }
#'
#' @importFrom Biostrings oligonucleotideFrequency
#' @importFrom stats pbinom fisher.test
#'
#' @keywords internal
.calcKmerEnrichment <- function(k,
                                df,
                                test = c("fisher", "binomial"),
                                verbose = FALSE){

    # checks
    .assertScalar(x = k, type = "numeric", rngIncl = c(1, Inf))
    .checkDfValidity(df)
    test <- match.arg(test)
    .assertScalar(x = verbose, type = "logical")

    totalWgtForeground <- sum(df$seqWgt[df$isForeground])
    totalWgtBackground <- sum(df$seqWgt[!df$isForeground])

    kmerHitMatrix <- oligonucleotideFrequency(x = df$seqs,
                                               width = k,
                                               as.prob = FALSE,
                                               with.labels = TRUE)

    kmerHitMatrix[kmerHitMatrix > 0] <- 1 # ZOOPS
    kmerHitMatrixWeighted <- kmerHitMatrix * df$seqWgt
    KmatchedSeqCountForeground <-
        colSums(kmerHitMatrixWeighted[df$isForeground, ])
    KmatchedSeqCountBackground <-
        colSums(kmerHitMatrixWeighted[!df$isForeground, ])

    # calculate k-mer enrichment
    if (identical(test, "binomial")) {
        logP <- .binomEnrichmentTest(matchCountBg = KmatchedSeqCountBackground,
                                     totalWeightBg = totalWgtBackground,
                                     matchCountFg = KmatchedSeqCountForeground,
                                     totalWeightFg = totalWgtForeground,
                                     verbose = verbose)
    } else if (identical(test, "fisher")) {
        logP <- .fisherEnrichmentTest(matchCountBg = KmatchedSeqCountBackground,
                                      totalWeightBg = totalWgtBackground,
                                      matchCountFg = KmatchedSeqCountForeground,
                                      totalWeightFg = totalWgtForeground,
                                      verbose = verbose)
    }

    return(data.frame(motifName = names(logP),
                      logP = logP,
                      sumForegroundWgtWithHits = KmatchedSeqCountForeground,
                      sumBackgroundWgtWithHits = KmatchedSeqCountBackground,
                      totalWgtForeground = totalWgtForeground,
                      totalWgtBackground = totalWgtBackground))
}


#' @title Calculate k-mer enrichment in bins of sequences.
#'
#' @description Given a set of sequences and corresponding bins, identify
#'   enriched k-mers (n-grams) in each bin. The sequences can be given either
#'   directly or as genomic coordinates.
#'
#' @param seqs \code{\link[Biostrings]{DNAStringSet}} object with sequences to
#'   test
#' @param bins Factor of the same length and order as \code{seqs}, indicating
#'   the bin for each sequence. Typically the return value of
#'   \code{\link[monaLisa]{bin}}. For \code{background = "genome"} or
#'   \code{background = "model"}, \code{bins} can be omitted.
#' @param kmerLen A \code{numeric} scalar giving the k-mer length.
#' @param background A \code{character} scalar specifying the background
#'   sequences to use. One of \code{"otherBins"} (default), \code{"allBins"},
#'   \code{"zeroBin"}, \code{"genome"} or \code{"model"} (see "Details").
#' @param MMorder A \code{numeric} scalar giving the order of the Markov model
#'   used to calculate the expected frequencies for \code{background = "model"}.
#' @param test A \code{character} scalar specifying the type of enrichment test
#'   to perform. One of \code{"fisher"} (default) or \code{"binomial"}. The
#'   enrichment test is one-sided (enriched in foreground).
#' @param includeRevComp A \code{logical} scalar. If \code{TRUE} (default),
#'   count k-mer occurrences in both \code{seqs} and their reverse-complement,
#'   by concatenating \code{seqs} and their reverse-complemented versions
#'   before the counting. This is useful if motifs can be expected to occur
#'   on any strand (e.g. DNA sequences of ChIP-seq peaks). If motifs are only
#'   expected on the forward strand (e.g. RNA sequences of CLIP-seq peaks),
#'   \code{includeRevComp = FALSE} should be used. Note that \code{bins}
#'   will be recycled for the reverse complemented sequences, which means that
#'   each reverse-complemented sequence will be assigned to the same bib as the
#'   corresponding forward sequence.
#' @param maxFracN A numeric scalar with the maximal fraction of N bases allowed
#'   in a sequence (defaults to 0.7). Sequences with higher fractions are
#'   excluded from the analysis.
#' @param maxKmerSize The maximum k-mer size to consider, when adjusting
#'   background sequence weights for k-mer composition compared to the
#'   foreground sequences. The default value (3) will correct for mono-, di-
#'   and tri-mer composition.
#' @param GCbreaks The breaks between GC bins. The default value is based on
#'   the hard-coded bins used in Homer.
#' @param pseudocount.kmers A \code{numeric} scalar - will be added to the
#'   observed and expected counts for each k-mer to avoid zero values.
#' @param pseudocount.log2enr A numerical scalar with the pseudocount to add to
#'   foreground and background counts when calculating log2 motif enrichments
#' @param p.adjust.method A character scalar selecting the p value adjustment
#'   method (used in \code{\link[stats]{p.adjust}}).
#' @param genome A \code{BSgenome} or \code{DNAStringSet} object with the
#'   genome sequence. Only used for \code{background = "genome"} for extracting
#'   background sequences.
#' @param genome.regions An optional \code{\link[GenomicRanges]{GRanges}} object
#'   defining the intervals in \code{genome} from which background sequences are
#'   sampled for \code{background = "genome"}. If \code{NULL}, background
#'   sequences are sampled randomly from \code{genome}.
#' @param genome.oversample A \code{numeric} scalar of at least 1.0 defining how
#'   many background sequences will be sampled per foreground sequence for
#'   \code{background = "genome"}. Larger values will take longer but improve
#'   the sequence composition similarity between foreground and background
#'   (see \code{"Details"}).
#' @param BPPARAM An optional \code{\link[BiocParallel]{BiocParallelParam}}
#'     instance determining the parallel back-end to be used during evaluation.
#' @param verbose A \code{logical} scalar. If \code{TRUE}, report on progress.
#'
#' @details This function implements a binned k-mer enrichment analysis. In each
#'   enrichment analysis, the sequences in a specific bin are used as foreground
#'   sequences to test for k-mer enrichments comparing to background sequences
#'   (defined by \code{background}, see below), similarly as in done for motifs
#'   in \code{\link{calcBinnedMotifEnrR}}. Sequences are weighted to correct for
#'   GC and shorter k-mer composition differences between fore- and background
#'   sets.
#'
#'   The background sequences are defined according to the value of the
#'   \code{background} argument:
#'   \describe{
#'     \item{otherBins}{: sequences from all other bins (excluding the current
#'       bin)}
#'     \item{allBins}{: sequences from all bins (including the current bin)}
#'     \item{zeroBin}{: sequences from the "zero bin", defined by the
#'       \code{maxAbsX} argument of \code{\link[monaLisa]{bin}}. If \code{bins}
#'       does not define a "zero bin", for example because it was created by
#'       \code{bin(..., maxAbsX = NULL)}, selecting this background definition
#'       will abort with an error.}
#'     \item{genome}{: sequences randomly sampled from the genome (or the
#'       intervals defined in \code{genome.regions} if given). For each
#'       foreground sequence, \code{genome.oversample} background sequences
#'       of the same size are sampled (on average). From these, one per
#'       foreground sequence is selected trying to match the G+C composition.
#'       In order to make the sampling deterministic, a seed number needs to be
#'       provided to the \code{RNGseed} parameter in
#'       \code{\link[BiocParallel]{SerialParam}}
#'       or \code{\link[BiocParallel]{MulticoreParam}} when creating the
#'       \code{BiocParallelParam} instance in \code{BPPARAM}.}
#'     \item{model}{: a Markov model of the order \code{MMorder} is estimated
#'       from the foreground sequences and used to estimate expected k-mer
#'       frequencies. K-mer enrichments are then calculated comparing observed
#'       to these expected frequencies. In order to make the process
#'       deterministic, a seed number needs to be provided to the
#'       \code{RNGseed} parameter in \code{\link[BiocParallel]{SerialParam}} or
#'       \code{\link[BiocParallel]{MulticoreParam}} when creating the
#'       \code{BiocParallelParam} instance in \code{BPPARAM}.}
#'   }
#'
#'   For each k-mer, the weights of sequences is multiplied with the number
#'   of k-mer occurrences in each sequence and summed, separately for foreground
#'   (\code{sumForegroundWgtWithHits}) and background
#'   (\code{sumBackgroundWgtWithHits}) sequences. The function works in ZOOPS
#'   (Zero-Or-One-Per-Sequence) mode, so at most one occurrence per
#'   sequence is counted, which helps reduce the impact of sequence repeats.
#'   The total foreground (\code{totalWgtForeground}) and background
#'   (\code{totalWgtBackground}) sum of sequence weights is also calculated. If
#'   a k-mer has zero \code{sumForegroundWgtWithHits} and
#'   \code{sumBackgroundWgtWithHits}, then any values (p-values and enrichment)
#'   that are calculated using these two numbers are set to NA.
#'
#'   Two statistical tests for the calculation of enrichment log p-value are
#'   available: \code{test = "fisher"} (default) to perform Fisher's exact
#'   tests, or \code{test = "binomial"} to perform binomial tests, using:
#'   \describe{
#'     \item{fisher}{: \code{fisher.test(x = tab, alternative =
#'       "greater")}, where \code{tab} is the contingency table with the summed
#'       weights of sequences in foreground or background sets (rows), and with
#'       or without a occurrences of a particular k-mer (columns).}
#'     \item{binomial}{: \code{pbinom(q = sumForegroundWgtWithHits - 1, size =
#'       totalWgtForeground,
#'       prob = sumBackgroundWgtWithHits / totalWgtBackground,
#'       lower.tail = FALSE, log.p = TRUE)}}
#'   }
#'
#' @return A \code{\link[SummarizedExperiment]{SummarizedExperiment}} object
#'   with motifs in rows and bins in columns, containing seven assays: \describe{
#'   \item{negLog10P}{: -log10 P values}
#'   \item{negLog10Padj}{: -log10 adjusted P values}
#'   \item{pearsonResid}{: k-mer enrichments as Pearson residuals}
#'   \item{expForegroundWgtWithHits}{: expected number of foreground
#'     sequences with motif hits}
#'   \item{log2enr}{: k-mer enrichments as log2 ratios}
#'   \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
#'     in a bin that have k-mer occurrences}
#'   \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
#'     in a bin that have k-mer occurrences}
#' }
#' #' The \code{rowData} of the object contains annotations (name, PFMs, PWMs
#' and GC fraction) for the k-mers, while the \code{colData} slot contains
#' summary information about the bins.
#'
#' @examples
#' seqs <- Biostrings::DNAStringSet(c("GCATGCATGC", "CATGCGCATG"))
#' bins <- factor(1:2)
#' calcBinnedKmerEnr(seqs = seqs, bins = bins, kmerLen = 3)
#'
#' @seealso \code{\link{getKmerFreq}} used to calculate k-mer enrichments;
#'   \code{\link[BSgenome]{getSeq,BSgenome-method}} which is used to extract
#'   sequences from \code{genomepkg} if \code{x} is a \code{GRanges} object;
#'   \code{\link[BiocParallel]{bplapply}} that is used for parallelization;
#'   \code{\link{bin}} for binning of regions
#'
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom Biostrings reverseComplement
#' @importFrom S4Vectors DataFrame split
#' @importFrom TFBSTools PFMatrix PFMatrixList ID name toPWM
#' @importFrom stats ppois p.adjust
#' @importFrom BiocParallel bplapply SerialParam bpnworkers
#' @importFrom cli cli_abort cli_progress_step
#'
#' @export
calcBinnedKmerEnr <- function(seqs,
                              bins = NULL,
                              kmerLen = 5,
                              background = c("otherBins", "allBins",
                                             "zeroBin", "genome", "model"),
                              MMorder = 1,
                              test = c("fisher", "binomial"),
                              includeRevComp = TRUE,
                              maxFracN = 0.7,
                              maxKmerSize = 3L,
                              GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4,
                                           0.45, 0.5, 0.6, 0.7, 0.8),
                              pseudocount.kmers = 1,
                              pseudocount.log2enr = 8,
                              p.adjust.method = "BH",
                              genome = NULL,
                              genome.regions = NULL,
                              genome.oversample = 2,
                              BPPARAM = SerialParam(),
                              verbose = FALSE) {
    ## pre-flight checks
    .assertVector(x = seqs, type = "DNAStringSet")
    background <- match.arg(background)
    if (is.null(bins) && (background %in% c("genome", "model"))) {
        bins <- factor(rep(1, length(seqs)))
    }
    .assertVector(x = bins, type = "factor")
    if (length(seqs) != length(bins)) {
        cli_abort("{.arg seqs} and {.arg bins} must be of equal length")
    }
    .assertScalar(x = kmerLen, type = "numeric", rngIncl = c(1, Inf))
    test <- match.arg(test)
    .assertScalar(x = includeRevComp, type = "logical")
    .assertScalar(x = pseudocount.kmers, type = "numeric", rngIncl = c(0, Inf))
    .assertScalar(x = pseudocount.log2enr, type = "numeric",
                  rngIncl = c(0, Inf))
    .assertScalar(x = p.adjust.method, type = "character",
                  validValues = stats::p.adjust.methods)
    if (identical(background, "zeroBin") &&
        (is.null(getZeroBin(bins)) || is.na(getZeroBin(bins)))) {
        cli_abort(c("For {.code background = 'zeroBin'}, {.arg bins} has to define a zero bin ",
                    "(see {.arg maxAbsX} argument of {.fn bin} function)."))
    }
    if (identical(background, "genome")) {
        if (is.null(genome) || !(is(genome, "DNAStringSet") ||
                                 is(genome, "BSgenome"))) {
            cli_abort(c("For {.code background = 'genome'}, {.arg genome} must be either a ",
                        "{.cls DNAStringSet} or a {.cls BSgenome} object."))
        }
        if (!is.null(genome.regions)) {
            if (!is(genome.regions, "GRanges")) {
                cli_abort(c("For {.code background = 'genome'}, {.arg genome.regions} must be ",
                            "either {.code NULL} or a {.cls GRanges} object."))
            }
            if (!all(seqlevels(genome.regions) %in% names(genome))) {
                cli_abort(paste0(
                    "{.arg genome.regions} contains seqlevels not contained",
                    " in {.arg genome}"))
            }
        }
        .assertScalar(x = genome.oversample, type = "numeric",
                      rngIncl = c(1, Inf))
    }
    .assertVector(x = BPPARAM, type = "BiocParallelParam")
    .assertScalar(x = verbose, type = "logical")
    if (is.null(names(seqs))) {
        names(seqs) <- paste0("s", seq_along(seqs))
    }
    .checkIfSeqsAreEqualLength(x = seqs)


    ## include reverse-complement sequences?
    if (identical(includeRevComp, TRUE)) {
        seqsrc <- Biostrings::reverseComplement(seqs)
        names(seqsrc) <- paste0(names(seqs), "_rc")

        battr <- attributes(bins) # rescue attributes dropped by c()
        bin0 <- getZeroBin(bins)
        bins <- c(bins, bins)
        attr(bins, "binmode") <- battr$binmode
        attr(bins, "breaks") <- battr$breaks
        if (!is.null(bin0)) {
            bins <- setZeroBin(bins, bin0)
        }
        seqs <- c(seqs, seqsrc)
    }


    ## filter sequences
    .message("Filtering sequences ...")
    keep <- .filterSeqs(seqs, maxFracN = maxFracN, verbose = verbose)
    battr <- attributes(bins) # rescue attributes dropped by subsetting
    bin0 <- getZeroBin(bins)
    bins <- bins[keep]
    attr(bins, "binmode") <- battr$binmode
    attr(bins, "breaks") <- battr$breaks
    if (!is.null(bin0)) {
        bins <- setZeroBin(bins, bin0)
    }
    seqs <- seqs[keep]

    # stop if all sequences were filtered out
    if (sum(keep) == 0) {
        cli_abort(paste0(
            "No sequence passed the filtering step. ",
            "Cannot proceed with the enrichment analysis ..."))
    }


    # iterate over bins
    enrichL <- bplapply(structure(seq.int(nlevels(bins)), names = levels(bins)),
                        function(i) {

        .message("starting analysis of bin {levels(bins)[i]}")
        verbose1 <- verbose && bpnworkers(BPPARAM) == 1L

        if (identical(background, "model")) {
            # no need to calculate sequence weights for background = "model"
            is.fg <- as.numeric(bins) == i
            Nfg <- sum(is.fg)
            res1 <- getKmerFreq(seqs = seqs[is.fg],
                                kmerLen = kmerLen,
                                MMorder = MMorder,
                                pseudocount = pseudocount.kmers,
                                zoops = TRUE,
                                includeRevComp = FALSE)

            # exclude p value calculation from coverage (tested separately)
            # nocov start
            if (identical(test, "binomial")) {
                logP <- .binomEnrichmentTest(matchCountBg = res1$freq.exp,
                                             totalWeightBg = Nfg,
                                             matchCountFg = res1$freq.obs,
                                             totalWeightFg = Nfg,
                                             verbose = FALSE)
            } else if (identical(test, "fisher")) {
                logP <- .fisherEnrichmentTest(matchCountBg = res1$freq.exp,
                                              totalWeightBg = Nfg,
                                              matchCountFg = res1$freq.obs,
                                              totalWeightFg = Nfg,
                                              verbose = FALSE)
            }
            # nocov end

            return(data.frame(motifName = names(logP),
                              logP = logP,
                              sumForegroundWgtWithHits = res1$freq.obs,
                              sumBackgroundWgtWithHits = res1$freq.exp,
                              totalWgtForeground = Nfg,
                              totalWgtBackground = Nfg))

        } else {
            # define background set and create sequence info data frame
            if (verbose1) {
                cli_progress_step("Defining background sequence set ({background})...")
            }
            df <- .defineBackground(sqs = seqs,
                                    bns = bins,
                                    bg = background,
                                    currbn = i,
                                    gnm = genome,
                                    gnm.regions = genome.regions,
                                    gnm.oversample = genome.oversample,
                                    maxFracN = maxFracN)

            # calculate initial background sequence weights based on G+C
            # composition
            if (verbose1) {
                cli_progress_step("Correcting for GC differences to the background sequences...")
            }
            df <- .calculateGCweight(df = df,
                                     GCbreaks = GCbreaks,
                                     verbose = verbose1)

            # if df is empty, then all seqs were filtered out in the
            # GC weight calculation step
            if (nrow(df) == 0) {
                cli_abort(
                    c("No sequences remained after the GC weight calculation ",
                      "step in bin {.emph {levels(bins)[i]}} due to no GC bin ",
                      "containing both fore- and background sequences.",
                      "Cannot proceed with the enrichment analysis ..."))
            }

            # update background sequence weights based on k-mer composition
            if (verbose1) {
                cli_progress_step(paste0(
                    "Correcting for k-mer differences between fore- ",
                    "and background sequences..."))
            }
            df <- .iterativeNormForKmers(df = df,
                                         maxKmerSize = maxKmerSize,
                                         verbose = verbose1)

            # calculate motif enrichments
            if (verbose1) {
                cli_progress_step("Calculating {kmerLen}-mer enrichment...")
            }
            enrich1 <- .calcKmerEnrichment(k = kmerLen,
                                           df = df,
                                           test = test,
                                           verbose = verbose1)
            return(enrich1)
        }
    }, BPPARAM = BPPARAM)

    # summarize results as SE
    # ... -log10 of P value
    P <- do.call(cbind, lapply(enrichL, function(enrich1) {
        logpVals <- -enrich1[, "logP"] / log(10)
        names(logpVals) <- enrich1[, "motifName"]
        logpVals
    }))

    # ... -log10 of adjusted P value
    padj <- matrix(-log10(p.adjust(as.vector(10**(-P)),
                                   method = p.adjust.method)), nrow = nrow(P))
    dimnames(padj) <- dimnames(P)
    padj[which(padj == Inf, arr.ind = TRUE)] <- max(padj[is.finite(padj)])

    # ... Pearson residuals
    enrTF <- do.call(cbind, lapply(enrichL, function(enrich1) {
        enr <- .calcPearsonResiduals(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"])
        )
        names(enr) <- enrich1[, "motifName"]
        enr
    }))

    # expected foreground weights
    expFG <- do.call(cbind, lapply(enrichL, function(enrich1) {
        expfg <- .calcExpFg(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"])
        )
        names(expfg) <- enrich1[, "motifName"]
        expfg
    }))

    # log2 enrichments
    log2enr <- do.call(cbind, lapply(enrichL, function(enrich1) {
        l2e <- .calcLog2Enr(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"]),
            pseudocount = pseudocount.log2enr
        )
        names(l2e) <- enrich1[, "motifName"]
        l2e
    }))

    # return SummarizedExperiment
    kmers <- enrichL[[1]]$motifName
    pfmL <- do.call(TFBSTools::PFMatrixList, lapply(kmers, function(kmer) {
        TFBSTools::PFMatrix(ID = kmer, name = kmer,
                            profileMatrix = .cons2matrix(kmer))
    }))
    pwmL <- TFBSTools::toPWM(pfmL)
    percentGC <- unlist(lapply(pfmL, function(x) {
        m <- TFBSTools::Matrix(x)
        100 * sum(m[c("C","G"), ]) / sum(m)
    }), use.names = FALSE)
    rdat <- DataFrame(motif.id = TFBSTools::ID(pwmL),
                      motif.name = TFBSTools::name(pwmL),
                      motif.pfm = pfmL,
                      motif.pwm = pwmL,
                      motif.percentGC = percentGC)
    if (is.null(attr(bins, "breaks"))) {
        binL <- binH <- rep(NA, nlevels(bins))
    } else {
        binL <- attr(bins, "breaks")[-(nlevels(bins) + 1)]
        binH <- attr(bins, "breaks")[-1]
    }
    cdat <- DataFrame(
        bin.names = levels(bins),
        bin.lower = binL,
        bin.upper = binH,
        bin.nochange = seq.int(nlevels(bins)) %in% getZeroBin(bins),
        totalWgtForeground = do.call(c, lapply(enrichL, function(x) {
            x$totalWgtForeground[1]
        })),
        totalWgtBackground = do.call(c, lapply(enrichL, function(x) {
            x$totalWgtBackground[1]
        }))
    )
    mdat <- list(bins = bins,
                 bins.binmode = attr(bins, "binmode"),
                 bins.breaks = as.vector(attr(bins, "breaks")),
                 bins.bin0 = getZeroBin(bins),
                 param = list(kmerLen = kmerLen,
                              background = background,
                              MMorder = MMorder,
                              test = test,
                              includeRevComp = includeRevComp,
                              maxFracN = maxFracN,
                              maxKmerSize = maxKmerSize,
                              pseudocount.kmers = pseudocount.kmers,
                              pseudocount.log2enr = pseudocount.log2enr,
                              zoops = TRUE,
                              p.adj.method = p.adjust.method,
                              genome.class = class(genome),
                              genome.regions = genome.regions,
                              genome.oversample = genome.oversample,
                              BPPARAM.class = class(BPPARAM),
                              BPPARAM.bpnworkers = bpnworkers(BPPARAM),
                              verbose = verbose))
    assaySumForegroundWgtWithHits <-
        do.call(cbind, lapply(enrichL, function(x){x$sumForegroundWgtWithHits}))
    assaySumBackgroundWgtWithHits <-
        do.call(cbind, lapply(enrichL, function(x){x$sumBackgroundWgtWithHits}))

    # ... set motifs with zero fore- and background sums to NA
    assayFgBgSum <- assaySumForegroundWgtWithHits +
        assaySumBackgroundWgtWithHits
    set_NA <- assayFgBgSum == 0
    P[set_NA] <- NA
    padj[set_NA] <- NA
    enrTF[set_NA] <- NA
    log2enr[set_NA] <- NA
    expFG[set_NA] <- NA

    se <- SummarizedExperiment(
        assays = list(negLog10P = P,
                      negLog10Padj = padj,
                      pearsonResid = enrTF,
                      expForegroundWgtWithHits = expFG,
                      log2enr = log2enr,
                      sumForegroundWgtWithHits = assaySumForegroundWgtWithHits,
                      sumBackgroundWgtWithHits = assaySumBackgroundWgtWithHits),
        rowData = rdat, colData = cdat, metadata = mdat
    )
    rownames(se) <- kmers

    return(se)
}

test_that(".cons2matrix works as expected", {
    expect_error(.cons2matrix(x = c("error","error")))
    expect_error(.cons2matrix(x = 1L))
    expect_error(.cons2matrix("ACGT", n = "error"))

    expect_type(res1 <- .cons2matrix(x = "ACGT", n = 1L), "integer")
    expect_type(res2 <- .cons2matrix(x = "ACGT", n = 2L), "integer")
    expect_identical(dim(res1), c(4L, 4L))
    expect_identical(rownames(res1), c("A","C","G","T"))
    expect_equal(res1, diag(4), ignore_attr = TRUE)
    expect_identical(res1 * 2L, res2)
})

test_that("getKmerFreq works as expected", {
    suppressPackageStartupMessages({
        library(Biostrings)
    })

    ## truly random sequences...
    set.seed(1)
    seqs <- sapply(1:100, function(i) paste(sample(x = c("A","C","G","T"),
                                                   size = 500L, replace = TRUE),
                                            collapse = ""))
    r <- sample(500L - 5L, 100L)
    ## ... with a planted 6-mer
    substr(seqs, start = r, stop = r + 5L) <- "AACGTT"
    seqsDSS <- Biostrings::DNAStringSet(seqs)

    expect_error(getKmerFreq(1L))
    expect_error(getKmerFreq(seqs, kmerLen = "error"))
    expect_error(getKmerFreq(seqs, kmerLen = 1:2))
    expect_error(getKmerFreq(seqs, kmerLen = 2.5))
    expect_error(getKmerFreq(seqsDSS, MMorder = "error"))
    expect_error(getKmerFreq(seqsDSS, MMorder = 1:2))
    expect_error(getKmerFreq(seqsDSS, MMorder = 2.5))
    expect_error(getKmerFreq(seqsDSS, MMorder = -1))
    expect_error(getKmerFreq(seqsDSS, MMorder = 4))
    expect_error(getKmerFreq(seqs, 3, includeRevComp = "error"))

    ## zoops = FALSE
    expect_type(res1 <- getKmerFreq(seqs, kmerLen = 4, zoops = FALSE),    "list")
    expect_type(res2 <- getKmerFreq(seqsDSS, kmerLen = 4, zoops = FALSE), "list")
    expect_identical(res1, res2)
    expect_equal(sum(res1$freq.obs), sum(res1$freq.exp), tolerance = 0.001)
    expect_identical(names(res1$log2enr)[which.max(res1$log2enr)], "ACGT")
    expect_true(all(names(res1$padj)[res1$padj < 0.001] %in% c("AACG", "ACGT", "CGTT")))

    ## zoops = TRUE
    set.seed(2)
    seqs <- sapply(1:100, function(i) paste(sample(x = c("A","C","G","T"),
                                                   size = 500L, replace = TRUE),
                                            collapse = ""))
    seqs <- c(DNAStringSet(DNAString(paste(rep("CA", 250), collapse = ""))), seqs[-1])
    expect_type(res3 <- getKmerFreq(seqs, kmerLen = 4, zoops = TRUE),  "list")
    expect_type(res4 <- getKmerFreq(seqs, kmerLen = 4, zoops = FALSE, includeRevComp = FALSE), "list")
    expect_equal(sum(res3$padj < 0.001), 0L)
    expect_equal(sum(res4$padj < 0.001), 2L)
    expect_equal(names(res4$padj[res4$padj < 0.001]), c("ACAC", "CACA"))

    ## strata
    expect_type(res5 <- getKmerFreq(seqsDSS, kmerLen = 4, zoops = FALSE, strata = 3), "list")
    expect_equal(sum(res1$freq.obs), sum(res5$freq.obs), tolerance = 0.001)
    expect_equal(sum(res1$freq.exp), sum(res5$freq.exp), tolerance = 0.001)
    expect_true(all(res5$strata %in% c(1L, 2L, 3L)))
    expect_length(res5$freq.strata, 3L)
    expect_equal(sum(res5$CpGoe), 204.030341557169, tolerance = 1e-6)
    expect_identical(names(res5$log2enr)[which.max(res5$log2enr)], "ACGT")
    expect_true(all(names(res5$padj)[res5$padj < 0.001] %in% c("AACG", "ACGT", "CGTT")))
})

test_that(".calcKmerEnrichment works", {
    fseq <- c(f1  = "AGGGGGGGGG", f3  = "AAAGGGGGGG", f4  = "AAAAGGGGGG",
              f6  = "AAAAAAGGGG", f8  = "AAAAAAAAGG")
    bseq <- c(b1  = "AGGGGGGGGG", b2  = "AAGGGGGGGG", b3  = "AAAGGGGGGG",
              b4  = "AAAAGGGGGG", b5  = "AAAAAGGGGG")
    df <- DataFrame(seqs = DNAStringSet(c(fseq, bseq)),
                    isForeground = rep(c(TRUE, FALSE), c(length(fseq), length(bseq))),
                    GCfrac = NA_real_,
                    GCbin = NA_integer_,
                    GCwgt = NA_real_,
                    seqWgt = NA_real_)
    attr(df, "err") <- 0
    df <- .calculateGCweight(df)
    df <- .iterativeNormForKmers(df)
    k <- 2L

    expect_error(.calcKmerEnrichment(k = "error", df = df),
                 ".k. must be of class .*numeric.")
    expect_error(.calcKmerEnrichment(k = k, df = "error"),
                 ".df. should be a .*DataFrame.")
    expect_error(.calcKmerEnrichment(k = k, df = df,
                                     test = "error"),
                 "should be one of")
    expect_error(.calcKmerEnrichment(k = k, df = df,
                                     test = "fisher", verbose = "error"),
                 ".verbose. must be of class .*logical.")

    suppressMessages(expect_message(
        res1 <- .calcKmerEnrichment(k = k, df = df,
                                    test = "binomial", verbose = TRUE)))
    suppressMessages(expect_message(
        res3 <- .calcKmerEnrichment(k = k, df = df,
                                    test = "fisher", verbose = TRUE)))

    expect_type(res1, "list")
    expect_type(res3, "list")

    expect_equal(dim(res1), c(4^k, 6))
    expect_identical(res1$sumForegroundWgtWithHits, res3$sumForegroundWgtWithHits)
    expect_identical(res1$sumBackgroundWgtWithHits, res3$sumBackgroundWgtWithHits)
    expect_equal(res1$logP, c(-0.163497930965412, 0, -0.843717559537887, 0, 0,
                              0, 0, 0, 0, 0, -0.843717559537887, 0, 0, 0, 0, 0))
    expect_equal(res3$logP, c(-0.154150679827258, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                              0, 0, 0, 0, 0))
})


test_that("calcBinnedKmerEnr works as expected", {
    suppressPackageStartupMessages({
        library(SummarizedExperiment)
        library(BiocParallel)
    })
    if (.Platform$OS.type == "unix") {
        pparams <- MulticoreParam(2L, RNGseed = 42L)
    } else {
        pparams <- SerialParam(RNGseed = 42L)
    }

    set.seed(1)
    k <- 3L
    seqstr <- unlist(lapply(1:200,
                            function(i) paste(sample(c("A","C","G","T"),
                                                     50, replace = TRUE),
                                              collapse = "")))
    b <- bin(rep(1:2, each = 100), binmode = "equalN", nElements = 100)
    m <- structure(c("AAC", "CCA"), names = levels(b))
    mrc <- as.character(Biostrings::reverseComplement(Biostrings::DNAStringSet(m)))
    m2 <- rbind(m, mrc)
    rownames(m2) <- NULL
    for (b1 in levels(b))
        substr(seqstr[b == b1], start = 10, stop = 12) <- m[b1]
    seqs <- DNAStringSet(seqstr)
    gnm <- DNAStringSet(unlist(lapply(1:10,
                                      function(i) paste(sample(c("A","C","G","T"),
                                                               1000 - i * 10,
                                                               replace = TRUE),
                                                        collapse = ""))))
    names(gnm) <- paste0("g", seq_along(gnm))


    expect_error(calcBinnedKmerEnr("error"))
    expect_error(calcBinnedKmerEnr(seqs, bins = NULL))
    expect_error(calcBinnedKmerEnr(seqs, bins = b[1:20]))
    expect_error(calcBinnedKmerEnr(seqs, bins = as.numeric(b)))
    expect_error(calcBinnedKmerEnr(seqs, b, kmerLen = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "model", MMorder = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "zeroBin"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "genome"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, test = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, includeRevComp = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, maxFracN = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, maxKmerSize = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, GCbreaks = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, pseudocount.kmers = -1))
    expect_error(calcBinnedKmerEnr(seqs, b, k, pseudocount.log2enr = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, pseudofreq.pearsonResid = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, zoops = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, p.adjust.method = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "genome",
                                   genome = gnm,
                                   genome.regions = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "genome",
                                   genome = gnm,
                                   genome.regions = GRanges("error",
                                                            IRanges(1, 10))))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "genome",
                                   genome = gnm, genome.oversample = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, background = "genome",
                                   genome = gnm, genome.seed = "error"))
    expect_error(calcBinnedKmerEnr(seqs, b, k, BPPARAM = "error"))
    expect_error(calcBinnedKmerEnr(DNAStringSet(rep("NNNNNNNNNN", 10)), background = "model"))
    suppressMessages(
        expect_message(res1 <- calcBinnedKmerEnr(seqs, b, k, includeRevComp = FALSE, verbose = TRUE))
    )

    res2 <- calcBinnedKmerEnr(seqs, b, k, background = "genome", genome = gnm,
                              includeRevComp = FALSE, verbose = FALSE, BPPARAM = pparams)
    res3 <- calcBinnedKmerEnr(seqs, b, k, background = "model",
                              BPPARAM = pparams)
    res4 <- calcBinnedKmerEnr(seqs, b, k, background = "model",
                              test = "binomial")

    expect_s4_class(res1, "SummarizedExperiment")
    expect_s4_class(res2, "SummarizedExperiment")
    expect_s4_class(res3, "SummarizedExperiment")
    expect_s4_class(res4, "SummarizedExperiment")
    expect_identical(assayNames(res1),
                     c("negLog10P", "negLog10Padj", "pearsonResid",
                       "expForegroundWgtWithHits", "log2enr",
                       "sumForegroundWgtWithHits", "sumBackgroundWgtWithHits"))
    expect_identical(apply(assay(res1, "negLog10Padj"), 2,
                           function(x) names(x)[x > 3]), m)
    expect_identical(apply(assay(res2, "negLog10Padj"), 2,
                           function(x) names(x)[x > 3]), m)
    expect_identical(apply(assay(res3, "negLog10Padj"), 2,
                           function(x) names(x)[x > 0.5]), m2)
    expect_identical(apply(assay(res4, "negLog10Padj"), 2,
                           function(x) names(x)[x > 1]), m2)
    expect_equal(colSums(assay(res1, "negLog10P")),
                 c(`[1,1.5]` = 33.1936891496806, `(1.5,2]` = 31.5395993919718))
    expect_equal(colSums(assay(res3, "negLog10P")),
                 c(`[1,1.5]` = 27.2409566382244, `(1.5,2]` = 23.5971145106083))
    expect_equal(colSums(assay(res4, "negLog10P")),
                 c(`[1,1.5]` = 37.2309483817477, `(1.5,2]` = 30.1142668663514))
    expect_identical(nrow(res1), as.integer(4^k))
    expect_identical(ncol(res1), nlevels(b))
    expect_identical(assay(res1, "sumForegroundWgtWithHits")[,1],
                     assay(res2, "sumForegroundWgtWithHits")[,1])
    expect_identical(assays(res3)[-c(1, 2)], assays(res4)[-c(1, 2)])

    skip_on_os("windows")
    ## Note that all tests after this point (within the test_that block) will
    ## be skipped on windows.
    expect_equal(colSums(assay(res2, "negLog10P")),
                 c(`[1,1.5]` = 34.8521231337902, `(1.5,2]` = 35.6739828473288))
})

#' @title Sample random regions of fixed length.
#'
#' @description Sample random regions from the mappable parts of the genome with
#'     a given fraction from CpG islands.
#'
#' @param allowedRegions An unstranded \code{GRanges} object of the "allowed" 
#'     of the genome, usually the mappable regions. 
#' @param N Number of regions to sample.
#' @param regWidth Region width.
#'
#'
#' @details In order to make the results deterministic, set the random
#'     number seed before calling \code{sampleRandomRegions} using 
#'     \code{set.seed}.
#'
#' @return A \code{GRanges} object with randomly sampled mappable regions of 
#'     width \code{regWidth} with \code{fractionCGI} coming from CpG islands.
#'
#' @examples 
#' regs <- GenomicRanges::GRanges(
#'   seqnames = rep(c("chr1", "chr2"), each = 2), 
#'   ranges = IRanges::IRanges(start = 1:4, end = 5:8))
#' set.seed(123)
#' sampleRandomRegions(regs, N = 2, regWidth = 3L)
#' 
#' @importFrom Seqinfo seqlengths
#' @importFrom GenomicRanges width end end<- start seqnames GRanges sort
#' @importFrom IRanges IRanges
#'
#' @export
sampleRandomRegions <- function(allowedRegions = NULL, N = 100L,
                                  regWidth = 200L){

    .assertScalar(x = N, type = "numeric")
    .assertScalar(x = regWidth, type = "numeric")
    stopifnot(exprs = {
        is(allowedRegions, "GRanges")
        length(allowedRegions) > 0
        sum(width(allowedRegions) >= regWidth) > 0
        all(strand(allowedRegions) == "*")
    })

    #in case these parameters are not integers, round to integer
    N <- round(N)
    regWidth <- round(regWidth)

    #reduce to ranges that are larger than or equal to width and adjust
    #end position such that the object only contains
    #the start positions that when extended by width are
    #entirely within the mappable parts of the genome
    gr <- allowedRegions[width(allowedRegions) >= regWidth]
    end(gr) <- end(gr) - regWidth + 1

    #first sample regions according to the number of positions
    #then sample position uniformly within each region

    #probability of sampling each region
    widths <- width(gr)
    ps <- widths/sum(widths)

    #sample regions
    indx <- sample(seq_along(gr), size = N, prob = ps, replace = TRUE)

    #for each range, sample 1 position uniformly
    gr.sampled <- gr[indx]
    st.sampled <- start(gr.sampled)
    end.sampled <- end(gr.sampled)
    chr.sampled <- seqnames(gr.sampled)

    pos.sampled <- unlist(lapply(seq_along(gr.sampled), function(i){
        sample(st.sampled[i]:end.sampled[i], 1)
    }))
    gr.sampled <- GRanges(seqnames = chr.sampled,
                          ranges = IRanges(start = pos.sampled, 
                                           width = regWidth),
                          seqlengths = seqlengths(gr))
    sort(gr.sampled)
}

test_that("sampleRandomRegions() works properly", {
    gr <- GenomicRanges::GRanges(seqnames = paste0("chr", seq.int(20L)),
                                 ranges = IRanges::IRanges(start = 1L, width = 10000L))

    expect_error(sampleRandomRegions())
    expect_error(sampleRandomRegions(N = 1:2))
    expect_error(sampleRandomRegions(N = "error"))
    # todo: add some more

    set.seed(123)
    res1 <- sampleRandomRegions(allowedRegions = gr)
    set.seed(123)
    res2 <- sampleRandomRegions(allowedRegions = gr)

    expect_s4_class(res1, "GRanges")
    expect_identical(res1, res2)
    expect_length(res1, 100L)
    expect_true(all(width(res1) == 200L))
    # todo: add some more (e.g. for fractionCGI)
})

# Finding TFs enriched in differentially methylated regions


# load packages
library(GenomicRanges)
library(SummarizedExperiment)
library(monaLisa)
library(JASPAR2020)
library(TFBSTools)
library(BSgenome.Mmusculus.UCSC.mm10)


# load regions of interest: low-methylated regions (LMRs)
# - LMRs are provided as a GRanges object for the mm10 genome in the monaLisa
#   package at system.file("extdata", "LMRsESNPmerged.gr.rds", package = "monaLisa")
# - they were generated as described in Stadler, Murr, Burger et al., Nature 2011
#   (https://doi.org/10.1038/nature10716). Briefly:
#   * bisulfite-sequencing data from mouse ES and NP cells were aligned to the
#     mouse mm9 genome using QuasR::qAlign with default parameters
#   * CpG methylation states were called using QuasR::qMeth with default parameters
#   * low-methylated regions were identified using a three-state hidden markov model,
#     but can now be more easily be identified using the MethylSeekR package
#     (https://bioconductor.org/packages/MethylSeekR/)
#   * LMRs were lifted over from mm9 to mm10 coordinates, using
#     rtracklayer::liftOver and the chain file at
#     http://hgdownload.soe.ucsc.edu/goldenPath/mm9/liftOver/mm9ToMm10.over.chain.gz
#   * Average fraction of methylated CpGs in identified LMR regions were
#     calculated for ES and NP cells, and the difference of these fractions
#     (NP - ES) was stored in the metadata column "deltaMeth" of the LMR
#     GRanges object.
regfile <- system.file("extdata", "LMRsESNPmerged.gr.rds", package = "monaLisa")
reg <- readRDS(regfile)
reg


# sub-sample to 10,000 regions
set.seed(1)
reg <- reg[ sample(x = length(reg), size = 10000, replace = FALSE) ]


# make regions of interest equally long
reg <- trim(resize(reg, width = median(width(reg)), fix = "center"))


# extract sequences for regions of interest
regseq <- getSeq(BSgenome.Mmusculus.UCSC.mm10, reg)


# bin regions of interest according to methylation change
# - each bin should contain 800 regions
# - methylation changes below 0.3 are considered as no change
bins <- bin(x = reg$deltaMeth, binmode = "equalN", nElement = 800, minAbsX = 0.3)
table(bins)


# check if bins differ in sequence length or composition
plotBinDiagnostics(seqs = regseq, bins = bins, aspect = "length") # all identical by definition
tapply(width(reg), bins, range)
plotBinDiagnostics(seqs = regseq, bins = bins, aspect = "GCfrac")
plotBinDiagnostics(seqs = regseq, bins = bins, aspect = "dinucfreq")
# regions that lose methyaltion in NP cells (NP-ES < 0, first bin) are GC-poorer


# get vertebrate motifs from Jaspar database
pfms <- getMatrixSet(JASPAR2020, list(tax_group = "vertebrates"))
pwms <- toPWM(pfms)
pwms


# performe binned motif enrichment analysis
se <- calcBinnedMotifEnrR(seqs = regseq,
                          bins = bins,
                          pwmL = pwms,
                          BPPARAM = BiocParallel::MulticoreParam(40),
                          verbose = TRUE)
# saveRDS(se, "inst/extdata/results.binned_motif_enrichment_LMRs.rds")


# perform binned 6-mer enrichment analysis
sk <- calcBinnedKmerEnr(seqs = regseq,
                        bins = bins,
                        kmerLen = 6L,
                        BPPARAM = BiocParallel::MulticoreParam(40),
                        verbose = TRUE)
# saveRDS(sk, "inst/extdata/results.binned_6mer_enrichment_LMRs.rds")

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.width = 7,
    fig.height = 5,
    out.width = "80%",
    fig.align = "center",
    crop = NULL # suppress "The magick package is required to crop" issue
)
library(BiocStyle)

## ----libs, message=FALSE------------------------------------------------------
library(monaLisa)
library(JASPAR2020)
library(TFBSTools)
library(BSgenome.Mmusculus.UCSC.mm10)
library(Biostrings)
library(SummarizedExperiment)
library(ComplexHeatmap)
library(circlize)
library(ggrepel)

## ----loadData-----------------------------------------------------------------
# load GRanges object with logFC and peaks
gr_path <- system.file("extdata", "atac_liver_vs_lung.rds", 
                       package = "monaLisa")
gr <- readRDS(gr_path)

## ----predictorMatrix, warning=FALSE-------------------------------------------
# get PFMs (vertebrate TFs from Jaspar)
pfms <- getMatrixSet(JASPAR2020, list(matrixtype = "PFM", 
                                      tax_group = "vertebrates"))

# randomly sample 300 PFMs for illustration purposes (for quick runtime)
set.seed(4563)
pfms <- pfms[sample(length(pfms), size = 300)]

# convert PFMs to PWMs
pwms <- toPWM(pfms)

# get TFBS on given GRanges (peaks)
# suppress warnings generated by matchPWM due to the presence of Ns 
# in the sequences
peakSeq <- getSeq(BSgenome.Mmusculus.UCSC.mm10, gr)
suppressWarnings({
  hits <- findMotifHits(query = pwms, subject = peakSeq, min.score = 10.0,
                        BPPARAM = BiocParallel::SerialParam())
})

# get TFBS matrix
TFBSmatrix <- unclass(table(factor(seqnames(hits), levels = seqlevels(hits)),
                            factor(hits$pwmname, levels = name(pwms))))
TFBSmatrix[1:6, 1:6]

# remove TF motifs with 0 binding sites in all regions
zero_TF <- colSums(TFBSmatrix) == 0
sum(zero_TF)
TFBSmatrix <- TFBSmatrix[, !zero_TF]

# calculate G+C and CpG obs/expected
fMono <- oligonucleotideFrequency(peakSeq, width = 1L, as.prob = TRUE)
fDi <- oligonucleotideFrequency(peakSeq, width = 2L, as.prob = TRUE)
fracGC <- fMono[, "G"] + fMono[, "C"]
oeCpG <- (fDi[, "CG"] + 0.01) / (fMono[, "G"] * fMono[, "C"] + 0.01)

# add GC and oeCpG to predictor matrix
TFBSmatrix <- cbind(fracGC, oeCpG, TFBSmatrix)
TFBSmatrix[1:6, 1:6]

## ----stabSelTFs---------------------------------------------------------------
## randLassoStabSel() is stochastic, so if we run with parallelization
##   (`mc.cores` argument), we must select a random number generator that can
##   provide multiple streams of random numbers used in the `parallel` package
##   and set its seed for reproducible results
# RNGkind("L'Ecuyer-CMRG")
# set.seed(123)
# se <- randLassoStabSel(x = TFBSmatrix, y = gr$logFC_liver_vs_lung, 
#                        cutoff = 0.8, mc.preschedule = TRUE, 
#                        mc.set.seed = TRUE, mc.cores = 2L)

# if not running in parallel mode, it is enough to use set.seed() before 
#   the call to ensure reproducibility (`mc.sores = 1`)
set.seed(123)
se <- randLassoStabSel(x = TFBSmatrix, y = gr$logFC_liver_vs_lung, 
                       cutoff = 0.8)
se

# selected TFs
colnames(se)[se$selected]

## ----plotStabilityPaths, fig.width=8, fig.height=4----------------------------
plotStabilityPaths(se)

## ----plotStabilityPathsWithSelLabels, fig.width=10, fig.height=4--------------
set.seed(123)
plotStabilityPaths(se, labelPaths = TRUE)

## ----plotStabilityPathsWithLabels, fig.width=8, fig.height=4------------------
set.seed(123)
plotStabilityPaths(se, labelPaths = TRUE, labelNudgeX = 3,
                   labels = c("ISL2", "NR2C2", "NR2F1", "GATA4"))

## ----plotSelProbs, fig.width=10, fig.height=5---------------------------------
plotSelectionProb(se, directional = TRUE, ylimext = 0.5)

## ----TFBScor_selected, fig.width=10, fig.height=7-----------------------------
# subset the selected TFs
sel <- colnames(se)[se$selected]
se_sub <- se[, sel]

# exclude oeCpG and fracGC
excl <- colnames(se_sub) %in% c("oeCpG", "fracGC")
se_sub <- se_sub[, !excl]

# correlation matrix 
TFBSmatrixCorSel <- cor(TFBSmatrix[, colnames(se_sub)], method = "pearson")

# heatmap
pfmsSel <- pfms[match(colnames(TFBSmatrixCorSel), name(pfms))]
maxwidth <- max(sapply(TFBSTools::Matrix(pfmsSel), ncol))
seqlogoGrobs <- lapply(pfmsSel, seqLogoGrob, xmax = maxwidth)

hmSeqlogo <- rowAnnotation(logo = annoSeqlogo(seqlogoGrobs, which = "row"),
                           annotation_width = unit(2, "inch"), 
                           show_annotation_name = FALSE
)

colAnn <- HeatmapAnnotation(AUC = se_sub$selAUC, selProb = se_sub$selProb,
                            show_legend = TRUE, 
                            show_annotation_name = TRUE,
                            col = list(
                              AUC = colorRamp2(c(0, 1), 
                                               c("white", "brown")),
                              selProb = colorRamp2(c(0, 1), 
                                                   c("white", "steelblue")))
)

Heatmap(TFBSmatrixCorSel, 
        show_row_names = TRUE, 
        show_column_names = TRUE, 
        name = "Pear. Cor.", column_title = "Selected TFs",
        col = colorRamp2(c(-1, 0, 1), c("blue", "white", "red")), 
        right_annotation = hmSeqlogo,
        top_annotation = colAnn)

## ----topPeaks-----------------------------------------------------------------
TF <- sel[2]
TF

i <- which(assay(se, "x")[, TF] > 0) # peaks that contain TF hits...
nm <- names(sort(abs(gr$logFC_liver_vs_lung[i]), 
                 decreasing = TRUE)) # ... order by |logFC|

gr[nm]

## ----session------------------------------------------------------------------
sessionInfo()

#' @importFrom grDevices colorRampPalette
#' @importFrom stats density dist hclust
#' @importFrom S4Vectors isEmpty
NULL


#' @title Get colors by bin.
#'
#' @description Get colors for elements according to their bin.
#'     Colors are assigned to bins forming a gradient from \code{col1}
#'     to \code{col2} in the order of \code{levels{b}}. \code{col0} is assigned
#'     to the neutral bin (attribute \code{""}) if available.
#'
#' @param b A factor that groups elements into bins (typically the output of
#'     \code{\link{bin}}).
#' @param col1 First color.
#' @param col2 Second color.
#' @param col0 Neutral color.
#'
#' @seealso \code{\link{bin}}.
#'
#' @return A character vector with colors for the elements in \code{b}.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' b <- bin(x, "equalN", nElements = 10)
#' cols <- getColsByBin(b)
#'
#' @importFrom grDevices col2rgb
#'
#' @export
getColsByBin <- function(b,
                         col1 = c("#003C30", "#01665E", "#35978F",
                                  "#80CDC1", "#C7EAE5"),
                         col2 = c("#F6E8C3", "#DFC27D", "#BF812D",
                                  "#8C510A", "#543005"),
                         col0 = "#F5F5F5") {
    if (!is.factor(b)) {
        b <- factor(b, levels = unique(b))
        b <- setZeroBin(b, NA)
    }

    if (!is.null(getZeroBin(b)) && !is.na(getZeroBin(b))) {
        bin0 <- getZeroBin(b)
        cols <- c(colorRampPalette(col1)(bin0 - 1L),
                  "#AAAAAA33",
                  colorRampPalette(col2)(nlevels(b) - bin0))
    } else {
        nh <- round(nlevels(b) / 2)
        cols <- c(colorRampPalette(col1)(nh),
                  colorRampPalette(col2)(nlevels(b) - nh))
    }

    res <- cols[b]
    names(cols) <- levels(b)
    attr(res, "cols") <- cols
    return(res)
}


#' @title Histogram of binned elements.
#'
#' @description Plot a histogram of binned elements with binning information.
#'
#' @param x A numerical vector with the values used for binning.
#' @param b A factor that groups elements of \code{x} into bins (typically
#'     the output of \code{\link{bin}}).
#' @param breaks A \code{numeric} scalar controlling the histogram breaks
#'     (passed to \code{geom_hist(..., bins = breaks)}).
#' @param xlab,ylab,main \code{character} scalars that set the x-axis label,
#'     y-axis label and the main title. Use \code{""} to suppress the label.
#' @param legendPosition A \code{character} scalar.
#'     If not \code{"none"}, draw a legend with binning information. The value
#'     is used to control the legend position and will be passed to
#'     \code{theme(legend.position = legendPosition)}.
#' @param legend Deprecated (ignored). Please use \code{legendPosition} to
#'     control the drawing and position of the legend.
#' @param legend.cex Deprecated (ignored). You can use
#'     \code{\link[ggplot2]{theme}} to set legend and other graphical
#'     parameters.
#' @param ... Further arguments passed to \code{\link{getColsByBin}}.
#'
#' @seealso \code{\link{getColsByBin}}, \code{\link[ggplot2]{geom_histogram}}
#'
#' @return The generated histogram as a \code{ggplot} object.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' b <- bin(x, "equalN", nElements = 10)
#' plotBinHist(x, b)
#'
#' @importFrom ggplot2 ggplot aes geom_histogram theme_classic theme
#' @importFrom cli cli_warn
#'
#' @export
plotBinHist <- function(x, b,
                        breaks = 6 * nlevels(b),
                        xlab = deparse(substitute(x, env = as.environment(-1))),
                        ylab = "Frequency",
                        main = "",
                        legendPosition = "right",
                        legend = NULL,
                        legend.cex = NULL, ...) {
    .assertVector(x = x, type = "numeric")
    .assertVector(x = b, type = "factor", len = length(x))
    .assertScalar(x = breaks, type = "numeric", allowNULL = TRUE)
    .assertScalar(x = xlab, type = "character")
    .assertScalar(x = ylab, type = "character")
    .assertScalar(x = main, type = "character")
    if (!is.null(legend)) {
        cli_warn(c("{.arg legend} is deprecated and ignored.",
                   "i" = "You can use {.arg legendPosition} to control legend drawing and position"))
    }
    if (!is.null(legend.cex)) {
        cli_warn(c("{.arg legend.cex} is deprecated and ignored.",
                   "i" = "You can use {.fn theme} to control legend and other graphical parameters"))
    }

    cols <- getColsByBin(b, ...)
    bincols <- attr(cols, "cols")

    # add number of elements to bin names
    bn <- unclass(table(b))
    levels(b) <- names(bincols) <- paste0(levels(b), ": ", bn)

    p <- ggplot(data = data.frame(x = x, b = b), mapping = aes(x = x, fill = b)) +
        geom_histogram(bins = breaks, colour = "gray20") +
        scale_fill_manual(values = bincols) +
        labs(fill = "Bins") +
        theme_classic() +
        theme(legend.position = legendPosition)
    if (!identical(xlab, "")) {
        p <- p + labs(x = xlab)
    } else {
        p <- p + labs(x = NULL)
    }
    if (!identical(ylab, "")) {
        p <- p + labs(y = ylab)
    } else {
        p <- p + labs(y = NULL)
    }
    if (!identical(main, "")) {
        p <- p + labs(title = main)
    }

    return(p)
}


#' @title Density plot of binned elements.
#'
#' @description Plot the density of binned elements with binning information.
#'
#' @param x A numerical vector with the values used for binning.
#' @param b A factor that groups elements of \code{x} into bins (typically the
#'     output of \code{\link{bin}}).
#' @param xlab,ylab,main \code{character} scalars that set the x-axis label,
#'     y-axis label and the main title. Use \code{""} to suppress the label.
#' @param legendPosition A \code{character} scalar.
#'     If not \code{"none"}, draw a legend with binning information. The value
#'     is used to control the legend position and will be passed to
#'     \code{theme(legend.position = legendPosition)}.
#' @param legend Deprecated (ignored). Please use \code{legendPosition} to
#'     control the drawing and position of the legend.
#' @param legend.cex Deprecated (ignored). You can use
#'     \code{\link[ggplot2]{theme}} to set legend and other graphical
#'     parameters.
#' @param ... Further arguments passed to \code{\link{getColsByBin}}.
#'
#' @seealso \code{\link{getColsByBin}}, \code{\link[ggplot2]{geom_density}}
#'
#' @return The generated density plot as a \code{ggplot} object.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' b <- bin(x, "equalN", nElements = 10)
#' plotBinDensity(x, b)
#'
#' @importFrom stats density
#' @importFrom ggplot2 ggplot aes geom_area geom_line geom_rug theme_classic
#'     theme
#' @importFrom cli cli_warn
#' @importFrom rlang .data
#'
#' @export
plotBinDensity <- function(x, b,
                           xlab = deparse(
                               substitute(x, env = as.environment(-1))),
                           ylab = "Density",
                           main = "",
                           legendPosition = "right",
                           legend = NULL,
                           legend.cex = NULL,
                           ...) {
    .assertVector(x = x, type = "numeric")
    .assertVector(x = b, type = "factor", len = length(x))
    stopifnot("breaks" %in% names(attributes(b)))
    .assertScalar(x = xlab, type = "character")
    .assertScalar(x = ylab, type = "character")
    .assertScalar(x = main, type = "character")
    if (!is.null(legend)) {
        cli_warn(c("{.arg legend} is deprecated and ignored.",
                   "i" = "You can use {.arg legendPosition} to control legend drawing and position"))
    }
    if (!is.null(legend.cex)) {
        cli_warn(c("{.arg legend.cex} is deprecated and ignored.",
                   "i" = "You can use {.fn theme} to control legend and other graphical parameters"))
    }

    cols <- getColsByBin(b, ...)
    binbreaks <- attr(b, "breaks")
    bincols <- attr(cols, "cols")

    # add number of elements to bin names
    bn <- unclass(table(b))
    levels(b) <- names(bincols) <- paste0(levels(b), ": ", bn)

    # calculate density and assign bins
    dens <- data.frame(density(x = x)[c("x", "y")])
    binbreaks[c(1, length(binbreaks))] <- range(dens$x)
    dens$b <- factor(x = levels(b)[cut(dens$x, breaks = binbreaks,
                                       include.lowest = TRUE, labels = FALSE)],
                     levels = levels(b))

    p <- ggplot(dens) +
        geom_area(data = dens, mapping = aes(.data$x, .data$y,
                                             colour = .data$b, fill = .data$b),
                  outline.type = "full") +
        geom_line(data = dens, mapping = aes(.data$x, .data$y), colour = "gray20") +
        geom_rug(data = data.frame(x = binbreaks),
                 mapping = aes(.data$x), colour = "gray20") +
        scale_colour_manual(values = bincols) +
        scale_fill_manual(values = bincols) +
        labs(colour = "Bins",
             fill = "Bins") +
        theme_classic() +
        theme(legend.position = legendPosition)
    if (!identical(xlab, "")) {
        p <- p + labs(x = xlab)
    } else {
        p <- p + labs(x = NULL)
    }
    if (!identical(ylab, "")) {
        p <- p + labs(y = ylab)
    } else {
        p <- p + labs(y = NULL)
    }
    if (!identical(main, "")) {
        p <- p + labs(title = main)
    }

    return(p)
}


#' @title Scatter plot (xy-plot) of binned elements.
#'
#' @description Plot a scatter (xy-plot) of binned elements with binning
#'     information.
#'
#' @param x A numerical vector with x values.
#' @param y A numerical vector with y values (the values used for binning).
#' @param b A factor that groups elements of \code{x,y} into bins (typically
#'     the output of \code{\link{bin}(y)}).
#' @param cols \code{NULL} or a color vector defining the colors of points.
#'     If \code{NULL}, the colors will be computed based on \code{b} using
#'     \code{\link{getColsByBin}(b)}).
#' @param xlab Label for x-axis.
#' @param ylab Label for y-axis.
#' @param main Main title.
#' @param legendPosition A \code{character} scalar.
#'     If not \code{"none"}, draw a legend with binning information. The value
#'     is used to control the legend position and will be passed to
#'     \code{theme(legend.position = legendPosition)}.
#' @param legend Deprecated (ignored). Please use \code{legendPosition} to
#'     control the drawing and position of the legend.
#' @param legend.cex Deprecated (ignored). You can use
#'     \code{\link[ggplot2]{theme}} to set legend and other graphical
#'     parameters.
#' @param ... Further arguments passed to \code{\link{getColsByBin}} (only used
#'     if \code{cols} is \code{NULL}).
#'
#' @seealso \code{\link{bin}}, \code{\link{getColsByBin}},
#'     \code{\link[ggplot2]{geom_point}}
#'
#' @return The generated scatter plot as a \code{ggplot} object.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' y <- rnorm(100)
#' b <- bin(y, "equalN", nElements = 10)
#' plotBinScatter(x, y, b)
#'
#' @importFrom ggplot2 ggplot aes geom_point theme_classic theme
#' @importFrom cli cli_warn
#'
#' @export
plotBinScatter <- function(x, y, b,
                           cols = NULL,
                           xlab = deparse(
                               substitute(x, env = as.environment(-1))),
                           ylab = deparse(
                               substitute(y, env = as.environment(-1))),
                           main = "",
                           legendPosition = "right",
                           legend = NULL,
                           legend.cex = NULL,
                           ...) {
    .assertVector(x = x, type = "numeric")
    .assertVector(x = y, type = "numeric", len = length(x))
    .assertVector(x = b, len = length(x))
    bincols <- NULL
    if (is.null(cols)) {
        cols <- getColsByBin(b, ...)
        bincols <- attr(cols, "cols")
    } else if (length(cols) == 1L) {
        cols <- rep(cols, length(x))
    }
    .assertVector(x = cols, len = length(x))
    .assertScalar(x = xlab, type = "character")
    .assertScalar(x = ylab, type = "character")
    .assertScalar(x = main, type = "character")
    if (is.null(bincols) && !identical(legendPosition, "none")) {
        cli_warn(paste0(
            "Setting {.arg legendPosition} to 'none' - ",
            "cannot use custom colors ({.arg cols}) with bin-based legend"))
    }
    if (!is.null(legend)) {
        cli_warn(c("{.arg legend} is deprecated and ignored.",
                   "i" = "You can use {.arg legendPosition} to control legend drawing and position"))
    }
    if (!is.null(legend.cex)) {
        cli_warn(c("{.arg legend.cex} is deprecated and ignored.",
                   "i" = "You can use {.fn theme} to control legend and other graphical parameters"))
    }

    # add number of elements to bin names
    bn <- unclass(table(b))
    levels(b) <- paste0(levels(b), ": ", bn)

    p <- ggplot(data = data.frame(x = x, y = y, b = b, cols = cols),
                mapping = aes(x, y)) +
        labs(colour = "Bins",
             fill = "Bins") +
        theme_classic() +
        theme(legend.position = legendPosition)
    if (!identical(xlab, "")) {
        p <- p + labs(x = xlab)
    } else {
        p <- p + labs(x = NULL)
    }
    if (!identical(ylab, "")) {
        p <- p + labs(y = ylab)
    } else {
        p <- p + labs(y = NULL)
    }
    if (!identical(main, "")) {
        p <- p + labs(title = main)
    }

    if (is.null(bincols)) {
        p <- p + geom_point(colour = cols)
    } else {
        names(bincols) <- levels(b)
        p <- p + geom_point(aes(colour = b)) +
            scale_colour_manual(values = bincols)
    }

    return(p)
}


#' @title Heatmap of motif enrichments.
#'
#' @description Plot motif enrichments (e.g. significance or magnitude) as a
#'     heatmap.
#'
#' @param x A \code{\link[SummarizedExperiment]{SummarizedExperiment}} with
#'     numerical matrices (motifs-by-bins) in its \code{assays()}, typically
#'     the return value of \code{\link{calcBinnedMotifEnrR}} or
#'     \code{\link{calcBinnedMotifEnrHomer}}.
#' @param which.plots Selects which heatmaps to plot (one or several from
#'     \code{"negLog10P"}, \code{"negLog10Padj"}, \code{"pearsonResid"} and
#'     \code{"log2enr"}).
#' @param width The width (in inches) of each individual heatmap, without
#'     legend.
#' @param col.enr Colors used for enrichment heatmap ("pearsonResid" and
#'     "log2enr").
#' @param col.sig Colors used for significance hetmaps ("negLog10P" and
#'     "negLog10Padj").
#' @param col.gc Colors used for motif GC content (for
#'     \code{show_motif_GC = TRUE}).
#' @param maxEnr Cap color mapping at enrichment = \code{maxEnr}
#'     (default: 99.5th percentile).
#' @param maxSig Cap color mapping at -log10 P value or -log10 FDR =
#'     \code{maxSig} (default: 99.5th percentile).
#' @param highlight A logical vector indicating motifs to be highlighted.
#' @param cluster If \code{TRUE}, the order of transcription factors will be
#'     determined by hierarchical clustering of the \code{"pearsonResid"}
#'     component. Alternatively, an \code{hclust}-object can be supplied which
#'     will determine the motif ordering.
#'     No reordering is done for \code{cluster = FALSE}.
#' @param show_dendrogram If \code{cluster != FALSE}, controls whether to show
#'     a row dendrogram for the clustering of motifs. Ignored for
#'     \code{cluster = FALSE}.
#' @param show_motif_GC If \code{TRUE}, show a column with the percent G+C of
#'     the motif as part of the heatmap.
#' @param show_seqlogo If \code{TRUE}, show a sequence logo next to each motif
#'     label. This will likely only make sense for a heatmap with a low number
#'     of motifs.
#' @param show_bin_legend If \code{TRUE}, show a legend for the bin labels.
#'     If FALSE (default), the bin legend will be hidden.
#' @param width.seqlogo The width (in inches) for the longest sequence logo
#'     (shorter logos are drawn to scale).
#' @param use_raster \code{TRUE} or \code{FALSE} (default). Passed to
#'     \code{use_raster} of \code{\link[ComplexHeatmap]{Heatmap}}.
#' @param na_col "white" (default). Passed to \code{na_col} of
#'     \code{\link[ComplexHeatmap]{Heatmap}}.
#' @param doPlot If \code{TRUE} (default), plot the generated heatmap(s)
#'     using \code{Reduce(ComplexHeatmap::add_heatmap, heatmapList)}. If
#'     \code{FALSE}, just return the list of heatmap(s) (\code{heatmapList}) in
#'     example before), allowing to modify them further before plotting.
#' @param ... Further arguments passed to \code{\link[ComplexHeatmap]{Heatmap}}
#'     when creating the main heatmaps selected by \code{which.plots}. For
#'     example, the following will set the font size of the motif names:
#'     \code{plotMotifHeatmaps(..., row_names_gp = gpar(fontsize = 12))}
#'
#' @details The heatmaps are created using the \pkg{ComplexHeatmap} package
#'     and plotted side-by-side.
#'
#'     Each heatmap will be \code{width} inches wide, so the total plot needs a
#'     graphics device with a width of at least
#'     \code{length(which.plots) * width} plus the space used for motif names
#'     and legend. The height will be auto-adjusted to the graphics device.
#'
#' @seealso \code{\link{bin}}, \code{\link[ComplexHeatmap]{Heatmap}}
#'
#' @references Gu, Z. Complex heatmaps reveal patterns and correlations in
#'     multidimensional genomic data. Bioinformatics 2016.
#'
#' @return A list of \code{ComplexHeatmap::Heatmap} objects.
#'
#' @examples
#' se <- readRDS(system.file("extdata",
#'                           "results.binned_motif_enrichment_LMRs.rds",
#'                           package = "monaLisa"))
#' i <- which(SummarizedExperiment::assay(se, "negLog10Padj")[, 8] > 4)
#' plotMotifHeatmaps(se[i, ], which.plots = "pearsonResid",
#'                   width = 2, show_seqlogo = TRUE)
#'
#' @importFrom methods is show
#' @importFrom stats hclust dist quantile
#' @importFrom TFBSTools Matrix
#' @importFrom grDevices colorRampPalette
#' @importFrom S4Vectors metadata
#' @importFrom SummarizedExperiment assayNames assay rowData
#' @importFrom ComplexHeatmap HeatmapAnnotation Heatmap add_heatmap
#' @importFrom grid unit
#' @importFrom circlize colorRamp2
#' @importFrom cli cli_abort
#'
#' @export
plotMotifHeatmaps <- function(x,
                              which.plots = c("negLog10P", "pearsonResid",
                                              "negLog10Padj", "log2enr"),
                              width = 4,
                              col.enr = c("#053061", "#2166AC", "#4393C3",
                                          "#92C5DE", "#D1E5F0", "#F7F7F7",
                                          "#FDDBC7", "#F4A582", "#D6604D",
                                          "#B2182B", "#67001F"),
                              col.sig = c("#F0F0F0", "#D9D9D9", "#BDBDBD",
                                          "#969696", "#737373", "#525252",
                                          "#252525", "#000000"),
                              col.gc = c("#F7FCF5", "#E5F5E0", "#C7E9C0",
                                         "#A1D99B", "#74C476", "#41AB5D",
                                         "#238B45", "#006D2C", "#00441B"),
                              maxEnr = NULL,
                              maxSig = NULL,
                              highlight = NULL,
                              cluster = FALSE,
                              show_dendrogram = FALSE,
                              show_motif_GC = FALSE,
                              show_seqlogo = FALSE,
                              show_bin_legend = FALSE,
                              width.seqlogo = 1.5,
                              use_raster = FALSE,
                              na_col = "white",
                              doPlot = TRUE,
                              ...) {
    stopifnot(exprs = {
        is(x, "SummarizedExperiment")
        all(which.plots %in% assayNames(x))
        "bins" %in% names(metadata(x))
        (!show_motif_GC || "motif.percentGC" %in% colnames(rowData(x)))
    })
    b <- metadata(x)$bins
    .assertScalar(x = width, type = "numeric", rngExcl = c(0, Inf))
    .assertScalar(x = show_dendrogram, type = "logical")
    .assertScalar(x = show_motif_GC, type = "logical")
    .assertScalar(x = show_seqlogo, type = "logical")
    .assertScalar(x = show_bin_legend, type = "logical")
    .assertScalar(x = width.seqlogo, type = "numeric", rngExcl = c(0, Inf))
    .assertScalar(x = use_raster, type = "logical")
    .assertScalar(x = na_col, type = "character")
    .assertScalar(x = doPlot, type = "logical")
    stopifnot(exprs = {
        ncol(x) == nlevels(b)
        all(which.plots %in% c("negLog10P", "negLog10Padj",
                               "pearsonResid", "log2enr"))
        is.null(highlight) || (is.logical(highlight) &&
                                 length(highlight) == nrow(x))
    })
    bincols <- attr(getColsByBin(b), "cols")
    if (identical(cluster, TRUE)) {
        clAssayName <- "pearsonResid"
        clAssay <- assay(x, clAssayName)
        allNA <- rowSums(is.na(clAssay)) == ncol(clAssay)
        if (any(allNA)) {
            warning("removing motifs without finite values in '",
                    clAssayName, "': ",
                    paste(rownames(clAssay)[allNA], collapse = ", "))
            x <- x[!allNA, ]
            clAssay <- clAssay[!allNA, ]
        }
        clres <- hclust(dist(clAssay))
    } else if (identical(cluster, FALSE)) {
        clres <- FALSE
    } else if (is(cluster, "hclust")) {
        clres <- cluster
    } else {
        cli_abort("{.arg cluster} must be either {.code TRUE}, {.code FALSE} or an {.cls hclust}-object.")
    }
    hmBin <- HeatmapAnnotation(
        df = data.frame(bin = factor(colnames(x),
                                     levels = colnames(x))),
        name = "bin",
        col = list(bin = bincols),
        show_annotation_name = FALSE,
        which = "column", width = unit(width,"inch"),
        annotation_height = unit(width / 16, "inch"),
        show_legend = show_bin_legend)
    tmp <- matrix(if (!is.null(highlight)) {
        as.character(highlight)
    } else {
        rep(NA, nrow(x))
    },
    ncol = 1, dimnames = list(unname(rowData(x)$motif.name), NULL))
    hmSeqlogo <- NULL
    if (show_seqlogo) {
        pfms <- rowData(x)$motif.pfm
        maxwidth <- max(vapply(TFBSTools::Matrix(pfms), ncol, 0L))
        grobL <- lapply(pfms, seqLogoGrob, xmax = maxwidth, xjust = "center")
        hmSeqlogo <- HeatmapAnnotation(
            logo = annoSeqlogo(grobL = grobL, which = "row",
                               space = unit(0.5, "mm"),
                               width = unit(width.seqlogo, "inch")),
            show_legend = FALSE, show_annotation_name = FALSE, which = "row")
    }
    hmMotifs <- Heatmap(
        matrix = tmp, name = "names",
        width = unit(if (!is.null(highlight)) .2 else 0, "inch"),
        na_col = NA, col = c("TRUE" = "green3", "FALSE" = "white"),
        cluster_rows = clres, show_row_dend = show_dendrogram,
        cluster_columns = FALSE, show_row_names = TRUE,
        row_names_side = "left", show_column_names = FALSE,
        show_heatmap_legend = FALSE, left_annotation = hmSeqlogo,
        ...
    )

    assayNameMap1 <- c(negLog10P = "P value",
                       negLog10Padj = "adj. P value",
                       pearsonResid = "Pearson residual",
                       log2enr = "log2 enrichment")
    assayNameMap2 <- c(negLog10P = "P value (-log10)",
                       negLog10Padj = "adj. P value (-log10)",
                       pearsonResid = "Pearson residual (o-e)/sqrt(e)",
                       log2enr = "enrichment (log2)")
    L <- list(labels = hmMotifs)
    if (show_motif_GC) {
        tmp <- as.matrix(rowData(x)[, "motif.percentGC", drop = FALSE])
        hmPercentGC <- Heatmap(
            matrix = tmp, name = "Percent G+C",
            width = unit(0.2, "inch"), na_col = NA,
            col = colorRamp2(breaks = c(0, seq(20, 80, length.out = 254), 100),
                             colors = colorRampPalette(col.gc)(256)),
            cluster_rows = FALSE, cluster_columns = FALSE,
            show_row_names = FALSE, show_column_names = FALSE,
            show_heatmap_legend = TRUE,
            heatmap_legend_param = list(color_bar = "continuous"),
            use_raster = use_raster,
            ...
        )
        L <- c(L, list("percentGC" = hmPercentGC))
    }
    ret <- c(L, lapply(which.plots, function(w) {
        dat <- assay(x, w)
        if ((w == "pearsonResid") | (w == "log2enr")) {
            rng <- c(-1, 1) * if (is.null(maxEnr)) {
                quantile(abs(dat), .995, na.rm = TRUE)
            } else {
                maxEnr
            }
            cols <- col.enr
        } else {
            rng <- c(0,
                     if (is.null(maxSig)) {
                         quantile(dat, .995, na.rm = TRUE)
                     } else {
                         maxSig
                     })
            cols <- col.sig
        }
        Heatmap(
            matrix = dat,
            name = assayNameMap1[w],
            width = unit(width,"inch"),
            column_title = assayNameMap2[w],
            col = colorRamp2(breaks = seq(rng[1], rng[2], length.out = 256),
                             colors = colorRampPalette(cols)(256)),
            cluster_rows = FALSE, cluster_columns = FALSE,
            show_row_names = FALSE, show_column_names = FALSE,
            # column_names_side = "bottom",
            # column_names_max_height = unit(1.5,"inch"),
            top_annotation = hmBin, show_heatmap_legend = TRUE,
            heatmap_legend_param = list(color_bar = "continuous"),
            use_raster = use_raster,
            na_col = na_col,
            ...
        )
    }))
    names(ret)[seq(length(ret) - length(which.plots) + 1L, length(ret))] <-
        which.plots
    if (doPlot) {
        show(Reduce(ComplexHeatmap::add_heatmap, ret))
    }
    invisible(ret)
}


#' @title Plot Stability Paths
#'
#' @description Plot the stability paths of each variable (predictor),
#'   showing the selection probability as a function of the regularization step.
#'
#' @param se The \code{SummarizedExperiment} object resulting from stability
#'   selection, by running \code{\link[monaLisa]{randLassoStabSel}}.
#' @param selProbMin A numerical scalar in [0,1]. Predictors with a selection
#'   probability greater than \code{selProbMin} are shown as colored lines. The
#'   color is defined by the \code{col} argument.
#' @param selColor Color for the selected predictors which have a selection
#'    probability greater than \code{selProbMin}.
#' @param notSelColor Color for the rest of the (un-selected) predictors.
#' @param selProbCutoffColor Color for the line depicting the selection
#'    probability cutoff.
#' @param linewidth Line width.
#' @param alpha Line transparency of the stability paths.
#' @param ylim Limits for y-axis.
#' @param labelPaths If \code{TRUE}, the predictor labels will be shown at the
#'    end of the stability paths. The predictor labels given in \code{labels}
#'    will be shown. If unspecified, the labels corresponding to the selected
#'    predictors will be added. If predictors have the same y-value in the last
#'    regularization step, the labels will be shown in a random order. One
#'    needs to use \code{set.seed} to reproduce the plot in this case.
#' @param labels If \code{labelPaths = TRUE}, the predictors which should be
#'    labelled. If \code{NULL}, the selected predictors greater than
#'    \code{metadata(se)$stabsel.params.cutoff} will be shown.
#' @param labelNudgeX If \code{labelPaths = TRUE}, how much to nudge the labels
#'    to the right of the x-axis.
#' @param labelSize If \code{labelPaths = TRUE}, the size of the labels.
#'
#' @return a \code{ggplot2} object.
#'
#' @examples
#' ## create data set
#' Y <- rnorm(n = 500, mean = 2, sd = 1)
#' X <- matrix(data = NA, nrow = length(Y), ncol = 50)
#' for (i in seq_len(ncol(X))) {
#'   X[ ,i] <- runif(n = 500, min = 0, max = 3)
#' }
#' s_cols <- sample(x = seq_len(ncol(X)), size = 10,
#'   replace = FALSE)
#' for (i in seq_along(s_cols)) {
#'   X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
#' }
#'
#' ## reproducible randLassoStabSel() with 1 core
#' set.seed(123)
#' ss <- randLassoStabSel(x = X, y = Y)
#' plotStabilityPaths(ss)
#'
#' @seealso \code{\link[stabs]{stabsel}}
#'
#' @importFrom SummarizedExperiment assay rowData colData
#' @importFrom ggplot2 ggplot aes geom_line scale_color_manual geom_segment labs
#'     scale_y_continuous scale_x_continuous guides guide_legend element_blank
#'     theme_classic theme
#' @importFrom tidyr pivot_longer starts_with
#' @importFrom cli cli_abort
#' @importFrom rlang .data
#'
#' @export
plotStabilityPaths <- function(se,
                               selProbMin = metadata(se)$stabsel.params.cutoff,
                               selColor = "cadetblue",
                               notSelColor = "grey",
                               selProbCutoffColor = "firebrick",
                               linewidth = 0.5,
                               alpha = 1,
                               ylim = c(0, 1),
                               labelPaths = FALSE,
                               labels = NULL,
                               labelNudgeX = 8,
                               labelSize = 3) {
    # checks
    if (!is(se, "SummarizedExperiment")) {
        cli_abort("{.arg se} must be a {.cls SummarizedExperiment}")
    }
    .assertScalar(x = selProbMin, type = "numeric", rngIncl = c(0, 1))
    .assertColor(x = selColor, len = 1)
    .assertColor(x = notSelColor, len = 1)
    .assertColor(x = selProbCutoffColor, len = 1)
    .assertScalar(x = linewidth, type = "numeric")
    .assertScalar(x = alpha, type = "numeric", rngIncl = c(0, 1))
    .assertVector(x = ylim, type = "numeric", len = 2)
    .assertVector(x = colnames(se), type = "character", len = ncol(se))
    .assertVector(x = rownames(se), type = "character", len = nrow(se))
    .assertVector(x = colnames(colData(se)), type = "character")
    if (!any(grepl(pattern = "^regStep", x = colnames(colData(se))))) {
        cli_abort("the columns in {.code colData(se)} containing the selection
                probabilities for each regularization step {.code i} must have
                column names starting with {.emph regStep}. See
                {.fn randLassoStabSel} for more details.")
    }

    # prepare dataframe to plot
    df <- as.data.frame(colData(se))
    df$predictor <- rownames(df)
    df$selected <- df$selProb > selProbMin
    df <- tidyr::pivot_longer(df,
                              cols = tidyr::starts_with(match = "regStep"),
                              names_to = "regStep",
                              values_to = "selectionProbability")
    df$regStep <- as.integer(gsub(pattern = "regStep",
                                  replacement = "",
                                  x = df$regStep))
    df$yintercept <- selProbMin
    df$cutoff <- paste0("selProbMin = ", selProbMin)
    xAxisTicks <- round(seq(from = min(df$regStep),
                            to = max(df$regStep),
                            length.out = 5))

    # plot stability paths (returns ggplot object)
    gg <- ggplot(data = df,
           mapping = aes(x = .data$regStep, y = .data$selectionProbability)) +
        geom_line(mapping = aes(group = .data$predictor, color = .data$selected),
                  linewidth = linewidth,
                  alpha = alpha) +
        scale_color_manual(values = c("TRUE" = selColor,
                                      "FALSE" = notSelColor)) +
        geom_segment(mapping = aes(x = min(.data$regStep),
                                   xend = max(.data$regStep),
                                   y = .data$yintercept,
                                   yend = .data$yintercept,
                                   linetype = .data$cutoff),
                     color = selProbCutoffColor,
                   linewidth = linewidth) +
        labs(x = "Regularization Step",
             y = "Selection Probability") +
        scale_y_continuous(expand = c(0, 0), limits = ylim) +
        scale_x_continuous(expand = c(0, 0),
                           breaks = xAxisTicks,
                           labels = xAxisTicks) +
        guides(colour = guide_legend(override.aes = list(alpha = 1))) +
        theme_classic() +
        geom_segment(data = data.frame(x = min(df$regStep),
                                       xend = max(df$regStep), y = 0),
                     mapping = aes(x = .data$x, xend = .data$xend,
                                   y = .data$y, yend = .data$y)) +
        geom_segment(data = data.frame(x = min(df$regStep), y = ylim[1],
                                       yend = ylim[2]),
                     mapping = aes(x = .data$x, xend = .data$x,
                                   y = .data$y, yend = .data$yend)) +
        theme(axis.line = element_blank())

    if (labelPaths) {
        .assertPackagesAvailable("ggrepel")
        .assertScalar(x = labelNudgeX, type = "numeric")
        .assertScalar(x = labelSize, type = "numeric")

        if (is.null(labels)) {
            labels <- unique(df$predictor[df$selected])
        } else {
            # check that the labels are correct and exist
            .assertVector(x = labels, type = "character",
                          validValues = unique(df$predictor))
        }
        gg <- gg +
            ggrepel::geom_text_repel(data = df[(df$predictor %in% labels) &
                                                   (df$regStep == max(df$regStep)), ],
                                     aes(label = .data$predictor,
                                         color = .data$selected),
                                     max.overlaps = Inf,
                                     nudge_x = labelNudgeX, na.rm = TRUE,
                                     size = labelSize, direction = "y",
                                     hjust = 0, segment.linetype = "dotted",
                                     segment.size = 0.7, segment.curvature = -0.1,
                                     segment.angle = 20, box.padding = 0.4,
                                     segment.alpha = 0.5, vjust = 0,
                                     show.legend = FALSE)

    }
    gg
}


#' @title Plot selection probabilities of predictors
#'
#' @description This function plots the selection probabilities of predictors
#'   (for example the selected motifs), optionally multiplied with either +1 or
#'   -1 to give a sense of both the strength and the directionality of the
#'   associated effects. The directionality is estimated from the sign of the
#'   correlation coefficient between each predictor and the response vector.
#'
#' @param se The \code{SummarizedExperiment} object with the results from
#'   stability selection (typically returned by \code{\link{randLassoStabSel}}).
#' @param directional A logical scalar. If \code{TRUE}, selection probabilities
#'   are plotted with the sign of the marginal correlation between a predictor
#'   and the response.
#' @param selProbMin A numerical scalar in [0,1]. Predictors with a selection
#'   probability greater than \code{selProbMin} are considered selected and
#'   colored by the input from \code{selColor}. By default, \code{selProbMin} is
#'   extracted from the parameters stored in \code{se}.
#' @param selProbMinPlot A numerical scalar in [0,1] less than
#'   \code{selProbMin}. Predictors with a selection probability greater
#'   than \code{selProbMinPlot} but less than \code{selProbMin} are shown as
#'   bars with color defined in \code{notSelColor}. \code{selProbMinPlot} is
#'   useful in order to include additional predictors in the barplot, that were
#'   not selected according to \code{selProbMin} but may be close to that cutoff
#'   or are simply nice to visualize alongside the selected predictors. Setting
#'   \code{selProbMinPlot = 0} will include all predictors.
#' @param showSelProbMin A logical scalar. If \code{TRUE}, the value of
#'   \code{selProbMin} is shown by a horizontal line with the color defined
#'   by \code{selProbCutoffColor}.
#' @param selColor Color for the selected predictors which have a selection
#'    probability greater than \code{selProbMin}.
#' @param notSelColor Color for the rest of the (unselected) predictors which
#'    will be show in the barplot.
#' @param selProbCutoffColor Color for the line depicting the selection
#'    probability cutoff.
#' @param method A character scalar with the correlation method to use in the
#'   calculation of predictor-response marginal correlations. One of "pearson",
#'   "kendall" or "spearman" (see \code{\link[stats]{cor}}).
#' @param ylimext A numeric scalar defining how much the y axis limits should be
#'   expanded beyond the plotted probabilities to allow for space for the
#'   bar labels. This value can be increased if the predictor names above the
#'   bars are too long and not showing in the plot.
#'
#' @details This function creates a bar plot with \code{ggplot}.
#'   Each bar corresponds to a predictor (motif) and the colors correspond to
#'   whether or not it was selected. The y-axis shows the selection
#'   probabilities (\code{directional=FALSE}) or selection probabilities with
#'   the sign of the marginal correlation to the response
#'   (\code{directional=TRUE}).
#'
#' @return a \code{ggplot2} object.
#'
#' @examples
#' ## create data set
#' set.seed(321)
#' Y <- rnorm(n = 500, mean = 2, sd = 1)
#' X <- matrix(data = NA, nrow = length(Y), ncol = 50)
#' for (i in seq_len(ncol(X))) {
#'   X[ ,i] <- runif(n = 500, min = 0, max = 3)
#' }
#' s_cols <- sample(x = seq_len(ncol(X)), size = 10,
#'   replace = FALSE)
#' for (s in s_cols) {
#'   X[ ,s] <- X[, s] + (Y + rnorm(500, 0, 4)) * ifelse(s %% 2, -1, 1)
#' }
#'
#' ## reproducible randLassoStabSel() with 1 core
#' set.seed(123)
#' ss <- randLassoStabSel(x = X, y = Y)
#' plotSelectionProb(ss)
#'
#' @importFrom SummarizedExperiment rowData assay
#' @importFrom S4Vectors metadata
#' @importFrom stats cor reorder
#' @importFrom ggplot2 ggplot aes geom_col scale_fill_manual geom_hline labs
#'     geom_text ylim element_blank theme theme_classic
#' @importFrom rlang .data
#'
#' @export
plotSelectionProb <- function(se,
                              directional = TRUE,
                              selProbMin = metadata(se)$stabsel.params.cutoff,
                              selProbMinPlot = 0.4,
                              showSelProbMin = TRUE,
                              selColor = "cadetblue",
                              notSelColor = "grey",
                              selProbCutoffColor = "firebrick",
                              method = c("pearson", "kendall", "spearman"),
                              ylimext = 0.2) {

    # checks
    .assertScalar(x = directional, type = "logical")
    .assertScalar(x = selProbMin, type = "numeric", rngIncl = c(0, 1))
    .assertScalar(x = selProbMinPlot, type = "numeric", rngIncl = c(0, 1))
    .assertScalar(x = showSelProbMin, type = "logical")
    stopifnot(exprs = {
        is(se, "SummarizedExperiment")
        selProbMin >= selProbMinPlot
    })
    .assertColor(x = selColor, len = 1)
    .assertColor(x = notSelColor, len = 1)
    .assertColor(x = selProbCutoffColor, len = 1)
    method <- match.arg(method)
    .assertScalar(x = ylimext, type = "numeric", rngIncl = c(0, Inf))

    # prepare dataframe to plot
    df <- data.frame(
      corcoef = as.vector(cor(x = SummarizedExperiment::rowData(se)$y,
                              y = SummarizedExperiment::assay(se, "x"),
                              method = method)),
      probs = se$selProb,
      predNames = colnames(se),
      selected = se$selProb > selProbMin
    )
    df$yintercept <- selProbMin
    df$cutoff <- paste0("selProbMin = ", selProbMin)

    # ... multiply prob by the sign of corcoef if directional=TRUE
    if(directional){
      df$probs <- df$probs * sign(df$corcoef)
    }

    # ... only keep abs(probs) >= selProbMinPlot
    df <- df[abs(df$probs) >= selProbMinPlot, ]
    ymin <- min(min(df$probs), 0) - ylimext*max(df$probs)
    ymax <- max(df$probs) + ylimext*max(df$probs)

    # plot (returns ggplot object)
    gg <- ggplot(data = df,
                 mapping = aes(x = stats::reorder(.data$predNames,
                                                  -.data$probs),
                               y = .data$probs)) +
      geom_col(mapping = aes(fill = .data$selected)) +
      scale_fill_manual(values = c("TRUE" = selColor, "FALSE" = notSelColor)) +
      labs(x = NULL,
           y = ifelse(
             directional,
             "Directional selection probability",
             "Selection probability"
           )) +
      ylim(c(ymin, ymax)) +
      geom_text(mapping = aes(label = .data$predNames,
                              hjust = ifelse(.data$probs >= 0, -0.1, 1.1)),
                angle = 90) +
      theme_classic() +
      theme(axis.text.x = element_blank(),
            axis.line.x = element_blank(),
            axis.ticks.x = element_blank(),
            axis.ticks.length.y  = unit(0.2, "cm"))
    if(showSelProbMin){
      gg <- gg +
        geom_hline(mapping = aes(yintercept = .data$yintercept,
                                 linetype = .data$cutoff),
                   color = selProbCutoffColor, linewidth = 1)
      if(directional & min(df$probs) <= -selProbMin){
        gg <- gg +
          geom_hline(yintercept = -selProbMin,
                     color = selProbCutoffColor,
                     linewidth = 1)
      }

    }

    gg

}

# create data

# ... binning
set.seed(1)
x <- rnorm(1000)
b1 <- bin(x, binmode = "equalN", nElements = 100)
b2 <- bin(x, binmode = "equalN", nElements = 50, minAbsX = 0.6)
se <- readRDS(system.file("extdata", "results.binned_motif_enrichment_LMRs.rds",
                          package = "monaLisa"))[1:10, 1:8]
seqs <- Biostrings::DNAStringSet(
    vapply(seq_along(x),
           function(i) paste(sample(c("A", "C", "G", "T"), 10,
                                    replace = TRUE), collapse = ""), "")
)

# ... stability selection
Y <- rnorm(n = 100, mean = 2, sd = 1)
X <- matrix(data = runif(n = 20 * 100, min = 0, max = 3), nrow = length(Y), ncol = 20)
for (i in sample(x = seq_len(ncol(X)), size = 10, replace = FALSE))
    X[ ,i] <- X[ ,i] + Y * c(1, -1)[(i %% 2) + 1]
ss <- monaLisa::randLassoStabSel(x = X, y = Y)


test_that("getColsByBin() works properly", {
    c1 <- getColsByBin(as.numeric(b1))
    c2 <- getColsByBin(b2)

    expect_length(c1, 1000L)
    expect_identical(as.vector(c1), as.vector(getColsByBin(c1)))
    expect_equal(sort(unname(table(c2))), sort(unname(table(b2))))
})


test_that("plotBinHist() runs", {
    expect_warning(plotBinHist(x = x, b = b1, legend = "topright"))
    expect_warning(plotBinHist(x = x, b = b1, legend.cex = 1.0))

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_true(ggplot2::is_ggplot(plotBinHist(x = x, b = b1)))
    expect_true(ggplot2::is_ggplot(plotBinHist(x = x, b = b1, xlab = "", ylab = "", main = "TEST")))

    dev.off()
    unlink(tf)
})


test_that("plotBinDensity() runs", {
    expect_warning(plotBinDensity(x = x, b = b1, legend = "topright"))
    expect_warning(plotBinDensity(x = x, b = b1, legend.cex = 1.0))

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_true(ggplot2::is_ggplot(plotBinDensity(x = x, b = b1)))
    expect_true(ggplot2::is_ggplot(plotBinDensity(x = x, b = b1, xlab = "", ylab = "", main = "TEST")))

    dev.off()
    unlink(tf)
})

test_that("plotBinDiagnostics() runs", {
    expect_error(plotBinDiagnostics(seqs = seqs, bins = b1[1:3]))

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_true(ggplot2::is_ggplot(
        plotBinDiagnostics(seqs = seqs, bins = b1, aspect = "length")))
    expect_true(ggplot2::is_ggplot(
        plotBinDiagnostics(seqs = seqs, bins = b1, aspect = "GCfrac")))
    expect_s4_class(
        plotBinDiagnostics(seqs = seqs, bins = b1, aspect = "dinucfreq"),
        "Heatmap")

    dev.off()
    unlink(tf)

    expect_error(plotBinDiagnostics(seqs = x, bins = b1))
    expect_error(plotBinDiagnostics(seqs = seqs, bins = as.numeric(b1)))
    expect_error(plotBinDiagnostics(seqs = seqs, bins = as.character(b1)))
    expect_error(plotBinDiagnostics(seqs = seqs, bins = b1, aspect = "missing"))
})

test_that("plotBinScatter() runs", {
    expect_warning(plotBinScatter(x = x, y = x, b = b1, cols = "red",
                                  legendPosition = "right"))
    expect_warning(plotBinScatter(x = x, y = x, b = b1, legend = "topright"))
    expect_warning(plotBinScatter(x = x, y = x, b = b1, legend.cex = 1.0))

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_true(ggplot2::is_ggplot(plotBinScatter(x = x, y = x, b = b1)))
    expect_true(ggplot2::is_ggplot(plotBinScatter(x = x, y = x, b = b1, xlab = "", ylab = "", main = "TEST")))
    expect_true(ggplot2::is_ggplot(plotBinScatter(x = x, y = x, b = b1,
                                                  cols = "gray",
                                                  legendPosition = "none")))

    dev.off()
    unlink(tf)
})


test_that("plotMotifHeatmaps() runs", {
    expect_error(plotMotifHeatmaps(x = se, cluster = "error"))

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_type(plotMotifHeatmaps(x = se, which.plots = "pearsonResid", cluster = FALSE, show_motif_GC = TRUE), "list")
    expect_type(plotMotifHeatmaps(x = se, which.plots = "negLog10Padj", cluster = TRUE, show_seqlogo = TRUE), "list")
    cl <- hclust(dist(SummarizedExperiment::assay(se, "log2enr")))
    expect_type(plotMotifHeatmaps(x = se, which.plots = "log2enr", cluster = cl, show_dendrogram = TRUE), "list")

    se2 <- se
    tmp <- SummarizedExperiment::assay(se2, "pearsonResid")
    tmp[1:2, ] <- NA
    SummarizedExperiment::assay(se2, "pearsonResid") <- tmp
    expect_warning(res <- plotMotifHeatmaps(x = se2, which.plots = "log2enr", cluster = TRUE))
    expect_type(res, "list")

    expect_error(plotMotifHeatmaps(x = se, show_bin_legend = "error"))

    result_true <- plotMotifHeatmaps(x = se, which.plots = "pearsonResid",
                                     show_bin_legend = TRUE, doPlot = FALSE,
                                     highlight = rep(c(TRUE, FALSE), c(3, 7)))
    expect_true(result_true$pearsonResid@top_annotation@anno_list$bin@show_legend)

    result_false <- plotMotifHeatmaps(x = se, which.plots = c("pearsonResid", "negLog10P"),
                                      show_bin_legend = FALSE, doPlot = FALSE,
                                      maxEnr = 4, maxSig = 8)
    expect_false(result_false$pearsonResid@top_annotation@anno_list$bin@show_legend)

    dev.off()
    unlink(tf)
})


test_that("plotStabilityPaths() runs", {
    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)
    expect_error(plotStabilityPaths("error"))
    expect_true(ggplot2::is_ggplot(plotStabilityPaths(ss)))
    dev.off()
    unlink(tf)

    # with labels
    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)
    expect_true(ggplot2::is_ggplot(plotStabilityPaths(ss, labelPaths = TRUE)))
    dev.off()
    unlink(tf)

    # with predefined labels
    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)
    expect_true(ggplot2::is_ggplot(plotStabilityPaths(ss, labelPaths = TRUE, labels = c("pred1", "pred2"))))
    dev.off()
    unlink(tf)

    # catch invalid input
    sstmp <- ss
    rsidx <- grep("regStep", colnames(colData(sstmp)))
    colnames(SummarizedExperiment::colData(sstmp))[rsidx] <-
        paste0("abc_", colnames(SummarizedExperiment::colData(sstmp))[rsidx])
    expect_error(plotStabilityPaths(sstmp), "the columns in")

    sstmp <- ss
    rownames(SummarizedExperiment::colData(sstmp)) <- NULL
    expect_error(plotStabilityPaths(sstmp), "must not be")
})


test_that("plotSelectionProb() runs", {
    tf <- tempfile(fileext = ".pdf")

    pdf(file = tf)

    expect_error(plotSelectionProb(se = "error", selProbMin = 0.5))
    expect_error(plotSelectionProb(se = ss, directional = "error"), "logical")
    expect_error(plotSelectionProb(se = ss, directional = TRUE, selProbMin = 2.0), "between")
    expect_error(plotSelectionProb(se = ss, selProbMinPlot = "error"), "numeric")
    expect_error(plotSelectionProb(se = ss, selProbMin = 0.5, selProbMinPlot = 0.6))
    expect_error(plotSelectionProb(se = ss, showSelProbMin = "error"), "logical")
    expect_error(plotSelectionProb(se = ss, selColor = "error"))
    expect_error(plotSelectionProb(se = ss, method = "error"), "should be one of")
    expect_true(ggplot2::is_ggplot(plotSelectionProb(ss)))

    dev.off()
    unlink(tf)
})

library(hexSticker)

imgurl <- "monaLisa_logo_v1_transparent.png"
colr_pname <- "#5e6769"
colr_border <- "#df663e"
colr_fill <- "#fce2d9"

for (frmt in c("png", "pdf")) {
    stk <- sticker(subplot = imgurl, s_x = 1, s_y = 0.9, ## subplot name, location
                   s_width = 0.85, asp = 320/400, ## subplot width, aspect ratio
                   package = "monaLisa", p_x = 1, p_y = 1.55, p_color = colr_pname, ## package name, location, color
                   p_family = "Aller_Lt", p_size = 7.2, ## package font, size
                   h_fill = colr_fill, h_color = colr_border, h_size = 1.8, ## color to fill hexagon, hexagon border color, border width
                   spotlight = TRUE, l_x = 1, l_y = 1.4, ## spotlight position
                   filename = paste0("../../man/figures/monaLisa.", frmt),
                   url = "www.bioconductor.org")
    stk <- stk + geom_url("Image credit: http://vectorish.com/lisa-simpson.html",
                          x = 1, y = 0.45, color = "grey", 
                          family = "Aller_Rg", size = 0.75, angle = 0, hjust = 0.8)
    save_sticker(paste0("../../man/figures/monaLisa.", frmt), stk, dpi = 300)
}

.binomEnrichmentTest <- function(matchCountBg, totalWeightBg, matchCountFg,
                                 totalWeightFg, verbose) {
    .assertVector(matchCountBg, type = "numeric")
    .assertScalar(totalWeightBg, type = "numeric")
    .assertVector(matchCountFg, type = "numeric")
    .assertScalar(totalWeightFg, type = "numeric")
    .assertScalar(verbose, type = "logical")

    .message("using binomial test to calculate log(p-values) for enrichments")

    prob <- matchCountBg / totalWeightBg
    minProb <- 1 / totalWeightBg
    maxProb <- (totalWeightBg - 1) / totalWeightBg
    if (any(i <- (prob < minProb))) {
        prob[i] <- minProb
    }
    if (any(i <- (prob > maxProb))) {
        prob[i] <- maxProb
    }

    pbinom(q = matchCountFg - 1,
           size = totalWeightFg,
           prob = prob, lower.tail = FALSE, log.p = TRUE)
}

.fisherEnrichmentTest <- function(matchCountBg, totalWeightBg, matchCountFg,
                                  totalWeightFg, verbose) {
    .assertVector(matchCountBg, type = "numeric")
    .assertScalar(totalWeightBg, type = "numeric")
    .assertVector(matchCountFg, type = "numeric")
    .assertScalar(totalWeightFg, type = "numeric")
    .assertScalar(verbose, type = "logical")

    .message("using Fisher's exact test (one-sided) to calculate log(p-values) for enrichments")

    # contingency table per sequence for Fisher's exact test
    # (rounded to integer):
    #              withHit  noHit
    #   foreground    x       y
    #   background    z       w
    #
    logP <- log(vapply(structure(seq_along(matchCountFg),
                                 names = names(matchCountFg)),
                       function(i) {
                           ctab <- rbind(c(matchCountFg[i],
                                           totalWeightFg - matchCountFg[i]),
                                         c(matchCountBg[i],
                                           totalWeightBg - matchCountBg[i]))
                           ctab <- round(ctab)
                           fisher.test(x = ctab,
                                       alternative = "greater")$p.value
                       }, FUN.VALUE = numeric(1)))
}

.calcPearsonResiduals <- function(matchCountBg, totalWeightBg, matchCountFg,
                                  totalWeightFg) {
    .assertVector(matchCountBg, type = "numeric")
    .assertScalar(totalWeightBg, type = "numeric")
    .assertVector(matchCountFg, type = "numeric")
    .assertScalar(totalWeightFg, type = "numeric")

    obsTF <- matchCountFg
    expTF <- totalWeightFg * (matchCountFg + matchCountBg) /
        (totalWeightFg + totalWeightBg)
    N <- totalWeightFg + totalWeightBg
    enr <- (obsTF - expTF) / sqrt(expTF * (1 - totalWeightFg / N) *
                                      (1 - (matchCountFg +
                                                matchCountBg) / N))
    enr[is.na(enr)] <- 0
    enr
}

.calcExpFg <- function(matchCountBg, totalWeightBg, matchCountFg,
                       totalWeightFg) {
    .assertVector(matchCountBg, type = "numeric")
    .assertScalar(totalWeightBg, type = "numeric")
    .assertVector(matchCountFg, type = "numeric")
    .assertScalar(totalWeightFg, type = "numeric")

    totalWeightFg * (matchCountFg + matchCountBg) /
        (totalWeightFg + totalWeightBg)
}

.calcLog2Enr <- function(matchCountBg, totalWeightBg, matchCountFg,
                         totalWeightFg, pseudocount) {
    .assertVector(matchCountBg, type = "numeric")
    .assertScalar(totalWeightBg, type = "numeric")
    .assertVector(matchCountFg, type = "numeric")
    .assertScalar(totalWeightFg, type = "numeric")

    minTot <- min(totalWeightFg, totalWeightBg)
    normFg <- log2(matchCountFg/totalWeightFg * minTot + pseudocount)
    normBg <- log2(matchCountBg/totalWeightBg * minTot + pseudocount)
    log2enr <- normFg - normBg
    log2enr
}

#' @title Check if seqinfo DataFrame is valid
#'
#' @description Check if the \code{DataFrame} with sequence information is 
#'   valid, i.e. is of the correct object type (\code{DataFrame}) and has all 
#'   expected columns and attributes.
#'
#' @param df Input object to be checked. It should have an attribute \code{err}
#'   and columns:
#'   \describe{
#'     \item{\code{seqs}}{: a \code{DNAStringSet} object.}
#'     \item{\code{isForeground}}{ that indicates if a sequence is in the
#'                                 foreground group.}
#'     \item{\code{GCfrac}}{: the fraction of G+C bases per sequence.}
#'     \item{\code{GCbin}}{: the GC bin for each sequence.}
#'     \item{\code{GCwgt}}{: the sequence weight to adjust for GC
#'       differences between foreground and background sequences.}
#'     \item{\code{seqWgt}}{: the sequence weight to adjust for k-mer
#'       differences between foreground and background sequences.}
#'   }
#'
#' @return \code{TRUE} (invisibly) if \code{df} is valid, otherwise it
#'   raises an exception using \code{cli::cli_abort()}
#'
#' @importFrom cli cli_abort
#'
#' @keywords internal
.checkDfValidity <- function(df) {
    expected_cols <- c("seqs", "isForeground",
                       "GCfrac", "GCbin", "GCwgt", "seqWgt")
    expected_types <- c("DNAStringSet", "logical",
                        "numeric", "numeric", "numeric", "numeric")
    expected_attrs <- c("err")

    if (!is(df, "DataFrame")) {
        cli_abort("{.arg df} should be a {.cls DataFrame}, but it is a {.cls {class(df)}}")

    } else if (!all(expected_cols %in% colnames(df))) {
        cli_abort("{.arg df} has to have columns: {expected_cols}")

    } else if (!all(unlist(lapply(seq_along(expected_cols), function(i) {
        is(df[, expected_cols[i]], expected_types[i])
    })))) {
        cli_abort(c(
            "Not all columns in {.arg df} have the expected types:",
            vapply(seq.int(length(expected_cols)),
                   \(i) paste0(expected_cols[i], ": {.cls ", expected_types[i], "}"),
                   character(1))))

    } else if (!all(expected_attrs %in% names(attributes(df)))) {
        cli_abort("{.arg df} has to have the attribute{?s}: {expected_attrs}")
    }

    return(invisible(TRUE))
}

#' @title Filter Sequences
#'
#' @description Filter sequences that are unlikely to be useful for motif
#'   enrichment analysis. The current defaults are based on HOMER
#'   (version 4.11).
#'
#' @param seqs A \code{DNAStringSet} object.
#' @param maxFracN A numeric scalar with the maximal fraction of N bases allowed
#'   in a sequence (defaults to 0.7).
#' @param minLength The minimum sequence length (default from Homer).
#'   Sequences shorter than this will be filtered out.
#' @param maxLength The maximum sequence length (default from Homer).
#'   Sequences bigger than this will be filtered out.
#' @param verbose A logical scalar. If \code{TRUE}, report on filtering.
#'
#' @details The filtering logic is based on \code{removePoorSeq.pl} from Homer.
#'
#' @return A logical vector of the same length as \code{seqs} with \code{TRUE}
#'   indicated to keep the sequence and \code{FALSE} to filter it out.
#'
#' @importFrom Biostrings alphabetFrequency DNAStringSet
#' @importFrom S4Vectors DataFrame
#' @importFrom cli cli_abort
#'
#' @keywords internal
.filterSeqs <- function(seqs, maxFracN = 0.7, minLength = 5L,
                        maxLength = 100000L, verbose = FALSE) {

    if (!is(seqs, "DNAStringSet")) {
        cli_abort("{.arg seqs} must be a {.cls DNAStringSet} object.")
    }
    .assertScalar(x = maxFracN,  type = "numeric", rngIncl = c(0, 1))
    .assertScalar(x = minLength, type = "numeric", rngIncl = c(0, Inf))
    .assertScalar(x = maxLength, type = "numeric",
                  rngIncl = c(max(minLength, 0), Inf))
    .assertScalar(x = verbose,   type = "logical")

    # fraction of N bases per sequence
    observedFracN <- alphabetFrequency(seqs, as.prob = TRUE)[, "N"]

    f1 <- width(seqs) > 0 & observedFracN > maxFracN
    if (sum(f1) > 0 && verbose) {
        .message(paste0(
            "  {sum(f1)} of {length(seqs)} sequences (",
            "{round(100 * sum(f1) / length(seqs), 1)}%) have too many N bases"))
    }

    f2 <- (width(seqs) < minLength) | (width(seqs) > maxLength)
    if (sum(f2) > 0 && verbose) {
        .message(paste0(
            "  {sum(f2)} of {length(seqs)} sequences (",
            "{round(100 * sum(f2) / length(seqs), 1)}%) are too short or too long"))
    }

    res <- !(f1 | f2)
    .message(paste0(
        "  in total filtering out {sum(!res)} of {length(seqs)} sequences (",
        "{round(100 * sum(!res) / length(seqs), 1)}%)"))

    return(res)
}

#' @title Define background sequence set for a single motif enrichment
#'   calculation
#'
#' @description Define the background set for the motif enrichment calculation
#'   in a single bin, depending on the background mode and given foreground
#'   sequences.
#'
#' @param sqs,bns,bg The \code{seqs}, \code{bins} and \code{background}
#'   arguments from \code{calcBinnedMotifEnrR}.
#' @param currbn An \code{integer} scalar with the current bin defining the
#'   foreground sequences.
#' @param gnm,gnm.regions,gnm.oversample The \code{genome},
#'   \code{genome.regions} and \code{genome.oversample} arguments from
#'   \code{calcBinnedMotifEnrR}.
#' @param maxFracN The \code{maxFracN} argument from \code{calcBinnedMotifEnrR}.
#' @param GCbreaks The breaks between GC bins. The default value is based on
#'   the hard-coded bins used in Homer.
#'
#' @return A \code{DataFrame} with sequences represented by rows and columns
#'   \code{seqs}, \code{isForeground}, \code{GCfrac}, \code{GCbin}, \code{GCwgt}
#'   and \code{seqWgt}. Only the first three are already filled in.
#'
#' @importFrom Biostrings oligonucleotideFrequency DNAStringSet
#' @importFrom S4Vectors DataFrame
#' @importFrom BSgenome getSeq
#' @importFrom Seqinfo seqlengths seqnames
#' @importFrom BiocGenerics width
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom stats quantile
#'
#' @keywords internal
.defineBackground <- function(sqs,
                              bns,
                              bg,
                              currbn,
                              gnm,
                              gnm.regions,
                              gnm.oversample,
                              maxFracN = 0.7,
                              GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4,
                                           0.45, 0.5, 0.6, 0.7, 0.8)) {

    # calculate G+C frequencies of input sequences
    fmono <- oligonucleotideFrequency(sqs, width = 1, as.prob = TRUE)
    gcf <- fmono[, "G"] + fmono[, "C"]

    inCurrBin <- as.integer(bns) == currbn

    if (identical(bg, "genome")) {

        # (over-)sample random sequences from the genome
        n <- round(gnm.oversample * sum(inCurrBin))
        w <- width(sqs)[inCurrBin]
        mw <- mean(w)
        if (is.null(gnm.regions)) {
            slen <- seqlengths(gnm)
            gnm.regions <- GRanges(seqnames = names(slen),
                                   ranges = IRanges(start = 1, end = slen))
        }
        gnm.regions.width <- width(gnm.regions)
        gnmsqs <- DNAStringSet()

        iter <- 0
        while (length(gnmsqs) < n && iter < 10) {
            # sample coordinates
            n1 <- n - length(gnmsqs)
            ridx <- sort(sample(
                x = length(gnm.regions), size = n1,
                replace = TRUE,
                prob = pmax(0, gnm.regions.width - mean(w) + 1)),
                decreasing = FALSE)
            rw <- sample(x = w, size = n1, replace = TRUE)
            rst <- start(gnm.regions)[ridx] +
                unlist(lapply(pmax(gnm.regions.width[ridx] - rw, 0),
                              function(w1) sample(x = w1, size = 1)))
            reg <- GRanges(seqnames = seqnames(gnm.regions)[ridx],
                           ranges = IRanges(start = rst,
                                            end = pmin(rst + rw - 1,
                                                       end(gnm.regions)[ridx])),
                           seqlengths = seqlengths(gnm))

            # extract sequences
            s <- getSeq(gnm, reg)

            # filter sequences
            keep <- .filterSeqs(seqs = s, maxFracN = maxFracN)

            # add to already sampled sequences
            gnmsqs <- c(gnmsqs, s[keep])

            iter <- iter + 1
        }
        names(gnmsqs) <- paste0("g", seq_along(gnmsqs))

        # calculate G+C composition of sampled sequences
        fmono.gnm <- oligonucleotideFrequency(gnmsqs, width = 1, as.prob = TRUE)
        gcf.gnm <- fmono.gnm[, "G"] + fmono.gnm[, "C"]

        # select a set that matches sqs[inCurrBin]
        sqs.gcbin <- findInterval(x = gcf[inCurrBin],
                                  vec = GCbreaks, all.inside = TRUE)
        gnm.gcbin <- findInterval(x = gcf.gnm,
                                  vec = GCbreaks, all.inside = TRUE)
        sqs.tab <- tabulate(sqs.gcbin,
                            nbins = length(GCbreaks) - 1) / length(sqs.gcbin)
        gnm.tab <- tabulate(gnm.gcbin,
                            nbins = length(GCbreaks) - 1) / length(gnm.gcbin)
        sel <- sample(x = length(gnmsqs), size = sum(inCurrBin),
                      replace = FALSE,
                      prob = ((sqs.tab + 0.5) / (gnm.tab + 0.5))[gnm.gcbin])

        gnm.tab.sel <- tabulate(gnm.gcbin[sel],
                                nbins = length(GCbreaks) - 1) / length(sel)
        gcdist <- sqrt(sum((sqs.tab - gnm.tab.sel)^2))
        if (gcdist > (3 / (length(GCbreaks) - 1))) {
            warning(
                "The background sequences sampled from 'genome' do not match ",
                "well\nthe G+C content of 'seqs' (normdist = ",
                round(gcdist, 3), ").\n\n",
                "Consider increasing 'genome.oversample', and/or focus the ",
                "sampling on a subset\nwith similar sequence composition as ",
                "'seqs' using 'genome.regions'.\n\n",
                "It may also be useful to split 'seqs' into subsets with ",
                "homogenous G+C\n(e.g. with/without CpG islands) and use ",
                "an appropriate 'genome' for them\n(e.g. all CpG islands and ",
                "the rest of the genome, respectively)."
            )
        }

        isFg <- rep(c(TRUE, FALSE), each = sum(inCurrBin))
        sqs <- c(sqs[inCurrBin], gnmsqs[sel])
        gcf <- c(gcf[inCurrBin], gcf.gnm[sel])

    } else {

        if (identical(bg, "otherBins")) {
            isFg <- inCurrBin

        } else if (identical(bg, "allBins")) {
            isFg <- rep(c(TRUE, FALSE),
                        c(sum(inCurrBin), length(sqs)))
            sqs <- c(sqs[inCurrBin], sqs)
            gcf <- c(gcf[inCurrBin], gcf)

        } else if (identical(bg, "zeroBin")) {
            inZeroBin <- as.integer(bns) == getZeroBin(bns)
            isFg <- rep(c(TRUE, FALSE),
                        c(sum(inCurrBin), sum(inZeroBin)))
            sqs <- c(sqs[inCurrBin], sqs[inZeroBin])
            gcf <- c(gcf[inCurrBin], gcf[inZeroBin])
        }
    }

    # create sequence DataFrame
    df <- DataFrame(seqs = sqs,
                    isForeground = isFg,
                    GCfrac = gcf,
                    GCbin = rep(NA_integer_, length(sqs)),
                    GCwgt = rep(NA_real_, length(sqs)),
                    seqWgt = rep(NA_real_, length(sqs)))
    attr(df, "err") <- NA

    # return DataFrame
    return(df)
}

#' @title Get background sequence weights for GC bins
#'
#' @description The logic is based on Homer (version 4.11). All sequences
#'   binned depending on GC content (\code{GCbreaks}). The numbers of
#'   foreground and background sequences in each bin are counted, and weights
#'   for background sequences in bin i are defined as:
#'   weight_i = (number_fg_seqs_i / number_bg_seqs_i) * (number_bg_seqs_total /
#'   number_fg_seqs_total)
#'
#' @param df A \code{DataFrame} with sequence information.
#' @param GCbreaks The breaks between GC bins. The default value is based on
#'   the hard-coded bins used in Homer.
#' @param verbose A logical scalar. If \code{TRUE}, report on GC weight
#'   calculation.
#'
#' @return A \code{DataFrame} of the same dimensions as the input \code{df},
#'   with the columns \code{GCfrac}, \code{GCbin} and \code{GCwgt}
#'   filled in with the sequence GC content, assigned GC bins and weights to
#'   correct differences in GC distributions between foreground and background
#'   sequences.
#'
#' @importFrom BiocGenerics width
#' @importFrom stats median
#' @importFrom Biostrings oligonucleotideFrequency DNAStringSet
#' @importFrom S4Vectors DataFrame
#' @importFrom cli cli_abort
#'
#' @keywords internal
.calculateGCweight <- function(df,
                               GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4,
                                            0.45, 0.5, 0.6, 0.7, 0.8),
                               verbose = FALSE) {

    .checkDfValidity(df)
    GCbreaks <- sort(GCbreaks, decreasing = FALSE)
    .assertVector(x = GCbreaks, type = "numeric", rngIncl = c(0, 1))
    if (length(GCbreaks) < 2) {
        cli_abort("{.arg GCbreaks} must be of length 2 or greater")
    }
    .assertScalar(x = verbose,   type = "logical")

    # calculate G+C frequencies
    if (any(is.na(df$GCfrac))) {
        fmono <- oligonucleotideFrequency(df$seqs, width = 1, as.prob = TRUE)
        df$GCfrac <- fmono[, "G"] + fmono[, "C"]
    }

    # assign sequences to a GC bin
    df$GCbin <- findInterval(x = df$GCfrac, vec = GCbreaks, all.inside = TRUE)

    # keep bins that have at least 1 foreground and 1 background sequence
    # and filter out sequences from unused bins
    used_bins <- sort(intersect(df$GCbin[df$isForeground],
                                df$GCbin[!df$isForeground]))
    keep <- df$GCbin %in% used_bins
    .message(paste0(
        "  {length(used_bins)} of {length(GCbreaks) - 1} GC-bins used (",
        "have both fore- and background sequences)\n",
        "  {sum(!keep)} of {nrow(df)} sequences ({round(100 * sum(!keep) / nrow(df), 1)}%) ",
        "filtered out from unused GC-bins."))
    df <- df[keep, ]

    # total number of foreground and background sequences
    total_fg <- sum(df$isForeground)
    total_bg <- sum(!df$isForeground)

    # calculate GC weight per bin
    n_fg_b <- table(df$GCbin[df$isForeground])
    n_bg_b <- table(df$GCbin[!df$isForeground])
    weight_per_bin <- (n_fg_b / n_bg_b) * (total_bg / total_fg)

    # assign calculated GC weight to each background sequence
    # (foreground sequences get a weight of 1)
    df$GCwgt <- ifelse(df$isForeground,
                       1.0,
                       weight_per_bin[as.character(df$GCbin)])

    # return df
    return(df)
}

#' @title Adjust for k-mer composition (single iteration)
#'
#' @description Adjust background sequence weights for differences in k-mer
#'   composition compared to the foreground sequences. This function
#'   implements a single iteration, and is called iteratively by
#'   \code{.iterativeNormForKmers} to get to the final set of adjusted
#'   weights, which will be the result of adjusting for GC and k-mer
#'   composition. The logic is based on Homer's
#'   \code{normalizeSequenceIteration()} function found in \code{Motif2.cpp}.
#'
#' @param kmerFreq A \code{list} with of matrices. The matrix at index \code{i}
#'   in the list contains the probability of k-mers of length \code{i}, for each
#'   k-mer (columns) and sequence (rows).
#' @param goodKmers A \code{list} of \code{numeric} vectors; the element at
#'   index \code{i} contains the number of good (non-N-containing) k-mers of
#'   length \code{i} for each sequence.
#' @param kmerRC A \code{list} of character vectors; the element at index
#'   \code{i} contains the reverse complement sequences of all k-mers of length
#'   \code{i}.
#' @param seqWgt A \code{numeric} vector with starting sequence weights
#'   at the beginning of the iteration.
#' @param isForeground Logical vector of the same length as \code{seqs}.
#'   \code{TRUE} indicates that the sequence is from the foreground,
#'   \code{FALSE} that it is a background sequence.
#' @param minSeqWgt Numeric scalar greater than zero giving the
#'   minimal weight of a sequence. The default value (0.001) is based on
#'   \code{Homer} (HOMER_MINIMUM_SEQ_WEIGHT constant in Motif2.h).
#' @param maxSeqWgt Numeric scalar greater than zero giving the
#'   maximal weight of a sequence. The default value (1000) is based on
#'   \code{HOMER} (1 / HOMER_MINIMUM_SEQ_WEIGHT constant in Motif2.h).
#'
#' @return A named \code{list} with elements \code{seqWgt} (updated
#'   weights) and \code{err} (error measuring difference of foreground
#'   and weighted background sequence compositions).
#'
#' @keywords internal
.normForKmers <- function(kmerFreq,
                          goodKmers,
                          kmerRC,
                          seqWgt,
                          isForeground,
                          minSeqWgt = 0.001,
                          maxSeqWgt = 1000) {

    # set starting error
    err <- 0

    # iterate over the k-mer sizes
    for (k in seq_along(kmerFreq)) {

        # sum k-mer weights for fore- and background sequences
        kmerWgtPerSeq <- kmerFreq[[k]] * seqWgt
        kmerWgtSumForeground <- colSums(kmerWgtPerSeq[isForeground, ])
        kmerWgtSumBackground <- colSums(kmerWgtPerSeq[!isForeground, ])

        totalWgtForeground <- sum(kmerWgtSumForeground)
        totalWgtBackground <- sum(kmerWgtSumBackground)

        # average weight of a k-mer and its reverse complement
        # (cap at the bottom at 0.5 / total)
        kmerWgtSumForeground <- pmax(
            (kmerWgtSumForeground + kmerWgtSumForeground[kmerRC[[k]]]) / 2,
            0.5 / totalWgtForeground
        )
        kmerWgtSumBackground <- pmax(
            (kmerWgtSumBackground + kmerWgtSumBackground[kmerRC[[k]]]) / 2,
            0.5 / totalWgtBackground
        )


        # Calculate kmerNormFactors
        kmerNormFactors <- (kmerWgtSumForeground / kmerWgtSumBackground) *
            (totalWgtBackground / totalWgtForeground)

        # update error
        err <- err + mean((kmerNormFactors - 1)^2)

        # calculate new weights for background sequences
        # ... sum the kmerNormFactors of all k-mers per background sequence
        newSeqWgtBackground <- rowSums(
            sweep(x = kmerFreq[[k]][!isForeground, ],
                  MARGIN = 2, STATS = kmerNormFactors, FUN = "*")
        )

        # ... new weight for each background sequence
        seqWgtBackground <- seqWgt[!isForeground]
        newSeqWgtBackground <- newSeqWgtBackground * seqWgtBackground

        # ... apply minimum and maximum weights
        newSeqWgtBackground[newSeqWgtBackground < minSeqWgt] <- minSeqWgt
        newSeqWgtBackground[newSeqWgtBackground > maxSeqWgt] <- maxSeqWgt

        # ... calculate correction
        penalityBackground <- (ifelse(newSeqWgtBackground > 1,
                                      newSeqWgtBackground,
                                      1 / newSeqWgtBackground))^2
        diffBackground <-  newSeqWgtBackground - seqWgtBackground

        toCorrect <- penalityBackground > 1 &
            ((diffBackground > 0 & newSeqWgtBackground > 1) |
                 (diffBackground < 0 & newSeqWgtBackground < 1))
        newSeqWgtBackground[toCorrect] <- seqWgtBackground[toCorrect] +
            diffBackground[toCorrect] / penalityBackground[toCorrect]

        # update seqWgt with newSeqWgtBackground
        seqWgt[!isForeground] <- newSeqWgtBackground
    }

    # return new seqWgt and error
    list(seqWgt = seqWgt, err = err)
}

#' @title Adjust for k-mer composition (multiple iterations)
#'
#' @description Here we run `.normForKmers` multiple times to converge to
#'   the final weights that will be used to correct the background
#'   sequences for k-mer composition differences compared to the foreground. We
#'   closely follow \code{HOMER}'s \code{normalizeSequence()} function found in
#'   \code{Motif2.cpp}. Note that \code{HOMER} runs the
#'   \code{normalizeSequence()} one last time after going through all iterations
#'   or reaching a low error, which we do not do here.
#'
#' @param df A \code{DataFrame} with sequence information as returned by
#'   \code{.calculateGCweight}.
#' @param maxKmerSize Integer scalar giving the maximum k-mer size to
#'   consider. The default is set to 3 (like in \code{HOMER}), meaning that
#'   k-mers of size 1, 2 and 3 are considered.
#' @param minSeqWgt Numeric scalar greater than zero giving the
#'   minimal weight of a sequence. The default value (0.001) was also used by
#'   \code{HOMER} (HOMER_MINIMUM_SEQ_WEIGHT  constant in Motif2.h).
#' @param maxIter An integer scalar giving the maximum number if
#'   times to run \code{.normForKmers}. the default is set to 160 (as in
#'   \code{HOMER}).
#' @param verbose A logical scalar. If \code{TRUE}, report on k-mer composition
#'   adjustment.
#'
#' @return A \code{DataFrame} containing: \describe{ \item{sequenceWeights}{: a
#'   \code{dataframe} containing the sequence GC content, GC bins they were
#'   assigned to, the weight to correct for GC differences between foreGround
#'   and background sequences, the weight to adjust for kmer composition, and
#'   the the error term} \item{sequenceNucleotides}{: a \code{DNAStringSet}
#'   object containing the raw sequences} }
#'
#' @importFrom Biostrings oligonucleotideFrequency reverseComplement
#'   DNAStringSet
#' @importFrom S4Vectors DataFrame
#'
#' @keywords internal
.iterativeNormForKmers <- function(df,
                                   maxKmerSize = 3L,
                                   minSeqWgt = 0.001,
                                   maxIter = 160L,
                                   verbose = FALSE) {

    .checkDfValidity(df)
    .assertScalar(x = maxKmerSize, type = "integer", rngIncl = c(1, Inf))
    .assertScalar(x = minSeqWgt, type = "numeric", rngExcl = c(0, Inf))
    .assertScalar(x = maxIter, type = "integer", rngExcl = c(0, Inf))
    .assertScalar(x = verbose, type = "logical")

    # initialize seqWgt using GCwgt
    lastErr <- Inf
    curWgt <- df$GCwgt

    # pre-calculate k-mer frequencies used in iterations
    kmerFreq <- goodKmers <- kmerRC <- list()
    for (k in seq_len(maxKmerSize)) {
        kmerFreq[[k]] <- oligonucleotideFrequency(x = df$seqs, width = k)
        goodKmers[[k]] <- rowSums(kmerFreq[[k]])
        kmerFreq[[k]] <- kmerFreq[[k]] / goodKmers[[k]]
        kmers <- DNAStringSet(colnames(kmerFreq[[k]]))
        kmerRC[[k]] <- as.character(reverseComplement(x = kmers))
    }

    # run .normForKmers() up to maxIter times or
    # stop when new error is bigger than the error from the previous iteration
    .message("  starting iterative adjustment for k-mer composition (up to {maxIter} iterations)")

    res <- list()
    for (i in seq_len(maxIter)) {

        res <- .normForKmers(kmerFreq = kmerFreq,
                             goodKmers = goodKmers,
                             kmerRC = kmerRC,
                             seqWgt = curWgt,
                             isForeground = df$isForeground,
                             minSeqWgt = minSeqWgt)

        if (res$err >= lastErr) {
            .message("    detected increasing error - stopping after {i} iterations")
            break
        } else {
            if (verbose && (i %% 40 == 0)) {
                .message("    {i} of {maxIter} iterations done")
            }
            curWgt <- res$seqWgt
            lastErr <- res$err
        }
    }
    .message("    iterations finished", noTimer = TRUE)

    # return final weights
    df$seqWgt <- curWgt
    attr(df, "err") <- lastErr
    return(df)
}

#' @title Check if elements of `x` are have equal lengths
#'
#' @description Check if the elements of `x` are all equally long.
#'   If not, generate a warning.
#'
#' @param x An object that implements a \code{width} method, typically a
#'   \code{GRanges} or \code{DNAStringSet} object.
#'
#' @return \code{NULL} (invisibly). The function is called for its side-effect
#'   of generating a warning if elements of the input are not of equal lengths.
#'
#' @importFrom BiocGenerics width
#'
#' @keywords internal
.checkIfSeqsAreEqualLength <- function(x) {
    args <- lapply(sys.call()[-1], as.character)
    xname <- if ("x" %in% names(args)) args$x else "argument"
    xlen <- width(x)
    if (!identical(xlen, rep(xlen[1], length(x)))) {
        warning("Not all elements of ", xname, " have the same length.\n",
                "It is recommended to adjust lengths to be equal, in order ",
                "to have homogeneous elements in each bin.\n",
                "You can use `plotBinDiagnostics` to compare lengths or ",
                "sequence composition across bins.",
                call. = FALSE, immediate. = TRUE)
    }
    return(invisible(NULL))
}

test_that(".calcMotifEnrichment works", {
    fseq <- c(f1  = "AGGGGGGGGG", f3  = "AAAGGGGGGG", f4  = "AAAAGGGGGG",
              f6  = "AAAAAAGGGG", f8  = "AAAAAAAAGG")
    bseq <- c(b1  = "AGGGGGGGGG", b2  = "AAGGGGGGGG", b3  = "AAAGGGGGGG",
              b4  = "AAAAGGGGGG", b5  = "AAAAAGGGGG")
    df <- DataFrame(seqs = DNAStringSet(c(fseq, bseq)),
                    isForeground = rep(c(TRUE, FALSE), c(length(fseq), length(bseq))),
                    GCfrac = NA_real_,
                    GCbin = NA_integer_,
                    GCwgt = NA_real_,
                    seqWgt = NA_real_)
    attr(df, "err") <- 0
    df <- .calculateGCweight(df)
    df <- .iterativeNormForKmers(df)
    mhits <- cbind(m1 = c(1, 1, 0, 0, 0, 0, 1),
                   m2 = c(0, 0, 1, 1, 1, 1, 0),
                   m3 = c(1, 1, 1, 1, 1, 1, 1),
                   m4 = c(0, 0, 0, 0, 0, 0, 0))

    expect_error(.calcMotifEnrichment("error", df), "has to be a matrix")
    expect_error(.calcMotifEnrichment(mhits, df[1:3, ]), "same number of rows")
    mhits2 <- mhits
    rownames(mhits2) <- as.character(seq.int(nrow(mhits2)))
    expect_error(.calcMotifEnrichment(mhits2, df), "identical rownames")
    expect_error(.calcMotifEnrichment(mhits, df[1:3]), "has to have columns")
    expect_error(.calcMotifEnrichment(mhits, df, test = "error"), "should be one of")
    expect_error(.calcMotifEnrichment(mhits, df, verbose = "error"), "logical")

    suppressMessages(expect_message(
        res1 <- .calcMotifEnrichment(motifHitMatrix = mhits, df = df,
                                     test = "binom", verbose = TRUE)))
    expect_type(res1, "list")
    expect_identical(rownames(res1), colnames(mhits))
    expect_identical(round(res1$logP, 3), c(-1.341, -0.038, -0.844, 0))
    suppressMessages(expect_message(
        res2 <- .calcMotifEnrichment(motifHitMatrix = mhits, df = df,
                                     test = "fisher", verbose = TRUE)))
    expect_type(res2, "list")
    expect_identical(res1[, -2], res2[, -2])
    expect_identical(round(res2$logP, 3), c(-0.99, -0.029, 0, 0))
})


test_that("calcBinnedMotifEnrR() works (synthetic data)", {
    set.seed(1)
    len <- 50
    seqschar <- unlist(lapply(seq.int(150), function(i) {
        paste(sample(c("A","C","G","T"), len, replace = TRUE), collapse = "")
    }))
    b <- factor(rep(c(1, 2, 3), each = 50))
    b <- setZeroBin(b, NA)
    m1 <- rbind(A = c(7, 7, 7, 7, 7), # AAAAA
                C = c(1, 1, 1, 1, 1),
                G = c(1, 1, 1, 1, 1),
                T = c(1, 1, 1, 1, 1))
    m2 <- rbind(A = c(7, 1, 1, 1, 7), # ACGTA
                C = c(1, 7, 1, 1, 1),
                G = c(1, 1, 7, 1, 1),
                T = c(1, 1, 1, 7, 1))
    pfm <- TFBSTools::PFMatrixList(m1 = TFBSTools::PFMatrix(ID = "m1", name = "m1", profileMatrix = m1),
                                   m2 = TFBSTools::PFMatrix(ID = "m2", name = "m2", profileMatrix = m2))
    pwm <- TFBSTools::toPWM(pfm)
    # plant m1 in bin 1
    p1 <- sample(len - 2 * ncol(m1), round(sum(b == 1) * 0.8), replace = TRUE)
    substring(seqschar[b == 1], first = p1, last = p1 + ncol(m1) - 1) <- "AAAAA"
    # plant m2 in bin 2
    p2 <- sample(len - 2 * ncol(m2), round(sum(b == 2) * 0.8), replace = TRUE)
    substring(seqschar[b == 2], first = p2, last = p2 + ncol(m2) - 1) <- "ACGTA"
    seqs <- Biostrings::DNAStringSet(seqschar)
    gnm <- DNAStringSet(unlist(lapply(1:10,
                                      function(i) paste(sample(c("A","C","G","T"),
                                                               1000 - i * 10,
                                                               replace = TRUE),
                                                        collapse = ""))))
    names(gnm) <- paste0("g", seq_along(gnm))

    # argument checks
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm,
                                     min.score = 20), "No motif hits")
    expect_error(calcBinnedMotifEnrR(seqs = Biostrings::DNAStringSet(c("NNN","NNN","NNN")),
                                     bins = factor(1:3), pwmL = pwm), "No sequence passed")
    expect_error(calcBinnedMotifEnrR(seqs = Biostrings::DNAStringSet(c("TAAAAAAT","GCACGTAT","GCCCCCCG")),
                                     bins = factor(1:3), pwmL = pwm, min.score = 6),
                 "No sequences remained after the GC weight")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm,
                                     background = "error"),
                 "should be one of")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm,
                                     background = "zeroBin"),
                 "has to define a zero bin")
    b2 <- b
    attr(b2, "bin0") <- NULL
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b2, pwmL = pwm,
                                     background = "zeroBin"),
                 "has to define a zero bin")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = NULL, pwmL = pwm,
                                     background = "genome", genome = "error"),
                 ".genome. must be")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = NULL, pwmL = pwm,
                                     background = "genome", genome = gnm,
                                     genome.regions = "error"),
                 ".genome.regions. must be")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = NULL, pwmL = pwm,
                                     background = "genome", genome = gnm,
                                     genome.regions = GenomicRanges::GRanges("error", IRanges::IRanges(1, 10))),
                 "seqlevels not contained")
    expect_error(expect_warning(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm,
                                     background = "genome", min.score = 6,
                                     genome = DNAStringSet(c(g1 = paste(rep("G", 300), collapse = "")))),
                                "do not match well"),
                 "No motif hits found in any of the genomic background sequences")
    expect_error(calcBinnedMotifEnrR(seqs = "error"), "DNAStringSet")
    expect_error(calcBinnedMotifEnrR(seqs = as.character(seqs)), "DNAStringSet")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = "error"), "factor")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b[-1]), "must be of equal length")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = "error"), "PWMatrixList")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, maxFracN = "error"), "numeric")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, min.score = 6, maxKmerSize = "error"), "integer")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, pseudocount.log2enr = "error"))
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, pseudofreq.pearsonResid = "error"))
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, p.adjust.method = "error"))
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, BPPARAM = "error"), "BiocParallelParam")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = pwm, verbose = "error"), "logical")
    expect_error(calcBinnedMotifEnrR(seqs = seqs, bins = b, pwmL = TFBSTools::Matrix(pwm[[1]])), "PWMatrixList")

    # results correctness
    suppressMessages(
        expect_message(res1 <- calcBinnedMotifEnrR(seqs = seqs,
                                                   bins = b,
                                                   pwmL = pwm,
                                                   min.score = 6,
                                                   test = "binom",
                                                   verbose = TRUE))
    )
    attr(b, "breaks") <- c(1:4 - 0.5)
    suppressMessages(
        expect_message(res2 <- calcBinnedMotifEnrR(seqs = seqs,
                                                   bins = b,
                                                   pwmL = pwm,
                                                   min.score = 6,
                                                   test = "fisher",
                                                   verbose = TRUE))
    )
    set.seed(42L)
    suppressMessages(
        expect_message(res3 <- calcBinnedMotifEnrR(seqs = seqs,
                                                   bins = b,
                                                   pwmL = pwm,
                                                   min.score = 6,
                                                   test = "fisher",
                                                   background = "genome",
                                                   genome = gnm,
                                                   verbose = TRUE))
    )
    expect_s4_class(res1, "SummarizedExperiment")
    expect_s4_class(res2, "SummarizedExperiment")
    expect_s4_class(res3, "SummarizedExperiment")
    expect_identical(dim(res1), c(length(pwm), nlevels(b)))
    expect_identical(dim(res1), dim(res1))
    expect_identical(dimnames(res1), list(names(pwm), levels(b)))
    expect_identical(dimnames(res1), dimnames(res1))
    expect_identical(names(metadata(res1)),
                     c("bins", "bins.binmode", "bins.breaks", "bins.bin0", "param"))
    expect_identical(metadata(res1)$param$test, "binom")
    expect_identical(metadata(res2)$param$test, "fisher")
    expect_identical(metadata(res1)$param[-3], metadata(res2)$param[-3])
    expect_identical(metadata(res2)$bins, b)
    expect_identical(assayNames(res1), c("negLog10P", "negLog10Padj", "pearsonResid", "expForegroundWgtWithHits", "log2enr", "sumForegroundWgtWithHits", "sumBackgroundWgtWithHits"))
    expect_identical(assayNames(res2), c("negLog10P", "negLog10Padj", "pearsonResid", "expForegroundWgtWithHits", "log2enr", "sumForegroundWgtWithHits", "sumBackgroundWgtWithHits"))
    expect_identical(colnames(rowData(res1)), c("motif.id", "motif.name", "motif.pfm", "motif.pwm", "motif.percentGC"))
    expect_identical(rowData(res1), rowData(res2))
    expect_identical(dim(SummarizedExperiment::colData(res1)), c(3L, 6L))
    expect_identical(SummarizedExperiment::colData(res1)[, -c(2,3)],
                     SummarizedExperiment::colData(res2)[, -c(2,3)])
    expect_identical(SummarizedExperiment::colData(res2)[, 2],
                     attr(b, "breaks")[-4])
    expect_identical(SummarizedExperiment::colData(res2)[, 3],
                     attr(b, "breaks")[-1])
    expect_equal(-pbinom(q = assay(res1, "sumForegroundWgtWithHits")[, 3] - 1,
                         size = res1$totalWgtForeground[3],
                         prob = assay(res1, "sumBackgroundWgtWithHits")[, 3] /
                         res1$totalWgtBackground[3], lower.tail = FALSE, log.p = TRUE),
                 assay(res1, "negLog10P")[, 3])
    expect_identical(round(assay(res1, "negLog10P"), 3),
                     structure(c(25.893, 0, 0, 34.537, 0, 0),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res1, "negLog10Padj"), 3),
                     structure(c(25.416, 0, 0, 33.759, 0, 0),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res1, "pearsonResid"), 3),
                     structure(c(7.827, -3.847, -3.902, 8.878, -4.541, -5.114),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res1, "log2enr"), 3),
                     structure(c(1.374, -1.219, -1.293, 1.673, -1.299, -1.423),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res2, "negLog10P"), 3),
                     structure(c(17.038, 0, 0, 21.361, 0, 0),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res2, "negLog10Padj"), 3),
                     structure(c(16.561, 0, 0, 20.582, 0, 0),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res2, "pearsonResid"), 3),
                     structure(c(7.827, -3.847, -3.902, 8.878, -4.541, -5.114),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
    expect_identical(round(assay(res2, "log2enr"), 3),
                     structure(c(1.374, -1.219, -1.293, 1.673, -1.299, -1.423),
                               dim = c(length(pwm), nlevels(b)),
                               dimnames = list(names(pwm), levels(b))))
})

test_that(".binomEnrichmentTests works", {
    suppressMessages(expect_message(
        res <- .binomEnrichmentTest(
            matchCountBg = c(5, 8), totalWeightBg = 17,
            matchCountFg = c(9, 3), totalWeightFg = 20, verbose = TRUE)
    ))
    expect_equal(res[1],
                 log(binom.test(x = 9, n = 20, p = 5/17,
                                alternative = "greater")$p.value))
    expect_equal(res[2],
                 log(binom.test(x = 3, n = 20, p = 8/17,
                                alternative = "greater")$p.value))
})

test_that(".fisherEnrichmentTest works", {
    suppressMessages(expect_message(
        res <- .fisherEnrichmentTest(
            matchCountBg = c(5, 8), totalWeightBg = 17,
            matchCountFg = c(9, 3), totalWeightFg = 20, verbose = TRUE)
    ))
    expect_equal(res[1],
                 log(fisher.test(x = matrix(c(9, 20 - 9, 5, 17 - 5), nrow = 2),
                                 alternative = "greater")$p.value))
    expect_equal(res[2],
                 log(fisher.test(x = matrix(c(3, 20 - 3, 8, 17 - 8), nrow = 2),
                                 alternative = "greater")$p.value))
})

test_that(".calcPearsonResiduals works", {
    res <- .calcPearsonResiduals(
        matchCountBg = c(5, 8), totalWeightBg = 17,
        matchCountFg = c(9, 3), totalWeightFg = 20)
    expect_equal(res[1],
                 (9 - (9 + 5)/(20 + 17) * 20)/sqrt((9 + 5)/(20 + 17) * 20 *
                                                       (1 - 20/(20 + 17)) *
                                                       (1 - (5 + 9)/(20 + 17))))
    expect_equal(res[2],
                 (3 - (3 + 8)/(20 + 17) * 20)/sqrt((3 + 8)/(20 + 17) * 20 *
                                                       (1 - 20/(20 + 17)) *
                                                       (1 - (8 + 3)/(20 + 17))))

})

test_that(".calcExpFg works", {
    res <- .calcExpFg(
        matchCountBg = c(5, 8), totalWeightBg = 17,
        matchCountFg = c(9, 3), totalWeightFg = 20)
    expect_equal(res[1], (9 + 5)/(20 + 17) * 20)
    expect_equal(res[2], (3 + 8)/(20 + 17) * 20)
})

test_that(".calcLog2Enr works", {
    res <- .calcLog2Enr(
        matchCountBg = c(5, 8), totalWeightBg = 17,
        matchCountFg = c(9, 3), totalWeightFg = 20, pseudocount = 3)
    expect_equal(res[1], log2((9/20 * 17 + 3)/(5/17 * 17 + 3)))
    expect_equal(res[2], log2((3/20 * 17 + 3)/(8/17 * 17 + 3)))
})

test_that(".checkDfValidity() works", {
    seqchar <- c(s1 = "GTGCATGCAT", s2 = "ACGTACGTAC")
    df <- DataFrame(seqs = DNAStringSet(seqchar),
                    isForeground = c(TRUE, FALSE),
                    GCfrac = NA_real_,
                    GCbin = NA_integer_,
                    GCwgt = NA_real_,
                    seqWgt = NA_real_)

    expect_error(.checkDfValidity("error"), "should be a .*DataFrame")
    expect_error(.checkDfValidity(df[1:3]), "has to have columns")
    expect_error(.checkDfValidity(DataFrame(seqs = seqchar, df[2:6])), "expected types")
    expect_error(.checkDfValidity(DataFrame(df[1], DataFrame(isForeground = 1:2), df[3:6])), "expected types")
    expect_error(.checkDfValidity(DataFrame(df[1:2], DataFrame(GCfrac = seqchar), df[4:6])), "expected types")
    expect_error(.checkDfValidity(DataFrame(df[1:3], DataFrame(GCbin = seqchar), df[5:6])), "expected types")
    expect_error(.checkDfValidity(DataFrame(df[1:4], DataFrame(GCwgt = seqchar), df[6])), "expected types")
    expect_error(.checkDfValidity(DataFrame(df[1:5], DataFrame(seqWgt = seqchar))), "expected types")
    expect_error(.checkDfValidity(df), "attribute.*: err")
})


test_that(".filterSeqs() works", {
    seqs <- DNAStringSet(c(s1 = "GTGCATGCATACCA", s2 = "ACGNNNGTAC", s3 = "AAA"))

    expect_error(.filterSeqs("error"), "DNAStringSet")
    expect_error(.filterSeqs(seqs, maxFracN = "error"), "numeric")
    expect_error(.filterSeqs(seqs, minLength = -1), "between 0 and Inf")
    expect_error(.filterSeqs(seqs, maxLength = 0), "between 5 and Inf")
    expect_error(.filterSeqs(seqs, verbose = "error"), "logical")
    suppressMessages(
        expect_message(.filterSeqs(seqs, maxFracN = 0.1, verbose = TRUE))
    )

    expect_identical(.filterSeqs(seqs), c(TRUE, TRUE, FALSE))
    expect_identical(.filterSeqs(seqs, maxFracN = 0.1, verbose = FALSE), c(TRUE, FALSE, FALSE))
    expect_identical(.filterSeqs(seqs, minLength = 12, verbose = FALSE), c(TRUE, FALSE, FALSE))
    expect_identical(.filterSeqs(seqs, maxLength = 10, verbose = FALSE), c(FALSE, TRUE, FALSE))
})


test_that(".defineBackground() works", {
    set.seed(1)
    seqs <- DNAStringSet(unlist(lapply(1:90,
                                       function(i) paste(sample(c("A","C","G","T"),
                                                                20, replace = TRUE,
                                                                prob = c(.2,.3,.3,.2)),
                                                         collapse = ""))))
    names(seqs) <- paste0("s", seq_along(seqs))
    b1 <- factor(rep(1:3, each = 30))
    b1 <- setZeroBin(b1, 2)
    b2 <- factor(rep(1:2, each = 45))
    b2 <- setZeroBin(b2, 2)
    gnm <- DNAStringSet(unlist(lapply(1:10,
                                      function(i) paste(sample(c("A","C","G","T"),
                                                               1000 - i * 10,
                                                               replace = TRUE),
                                                        collapse = ""))))
    names(gnm) <- paste0("g", seq_along(gnm))
    gnm2 <- DNAStringSet(unlist(lapply(1:10,
                                       function(i) paste(sample(c("A","C","G","T"),
                                                                1000 - i * 10,
                                                                replace = TRUE,
                                                                prob = c(.4, .1, .1, .4)),
                                                         collapse = ""))))
    names(gnm2) <- paste0("g", seq_along(gnm2))

    df1 <- .defineBackground(seqs, b1, "otherBins", 1, NULL, NULL, 2, 0.7)
    df2 <- .defineBackground(seqs, b1, "allBins",   1, NULL, NULL, 2, 0.7)
    df3 <- .defineBackground(seqs, b1, "zeroBin",   1, NULL, NULL, 2, 0.7)
    set.seed(123L)
    df4 <- .defineBackground(seqs, b1, "genome",    1, gnm,  NULL, 2, 0.7)

    df5 <- .defineBackground(seqs, b2, "otherBins", 1, NULL, NULL, 2, 0.7)
    df6 <- .defineBackground(seqs, b2, "zeroBin",   1, NULL, NULL, 2, 0.7)

    set.seed(42L)
    df7 <- .defineBackground(seqs, b1, "genome",    1, gnm,
                             GenomicRanges::GRanges("g3", IRanges::IRanges(1, 970)),
                             2, 0.7)
    expect_warning(df8 <- .defineBackground(seqs, b1, "genome", 1,
                                            gnm2, NULL, 2, 0.7))

    expect_s4_class(df1, "DataFrame")
    expect_s4_class(df2, "DataFrame")
    expect_s4_class(df3, "DataFrame")
    expect_s4_class(df4, "DataFrame")
    expect_s4_class(df5, "DataFrame")
    expect_s4_class(df6, "DataFrame")
    expect_s4_class(df7, "DataFrame")
    expect_s4_class(df8, "DataFrame")

    expect_identical(attr(df1, "err"), NA)

    expect_identical(dim(df1), c( 90L, 6L))
    expect_identical(dim(df2), c(120L, 6L))
    expect_identical(dim(df3), c( 60L, 6L))
    expect_identical(dim(df4), c( 60L, 6L))
    expect_identical(dim(df5), c( 90L, 6L))
    expect_identical(dim(df6), c( 90L, 6L))
    expect_identical(dim(df7), c( 60L, 6L))
    expect_identical(dim(df8), c( 60L, 6L))

    expect_identical(df5, df6)

    expect_identical(unlist(lapply(as.character(df7$seqs[!df7$isForeground]),
                                   function(gs) {
                                       grep(gs, as.character(gnm))
                                   }), use.names = FALSE), rep(3L, 30))

    expect_true(.checkDfValidity(df1))
    expect_true(.checkDfValidity(df2))
    expect_true(.checkDfValidity(df3))
    expect_true(.checkDfValidity(df4))
    expect_true(.checkDfValidity(df5))
    expect_true(.checkDfValidity(df6))
    expect_true(.checkDfValidity(df7))

    expect_identical(sum(df1$isForeground), 30L)
    expect_identical(sum(df2$isForeground), 30L)
    expect_identical(sum(df3$isForeground), 30L)
    expect_identical(sum(df4$isForeground), 30L)
    expect_identical(sum(df5$isForeground), 45L)
    expect_identical(sum(df6$isForeground), 45L)
    expect_identical(sum(df7$isForeground), 30L)

    expect_identical(rownames(df1), names(seqs))
    expect_identical(rownames(df2), names(seqs)[c(1:30, 1:90)])
    expect_identical(rownames(df3), names(seqs)[c(1:60)])
    expect_identical(rownames(df4)[1:30], names(seqs)[1:30])
    expect_true(all(grepl("^g[0-9]+$", rownames(df4)[31:60])))
    expect_identical(rownames(df5), names(seqs))
    expect_identical(rownames(df6), names(seqs))
    expect_identical(rownames(df7)[1:30], names(seqs)[1:30])
    expect_true(all(grepl("^g[0-9]+$", rownames(df7)[31:60])))

    # for background = "genome", does the sampling make the G+C distribution more similar?
    gnm.tiles <- BSgenome::getSeq(gnm,
                                  unlist(GenomicRanges::tileGenome(Seqinfo::seqlengths(gnm),
                                                                   tilewidth = 20)))
    set.seed(42L)
    df4b <- .defineBackground(gnm.tiles, factor(rep(1, length(gnm.tiles))), "otherBins", 1,
                              NULL, NULL, NULL, 0.7)
    GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.6, 0.7, 0.8)
    gnm.gcbin.tab <- unclass(tabulate(findInterval(df4b$GCfrac, GCbreaks, all.inside = TRUE), 9))
    bg.gcbin.tab  <- unclass(tabulate(findInterval(df4$GCfrac[!df4$isForeground], GCbreaks, all.inside = TRUE), 9))
    fg.gcbin.tab  <- unclass(tabulate(findInterval(df4$GCfrac[ df4$isForeground], GCbreaks, all.inside = TRUE), 9))
    expect_true(cor(fg.gcbin.tab, bg.gcbin.tab) > cor(fg.gcbin.tab, gnm.gcbin.tab))
})


test_that(".calculateGCweight() works", {
    fseq <- c(f1  = "AGGGGGGGGG", f2  = "AAGGGGGGGG", f3  = "AAAGGGGGGG",
              f4  = "AAAAGGGGGG",                     f6  = "AAAAAAGGGG",
              f7  = "AAAAAAAGGG", f8  = "AAAAAAAAGG", f9  = "AAAAAAAAAG")
    bseq <- c(b1  = "AGGGGGGGGG", b2  = "AAGGGGGGGG", b3  = "AAAGGGGGGG",
              b4  = "AAAAGGGGGG", b5  = "AAAAAGGGGG", b6  = "AAAAAAGGGG",
              b7  = "AAAAAAAGGG", b8  = "AAAAAAAAGG", b9  = "AAAAAAAAAG",
              b2b = "AAGGGGGGGG", b4b = "AAAAGGGGGG", b6b = "AAAAAAGGGG")
    df <- DataFrame(seqs = DNAStringSet(c(fseq, bseq)),
                    isForeground = rep(c(TRUE, FALSE), c(length(fseq), length(bseq))),
                    GCfrac = NA_real_,
                    GCbin = NA_integer_,
                    GCwgt = NA_real_,
                    seqWgt = NA_real_)
    attr(df, "err") <- 0

    expect_error(.calculateGCweight("error"), "should be a .*DataFrame")
    expect_error(.calculateGCweight(df, GCbreaks = "error"), "numeric")
    expect_error(.calculateGCweight(df, GCbreaks = 0.2), "length 2 or greater")
    expect_error(.calculateGCweight(df, verbose = "error"), "logical")
    suppressMessages(expect_message(.calculateGCweight(df, verbose = TRUE)))

    expect_s4_class(res1 <- .calculateGCweight(df, verbose = FALSE), "DataFrame")
    expect_identical(df[-13, 1:2], res1[, 1:2])
    expect_identical(res1$GCfrac, c(9:6,4:1,9:6,4:1,8,6,4) / 10)
    expect_identical(res1[res1$isForeground, "GCwgt"],
                     rep(1.0, sum(res1$isForeground)))
    expect_identical(res1[!res1$isForeground, "GCwgt"],
                     rep(c(1.03125, 0.68750, 1.37500, 1.03125, 0.68750), c(3, 2, 3, 1, 2)))
})


test_that(".normForKmers() works", {
    set.seed(123)
    len <- 50
    seqschar <- unlist(lapply(seq.int(150), function(i) {
        paste(sample(c("A","C","G","T","N"), len, replace = TRUE, prob = c(.24, .24, .24, .24, .04)), collapse = "")
    }))
    seqs <- DNAStringSet(seqschar)
    kmerfreq <- lapply(1:3, function(k) oligonucleotideFrequency(seqs, width = k))
    gkmers <- lapply(kmerfreq, rowSums)
    kmerfreq <- lapply(1:3, function(k) kmerfreq[[k]] / gkmers[[k]])
    kmerseqrc <- lapply(kmerfreq, function(x) as.character(reverseComplement(DNAStringSet(colnames(x)))))
    seqwgt <- c(rep(1, 75), rnorm(75, mean = 1, sd = 0.1))
    isfg <- rep(c(TRUE, FALSE), each = 75)

    res1 <- .normForKmers(kmerfreq, gkmers, kmerseqrc, seqwgt, isfg)

    expect_type(res1, "list")
    expect_length(res1, 2L)
    expect_identical(names(res1), c("seqWgt", "err"))
    expect_identical(round(res1$seqWgt[!isfg], 3),
                     c(0.856, 1.085, 1.06, 0.965, 1.056, 1.011, 1.046, 0.831, 1.204,
                       0.937, 0.787, 1.101, 0.839, 1.017, 0.882, 0.844, 0.964, 1.04,
                       0.979, 0.923, 0.967, 1.028, 0.955, 0.92, 1.081, 0.87, 1.064,
                       0.935, 0.955, 1.141, 0.94, 0.88, 0.873, 1.041, 0.812, 1.023,
                       0.934, 0.843, 0.986, 1.107, 0.806, 0.876, 1.095, 0.895, 0.866,
                       0.862, 0.95, 0.987, 0.932, 1.042, 1.049, 1.027, 1.078, 0.98,
                       0.986, 1.065, 0.994, 1.079, 0.985, 1.023, 1.039, 0.882, 1.029,
                       0.972, 1.178, 0.931, 1.077, 0.767, 0.923, 0.955, 1.113, 0.949,
                       0.972, 1.118, 0.989))
})


test_that(".iterativeNormForKmers() works", {
    fseq <- c(f1  = "AGGGGGGGGG", f2  = "AAGGGGGGGG", f3  = "AAAGGGGGGG",
              f4  = "AAAAGGGGGG",                     f6  = "AAAAAAGGGG",
              f7  = "AAAAAAAGGG", f8  = "AAAAAAAAGG", f9  = "AAAAAAAAAG")
    bseq <- c(b1  = "AGGGGGGGGG", b2  = "AAGGGGGGGG", b3  = "AAAGGGGGGG",
              b4  = "AAAAGGGGGG", b5  = "AAAAAGGGGG", b6  = "AAAAAAGGGG",
              b7  = "AAAAAAAGGG", b8  = "AAAAAAAAGG", b9  = "AAAAAAAAAG",
              b2b = "AAGGGGGGGG", b4b = "AAAAGGGGGG", b6b = "AAAAAAGGGG")
    df <- DataFrame(seqs = DNAStringSet(c(fseq, bseq)),
                    isForeground = rep(c(TRUE, FALSE), c(length(fseq), length(bseq))),
                    GCfrac = NA_real_,
                    GCbin = NA_integer_,
                    GCwgt = NA_real_,
                    seqWgt = NA_real_)
    attr(df, "err") <- 0
    df <- .calculateGCweight(df)

    expect_error(.iterativeNormForKmers("error"))
    expect_error(.iterativeNormForKmers(df, maxKmerSize = "error"), "integer")
    expect_error(.iterativeNormForKmers(df, minSeqWgt = -1), "between 0 and Inf")
    expect_error(.iterativeNormForKmers(df, maxIter = "error"), "integer")
    expect_error(.iterativeNormForKmers(df, verbose = "error"), "logical")

    suppressMessages(
        expect_message(res0 <- .iterativeNormForKmers(df, maxKmerSize = 2L, verbose = TRUE))
    )
    expect_s4_class(res0, "DataFrame")
    expect_identical(round(attr(res0, "err"), 6), 0.495758)
    expect_identical(dim(df), dim(res0))
    suppressMessages(
        expect_message(res1 <- .iterativeNormForKmers(df, verbose = TRUE))
    )
    expect_s4_class(res1, "DataFrame")
    expect_identical(round(attr(res1, "err"), 6), 0.954395)
    attr(df, "err") <- attr(res1, "err")
    expect_identical(dim(res1), dim(df))
    expect_identical(res1[1:5], df[1:5])
    expect_identical(round(res1[!res1$isForeground, "seqWgt"], 3),
                     c(1.251, 0.887, 0.913, 0.675, 0.7, 1.344, 1.347,
                       1.347, 0.887, 0.675, 0.7))
})


test_that(".checkIfSeqsAreEqualLength works as expected", {
    x1 <- Biostrings::DNAStringSet(c("AAA", "CCC", "GGGGGG"))
    x2 <- GenomicRanges::GRanges("chr1",
                                 IRanges::IRanges(start = c(1, 10, 20),
                                                  width = c(3,  3,  6)))

    expect_warning(.checkIfSeqsAreEqualLength(x = x1),
                   "Not all elements of x1 have the same length")
    expect_warning(.checkIfSeqsAreEqualLength(x = x2),
                   "Not all elements of x2 have the same length")

    expect_true(is.null(.checkIfSeqsAreEqualLength(x = x1[1:2])))
    expect_true(is.null(.checkIfSeqsAreEqualLength(x = x2[1:2])))
})

#' @title Randomized Lasso
#'
#' @description This function performs randomized lasso using the \code{glmnet}
#'     package. The function present in the \code{stabs} package that runs the
#'     lasso version was adapted for the randomized lasso here. Randomized
#'     lasso stability selection uses this function repeatedly
#'     to select predictors.
#'
#' @param x The predictor matrix. Passed to \code{x}
#'     of \code{glmnet.lasso} from \code{stabs} package.
#' @param y The response vector. Passed to \code{y}
#'     of \code{glmnet.lasso} from \code{stabs} package.
#' @param q The number of variables that are selected on each subsample.
#'     Passed to \code{q} of \code{glmnet.lasso} from \code{stabs} package.
#' @param weakness Weakness parameter used in randomized lasso (see details).
#' @param type Parameter passed to \code{type} of \code{glmnet.lasso} from
#'     \code{stabs} package. It is a character vector specifying how much the
#'     PFER should be controlled. If type is "conservative" (default), then the
#'     number of selected variables per subsample is <= q. If type is
#'     "anticonservative" then the number of selected variables per subsample
#'     is >= q.
#' @param ... Additional parameters for \code{glmnet}.
#'
#' @return The regression output which consists of a list of length 2. The
#'     list contains the following:
#'     \describe{
#'     \item{selected}{ - a logical vector of length equal to the total number
#'         of predictors. The predictors that were chosen have a value of TRUE.}
#'     \item{path}{ - a logical matrix containing the regularization steps as
#'         columns and the predictors as rows. An entry of TRUE indicates
#'         selection.}
#'     }
#'
#'
#' @details This function is identical to \code{glmnet.lasso} from the
#'     \code{stabs} package. The only addition/modification is the weakness
#'     parameter which has been added when calling the
#'     \code{glmnet} function by setting
#'     penalty.factor = 1/runif(ncol(x), weakness, 1),
#'     where ncol(x) is the number of predictors.
#'
#' @seealso \code{\link[stabs]{glmnet.lasso}} and \code{\link[glmnet]{glmnet}}
#'
#' @importFrom glmnet glmnet
#' @importFrom stats model.matrix runif predict
#' @importFrom cli cli_abort cli_inform
#'
#' @keywords internal
.glmnetRandomizedLasso <- function(x, y, q, weakness=1,
                                   type = c("conservative",
                                            "anticonservative"),
                                   ...) {
  if (is.data.frame(x)) {
    cli_inform("Note: {.arg x} is coerced to a model matrix without intercept")
    x <- stats::model.matrix(~. - 1, x)
  }
  if ("lambda" %in% names(list(...)))
    cli_abort(paste0(
        "It is not permitted to specify the penalty parameter ",
        "{.arg lambda} for lasso when used with stability selection."))
  type <- match.arg(type)

  # modify the function here to make it a randomized-lasso using the
  # weakness parameter
  if (type == "conservative")
    fit <- glmnet::glmnet(
      x, y, pmax = q,
      penalty.factor = 1/stats::runif(ncol(x), weakness,  1),  ...)
  if (type == "anticonservative")
    fit <- glmnet::glmnet(
      x, y, dfmax = q - 1,
      penalty.factor = 1/stats::runif(ncol(x), weakness,  1), ...)

  selected <- predict(fit, type = "nonzero")
  selected <- selected[[length(selected)]]
  ret <- logical(ncol(x))
  ret[selected] <- TRUE
  names(ret) <- colnames(x)
  cf <- fit$beta
  sequence <- as.matrix(cf != 0)
  return(list(selected = ret, path = sequence))
}



#' @title Randomized Lasso Stability Selection
#'
#' @description This function runs randomized lasso stability selection as
#'     presented by Meinshausen and Bühlmann (2010) and with the improved
#'     error bounds introduced by Shah and Samworth (2013). The function
#'     uses the \code{\link[stabs]{stabsel}} function from the \code{stabs}
#'     package, but implements the randomized lasso version.
#'
#' @param x The predictor matrix.
#' @param y The response vector. This should be a numeric vector (also for 
#'     the binomial case - in this case it will be converted to a factor 
#'     internally by \code{glmnet}).
#' @param weakness Value between 0 and 1 (default = 0.8).
#'     It affects how strict the method will be in selecting predictors. The
#'     closer it is to 0, the more stringent the selection. A weakness value
#'     of 1 is identical to performing lasso stability selection (not the
#'     randomized version).
#' @param glmnet.args Named list with additional arguments to the internal 
#'     \code{.glmnetRandomizedLasso} function (beyond \code{x}, 
#'     \code{y} and \code{weakness}, which are determined automatically, and 
#'     \code{q}, which should not be specified (it will be determined from 
#'     \code{cutoff} and \code{PFER}). 
#'     The available arguments to \code{.glmnetRandomizedLasso} are the same as 
#'     the ones for \code{\link[stabs]{glmnet.lasso}}. A typical use case would 
#'     be to define the \code{family} argument to \code{\link[glmnet]{glmnet}} 
#'     (currently "gaussian" and "binomial" are supported). 
#' @param cutoff Value between 0 and 1 (default = 0.8) which is the cutoff
#'     for the selection probability. Any variable with a selection probability
#'     that is higher than the set cutoff will be selected.
#' @param PFER Integer (default = 2) representing the absolute number of
#'     false positives that we allow for in the final list of selected
#'     variables. For details see Meinshausen and Bühlmann (2010).
#' @param mc.cores Integer (default = 1) specifying the number of cores to
#'     use in \code{\link[parallel]{mclapply}}, which is the default way
#'     \code{\link[stabs]{stabsel}} does parallelization.
#' @param ... Additional parameters that can be passed on to
#'     \code{\link[stabs]{stabsel}}.
#'
#' @details Randomized lasso stability selection runs a randomized lasso
#'     regression several times on subsamples of the response variable and
#'     predictor matrix. N/2 elements from the response variable are randomly
#'     chosen in each regression, where N is the length of the vector. The
#'     corresponding section of the predictor matrix is also chosen, and the
#'     internal \code{.glmnetRandomizedLasso} function is applied.
#'     Stability selection results in selection probabilities for each
#'     predictor. The probability of a specific predictor is the number of
#'     times it was selected divided by the total number of subsamples that
#'     were done (total number of times the regression was performed).
#'
#'     We made use of the \code{stabs} package that implements lasso stability
#'     selection, and adapted it to run randomized lasso stability selection.
#'
#' @return  A \code{SummarizedExperiment} object where the rows are the
#'     observations and the columns the predictors (same dimnames as the
#'     predictor matrix \code{x}).
#'     It contains: \describe{
#'       \item{assays}{: \describe{
#'         \item{x}{: the predictor matrix.}
#'         }
#'       }
#'       \item{rowData}{: a \code{DataFrame} with columns: \describe{
#'         \item{y}{: the response vector.}
#'         }
#'       }
#'       \item{colData}{: a \code{DataFrame} with columns: \describe{
#'         \item{selProb}{: the final selection probabilities for the
#'           predictors (from the last regularization step).}
#'         \item{selected}{: logical indicating the predictors that made
#'           the selection with the specified cutoff.}
#'         \item{selAUC}{: the normalized area under the seletion curve
#'           (mean of selection probabilities over regulatization steps).}
#'         \item{reg'\code{i}'}{: columns containing the selection
#'           probabilities for regularization step i. }
#'         }
#'       }
#'       \item{metadata}{: a list of output returned from
#'         \code{\link[stabs]{stabsel}} and \code{randLassoStabSel}: \describe{
#'         \item{stabsel.params.cutoff}{: probability cutoff set for selection
#'           of predictors (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.selected}{: elements with maximal selection
#'           probability greater \code{cutoff}
#'           (see \code{\link[stabs]{stabsel}}). }
#'         \item{stabsel.params.max}{: maximum of selection probabilities
#'           (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.q}{: average number of selected variables
#'           used (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.PFER}{: (realized) upper bound for the
#'           per-family error rate (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.specifiedPFER}{: specified upper bound for
#'           the per-family error rate (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.p}{: the number of effects subject to
#'           selection (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.B}{: the number of subsamples (see
#'           \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.sampling.type}{: the sampling type used for
#'           stability selection (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.assumption}{: the assumptions made on the
#'           selection probabilities (see \code{\link[stabs]{stabsel}}).}
#'         \item{stabsel.params.call}{: \code{\link[stabs]{stabsel}} the call.}
#'         \item{randStabsel.params.weakness}{: the weakness parameter in the
#'           randomized lasso stability selection.}
#'         }
#'       }
#'
#'     }
#'
#' @examples
#' ## create data set
#' Y <- rnorm(n = 500, mean = 2, sd = 1)
#' X <- matrix(data = NA, nrow = length(Y), ncol = 50)
#' for (i in seq_len(ncol(X))) {
#'   X[ ,i] <- runif(n = 500, min = 0, max = 3)
#' }
#' s_cols <- sample(x = seq_len(ncol(X)), size = 10,
#'   replace = FALSE)
#' for (i in seq_along(s_cols)) {
#'   X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
#' }
#'
#' ## reproducible randLassoStabSel() with 1 core
#' set.seed(123)
#' ss <- randLassoStabSel(x = X, y = Y)
#'
#' ## reproducible randLassoStabSel() in parallel mode
#' ## (only works on non-windows machines)
#' if (.Platform$OS.type == "unix") {
#'     RNGkind("L'Ecuyer-CMRG")
#'     set.seed(123)
#'     ss <- randLassoStabSel(x = X, y = Y, mc.preschedule = TRUE,
#'                            mc.set.seed = TRUE, mc.cores = 2L)
#' }
#'
#' @seealso \code{\link[stabs]{stabsel}}
#'
#' @references N. Meinshausen and P. Bühlmann (2010), Stability Selection,
#'     \emph{Journal of the Royal Statistical Society: Series B
#'     (Statistical Methodology)}, \strong{72}, 417–73. \cr
#'     R.D. Shah and R.J. Samworth (2013), Variable Selection with Error
#'     Control: Another Look at Stability Selection,
#'     \emph{Journal of the Royal Statistical Society: Series B
#'     (Statistical Methodology)}, \strong{75}, 55–80. \cr
#'     B. Hofner, L. Boccuto, and M. Göker (2015), Controlling False
#'     Discoveries in High-Dimensional Situations: Boosting with Stability
#'     Selection, \emph{BMC Bioinformatics}, \strong{16} 144.
#'
#' @importFrom stabs stabsel
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom cli cli_abort
#' @importFrom methods formalArgs
#'
#'@export
randLassoStabSel <- function(x, y, weakness=0.8, cutoff=0.8, PFER=2,
                             mc.cores=1L, glmnet.args = list(), ...) {

    # checks
    if (!is(x, "matrix")) {
        cli_abort("{.arg x} must be a {.cls matrix}")
    }
    .assertVector(x = y, type = "numeric")
    if (nrow(x) != length(y)) {
        cli_abort(paste0(
        "nrow of {.arg x} and length of {.arg y} are not equal. The rows of ",
        "{.arg x} must be the same length and order as the elements in {.arg y}."))
    }
    if (!is.null(names(y)) && !is.null(rownames(x)) &&
        !all(names(y) == rownames(x))) {
        cli_abort(paste0(
            "{.arg x} and {.arg y} have different names. Make sure that the names are ",
            "identical and that the orders match."))
    }
    if (is.null(rownames(x))) {
        rownames(x) <- paste0("obs", seq_len(nrow(x)))
    }
    if (is.null(colnames(x))) {
        colnames(x) <- paste0("pred", seq_len(ncol(x)))
    }
    .assertVector(x = glmnet.args, type = "list")
    if (length(glmnet.args) > 0) {
        .assertVector(x = names(glmnet.args), type = "character", 
                      validValues = c("weakness",
                                      union(formalArgs(glmnet::glmnet),
                                            formalArgs(stabs::glmnet.lasso))))
        if (any(i <- names(glmnet.args) %in% c("x", "y", "q", "weakness"))) {
            warning(paste0("Ignoring the following elements of 'glmnet.args' (as ", 
                           "they are set automatically): ", 
                           paste(names(glmnet.args)[i], collapse = ",")))    
            glmnet.args <- glmnet.args[!i]
        }
        if ("family" %in% names(glmnet.args) && 
            !glmnet.args$family %in% c("binomial", "gaussian")) {
            cli_abort("currently only binomial and gaussian families are supported")
        }
    }

    # run randomized lasso stability selection
    ss <- stabs::stabsel(x = x, y = y, fitfun = .glmnetRandomizedLasso,
                         args.fitfun = c(glmnet.args, list(weakness = weakness)),
                         cutoff = cutoff, PFER = PFER, mc.cores = mc.cores, ...)


    # restructure as SummarizedExperiment object
    mdat <- list(stabsel.params.cutoff = ss$cutoff,
                 stabsel.params.selected = ss$selected,
                 stabsel.params.max = ss$max,
                 stabsel.params.q = ss$q,
                 stabsel.params.PFER = ss$PFER,
                 stabsel.params.specifiedPFER = ss$specifiedPFER,
                 stabsel.params.p = ss$p,
                 stabsel.params.B = ss$B,
                 stabsel.params.sampling.type = ss$sampling.type,
                 stabsel.params.assumption = ss$assumption,
                 stabsel.params.call = ss$call,
                 randStabsel.params.weakness = weakness
                 )

    probMat <- as(ss$phat, "DataFrame")
    colnames(probMat) <- paste0("regStep", seq_len(ncol(probMat)))
    cdat <- S4Vectors::DataFrame(selProb = probMat[, ncol(probMat)],
                                 selected = seq.int(ncol(x)) %in% ss$selected,
                                 selAUC = rowMeans(as.matrix(probMat)),
                                 probMat)
    rdat <- S4Vectors::DataFrame(y = y)

    se <- SummarizedExperiment::SummarizedExperiment(assays = list(x = x),
                                                     rowData = rdat,
                                                     colData = cdat,
                                                     metadata = mdat)

    # return
    return(se)
}

test_that("randLassoStabSel() works properly", {

    # create data set
    set.seed(555)
    Y <- rnorm(n = 500, mean = 2, sd = 1)
    X <- matrix(data = NA, nrow = length(Y), ncol = 50)
    for (i in seq_len(ncol(X))) {
        X[, i] <- runif(n = 500, min = 0, max = 3)
    }
    s_cols <- sample(x = seq_len(ncol(X)), size = 10, replace = FALSE)
    for (i in seq_along(s_cols)) {
        X[, s_cols[i]] <- X[, s_cols[i]] + Y
    }

    X2 <- X
    Y2 <- Y
    rownames(X2) <- paste0("peak", seq_len(nrow(X2)))
    colnames(X2) <- paste0("motif", seq_len(ncol(X2)))
    names(Y2) <- paste0("peak", seq_along(Y2))

    # randomized lasso stability selection
    ss <- monaLisa::randLassoStabSel(x = X, y = Y)

    # tests
    expect_s4_class(ss, "SummarizedExperiment")
    expect_identical(rowData(ss)$y, Y)
    expect_identical(ss$selProb, colData(ss)[, ncol(colData(ss))])
    expect_identical(ss$selAUC,
                     rowMeans(as.matrix(colData(ss)[, grep("^regStep", colnames(colData(ss)))])))
    expect_true(all(ss$selProb >= 0 & ss$selProb <= 1))
    expect_true(all(ss$selAUC >= 0 & ss$selAUC <= 1))
    expect_true(all(s_cols %in% metadata(ss)$stabsel.params.selected))
    expect_identical(dim(ss), c(500L, 50L))
    expect_identical(length(Y), nrow(ss))
    expect_true(!is.null(SummarizedExperiment::assay(ss)))
    expect_error(randLassoStabSel(x = as.data.frame(X), y = Y))
    expect_error(randLassoStabSel(x = X2[1:100, ], y = Y2[2:101]))
    expect_error(randLassoStabSel(x = X2[1:100, ], y = Y2[2:100]))
    
    # with a different family
    set.seed(123)
    ssbnf <- randLassoStabSel(x = X, y = as.numeric(Y > 2), 
                              glmnet.args = list(family = "binomial"))
    expect_s4_class(ssbnf, "SummarizedExperiment")
    expect_identical(rowData(ssbnf)$y, as.numeric(Y > 2))
    expect_identical(ssbnf$selProb, colData(ssbnf)[, ncol(colData(ssbnf))])
    expect_identical(ssbnf$selAUC,
                     rowMeans(as.matrix(colData(ssbnf)[, grep("^regStep", colnames(colData(ssbnf)))])))
    expect_true(all(ssbnf$selProb >= 0 & ssbnf$selProb <= 1))
    expect_true(all(ssbnf$selAUC >= 0 & ssbnf$selAUC <= 1))
    expect_true(all(metadata(ssbnf)$stabsel.params.selected %in% s_cols))
    expect_identical(dim(ssbnf), c(500L, 50L))
    expect_identical(length(Y), nrow(ssbnf))
    expect_true(!is.null(SummarizedExperiment::assay(ssbnf)))
    
    # ignore selected arguments if passed to glmnet.args
    set.seed(123)
    expect_warning({
        ssbnf2 <- randLassoStabSel(x = X, y = as.numeric(Y > 2), 
                                   glmnet.args = list(family = "binomial", 
                                                      x = 3, weakness = 0.1))
    }, "Ignoring the following elements")
    expect_identical(ssbnf, ssbnf2)
    
    expect_error(randLassoStabSel(x = X, y = factor(Y > 2)), 
                 ".y. must be of class .numeric.")
    expect_error(randLassoStabSel(x = X, y = as.numeric(Y > 2), 
                                  glmnet.args = list(family = "multinomial")),
                 "currently only binomial and gaussian")
})

test_that("randLassoStabSel() is deterministic", {

  # create data set
  set.seed(555)
  Y <- rnorm(n = 500, mean = 2, sd = 1)
  X <- matrix(data = NA, nrow = length(Y), ncol = 50)
  for (i in seq_len(ncol(X))) {
    X[ ,i] <- runif(n = 500, min = 0, max = 3)
  }
  s_cols <- sample(x = seq_len(ncol(X)), size = 10, replace = FALSE)
  for (i in seq_along(s_cols)) {
    X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
  }

  # randomized lasso stability selection
  set.seed(123)
  ss1 <- monaLisa::randLassoStabSel(x = X, y = Y)
  set.seed(123)
  ss2 <- monaLisa::randLassoStabSel(x = X, y = Y)

  # tests
  expect_identical(ss1, ss2)

})


test_that(".glmnetRandomizedLasso() works properly", {

    # create data set
    set.seed(555)
    Y <- rnorm(n = 500, mean = 2, sd = 1)
    X <- matrix(data = NA, nrow = length(Y), ncol = 50)
    for (i in seq_len(ncol(X))) {
        X[ ,i] <- runif(n = 500, min = 0, max = 3)
    }
    s_cols <- sample(x = ncol(X), size = 10, replace = FALSE)
    for (i in seq_along(s_cols)) {
        X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
    }

    # tests
    # ... x as data.frame
    expect_warning(
      expect_message(.glmnetRandomizedLasso(x = as.data.frame(X), y = Y, q = 11),
                     "coerced to a model matrix without intercept"),
      "Number of nonzero coefficients along the path exceeds")

    # ... with specific lambda
    expect_error(.glmnetRandomizedLasso(x = X, y = Y, q = 11, lambda = 5))

    # ... with type="anticonservative"
    set.seed(123)
    rl <- .glmnetRandomizedLasso(x = X, y = Y, q = 11, type = "anticonservative")
    expect_type(rl, "list")
    expect_identical(names(rl), c("selected", "path"))
    expect_type(rl$selected, "logical")
    expect_type(rl$path, "logical")

    # expected number of selected variables
    expect_identical(sum(rl$selected), 11L)
    
    # with different family
    set.seed(123)
    expect_warning(
        expect_message(
            bnf <- .glmnetRandomizedLasso(x = as.data.frame(X), 
                                          y = as.numeric(Y > 0), 
                                          q = 11, family = "binomial"),
            "coerced to a model matrix without intercept"),
        "Number of nonzero coefficients along the path exceeds")
    expect_identical(sum(bnf$selected), 10L)

})

#' @param allowNULL Logical, whether or not \code{NULL} is an acceptable
#'     value for \code{x}.
#'
#' @author Michael Stadler, Charlotte Soneson
#' @noRd
#' @keywords internal
#' @importFrom methods is
.assertScalar <- function(x,
                          type = NULL,
                          rngIncl = NULL,
                          rngExcl = NULL,
                          validValues = NULL,
                          allowNULL = FALSE) {

    .assertVector(x = x, type = type, rngIncl = rngIncl,
                  rngExcl = rngExcl, validValues = validValues,
                  len = 1, rngLen = NULL, allowNULL = allowNULL)

}

#' Utility function to check validity of vector variable values.
#'
#' This function provides a convenient way e.g. to check that provided
#' arguments to functions satisfy required criteria.
#'
#' @param x The variable to be checked
#' @param type The desired type of \code{x}.
#' @param rngIncl The allowed range of the (numeric) variable \code{x},
#'     including the endpoints.
#' @param rngExcl The allowed range of the (numeric) variable \code{x},
#'     excluding the endpoints.
#' @param validValues A vector with the allowed values of \code{x}.
#' @param len The required length of \code{x}.
#' @param rngLen The allowed range for the length of \code{x}.
#' @param allowNULL Logical, whether or not \code{NULL} is an acceptable
#'     value for \code{x}.
#'
#' @author Michael Stadler, Charlotte Soneson
#' @noRd
#' @keywords internal
#' @importFrom methods is
#' @importFrom cli cli_abort
.assertVector <- function(x,
                          type = NULL,
                          rngIncl = NULL,
                          rngExcl = NULL,
                          validValues = NULL,
                          len = NULL,
                          rngLen = NULL,
                          allowNULL = FALSE) {
    sc <- sys.calls()
    mycall <- sc[[length(sc)]]
    if (length(sc) >= 2 &&
        identical(as.character(sc[[length(sc) - 1]])[1], ".assertScalar")) {
        mycall <- sc[[length(sc) - 1]]
    }
    args <- lapply(mycall, \(x) if (is(x, "language")) deparse(x) else as.character(x))[-1]
    xname <- if ("x" %in% names(args)) args$x else "argument"

    ## Check arguments
    stopifnot(is.null(type) || (length(type) == 1L && is.character(type)))
    stopifnot(is.null(rngIncl) || (length(rngIncl) == 2L && is.numeric(rngIncl)))
    stopifnot(is.null(rngExcl) || (length(rngExcl) == 2L && is.numeric(rngExcl)))
    stopifnot(is.null(len) || (length(len) == 1L && is.numeric(len)))
    stopifnot(is.null(rngLen) || (length(rngLen) == 2L && is.numeric(rngLen)))
    stopifnot(is.logical(allowNULL) && length(allowNULL) == 1L)
    if (!is.null(rngIncl) && !is.null(rngExcl)) {
        cli_abort("{.arg rngIncl} and {.arg rngExcl} can not both be specified",
                  call = NULL)
    }

    ## If there are too many valid values, print only the first 15
    if (length(validValues) > 15) {
        vvPrint <- paste(c(validValues[seq_len(15)],
                           "...(truncated)"),
                         collapse = ", ")
    } else {
        vvPrint <- paste(validValues, collapse = ", ")
    }

    if (is.null(x)) {
        if (allowNULL) {
            return(invisible(TRUE))
        } else {
            cli_abort("{.arg {xname}} must not be {.code NULL}", call = NULL)
        }
    }

    if (is.null(type) && (!is.null(rngIncl) || !is.null(rngExcl))) {
        type <- "numeric"
    }

    if (!is.null(type) && !is(x, type)) {
        cli_abort("{.arg {xname}} must be of class {.cls {type}}", call = NULL)
    }

    if (!is.null(rngIncl)) {
        if (!is.null(validValues)) {
            if (any((x < rngIncl[1] | x > rngIncl[2]) & !(x %in% validValues))) {
                cli_abort(paste0(
                    "{.arg {xname}} must be between {rngIncl} (inclusive), ",
                    "or one of: {vvPrint}"), call = NULL)
            }
        } else {
            if (any(x < rngIncl[1] | x > rngIncl[2])) {
                cli_abort(paste0(
                    "{.arg {xname}} must be between {rngIncl} (inclusive)"),
                    call = NULL)
            }
        }
    } else if (!is.null(rngExcl)) {
        if (!is.null(validValues)) {
            if (any((x <= rngExcl[1] | x >= rngExcl[2]) & !(x %in% validValues))) {
                cli_abort(paste0(
                    "{.arg {xname}} must be between {rngExcl} (exclusive), ",
                    "or one of: {vvPrint}"), call = NULL)
            }
        } else {
            if (any(x <= rngExcl[1] | x >= rngExcl[2])) {
                cli_abort(paste0(
                    "{.arg {xname}} must be between {rngExcl} (exclusive)"),
                    call = NULL)
            }
        }
    } else {
        if (!is.null(validValues) && !all(x %in% validValues)) {
            cli_abort("All values in {.arg {xname}} must be one of: {vvPrint}",
                      call = NULL)
        }
    }


    if (!is.null(len) && length(x) != len) {
        cli_abort("{.arg {xname}} must have length {len}", call = NULL)
    }

    if (!is.null(rngLen) && (length(x) < rngLen[1] || length(x) > rngLen[2])) {
        cli_abort(paste0(
            "length of {.arg {xname}} must be between {rngLen} (inclusive)"),
            call = NULL)
    }

    return(invisible(TRUE))
}

#' Utility function that makes sure that packages are available
#' 
#' The function tries loading the namespaces of the packages given in
#' \code{pkgs}, and throws an exception with an informative error message if
#' that is not the case.
#' 
#' @param pkgs Character vector with package names. Can be either just a
#'   package name or a string of the form \code{"githubuser/packagename"} for
#'   packages hosted on GitHub.
#' @param suggestInstallation Logical scalar. If \code{TRUE}, include an
#'   expression to install the missing package(s) as part of the generated
#'   error message.
#' 
#' @author Michael Stadler, Charlotte Soneson
#' 
#' @noRd
#' @keywords internal
.assertPackagesAvailable <- function(pkgs, suggestInstallation = TRUE) {
  stopifnot(exprs = {
    is.character(pkgs)
    is.logical(suggestInstallation)
    length(suggestInstallation) == 1L
  })
  
  avail <- unlist(lapply(sub("^[^/]+/", "", pkgs),
                         function(pkg) {
                           requireNamespace(pkg, quietly = TRUE)
                         }))
  
  if (any(!avail)) {
    caller <- deparse(sys.calls()[[sys.nframe() - 1]])
    callerfunc <- sub("\\(.+$", "", caller)
    haveBioc <- requireNamespace("BiocManager", quietly = TRUE)
    msg <- paste0("The package", ifelse(sum(!avail) > 1, "s '", " '"),
                  paste(sub("^[^/]+/", "", pkgs[!avail]), collapse = "', '"),
                  "' ",
                  ifelse(sum(!avail) > 1, "are", "is"), " required for ",
                  callerfunc, "(), but not installed.\n")
    if (suggestInstallation) {
      msg <- paste0(msg,
                    "Install ", ifelse(sum(!avail) > 1, "them", "it"), " using:\n",
                    ifelse(haveBioc, "", "install.packages(\"BiocManager\")\n"),
                    "BiocManager::install(c(\"",
                    paste(pkgs[!avail], collapse = "\", \""), "\"))")
    }
    stop(msg, call. = FALSE)
  }
  
  invisible(TRUE)
}

#' Generate console output messages
#'
#' This is a drop-in replacement for \code{base::message}, which only
#' creates a message if \code{verbose} exists in the calling environment and
#' is set to \code{TRUE}. It also supports inline-markup via the \code{cli}
#' package.
#'
#' @param message The message to be written to the console. It will be
#'     forwarded to \code{\link[cli]{cli_progress_step}} and thus supports
#'     inline markup (see \code{\link[cli]{inline-markup}}).
#' @param noTimer Logical scalar. If \code{FALSE} (the default), the message is
#'     generated using \code{\link[cli]{cli_progress_step}}, which will first
#'     show it with an "info" icon and then again with a "check" icon and timing
#'     information when the next message is generated or the function terminates.
#'     If \code{TRUE}, the message is generated using
#'     \code{\link[cli]{cli_alert_info}}, which means it will be show only once
#'     with an "info" icon.
#' @param ... Additional arguments passed to \code{\link[cli]{cli_progress_step}}
#'     (ignored if \code{noTimer = TRUE}).
#'
#' @importFrom cli cli_progress_step cli_alert_info
#'
#' @noRd
#' @keywords internal
.message <- function(message, noTimer = FALSE, ...) {
    # Try to get 'verbose' from the calling environment
    env <- parent.frame()
    verbose <- tryCatch(get("verbose", envir = env),
                        error = function(e) FALSE)
    if (verbose) {
        if (noTimer) {
            cli_alert_info(text = message, .envir = env)
        } else {
            cli_progress_step(msg = message, .envir = env, ...)
        }
    }
}

#' Utility function to check validity of R colors.
#'
#' This function checks if the provided characters (e.g. arguments to other
#' functions) are valid colors in R.
#'    
#' @param x character vector of colors.    
#' @param ... additional arguments to \code{.assertVector}
#'    
#' @importFrom grDevices col2rgb
#'
#' @noRd
#' @keywords internal
.assertColor <- function(x, ...) {
    .assertVector(x = x, type = "character", ...)  
    
    isColor <- function(char) {
        out <- tryCatch(col2rgb(char), error = function(e) {
            FALSE
        })
        if (is.matrix(out)){
            out <- TRUE
        }
        out
    }  
    
    out <- vapply(X = x, FUN = isColor, FUN.VALUE = logical(1))
    if (any(!out)) {
        cli_abort("The following is not a valid color in R: {.emph {x[!out]}}. Please
              provide a string that corresponds to a valid color.")
    } 
    
    return(invisible(TRUE))
}

## -------------------------------------------------------------------------- ##
## Checks, .assertScalar
## -------------------------------------------------------------------------- ##
test_that(".assertScalar works", {
    expect_error(.assertScalar(1, type = TRUE))
    expect_error(.assertScalar(1, type = 1))
    expect_error(.assertScalar(1, type = c("numeric", "character")))
    expect_error(.assertScalar(1, type = "numeric", rngIncl = TRUE))
    expect_error(.assertScalar(1, type = "numeric", rngIncl = "rng"))
    expect_error(.assertScalar(1, type = "numeric", rngIncl = 1))
    expect_error(.assertScalar(1, type = "numeric", rngIncl = 1:3))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = TRUE))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = "rng"))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = 1))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = 1:3))
    expect_error(.assertScalar(1, type = "numeric", rngIncl = c(0, 2), rngExcl = c(0, 2)))
    expect_error(.assertScalar(1, type = "numeric", allowNULL = 1))
    expect_error(.assertScalar(1, type = "numeric", allowNULL = "rng"))
    expect_error(.assertScalar(1, type = "numeric", allowNULL = NULL))
    expect_error(.assertScalar(1, type = "numeric", allowNULL = c(TRUE, FALSE)))

    expect_true(.assertScalar(1, type = "numeric", rngIncl = c(1, 3)))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = c(1, 3)))
    expect_true(.assertScalar(1, type = "numeric", rngExcl = c(1, 3), validValues = 1))
    expect_true(.assertScalar(-1, type = "numeric", rngIncl = c(1, 3), validValues = c(-1, 0)))
    expect_error(.assertScalar(-1, type = "numeric", rngIncl = c(1, 3), validValues = 0))
    expect_true(.assertScalar(-1, type = "numeric", validValues = c(-1, 0)))
    expect_error(.assertScalar(-1, type = "numeric", validValues = c(-2, 0)))
    expect_true(.assertScalar(NA_real_, type = "numeric", rngIncl = c(1, 2), validValues = NA_real_))
    expect_error(.assertScalar(NA, type = "numeric", rngIncl = c(1, 2), validValues = NA_real_))
    expect_true(.assertScalar(NA_real_, type = "numeric", rngIncl = c(1, 2), validValues = NA))
    expect_true(.assertScalar(1, type = "numeric", rngIncl = c(0, 3), validValues = 3))
    expect_true(.assertScalar(1, rngIncl = c(0, 3), validValues = 3))
    expect_true(.assertScalar(1, type = "numeric", rngIncl = c(0, 1)))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = c(0, 1)))
    expect_true(.assertScalar(1, type = "numeric", rngExcl = c(0, 1), validValues = 1))
    expect_error(.assertScalar(1, type = "numeric", rngExcl = c(0, 1), validValues = 3:4))
    expect_true(.assertScalar(NULL, type = "numeric", allowNULL = TRUE))
    expect_error(.assertScalar(NULL, type = "numeric", allowNULL = FALSE))
    expect_error(.assertScalar(1, type = "character"))
    expect_error(.assertScalar("x", type = "numeric"))
    expect_error(.assertScalar(FALSE, type = "character"))
    expect_error(.assertScalar(c(1, 2), type = "numeric"))
    test <- "text"
    expect_error(.assertScalar(x = test, type = "numeric"),
                 ".test. must be of class .numeric.")
    expect_error(.assertScalar(x = list(a = 1)$a, type = "logical"),
                 "list(a = 1)$a", fixed = TRUE)
    tmp <- matrix(1:4, ncol = 2)
    expect_error(.assertScalar(x = tmp[, 1], type = "logical"),
                 "tmp[, 1]", fixed = TRUE)
})

## -------------------------------------------------------------------------- ##
## Checks, .assertVector
## -------------------------------------------------------------------------- ##
test_that(".assertVector works", {
    expect_error(.assertVector(1, type = TRUE))
    expect_error(.assertVector(1, type = 1))
    expect_error(.assertVector(1, type = c("numeric", "character")))
    expect_error(.assertVector(1, type = "numeric", rngIncl = TRUE))
    expect_error(.assertVector(1, type = "numeric", rngIncl = "rng"))
    expect_error(.assertVector(1, type = "numeric", rngIncl = 1))
    expect_error(.assertVector(1, type = "numeric", rngIncl = 1:3))
    expect_error(.assertVector(1, type = "numeric", rngExcl = TRUE))
    expect_error(.assertVector(1, type = "numeric", rngExcl = "rng"))
    expect_error(.assertVector(1, type = "numeric", rngExcl = 1))
    expect_error(.assertVector(1, type = "numeric", rngExcl = 1:3))
    expect_error(.assertVector(1, type = "numeric", rngIncl = c(0, 2), rngExcl = c(0, 2)))
    expect_error(.assertVector(1, type = "numeric", allowNULL = 1))
    expect_error(.assertVector(1, type = "numeric", allowNULL = "rng"))
    expect_error(.assertVector(1, type = "numeric", allowNULL = NULL))
    expect_error(.assertVector(1, type = "numeric", allowNULL = c(TRUE, FALSE)))
    expect_error(.assertVector(1, type = "numeric", len = TRUE))
    expect_error(.assertVector(1, type = "numeric", len = "rng"))
    expect_error(.assertVector(1, type = "numeric", len = 1:3))
    expect_error(.assertVector(1, type = "numeric", rngLen = TRUE))
    expect_error(.assertVector(1, type = "numeric", rngLen = "rng"))
    expect_error(.assertVector(1, type = "numeric", rngLen = 1))
    expect_error(.assertVector(1, type = "numeric", rngLen = 1:3))

    expect_true(.assertVector(c(1, 2), type = "numeric", rngIncl = c(1, 3)))
    expect_error(.assertVector(c(1, 2), type = "numeric", rngIncl = c(1, 1.5)))
    expect_error(.assertVector(c(1, 2), type = "numeric", rngExcl = c(1, 3)))
    expect_true(.assertVector(c(1, 2), type = "numeric", rngExcl = c(1, 3), validValues = 1))
    expect_error(.assertVector(c(1, 2), type = "numeric", validValues = c(1, 3)))
    expect_true(.assertVector(c(1, 2), type = "numeric", validValues = c(1, 2)))
    expect_error(.assertVector(c(1, 2), type = "numeric", len = 1))
    expect_true(.assertVector(c(1, 2), type = "numeric", len = 2))
    expect_error(.assertVector(c(1, 2), type = "numeric", rngLen = c(3, 5)))
    expect_true(.assertVector(c(1, 2), type = "numeric", rngLen = c(2, 5)))
    expect_true(.assertVector(c(1, 2), type = "numeric", rngLen = c(1, 2)))
    expect_error(.assertVector(c("a", "b"), type = "character", validValues = c("A", "B")))
    expect_true(.assertVector(LETTERS[1:2], type = "character", validValues = LETTERS))
    test <- "text"
    expect_error(.assertVector(x = test, type = "numeric"),
                 ".test. must be of class .numeric.")
})

## -------------------------------------------------------------------------- ##
## Checks, .assertPackagesAvailable
## -------------------------------------------------------------------------- ##
test_that(".assertPackagesAvailable works", {
    testfunc <- function(...) .assertPackagesAvailable(...)
    expect_error(testfunc(1L))
    expect_error(testfunc("test", "error"))
    expect_error(testfunc("test", c(TRUE, FALSE)))
    
    expect_true(testfunc("base"))
    expect_true(testfunc("githubuser/base"))
    expect_true(testfunc(c("base", "methods")))
    expect_error(testfunc(c("error", "error2")), "BiocManager")
    expect_error(testfunc("error1", suggestInstallation = FALSE), "installed.\n$")
    rm(testfunc)
})

## -------------------------------------------------------------------------- ##
## Checks, .assertColor
## -------------------------------------------------------------------------- ##
test_that(".assertColor works", {
    expect_error(.assertColor(x = "nocolor"), "not a valid color")
    expect_error(.assertColor(x = c("nocolor1", "nocolor2")), "not a valid color")
    expect_error(.assertColor(x = c("green", "nocolor2")), "not a valid color")
    expect_error(.assertColor(x = 1), "must be of class")
    expect_true(.assertColor(x = "green"))
    expect_true(.assertColor(x = "#562108"))
})

#' @title Calculate motif enrichment
#'
#' @description Given motif counts, foreground/background labels and
#'   weights for a set of sequences, calculate the enrichment of each motif
#'   in foreground compared to background. This function is called by
#'   \code{calcBinnedMotifEnrR()} for each bin.
#'
#'   The default type of test is \code{"fisher"}, which is also what
#'   \code{Homer} uses if "-h" is specified for a hypergeometric test.
#'   Alternatively, a binomial test can be used by \code{test = "binomial"}
#'   (what \code{Homer} does by default). Using Fisher's exact test has
#'   the advantage that special cases such as zero background counts are
#'   handled without ad-hoc adjustments to the frequencies.
#'
#'   For \code{test = "fisher"}, \code{fisher.test} is used with
#'   \code{alternative = "greater"}, making it a one-sided test for enrichment,
#'   as is the case with the binomial test.
#'
#' @param motifHitMatrix Matrix with 0 and 1 entries for absence or presence of
#'   motif hits in each sequence.
#' @param df A \code{DataFrame} with sequence information as returned by
#'   \code{.iterativeNormForKmers()}.
#' @param test Type of motif enrichment test to perform.
#' @param verbose A logical scalar. If \code{TRUE}, report on progress.
#'
#' @return A \code{data.frame} containing the motifs as rows and the columns:
#'   \describe{
#'     \item{motifName}{: the motif name}
#'     \item{logP}{: the log p-value for enrichment (natural logarithm).
#'        If \code{test="binomial"} (default), this log p-value is identical to
#'        the one returned by Homer.}
#'     \item{sumForegroundWgtWithHits}{: the sum of the weights of the
#'        foreground sequences that have at least one instance of a specific
#'        motif (ZOOPS mode).}
#'     \item{sumBackgroundWgtWithHits}{: the sum of the weights of the
#'        background sequences that have at least one instance of a specific
#'        motif (ZOOPS mode).}
#'     \item{totalWgtForeground}{: the total sum of weights of foreground
#'        sequences.}
#'     \item{totalWgtBackground}{: the total sum of weights of background
#'        sequences.}
#'   }
#'
#' @importFrom stats pbinom fisher.test
#' @importFrom cli cli_abort
#'
#' @keywords internal
.calcMotifEnrichment <- function(motifHitMatrix,
                                 df,
                                 test = c("fisher", "binomial"),
                                 verbose = FALSE){

    # checks
    if (!is.matrix(motifHitMatrix)) {
        cli_abort("{.arg motifHitMatrix} has to be a matrix")
    }
    if (nrow(motifHitMatrix) != nrow(df)) {
        cli_abort("{.arg motifHitMatrix} and {.arg df} must have the same number of rows")
    }
    if (!is.null(rownames(motifHitMatrix)) && !is.null(rownames(df)) &&
        !identical(rownames(motifHitMatrix), rownames(df))) {
        cli_abort("{.arg motifHitMatrix} and {.arg df} must have identical rownames")
    }
    .checkDfValidity(df)
    test <- match.arg(test)
    .assertScalar(x = verbose, type = "logical")

    totalWgtForeground <- sum(df$seqWgt[df$isForeground])
    totalWgtBackground <- sum(df$seqWgt[!df$isForeground])

    motifHitMatrixWeighted <- motifHitMatrix * df$seqWgt
    TFmatchedSeqCountForeground <-
      colSums(motifHitMatrixWeighted[df$isForeground, , drop = FALSE])
    TFmatchedSeqCountBackground <-
      colSums(motifHitMatrixWeighted[!df$isForeground, , drop = FALSE])

    # calculate motif enrichment
    if (identical(test, "binomial")) {
        logP <- .binomEnrichmentTest(
            matchCountBg = TFmatchedSeqCountBackground,
            totalWeightBg = totalWgtBackground,
            matchCountFg = TFmatchedSeqCountForeground,
            totalWeightFg = totalWgtForeground,
            verbose = verbose
        )
    } else if (identical(test, "fisher")) {
        logP <- .fisherEnrichmentTest(
            matchCountBg = TFmatchedSeqCountBackground,
            totalWeightBg = totalWgtBackground,
            matchCountFg = TFmatchedSeqCountForeground,
            totalWeightFg = totalWgtForeground,
            verbose = verbose
        )
    }

    return(data.frame(motifName = names(logP),
                      logP = logP,
                      sumForegroundWgtWithHits = TFmatchedSeqCountForeground,
                      sumBackgroundWgtWithHits = TFmatchedSeqCountBackground,
                      totalWgtForeground = totalWgtForeground,
                      totalWgtBackground = totalWgtBackground))
}


#' @title Binned Motif Enrichment Analysis with \code{monaLisa}
#'
#' @description This function performs a motif enrichment analysis on bins of
#'   sequences. For each bin, the sequences in all other bins are used as
#'   background.
#'
#' @param seqs \code{\link[Biostrings]{DNAStringSet}} object with sequences to
#'   test
#' @param bins Factor of the same length and order as \code{seqs}, indicating
#'   the bin for each sequence. Typically the return value of
#'   \code{\link[monaLisa]{bin}}. For \code{background = "genome"}, \code{bins}
#'   can be omitted.
#' @param pwmL \code{PWMatrixList} with motifs for which to calculate 
#'   enrichments.
#' @param background A \code{character} scalar specifying the background
#'   sequences to use. One of \code{"otherBins"} (default), \code{"allBins"},
#'   \code{"zeroBin"} or \code{"genome"} (see "Details").
#' @param test A \code{character} scalar specifying the type of enrichment test
#'   to perform. One of \code{"fisher"} (default) or \code{"binomial"}. The
#'   enrichment test is one-sided (enriched in foreground).
#' @param maxFracN A numeric scalar with the maximal fraction of N bases allowed
#'   in a sequence (defaults to 0.7). Sequences with higher fractions are
#'   excluded from the analysis.
#' @param maxKmerSize The maximum k-mer size to consider, when adjusting
#'   background sequence weights for k-mer composition compared to the
#'   foreground sequences. The default value (3) will correct for mono-, di-
#'   and tri-mer composition.
#' @param min.score The minimal score for motif hits, used in
#'   \code{\link[monaLisa]{findMotifHits}}.
#' @param matchMethod The method used to scan for motif hits, passed to the
#'   \code{method} parameter in \code{\link[monaLisa]{findMotifHits}}.
#' @param GCbreaks The breaks between GC bins. The default value is based on
#'   the hard-coded bins used in Homer.
#' @param pseudocount.log2enr A numerical scalar with the pseudocount to add to
#'   foreground and background counts when calculating log2 motif enrichments
#' @param p.adjust.method A character scalar selecting the p value adjustment
#'   method (used in \code{\link[stats]{p.adjust}}).
#' @param genome A \code{BSgenome} or \code{DNAStringSet} object with the
#'   genome sequence. Only used for \code{background = "genome"} for extracting
#'   background sequences.
#' @param genome.regions An optional \code{\link[GenomicRanges]{GRanges}} object
#'   defining the intervals in \code{genome} from which background sequences are
#'   sampled for \code{background = "genome"}. If \code{NULL}, background
#'   sequences are sampled randomly from \code{genome}.
#' @param genome.oversample A \code{numeric} scalar of at least 1.0 defining how
#'   many background sequences will be sampled per foreground sequence for
#'   \code{background = "genome"}. Larger values will take longer but improve
#'   the sequence composition similarity between foreground and background
#'   (see \code{"Details"}).
#' @param BPPARAM An optional \code{\link[BiocParallel]{BiocParallelParam}}
#'     instance determining the parallel back-end to be used during evaluation.
#' @param verbose A logical scalar. If \code{TRUE}, print progress messages.
#' @param ... Additional arguments for  \code{\link[monaLisa]{findMotifHits}}.
#'
#' @details This function implements a binned motif enrichment analysis. In each
#'   enrichment analysis, the sequences in a specific bin are used as foreground
#'   sequences to test for motif enrichments comparing to background sequences
#'   (defined by \code{background}, see below). The logic follows the
#'   \code{findMotifsGenome.pl} tool from \code{Homer} version 4.11, with
#'   \code{-size given -nomotif -mknown} and additionally \code{-h} if using
#'   \code{test = "fisher"}, and gives very similar results. As in the
#'   \code{Homer} tool, sequences are weighted to correct for GC and k-mer
#'   composition differences between fore- and background sets.
#'
#'   The background sequences are defined according to the value of the
#'   \code{background} argument:
#'   \describe{
#'     \item{otherBins}{: sequences from all other bins (excluding the current
#'       bin)}
#'     \item{allBins}{: sequences from all bins (including the current bin)}
#'     \item{zeroBin}{: sequences from the "zero bin", defined by the
#'       \code{maxAbsX} argument of \code{\link[monaLisa]{bin}}. If \code{bins}
#'       does not define a "zero bin", for example because it was created by
#'       \code{bin(..., maxAbsX = NULL)}, selecting this background definition
#'       will abort with an error.}
#'     \item{genome}{: sequences randomly sampled from the genome (or the
#'       intervals defined in \code{genome.regions} if given). For each
#'       foreground sequence, \code{genome.oversample} background sequences
#'       of the same size are sampled (on average). From these, one per
#'       foreground sequence is selected trying to match the G+C composition.
#'       In order to make the sampling deterministic, a seed number needs to be
#'       provided to the \code{RNGseed} parameter in
#'       \code{\link[BiocParallel]{SerialParam}}
#'       or \code{\link[BiocParallel]{MulticoreParam}} when creating the
#'       \code{BiocParallelParam} instance in \code{BPPARAM}.}
#'   }
#'
#'   Motif hits are predicted using \code{\link[monaLisa]{findMotifHits}} and
#'   multiple hits per sequence are counted as just one hit (ZOOPS mode). For
#'   each motif, the weights of sequences that have a hit are summed separately
#'   for foreground (\code{sumForegroundWgtWithHits}) and background
#'   (\code{sumBackgroundWgtWithHits}). The total foreground
#'   (\code{totalWgtForeground}) and background (\code{totalWgtBackground})
#'   sum of sequence weights is also calculated. If a motif has zero
#'   \code{sumForegroundWgtWithHits} and \code{sumBackgroundWgtWithHits},
#'   then any values (p-values and enrichment) that are calculated using
#'   these two numbers are set to NA.
#'
#'   Two statistical tests for the calculation of enrichment log p-value are
#'   available: \code{test = "fisher"} (default) to perform Fisher's exact
#'   tests, or \code{test = "binomial"} to perform binomial tests
#'   (default in \code{Homer}), using:
#'   \describe{
#'     \item{fisher}{: \code{fisher.test(x = tab, alternative =
#'       "greater")}, where \code{tab} is the contingency table with the summed
#'       weights of sequences in foreground or background sets (rows), and with
#'       or without a hit for a particular motif (columns).}
#'     \item{binomial}{: \code{pbinom(q = sumForegroundWgtWithHits - 1, size =
#'       totalWgtForeground,
#'       prob = sumBackgroundWgtWithHits / totalWgtBackground,
#'       lower.tail = FALSE, log.p = TRUE)}}
#'   }
#'
#' @return A \code{\link[SummarizedExperiment]{SummarizedExperiment}} object
#'   with motifs in rows and bins in columns, containing seven assays: \describe{
#'   \item{negLog10P}{: -log10 P values}
#'   \item{negLog10Padj}{: -log10 adjusted P values}
#'   \item{pearsonResid}{: motif enrichments as Pearson residuals}
#'   \item{expForegroundWgtWithHits}{: expected number of foreground
#'     sequences with motif hits}
#'   \item{log2enr}{: motif enrichments as log2 ratios}
#'   \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
#'     in a bin that have motif hits}
#'   \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
#'     in a bin that have motif hits}
#' }
#' The \code{rowData} of the object contains annotations (name, PFMs, PWMs
#' and GC fraction) for the motifs, while the \code{colData} slot contains
#' summary information about the bins.
#'
#' @examples
#' seqs <- Biostrings::DNAStringSet(c("GTCAGTCGATC", "CAGTCTAGCTG",
#'                                    "CGATCGTCAGT", "AGCTGCAGTCT"))
#' bins <- factor(rep(1:2, each = 2))
#' m <- rbind(A = c(2, 0, 0),
#'            C = c(1, 1, 0),
#'            G = c(0, 2, 0),
#'            T = c(0, 0, 3))
#' pwms <- TFBSTools::PWMatrixList(
#'     TFBSTools::PWMatrix(ID = "m1", profileMatrix = m),
#'     TFBSTools::PWMatrix(ID = "m2", profileMatrix = m[, 3:1])
#' )
#' calcBinnedMotifEnrR(seqs = seqs, bins = bins, pwmL = pwms,
#'                     min.score = 3)
#'
#' @importFrom TFBSTools ID name
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom S4Vectors DataFrame
#' @importFrom Seqinfo seqnames seqlevels
#' @importFrom BiocParallel bplapply SerialParam bpnworkers
#' @importFrom stats p.adjust
#' @importFrom cli cli_abort cli_progress_step
#'
#' @export
calcBinnedMotifEnrR <- function(seqs,
                                bins = NULL,
                                pwmL = NULL,
                                background = c("otherBins", "allBins",
                                               "zeroBin", "genome"),
                                test = c("fisher", "binomial"),
                                maxFracN = 0.7,
                                maxKmerSize = 3L,
                                min.score = 10,
                                matchMethod = "matchPWM",
                                GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4,
                                             0.45, 0.5, 0.6, 0.7, 0.8),
                                pseudocount.log2enr = 8,
                                p.adjust.method = "BH",
                                genome = NULL,
                                genome.regions = NULL,
                                genome.oversample = 2,
                                BPPARAM = SerialParam(),
                                verbose = FALSE,
                                ...) {

    # checks
    .assertVector(x = seqs, type = "DNAStringSet")
    background <- match.arg(background)
    if (is.null(bins) && identical(background, "genome")) {
        bins <- factor(rep(1, length(seqs)))
    }
    .assertVector(x = bins, type = "factor")
    if (length(seqs) != length(bins)) {
        cli_abort("{.arg seqs} and {.arg bins} must be of equal length")
    }
    .assertVector(x = pwmL, type = "PWMatrixList")
    .assertScalar(x = pseudocount.log2enr, type = "numeric",
                  rngIncl = c(0, Inf))
    .assertScalar(x = p.adjust.method, type = "character",
                  validValues = stats::p.adjust.methods)
    if (identical(background, "zeroBin") &&
        (is.null(getZeroBin(bins)) || is.na(getZeroBin(bins)))) {
        cli_abort(c("For {.code background = 'zeroBin'}, {.arg bins} has to define a zero bin ",
                    "(see {.arg maxAbsX} arugment of {.fn bin} function)."))
    }
    if (identical(background, "genome")) {
        if (is.null(genome) || !(is(genome, "DNAStringSet") ||
                                 is(genome, "BSgenome"))) {
            cli_abort(c("For {.code background = 'genome'}, {.arg genome} must be either a ",
                        "{.cls DNAStringSet} or a {.cls BSgenome} object."))
        }
        if (!is.null(genome.regions)) {
            if (!is(genome.regions, "GRanges")) {
                cli_abort(c("For {.code background = 'genome'}, {.arg genome.regions} must be ",
                            "either {.code NULL} or a {.cls GRanges} object."))
            }
            if (!all(seqlevels(genome.regions) %in% names(genome))) {
                cli_abort("{.arg genome.regions} contains seqlevels not contained in {.arg genome}")
            }
        }
        .assertScalar(x = genome.oversample, type = "numeric",
                      rngIncl = c(1, Inf))
    }
    .assertVector(x = BPPARAM, type = "BiocParallelParam")
    .assertScalar(x = verbose, type = "logical")
    if (is.null(names(seqs))) {
        names(seqs) <- paste0("s", seq_along(seqs))
    }
    .checkIfSeqsAreEqualLength(x = seqs)


    # filter sequences
    .message("Filtering sequences ...")
    keep <- .filterSeqs(seqs, maxFracN = maxFracN, verbose = verbose)
    battr <- attributes(bins) # rescue attributes dropped by subsetting
    bin0 <- getZeroBin(bins)
    bins <- bins[keep]
    attr(bins, "binmode") <- battr$binmode
    attr(bins, "breaks") <- battr$breaks
    if (!is.null(bin0)) {
        bins <- setZeroBin(bins, bin0)
    }
    seqs <- seqs[keep]

    # stop if all sequences were filtered out
    if (sum(keep) == 0) {
      cli_abort(paste0(
          "No sequence passed the filtering step. Cannot proceed with the ",
          "enrichment analysis ..."))
    }

    # scan sequences with motif
    .message("Scanning sequences for motif hits...")
    hits <- findMotifHits(query = pwmL, subject = seqs, min.score = min.score,
                          method = matchMethod, BPPARAM = BPPARAM, ...)
    if (isEmpty(hits)) {
        cli_abort("No motif hits found in any of the sequences - aborting.")
    }


    # create motif hit matrix
    .message("Create motif hit matrix...")
    hitmatrix <- unclass(table(
        factor(seqnames(hits), levels = seqlevels(hits)),
        factor(hits$pwmid, levels = TFBSTools::ID(pwmL))
    ))
    # zoops (zero or one per sequence) mode
    hitmatrix[hitmatrix > 0] <- 1

    # iterate over bins
    enrichL <- bplapply(structure(seq.int(nlevels(bins)), names = levels(bins)),
                        function(i) {

        .message("starting analysis of bin {levels(bins)[i]}")
        verbose1 <- verbose && bpnworkers(BPPARAM) == 1L

        # define background set and create sequence info data frame
        if (verbose1) {
            cli_progress_step("Defining background sequence set ({background})...")
        }
        df <- .defineBackground(sqs = seqs,
                                bns = bins,
                                bg = background,
                                currbn = i,
                                gnm = genome,
                                gnm.regions = genome.regions,
                                gnm.oversample = genome.oversample,
                                maxFracN = maxFracN)

        # for background = "genome", scan sampled background sequences for
        # motifs
        if (identical(background, "genome")) {
            if (verbose1) {
                cli_progress_step("Scanning genomic background sequences for motif hits...")
            }
            hits.genome <- findMotifHits(
                query = pwmL, subject = df$seqs[!df$isForeground],
                min.score = min.score, method = matchMethod,
                BPPARAM = BPPARAM, ...)
            if (isEmpty(hits.genome)) {
              cli_abort(paste0(
                  "No motif hits found in any of the genomic background ",
                  "sequences - aborting."))
            }

            # create motif hit matrix
            hitmatrix.genome <- unclass(
                table(factor(seqnames(hits.genome),
                             levels = seqlevels(hits.genome)),
                      factor(hits.genome$pwmid,
                             levels = TFBSTools::ID(pwmL)))
            )
            # zoops (zero or one per sequence) mode
            hitmatrix.genome[hitmatrix.genome > 0] <- 1

            hitmatrix2 <- rbind(hitmatrix, hitmatrix.genome)

        } else {
            hitmatrix2 <- hitmatrix
        }

        # calculate initial background sequence weights based on G+C composition
        if (verbose1) {
            cli_progress_step("Correcting for GC differences to the background sequences...")
        }
        df <- .calculateGCweight(df = df,
                                 GCbreaks = GCbreaks,
                                 verbose = verbose1)

        # if df is empty, then all seqs were filtered out in the GC weight
        # calculation step
        if (nrow(df) == 0) {
          cli_abort(c(
              "No sequences remained after the GC weight calculation ",
              "step in bin {.emph {levels(bins)[i]}} due to no GC bin ",
              "containing both fore- and background sequences. ",
              "Cannot proceed with the enrichment analysis ..."))
        }

        # update background sequence weights based on k-mer composition
        if (verbose1) {
            cli_progress_step(paste0(
                "Correcting for k-mer differences between fore- and ",
                "background sequences..."))
        }
        df <- .iterativeNormForKmers(df = df,
                                     maxKmerSize = maxKmerSize,
                                     verbose = verbose1)

        # calculate motif enrichments
        if (verbose1) {
            cli_progress_step("Calculating motif enrichment...")
        }
        enrich1 <- .calcMotifEnrichment(
            motifHitMatrix = hitmatrix2[rownames(df), , drop = FALSE],
            df = df, test = test, verbose = verbose1
        )
        return(enrich1)

    }, BPPARAM = BPPARAM)


    # summarize results as SE
    # ... -log10 of P value
    P <- do.call(cbind, lapply(enrichL, function(enrich1) {
        logpVals <- -enrich1[, "logP"] / log(10)
        names(logpVals) <- enrich1[, "motifName"]
        logpVals
    }))

    # ... -log10 of adjusted P value
    padj <- matrix(-log10(p.adjust(as.vector(10**(-P)),
                                   method = p.adjust.method)), nrow = nrow(P))
    dimnames(padj) <- dimnames(P)
    padj[which(padj == Inf, arr.ind = TRUE)] <- max(padj[is.finite(padj)])

    # ... Pearson residuals
    enrTF <- do.call(cbind, lapply(enrichL, function(enrich1) {
        enr <- .calcPearsonResiduals(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"])
        )
        names(enr) <- enrich1[, "motifName"]
        enr
    }))

    # expected foreground weights
    expFG <- do.call(cbind, lapply(enrichL, function(enrich1) {
        expfg <- .calcExpFg(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"])
        )
        names(expfg) <- enrich1[, "motifName"]
        expfg
    }))

    # log2 enrichments
    log2enr <- do.call(cbind, lapply(enrichL, function(enrich1) {
        l2e <- .calcLog2Enr(
            matchCountBg = enrich1[, "sumBackgroundWgtWithHits"],
            totalWeightBg = unique(enrich1[, "totalWgtBackground"]),
            matchCountFg = enrich1[, "sumForegroundWgtWithHits"],
            totalWeightFg = unique(enrich1[, "totalWgtForeground"]),
            pseudocount = pseudocount.log2enr
        )
        names(l2e) <- enrich1[, "motifName"]
        l2e
    }))

    # return SummarizedExperiment
    pfmL <- do.call(TFBSTools::PFMatrixList, lapply(pwmL, function(x) {
        m <- TFBSTools::Matrix(x)
        m <- 2^m * 0.25 # assuming uniform background and no pseudocounts
        PFMatrix(ID = TFBSTools::ID(x),
                 name = TFBSTools::name(x),
                 profileMatrix = m * 100)
    }))
    percentGC <- unlist(lapply(pfmL, function(x) {
        x <- TFBSTools::Matrix(x)
        100 * sum(x[c("C","G"), ]) / sum(x)
    }), use.names = FALSE)
    rdat <- DataFrame(motif.id = TFBSTools::ID(pwmL),
                      motif.name = TFBSTools::name(pwmL),
                      motif.pfm = pfmL,
                      motif.pwm = pwmL,
                      motif.percentGC = percentGC)
    if (is.null(attr(bins, "breaks"))) {
        binL <- binH <- rep(NA, nlevels(bins))
    } else {
        binL <- attr(bins, "breaks")[-(nlevels(bins) + 1)]
        binH <- attr(bins, "breaks")[-1]
    }
    cdat <- DataFrame(
        bin.names = levels(bins),
        bin.lower = binL,
        bin.upper = binH,
        bin.nochange = seq.int(nlevels(bins)) %in% getZeroBin(bins),
        totalWgtForeground = do.call(c, lapply(enrichL, function(x) {
            x$totalWgtForeground[1]
        })),
        totalWgtBackground = do.call(c, lapply(enrichL, function(x) {
            x$totalWgtBackground[1]
        })))
    mdat <- list(bins = bins,
                 bins.binmode = attr(bins, "binmode"),
                 bins.breaks = as.vector(attr(bins, "breaks")),
                 bins.bin0 = getZeroBin(bins),
                 param = list(method = "R",
                              background = background,
                              test = test,
                              maxFracN = maxFracN,
                              maxKmerSize = maxKmerSize,
                              min.score = min.score,
                              matchMethod = matchMethod,
                              pseudocount.log2enr = pseudocount.log2enr,
                              p.adj.method = p.adjust.method,
                              genome.class = class(genome),
                              genome.regions = genome.regions,
                              genome.oversample = genome.oversample,
                              BPPARAM.class = class(BPPARAM),
                              BPPARAM.bpnworkers = bpnworkers(BPPARAM),
                              verbose = verbose))
    assaySumForegroundWgtWithHits <-
        do.call(cbind, lapply(enrichL, function(x){x$sumForegroundWgtWithHits}))
    assaySumBackgroundWgtWithHits <-
        do.call(cbind, lapply(enrichL, function(x){x$sumBackgroundWgtWithHits}))

    # ... set motifs with zero fore- and background sums to NA
    assayFgBgSum <- assaySumForegroundWgtWithHits +
        assaySumBackgroundWgtWithHits
    set_NA <- assayFgBgSum == 0
    P[set_NA] <- NA
    padj[set_NA] <- NA
    enrTF[set_NA] <- NA
    expFG[set_NA] <- NA
    log2enr[set_NA] <- NA

    se <- SummarizedExperiment(
      assays = list(negLog10P = P,
                    negLog10Padj = padj,
                    pearsonResid = enrTF,
                    expForegroundWgtWithHits = expFG,
                    log2enr = log2enr,
                    sumForegroundWgtWithHits = assaySumForegroundWgtWithHits,
                    sumBackgroundWgtWithHits = assaySumBackgroundWgtWithHits),
      rowData = rdat, colData = cdat, metadata = mdat
    )

    return(se)
}

#' @importFrom tools file_path_as_absolute
#' @importFrom utils read.delim write.table getFromNamespace
#' @importFrom stats p.adjust
#' @importFrom methods as
NULL


#' @title Find HOMER script file.
#'
#' @description Find absolute path to HOMER script file.
#'
#' @param homerfile Name of the script file to search.
#' @param dirs Directory names to look for \code{homerfile}. If
#'  \code{dirs=NULL}, all directories listed in the \code{PATH} environment
#'  variable will be searched.
#'
#' @details In addition to \code{dirs}, \code{findHomer} will also look in the
#'     directory provided in the environment variable \code{MONALISA_HOMER}.
#'
#' @return Absolute path to \code{homerfile}, or \code{NA} if none or several
#'   were found.
#'
#' @examples
#' homer_path <- findHomer()
#'
#' @export
findHomer <- function(homerfile = "findMotifsGenome.pl", dirs = NULL) {
    if (is.null(dirs))
        dirs <- strsplit(x = Sys.getenv("PATH"), split = ":")[[1]]
    monalisa_homer <- Sys.getenv("MONALISA_HOMER", unset = NA)
    if (!is.na(monalisa_homer))
        dirs <- c(strsplit(x = monalisa_homer, split = ":")[[1]], dirs)
    dirs <- unique(dirs)
    res <- list.files(path = dirs, pattern = paste0("^",homerfile,"$"),
                      full.names = TRUE, recursive = FALSE)
    if (length(res) == 1) {
        return(tools::file_path_as_absolute(res))
    } else {
        return(NA)
    }
}


#' @title Dump Jaspar motifs into a HOMER motif file.
#'
#' @description Get motifs from a Jaspar database package (e.g.
#'     \code{JASPAR2020}) and write them into a HOMER-compatible motif file
#'     as positional probability matrices.
#'
#' @param filename Name of the output file to be created.
#' @param pkg Name of the Jaspar package to use (default: \code{JASPAR2020}).
#' @param opts A list with search options used in
#'     \code{\link[TFBSTools]{getMatrixSet}}. By default, only vertebrate motifs
#'     are included in the output using
#'     \code{opts = list(tax_group = "vertebrates")}.
#' @param pseudocount A numerical scalar with the pseudocount to be added to
#'     each element of the position frequency matrix extracted from Jaspar,
#'     before its conversion to a position probability matrix (default: 1.0).
#' @param relScoreCutoff Currently ignored. numeric(1) in [0,1] that sets the
#'     default motif log-odds score cutof to relScoreCutoff * maximal score for
#'     each PWM (default: 0.8).
#' @param verbose A logical scalar. If \code{TRUE}, print progress messages.
#'
#' @return \code{TRUE} if successful.
#'
#' @seealso \code{\link[TFBSTools]{getMatrixSet}} for details on the argument
#'     \code{opts}. \code{\link{homerToPFMatrixList}} to read a file with
#'     HOMER-formatted motifs into a \code{\link[TFBSTools]{PFMatrixList}}.
#'
#' @examples
#' dumpJaspar(filename = tempfile(), pkg = "JASPAR2020",
#'            opts = list(ID = c("MA0006.1")))
#'
#' @importFrom utils getFromNamespace
#' @importFrom methods existsMethod
#' @importFrom TFBSTools getMatrixSet Matrix ID name
#' @importFrom RSQLite dbConnect dbDisconnect SQLite
#' @importFrom cli cli_abort
#'
#' @export
dumpJaspar <- function(filename,
                       pkg = "JASPAR2020",
                       opts = list(tax_group = "vertebrates"),
                       pseudocount = 1,
                       relScoreCutoff = 0.8,
                       verbose = FALSE) {
    .assertScalar(x = filename, type = "character")
    stopifnot(!file.exists(filename))
    .assertScalar(x = pseudocount, type = "numeric", rngIncl = c(0, Inf))
    .assertScalar(x = relScoreCutoff, type = "numeric", rngIncl = c(0, 1))
    if ("matrixtype" %in% names(opts) && opts[["matrixtype"]] != "PFM") {
      cli_abort("{.arg opts[['matrixtype']]} must be set to {.code 'PFM'}")
    } else {
      opts[["matrixtype"]] <- "PFM"
    }
    .assertScalar(x = verbose, type = "logical")

    # load PFMs and convert to HOMER format (base probabilties)
    requireNamespace(pkg)
    mdb <- utils::getFromNamespace(pkg, ns = pkg)
    if (!methods::existsMethod(f = getMatrixSet, signature = list(x = class(mdb)))) {
        # workaround for JASPAR2024 (no specific TFBSTools::getMatrixSet method yet)
        if (inherits(mdb, "function") && exists("db", envir = asNamespace(pkg))) {
            jobj <- do.call(what = mdb, args = list())
            dbfunc <- getFromNamespace(x = "db", ns = pkg)
            mdb <- RSQLite::dbConnect(RSQLite::SQLite(), dbfunc(jobj))
            on.exit(expr = RSQLite::dbDisconnect(mdb))
        } else {
            cli_abort("I don't know how to extract motifs from {.pkg {pkg}}")
        }
    }
    siteList <- TFBSTools::getMatrixSet(mdb, opts)
    .message("extracted {length(siteList)} motifs from {.pkg pkg}", noTimer = TRUE)

    # remark: pseudocount of 4 corresponds to adding 1 to each base count
    #         the following are identical:
    #wm1 <- Matrix(toPWM(siteList[[1]], type="prob", pseudocounts=4.0))
    #wm2 <- Matrix(siteList[[1]])+1 ; wm2 <- t(t(wm2) /colSums(wm2))
    #identical(wm1, wm2)

    .message("converting to HOMER format...")
    fh <- file(filename, "wb")
    for (i in seq_len(length(siteList))) {
        ppm <- TFBSTools::Matrix(siteList[[i]]) + pseudocount
        ppm <- t(t(ppm) / colSums(ppm))
        tmp.rn <- rownames(ppm)
        #scorecut <- relScoreCutoff * sum(log(apply(ppm, 2, max) / 0.25))
        # use constant cutoff for all motifs (ignore relScoreCutoff)
        scorecut <- log(2**10)
        ppm <- apply(ppm, 2, function(x){sprintf("%.3f", x)})
        rownames(ppm) <- tmp.rn
        wm.name <- paste0(TFBSTools::ID(siteList[[i]]), ":::",
                          TFBSTools::name(siteList[[i]]))

        # the -10 is added so that the motif file has 4 columns,
        # which is needed to run compareMotifs.pl for weight matrix clustering
        # (4th column not used, bug in compareMotifs.pl, I think)
        cat(sprintf(">%s\t%s\t%.2f\t-10\n",
                    paste(apply(ppm, 2, function(x) {
                        rownames(ppm)[which.max(x)]
                    }), collapse = ""),
                    wm.name, scorecut),  file = fh, append = TRUE)
        write.table(file = fh, t(ppm), row.names = FALSE, col.names = FALSE,
                    sep = "\t", quote = FALSE, append = TRUE)
        flush(fh)
    }
    close(fh)

    return(TRUE)
}


#' @title Read a HOMER motif file and create a PFMatrixList
#'
#' @description Read motifs from a file in HOMER format and create
#'     a PFMatrixList from them.
#'
#' @param filename Name of the input file with HOMER-formatted motifs.
#' @param n The number of observations (multiplied with base frequencies to
#'     create the number of observed bases at each position).
#'
#' @return A \code{\link[TFBSTools]{PFMatrixList}} with motifs from the file.
#'
#' @examples
#' library(JASPAR2020)
#' optsL <- list(ID = c("MA0006.1"))
#' pfm1 <- TFBSTools::getMatrixSet(JASPAR2020, opts = optsL)
#' TFBSTools::Matrix(pfm1)
#'
#' tmpfn <- tempfile()
#' dumpJaspar(filename = tmpfn, pkg = "JASPAR2020", opts = optsL)
#' pfm2 <- homerToPFMatrixList(tmpfn)
#' TFBSTools::Matrix(pfm2)
#'
#' unlink(tmpfn)
#'
#' @seealso \code{\link{dumpJaspar}} for writing motifs from a Jaspar database
#'     package into a file in HOMER format.
#'
#' @importFrom utils getFromNamespace
#' @importFrom TFBSTools PFMatrix PFMatrixList
#'
#' @export
homerToPFMatrixList <- function(filename, n = 100L) {
    .assertScalar(x = filename, type = "character")
    stopifnot(file.exists(filename))
    .assertScalar(x = n, type = "numeric", rngExcl = c(0, Inf))

    # parse HOMER motif file
    tmp <- readLines(filename)
    g <- grep(">", tmp)
    tmp[g] <- sub("^>","",tmp[g])
    fields <- strsplit(tmp[g], "\t", fixed = TRUE)
    L <- lapply(seq_along(g), function(i) {
        cons <- fields[[i]][1]
        nm <- fields[[i]][2]
        log2cut <- round(as.numeric(fields[[i]][3]) / log(2), 2)
        s <- g[i] + 1L
        e <- if (i == length(g)) length(tmp) else g[i + 1L] - 1L
        m <- round(n * do.call(cbind,
                               lapply(strsplit(tmp[s:e], "\t", fixed = TRUE),
                                      as.numeric)), 0)
        rownames(m) <- c("A", "C", "G", "T")
        TFBSTools::PFMatrix(
          ID = nm, name = nm, profileMatrix = m,
          tags = list(log2cut = log2cut,
                      comment = "imported from HOMER motif file")
        )
    })

    do.call(PFMatrixList, c(L, list(use.names = TRUE)))
}


#' @title Prepare input files for HOMER motif enrichment analysis.
#'
#' @description For each bin, write genomic coordinates for foreground and
#'     background regions into files for HOMER motif enrichment analysis.
#'
#' @param gr A \code{GRanges} object (or an object that can be coerced to one)
#'     with the genomic regions to analyze.
#' @param b A vector of the same length as \code{gr} that groups its elements
#'     into bins (typically a factor).
#' @param genomedir Directory containing sequence files in Fasta format (one
#'     per chromosome).
#' @param outdir A path specifying the folder into which the output files (two
#'     files per unique value of \code{b}) will be written.
#' @param motifFile A file with HOMER formatted PWMs to be used in the
#'     enrichment analysis.
#' @param homerfile Path and file name of the \code{findMotifsGenome.pl} HOMER
#'     script.
#' @param regionsize The peak size to use in HOMER (\code{"given"} keeps the
#'     coordinate region, an integer value will keep only that many bases in
#'     the region center).
#' @param Ncpu Number of parallel threads that HOMER can use.
#' @param verbose A logical scalar. If \code{TRUE}, print progress messages.
#'
#' @details For each bin (unique value of \code{b}) this functions creates two
#'     files in \code{outdir} (\code{outdir/bin_N_foreground.tab} and
#'     \code{outdir/bin_N_background.tab}, where \code{N} is the number of the
#'     bin and foreground/background correspond to the ranges that are/are not
#'     within the current bin). The files are in the HOMER peak file format
#'     (see http://homer.ucsd.edu/homer/ngs/peakMotifs.html for details).
#'
#'     In addition, a shell script file is created containing the shell commands
#'     to run the HOMER motif enrichment analysis.
#'
#' @return The path and name of the script file to run the HOMER motif
#'     enrichment analysis.
#'
#' @examples
#' # prepare genome directory (here: one dummy chromosome)
#' genomedir <- tempfile()
#' dir.create(genomedir)
#' writeLines(c(">chr1", "ATGCATGCATCGATCGATCGATCGTACGTA"),
#'            file.path(genomedir, "chr1.fa"))
#'
#' # prepare motif file, regions and bins
#' motiffile <- tempfile()
#' dumpJaspar(filename = motiffile, pkg = "JASPAR2020",
#'            opts = list(ID = c("MA0006.1")))
#' gr <- GenomicRanges::GRanges("chr1", IRanges::IRanges(1:4, width = 4))
#' b <- bin(1:4, nElements = 2)
#'
#' # create dummy file (should point to local Homer installation)
#' homerfile <- file.path(tempdir(), "findMotifsGenome.pl")
#' writeLines("dummy", homerfile)
#'
#' # run prepareHomer
#' outdir <- tempfile()
#' prepareHomer(gr = gr, b = b, genomedir = genomedir,
#'              outdir = outdir, motifFile = motiffile,
#'              homerfile = homerfile, verbose = TRUE)
#' list.files(outdir)
#'
#' # clean up example
#' unlink(c(genomedir, motiffile, homerfile, outdir))
#'
#' @importFrom GenomicRanges start end strand seqnames
#' @export
prepareHomer <- function(gr, b, genomedir, outdir, motifFile,
                         homerfile = findHomer(), regionsize = "given",
                         Ncpu = 2L, verbose = FALSE) {
    if (!inherits(gr, "GRanges"))
        as(gr, "GRanges")
    if (!is.factor(b))
        b <- factor(b, levels = unique(b))
    .assertVector(x = b, type = "factor", len = length(gr))
    .assertScalar(x = genomedir, type = "character")
    .assertScalar(x = outdir, type = "character")
    .assertScalar(x = motifFile, type = "character")
    .assertScalar(x = homerfile, type = "character")
    stopifnot(exprs = {
        file.exists(genomedir)
        file.exists(motifFile)
        file.exists(homerfile)
        regionsize == "given" || (is.numeric(regionsize) &&
                                    length(regionsize) == 1L && regionsize > 0)
    })
    .assertScalar(x = verbose, type = "logical")

    if (file.exists(outdir))
        cli_abort("{.path outdir} already exists - will not overwrite existing folder")
    dir.create(outdir)

    homerFile <- file.path(outdir, "run.sh")
    fh <- file(homerFile, "w")

    .message("creating foreground/background region files for HOMER")
    for (i in seq_len(nlevels(b))) {
        bn <- levels(b)[i]
        .message("  bin {bn}")

        fgfile  <- sprintf("%s/bin_%03d_foreground.tab", outdir, i)
        bgfile  <- sprintf("%s/bin_%03d_background.tab", outdir, i)
        outputf <- sprintf("%s/bin_%03d_output", outdir, i)

        tmp.gr <- gr[b == bn]
        write.table(
          file = fgfile,
          data.frame(seq_along(tmp.gr), as.character(seqnames(tmp.gr)),
                     start(tmp.gr) - 1, end(tmp.gr),
                     ifelse(as.character(strand(tmp.gr)) == "-", "-", "+")),
          sep = "\t", quote = FALSE, col.names = FALSE, row.names = FALSE
        )

        tmp.gr <- gr[b != bn]
        write.table(
          file = bgfile,
          data.frame(seq_along(tmp.gr), as.character(seqnames(tmp.gr)),
                     start(tmp.gr) - 1, end(tmp.gr),
                     ifelse(as.character(strand(tmp.gr)) == "-", "-", "+")),
          sep = "\t", quote = FALSE, col.names = FALSE, row.names = FALSE
        )

        cat(sprintf("%s %s %s %s -bg %s -nomotif -p %d -size %s -mknown %s\n",
                    homerfile, fgfile, genomedir, outputf, bgfile, Ncpu,
                    as.character(regionsize), motifFile), file = fh,
            append = TRUE)
    }
    close(fh)

    return(homerFile)
}

#' @title Load output from HOMER findMotifsGenome.pl into R
#'
#' @description Parse HOMER output files into R data structures.
#'
#' @param infiles HOMER output files to be parsed.
#' @param pseudocount.log2enr A numerical scalar with the pseudocount to add to
#'   foreground and background counts when calculating log2 motif enrichments
#' @param p.adjust.method A character scalar selecting the p value adjustment
#'   method (used in \code{\link[stats]{p.adjust}}).
#'
#' @return A list of nine components (\code{negLog10P}, \code{negLog10Padj},
#'     \code{pearsonResid}, \code{expForegroundWgtWithHits}, \code{log2enr},
#'     \code{sumForegroundWgtWithHits} and \code{sumBackgroundWgtWithHits}),
#'     seven containing each a motif (rows) by bin (columns) matrix with raw
#'     -log10 P values, -log10 adjusted P values, the expected number of
#'     foreground sequences with hits, the observed number of foreground and
#'     background sequences with hits,
#'     and motif enrichments as Pearson residuals (\code{pearsonResid}) and as
#'     log2 ratios (\code{log2enr}), and two containing the total foreground
#'     and background weight (\code{totalWgtForeground},
#'     \code{totalWgtBackground}).
#'
#' @examples
#' outfile <- system.file("extdata", "homer_output.txt.gz",
#'                        package = "monaLisa")
#' res <- parseHomerOutput(infiles = c(bin1 = outfile))
#' head(res$negLog10P)
#'
#' @importFrom stats p.adjust
#'
#' @export
parseHomerOutput <- function(infiles,
                             pseudocount.log2enr = 8,
                             p.adjust.method = "BH") {
    stopifnot(all(file.exists(infiles)))
    .assertScalar(x = pseudocount.log2enr, type = "numeric",
                  rngIncl = c(0, Inf))
    .assertScalar(x = p.adjust.method, type = "character",
                  validValues = stats::p.adjust.methods)

    tabL <- lapply(infiles, read.delim)
    mnms <- sort(tabL[[1]][, 1])
    names(tabL) <- if (is.null(names(infiles))) infiles else names(infiles)
    P <- do.call(cbind,
                 lapply(tabL, function(x) -x[match(mnms, x[, 1]), 4] / log(10)))
    # ... Pearson residuals
    presid <- do.call(cbind, lapply(tabL, function(tab) {
        # number of target seqs and bg seqs with motif
        numFgBgWithHits <- tab[, c(6, 8)]
        # total number of target and background sequences
        nTot <- as.numeric(gsub("\\S+\\.(\\d+)\\.", "\\1",
                                colnames(numFgBgWithHits)))
        enr <- .calcPearsonResiduals(
            matchCountBg = numFgBgWithHits[, 2],
            totalWeightBg = nTot[2],
            matchCountFg = numFgBgWithHits[, 1],
            totalWeightFg = nTot[1]
        )
        enr[is.na(enr)] <- 0
        enr[match(mnms, tab[, 1])]
    }))

    # expected foreground weights
    expFG <- do.call(cbind, lapply(tabL, function(tab) {
        # number of target seqs and bg seqs with motif
        numFgBgWithHits <- tab[, c(6, 8)]
        # total number of target and background sequences
        nTot <- as.numeric(gsub("\\S+\\.(\\d+)\\.", "\\1",
                                colnames(numFgBgWithHits)))
        expfg <- .calcExpFg(
            matchCountBg = numFgBgWithHits[, 2],
            totalWeightBg = nTot[2],
            matchCountFg = numFgBgWithHits[, 1],
            totalWeightFg = nTot[1]
        )
        expfg[match(mnms, tab[, 1])]
    }))

    log2enr <- do.call(cbind, lapply(tabL, function(tab) {
        # number of target seqs and bg seqs with motif
        numFgBgWithHits <- tab[, c(6, 8)]
        # total number of target and background sequences
        nTot <- as.numeric(gsub("\\S+\\.(\\d+)\\.", "\\1",
                                colnames(numFgBgWithHits)))
        l2e <- .calcLog2Enr(
            matchCountBg = numFgBgWithHits[, 2],
            totalWeightBg = nTot[2],
            matchCountFg = numFgBgWithHits[, 1],
            totalWeightFg = nTot[1],
            pseudocount = pseudocount.log2enr
        )
        l2e[match(mnms, tab[, 1])]
    }))

    sumFgWgt <- do.call(cbind,
                        lapply(tabL, function(tab) tab[match(mnms, tab[, 1]),
                                                       6]))
    sumBgWgt <- do.call(cbind,
                        lapply(tabL, function(tab) tab[match(mnms, tab[, 1]),
                                                       8]))

    totWgt <- do.call(rbind, lapply(tabL, function(tab) {
        # number of target seqs and bg seqs with motif
        numFgBgWithHits <- tab[, c(6, 8)]
        #total number of target and background sequences
        nTot <- as.numeric(gsub("\\S+\\.(\\d+)\\.", "\\1",
                                colnames(numFgBgWithHits)))
        nTot
    }))

    padj <- matrix(-log10(p.adjust(as.vector(10^(-P)),
                                   method = p.adjust.method)),
                  nrow = nrow(P), dimnames = dimnames(P))
    padj[which(padj == Inf, arr.ind = TRUE)] <- max(padj[is.finite(padj)])

    rownames(P) <- rownames(padj) <- rownames(presid) <- rownames(log2enr) <-
        rownames(expFG) <- rownames(sumFgWgt) <- rownames(sumBgWgt) <- mnms

    return(list(negLog10P = P, negLog10Padj = padj,
                pearsonResid = presid,
                expForegroundWgtWithHits = expFG, log2enr = log2enr,
                sumForegroundWgtWithHits = sumFgWgt,
                sumBackgroundWgtWithHits = sumBgWgt,
                totalWgtForeground = totWgt[, 1],
                totalWgtBackground = totWgt[, 2]))
}

# internal function:  Check if all the HOMER output files already exist
# and if the run was successful.
# - needs the motifFile and outdir inputs to calcBinnedMotifEnrHomer.
#' @importFrom utils read.table
.checkHomerRun <- function(motifFile, outdir, nbins){

    # Checks
    # --> check resultsfile is a txt file

    # get knownResults.txt files
    out_files <- dir(path = outdir, pattern = "knownResults.txt",
                     full.names = TRUE, recursive = TRUE, ignore.case = FALSE)

    # case 1: out_files is empty, so return FALSE
    if (isEmpty(out_files)) {
      return(FALSE)
    }

    # case 2: at least one file exists, so we check HOMER ran correctly and
    # that the number of output files matches the number of bins

      # get motif names from motifFile
      lns <- readLines(motifFile)
      motifs_motifFile <- unlist(lapply(strsplit(lns[grep("^>", lns)], "\t"),
                                        "[", 2))

      # get motif names from resultsfile
      df_list <- lapply(as.list(out_files), function(f) {
          read.table(f, header = FALSE, sep = "\t", skip = 1)
      }) # skip the column names
      motifs_outdir_list <- lapply(df_list, function(df){
          as.character(df[ ,1])
      })
      # check the completeness of the run and that the number of output files
      # equals number of bins
      all(vapply(motifs_outdir_list, function(x) {
          all(motifs_motifFile %in% x)
      }, NA)) & (length(out_files) == nbins)

}

#' @title Prepare and run HOMER motif enrichment analysis.
#'
#' @description Run complete HOMER motif enrichment analysis, consisting of
#'     calls to \code{\link{prepareHomer}}, \code{\link[base]{system2}} and
#'     \code{\link{parseHomerOutput}}. This function requires \code{HOMER}
#'     to be installed (see \url{http://homer.ucsd.edu/homer/index.html})
#'     and the path to the tool to be provided (\code{homerfile} argument).
#'
#' @param gr A \code{GRanges} object (or an object that can be coerced to one)
#'     with the genomic regions to analyze.
#' @param b A vector of the same length as \code{gr} that groups its elements
#'     into bins (typically a factor, such as the one returned by
#'     \code{\link{bin}}).
#' @param genomedir Directory containing sequence files in Fasta format
#'     (one per chromosome).
#' @param outdir A path specifying the folder into which the output files will
#'     be written.
#' @param motifFile A file with HOMER formatted PWMs to be used in the
#'     enrichment analysis.
#' @param homerfile Path and file name of the \code{findMotifsGenome.pl}
#'     HOMER script.
#' @param regionsize The peak size to use in HOMER (\code{"given"} keeps the
#'     coordinate region, an integer value will keep only that many bases in
#'     the region center).
#' @param pseudocount.log2enr A numerical scalar with the pseudocount to add to
#'   foreground and background counts when calculating log2 motif enrichments
#' @param p.adjust.method A character scalar selecting the p value adjustment
#'   method (used in \code{\link[stats]{p.adjust}}).
#' @param Ncpu Number of parallel threads that HOMER can use.
#' @param verbose A logical scalar. If \code{TRUE}, print progress messages.
#' @param verbose.Homer A logical scalar. If \code{TRUE}, print the console
#'   output when running Homer.
#'
#' @seealso The functions that are wrapped: \code{\link{prepareHomer}},
#'     \code{\link[base]{system2}} and \code{\link{parseHomerOutput}},
#'     \code{\link{bin}} for binning of regions
#'
#' @return A \code{SummarizedExperiment} object with motifs in rows and bins
#'   in columns, containing seven assays: \describe{
#'   \item{negLog10P}{: -log10 P values}
#'   \item{negLog10Padj}{: -log10 adjusted P values}
#'   \item{pearsonResid}{: motif enrichments as Pearson residuals}
#'   \item{expForegroundWgtWithHits}{: expected number of foreground
#'     sequences with motif hits}
#'   \item{log2enr}{: motif enrichments as log2 ratios}
#'   \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
#'     in a bin that have motif hits}
#'   \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
#'     in a bin that have motif hits}
#' }
#' The \code{rowData} of the object contains annotations (name, PFMs, PWMs
#' and GC fraction) for the motifs, while the \code{colData} slot contains
#' summary information about the bins.
#'
#' @examples
#' if (!is.na(findHomer())){
#'
#'   # genome
#'   genome <-  system.file("extdata", "exampleGenome.fa", package = "monaLisa")
#'
#'   # create motif file for Homer
#'   motiffile <- tempfile()
#'   motifIDs <- c("MA0139.1", "MA1102.1", "MA0740.1")
#'   dumpJaspar(filename = motiffile, pkg = "JASPAR2020",
#'              opts = list(ID = motifIDs))
#'
#'   # GRanges of regions used in binned motif enrichment analysis
#'   gr <- GenomicRanges::tileGenome(
#'       seqlengths = c(chr1 = 10000L, chr2 = 10000L, chr3 = 10000L),
#'       tilewidth = 200, cut.last.tile.in.chrom = TRUE)
#'
#'   # create bins (motif enrichment analysis will be per bin)
#'   bins <- factor(GenomicRanges::seqnames(gr))
#'   table(bins)
#'
#'   # run calcBinnedMotifEnrHomer
#'   outdir <- tempfile()
#'   se <- calcBinnedMotifEnrHomer(gr = gr, b = bins, genomedir = genome,
#'       outdir = outdir, motifFile = motiffile)
#'   list.files(outdir)
#'
#'   }
#'
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom S4Vectors DataFrame
#' @importFrom TFBSTools ID name Matrix
#' @importFrom cli cli_abort
#'
#' @export
calcBinnedMotifEnrHomer <- function(gr, b, genomedir, outdir, motifFile,
                                    homerfile = findHomer(),
                                    regionsize = "given",
                                    pseudocount.log2enr = 8,
                                    p.adjust.method = "BH",
                                    Ncpu = 2L,
                                    verbose = FALSE,
                                    verbose.Homer = FALSE) {
    if (!inherits(gr, "GRanges"))
        gr <- as(gr, "GRanges")
    if (!is.factor(b))
        b <- factor(b, levels = unique(b))
    .assertVector(x = b, type = "factor", len = length(gr))
    .assertScalar(x = genomedir, type = "character")
    .assertScalar(x = outdir, type = "character")
    .assertScalar(x = motifFile, type = "character")
    .assertScalar(x = homerfile, type = "character")
    stopifnot(exprs = {
        file.exists(genomedir)
        file.exists(motifFile)
        file.exists(homerfile)
        regionsize == "given" || (is.numeric(regionsize) &&
                                      length(regionsize) == 1L &&
                                      regionsize > 0)
    })
    .assertScalar(x = Ncpu, type = "numeric", rngIncl = c(1, Inf))
    .assertScalar(x = verbose, type = "logical")
    .assertScalar(x = verbose.Homer, type = "logical")
    .checkIfSeqsAreEqualLength(x = gr)

    ## ... check if the HOMER output is already there for all bins and if it
    ##     ran completely:
    ## ... ... If yes, go to the 'parse output step', otherwise run homer and
    ##         check again
    if (.checkHomerRun(motifFile = motifFile, outdir = outdir,
                       nbins = nlevels(b))) {
        .message("HOMER output files already exist, using existing files...", noTimer = TRUE)
    } else {

      ## ... case: all/some files exist and/or HOMER didn't run correctly:
      ## warn the User to remove all existing files and rerun
      if (any(file.exists(dir(path = outdir, pattern = "knownResults.txt",
                              full.names = TRUE, recursive = TRUE,
                              ignore.case = FALSE)))) {

          cli_abort(c("\nThere are existing {.file knownResults.txt} file(s) in {.path {outdir}}. ",
                      "There may be missing {.file knownResults.txt} files for some bins ",
                      "and/or the existing files are incomplete (cases where the ",
                      "HOMER run failed). Please delete these files and rerun ",
                      "{.fn calcBinnedMotifEnrHomer}."))

      }

      ## ... prepare
      .message("preparing input files...")
      runfile <- prepareHomer(gr = gr, b = b, genomedir = genomedir,
                              outdir = outdir,
                              motifFile = motifFile, homerfile = homerfile,
                              regionsize = regionsize, Ncpu = Ncpu)

      ## ... run
      .message("running HOMER...")
      system2(command = "sh", args = runfile,
              stdout = ifelse(verbose.Homer, "", FALSE),
              stderr = ifelse(verbose.Homer, "", FALSE),
              env = paste0("PATH=", dirname(homerfile), ":",
                           Sys.getenv("PATH"), ";"))

      ## ... check HOMER ran correctly
      if (!.checkHomerRun(motifFile = motifFile, outdir = outdir,
                          nbins = length(levels(b)))) {
          cli_abort("HOMER output wasn't complete. Try running again.")
      }

    }

    ## ... parse output
    resfiles <- sprintf("%s/bin_%03d_output/knownResults.txt", outdir,
                        seq_along(levels(b)))
    names(resfiles) <- levels(b)
    resL <- parseHomerOutput(infiles = resfiles,
                             pseudocount.log2enr = pseudocount.log2enr,
                             p.adjust.method = p.adjust.method)

    ## ... create SummarizedExperiment
    ## ... ... reorder parsed output according to motifs in motifFile
    pfms <- homerToPFMatrixList(motifFile)
    morder <- TFBSTools::name(pfms)
    o <- match(morder, rownames(resL[[1]]))

    ## Find the assays (the matrices) of the list and reorder
    assayidx <- vapply(resL, function(x) !is.null(dim(x)), FALSE)
    assayL <- lapply(resL[assayidx], function(x) x[o, , drop = FALSE])
    # assayL <- lapply(resL[seq_len(7)], function(x) x[o, ])

    ## ... ... colData
    if (is.null(attr(b, "breaks"))) {
        binL <- binH <- rep(NA, nlevels(b))
    } else {
        binL <- attr(b, "breaks")[-(nlevels(b) + 1)]
        binH <- attr(b, "breaks")[-1]
    }
    cdat <- S4Vectors::DataFrame(
        bin.names = levels(b),
        bin.lower = binL,
        bin.upper = binH,
        bin.nochange = seq.int(nlevels(b)) %in% getZeroBin(b),
        totalWgtForeground = resL$totalWgtForeground,
        totalWgtBackground = resL$totalWgtBackground
    )
    percentGC <- unlist(lapply(pfms, function(x) {
        m <- TFBSTools::Matrix(x)
        100 * sum(m[c("C","G"), ]) / sum(m)
    }), use.names = FALSE)
    mid <- rep(NA, length(pfms))
    mnm <- rownames(assayL[[1]])
    if (all(grepl(":::", rownames(assayL[[1]])))) {
        mid <- sub(":::.+$", "", rownames(assayL[[1]]))
        mnm <- sub("^.+:::", "", rownames(assayL[[1]]))
        assayL <- lapply(assayL, function(x) {
            rownames(x) <- sub(":::.+$", "", rownames(x))
            x
        })
        for (i in seq_along(pfms)) {
            pfms[[i]]@ID <- mid[i]
            pfms[[i]]@name <- mnm[i]
        }
    }
    ## ... ... rowData
    rdat <- S4Vectors::DataFrame(motif.id = mid,
                                 motif.name = mnm,
                                 motif.pfm = pfms,
                                 motif.pwm = rep(NA, length(pfms)),
                                 motif.percentGC = percentGC)
    ## ... ... metadata
    mdatL <- list(regions = gr,
                  bins = b,
                  bins.binmode = attr(b, "binmode"),
                  bins.breaks = as.vector(attr(b, "breaks")),
                  bins.bin0 = getZeroBin(b),
                  param = list(method = "Homer",
                               genomedir = genomedir,
                               outdir = outdir,
                               motifFile = motifFile,
                               homerfile = homerfile,
                               regionsize = regionsize,
                               pseudocount.log2enr = pseudocount.log2enr,
                               p.adj.method = p.adjust.method,
                               Ncpu = Ncpu),
                  motif.distances = NULL)
    ## ... ... return
    SummarizedExperiment::SummarizedExperiment(
      assays = assayL, colData = cdat, rowData = rdat,
      metadata = mdatL)
}

test_that("findHomer() works properly", {
    # store existing value
    orig <- Sys.getenv("MONALISA_HOMER", unset = NA)
    if (!is.na(orig))
        Sys.unsetenv("MONALISA_HOMER")

    # test non-existing
    res <- findHomer("I-do-not-exist")
    expect_true(is.na(res))

    Sys.setenv(MONALISA_HOMER = "/I/also/dont/exist")
    res <- findHomer(dirs = ".")
    expect_true(is.na(res))
    Sys.unsetenv("MONALISA_HOMER")

    # test existing
    res <- findHomer("results.binned_motif_enrichment_LMRs.rds", dirs = system.file("extdata", package = "monaLisa"))
    expect_true(file.exists(res))

    Sys.setenv(MONALISA_HOMER = system.file("extdata", package = "monaLisa"))
    res <- findHomer("results.binned_motif_enrichment_LMRs.rds")
    expect_true(file.exists(res))
    Sys.unsetenv("MONALISA_HOMER")

    # restore original value
    if (!is.na(orig))
        Sys.setenv(MONALISA_HOMER = orig)
})

test_that("dumpJaspar() works properly", {
    tmp1 <- tempfile()

    expect_error(dumpJaspar(filename = system.file("extdata",
                                                   "results.binned_motif_enrichment_LMRs.rds",
                                                   package = "monaLisa"),
                            pkg = "JASPAR2020"))
    expect_error(dumpJaspar(filename = tmp1,
                            pkg = "JASPAR2020",
                            opts = list(matrixtype = "PWM")))
    expect_error(dumpJaspar(filename = tmp1,
                            pkg = "JASPAR2020",
                            relScoreCutoff = "error"))
    suppressMessages(
        expect_message(
            expect_true(
                dumpJaspar(filename = tmp1,
                           pkg = "JASPAR2020",
                           opts = list(ID = c("MA0006.1", "MA0007.3", "MA0828.1")),
                           verbose = TRUE)
            )
        )
    )
    unlink(tmp1)
    suppressMessages(
        expect_message(
            expect_true(
                dumpJaspar(filename = tmp1,
                           pkg = "JASPAR2024",
                           opts = list(ID = c("MA0006.1", "MA0007.3", "MA0828.1")),
                           verbose = TRUE)
            )
        )
    )
    unlink(tmp1)
    expect_error(dumpJaspar(filename = tmp1,
                            pkg = "BSgenome",
                            opts = list(ID = c("MA0006.1", "MA0007.3", "MA0828.1")),
                            verbose = TRUE))
})

test_that("homerToPFMatrixList() works properly", {
    tmp1 <- tempfile()
    library(JASPAR2020)
    optsL <- list(ID = c("MA0006.1", "MA0007.3", "MA0019.1", "MA0025.1", "MA0029.1", "MA0030.1"))
    pfms <- TFBSTools::getMatrixSet(JASPAR2020, opts = optsL)
    expect_true(dumpJaspar(filename = tmp1, pkg = "JASPAR2020", opts = optsL))

    expect_error(homerToPFMatrixList("does_not_exist"))
    expect_error(homerToPFMatrixList(tmp1, "error"))

    res <- homerToPFMatrixList(tmp1, 1000L)
    expect_s4_class(res, "PFMatrixList")
    expect_length(res, length(pfms))
    expect_true(all(abs(colSums(do.call(cbind, TFBSTools::Matrix(res))) - 1000) <= 2)) # 2/1000 rounding error
    expect_true(all(sapply(TFBSTools::Matrix(res), nrow) == 4L))
    expect_identical(sapply(TFBSTools::Matrix(res), ncol), c(6L, 17L, 12L, 11L, 14L, 14L))
    expect_identical(TFBSTools::name(res), paste0(TFBSTools::ID(pfms), ":::", TFBSTools::name(pfms)))

    unlink(tmp1)
})

test_that("prepareHomer() works properly", {
    gr <- GenomicRanges::GRanges(rep(c("chr1","chr2","chr3"), each = 10),
                                 IRanges::IRanges(start = rep(10 * 1:10, 3), width = 5L))
    b <- 1:30 %% 3 + 1
    bF <- factor(b)
    tmp1 <- tempfile()
    dir.create(tmp1)
    tmp2 <- tempfile()
    fname <- system.file("extdata", "results.binned_motif_enrichment_LMRs.rds", package = "monaLisa")

    expect_error(prepareHomer(gr = gr, b = b, genomedir = "genomedir", outdir = tmp1,
                              motifFile = fname, homerfile = fname, regionsize = "given", Ncpu = 2))
    expect_error(prepareHomer(gr = gr, b = b, genomedir = tmp1, outdir = tmp1,
                              motifFile = fname, homerfile = fname, regionsize = "given", Ncpu = 2))
    expect_error(prepareHomer(gr = as(gr, "data.frame"), b = bF[1:10], genomedir = "genomedir", outdir = tmp2,
                              motifFile = fname, homerfile = fname, regionsize = "given", Ncpu = 2))
    expect_error(prepareHomer(gr = gr, b = bF, genomedir = "genomedir", outdir = tmp2,
                              motifFile = "error", homerfile = fname, regionsize = "given", Ncpu = 2))

    suppressMessages(
        expect_message(
            expect_identical(
                prepareHomer(gr = gr, b = bF, genomedir = ".", outdir = tmp2,
                             motifFile = fname, homerfile = fname, regionsize = "given", Ncpu = 2, verbose = TRUE),
                file.path(tmp2, "run.sh")
            )
        )
    )

    unlink(c(tmp1, tmp2), recursive = TRUE, force = TRUE)
})

test_that("parseHomerOutput() works properly", {
    outfile <- system.file("extdata", "homer_output.txt.gz", package = "monaLisa")

    expect_error(parseHomerOutput("does-not-exist"))
    expect_error(parseHomerOutput(outfile, pseudocount.log2enr = "error"))
    expect_error(parseHomerOutput(outfile, pseudofreq.pearsonResid = "error"))
    expect_error(parseHomerOutput(outfile, p.adjust.method = "error"))

    res <- parseHomerOutput(structure(c(outfile, outfile), names = c("bin1", "bin2")))
    expect_length(res, 9L)
    expect_identical(names(res), c("negLog10P", "negLog10Padj",
                                   "pearsonResid", "expForegroundWgtWithHits", "log2enr",
                                   "sumForegroundWgtWithHits",
                                   "sumBackgroundWgtWithHits",
                                   "totalWgtForeground",
                                   "totalWgtBackground"))
    expect_identical(colnames(res[[1]]), c("bin1", "bin2"))
    expect_identical(res$p[,1], res$p[,2])
    expect_true(all(sapply(res[1:6], dim) == c(579L, 2L)))
    expect_length(res[[8]], 2L)
    expect_length(res[[9]], 2L)
    expect_equal(sum(res$pearsonResid), 5646.01883770411)
    expect_equal(sum(res$log2enr), 447.056685196643)
    expect_identical(res[[9]], c(bin1 = 43339, bin2 = 43339))
})

test_that("calcBinnedMotifEnrHomer() works properly (synthetic data)", {
    homerbin <- findHomer("findMotifsGenome.pl") # on GHA should get it from Sys.getenv("MONALISA_HOMER")
    if (is.na(homerbin)) {
        homerbin <- findHomer("findMotifsGenome.pl", dirs = "/work/gbioinfo/Appz/Homer/Homer-4.11/bin")
    }

    if (!is.na(homerbin) && require("JASPAR2020")) {
        # genome
        set.seed(42)
        genomedir <- tempfile()
        chrsstr <-
            unlist(lapply(1:3, function(i) paste(sample(x = c("A","C","G","T"),
                                                        size = 10000,
                                                        replace = TRUE,
                                                        prob = c(.3,.2,.2,.3)),
                                                 collapse = "")))
        names(chrsstr) <- paste0("chr", seq_along(chrsstr))

        # regions
        gr <- GenomicRanges::tileGenome(seqlengths = nchar(chrsstr),
                                        tilewidth = 200, cut.last.tile.in.chrom = TRUE)
        bins <- factor(GenomicRanges::seqnames(gr))

        # motifs
        selids <- c("MA0139.1", "MA1102.1", "MA0740.1", "MA0493.1", "MA0856.1")
        pfm <- TFBSTools::getMatrixSet(JASPAR2020, opts = list(ID = selids))
        cons <- unlist(lapply(Matrix(pfm), function(x) paste(rownames(x)[apply(x, 2, which.max)], collapse = "")))
        #              MA0139.1          MA1102.1          MA0740.1       MA0493.1          MA0856.1
        # "TGGCCACCAGGGGGCGCTA"  "CACCAGGGGGCACC"  "GGCCACGCCCCCTT"  "GGCCACACCCA"  "GGGGTCAAAGGTCA"
        # ... dump to file for Homer
        mfile <- tempfile(fileext = ".motifs")
        expect_true(dumpJaspar(filename = mfile, pkg = "JASPAR2020",
                               opts = list(ID = selids)))
        # ... plant motifs
        for (chr1 in names(chrsstr)) {
            i <- which(as.character(Seqinfo::seqnames(gr)) == chr1)
            j <- sample(x = GenomicRanges::start(gr)[i], size = round(length(i) / 3))
            m <- match(chr1, names(chrsstr))
            for (j1 in j)
                substring(chrsstr[chr1], first = j1, last = j1 + nchar(cons[m]) - 1) <- cons[m]
        }
        chrs <- Biostrings::DNAStringSet(chrsstr)
        expect_true(dir.create(genomedir))
        genomefile <- file.path(genomedir, "genome.fa")
        Biostrings::writeXStringSet(x = chrs, filepath = genomefile, format = "fasta")

        outdir <- tempfile()

        expect_error(calcBinnedMotifEnrHomer(gr = gr, b = bins, motifFile = mfile,
                                             Ncpu = "error"))

        suppressMessages(
            expect_message(
                res <- calcBinnedMotifEnrHomer(
                    gr = as.character(gr), b = as.character(bins),
                    motifFile = mfile, genomedir = genomedir,
                    outdir = outdir, homerfile = homerbin, regionsize = "given",
                    Ncpu = 2L, verbose = TRUE),
                "preparing input files")
        )
        attr(bins, "breaks") <- seq(0.5, 3.5, by = 1)
        expect_message(res1 <- calcBinnedMotifEnrHomer(
            gr = as.character(gr), b = bins,
            motifFile = mfile, genomedir = genomedir,
            outdir = outdir, homerfile = homerbin, regionsize = "given",
            Ncpu = 2L, verbose = TRUE),
                       "HOMER output files already exist, using existing files")
        unlink(dir(path = outdir, pattern = "knownResults.txt", full.names = TRUE, recursive = TRUE, ignore.case = FALSE)[1])
        expect_error(calcBinnedMotifEnrHomer(
            gr = as.character(gr), b = as.character(bins),
            motifFile = mfile, genomedir = genomedir,
            outdir = outdir, homerfile = homerbin, regionsize = "given"),
            "missing 'knownResults.txt' files for some bins")

        expect_s4_class(res, "SummarizedExperiment")
        expect_s4_class(res1, "SummarizedExperiment")
        expect_identical(SummarizedExperiment::colData(res)[, -(2:3)],
                         SummarizedExperiment::colData(res1)[, -(2:3)])
        SummarizedExperiment::colData(res)[, 2:3] <- SummarizedExperiment::colData(res1)[, 2:3]
        expect_identical(S4Vectors::metadata(res)[-c(2,4)],
                         S4Vectors::metadata(res1)[-c(2,4)])
        S4Vectors::metadata(res)[c(2,4)] <- S4Vectors::metadata(res1)[c(2,4)]
        expect_identical(res, res1)
        expect_identical(rownames(res), selids)
        expect_length(SummarizedExperiment::assays(res), 7L)
        expect_identical(SummarizedExperiment::assayNames(res),
                         c("negLog10P", "negLog10Padj", "pearsonResid",
                           "expForegroundWgtWithHits", "log2enr",
                           "sumForegroundWgtWithHits", "sumBackgroundWgtWithHits"))
        expect_identical(dim(res), c(5L, 3L))
        expect_identical(rownames(res), SummarizedExperiment::rowData(res)[, "motif.id"])
        expect_identical(rownames(res), TFBSTools::ID(SummarizedExperiment::rowData(res)[, "motif.pfm"]))
        expect_identical(apply(SummarizedExperiment::assay(res, "negLog10P"), 2, which.max),
                         c(chr1 = 1L, chr2 = 2L, chr3 = 3L))
        expect_equal(sum(SummarizedExperiment::assay(res, "negLog10P")), 65.132971396505)
        expect_equal(sum(SummarizedExperiment::assay(res, "pearsonResid")), -0.23617661811598)

        unlink(c(mfile, outdir, genomedir), recursive = TRUE, force = TRUE)
    }
})

library(monaLisa)
lmrfile <- system.file("extdata", "LMRsESNPmerged.gr.rds", 
                       package = "monaLisa")
lmr <- readRDS(lmrfile)
set.seed(1)
lmrsel <- lmr[ sample(x = length(lmr), size = 10000, replace = FALSE) ]
bins <- bin(x = lmrsel$deltaMeth, binmode = "equalN", nElement = 800, 
            minAbsX = 0.3)
(gg <- plotBinDensity(lmrsel$deltaMeth, bins, legendPosition = "none") + 
        theme(axis.text = element_text(size = 14), 
              axis.title = element_text(size = 14)) + 
        labs(x = "Methylation difference"))
ggsave(plot = gg, filename = "man/figures/monaLisa_binning_small_ggplot.png")

#' @importFrom stats quantile

# get bin boundaries for bin(x, binmode="equalN", ...)
.breaksEqualN <- function(x, nElements, minAbsX = NULL) {
    if (!is.null(minAbsX) && 
        ((-minAbsX) > max(x, na.rm = TRUE) || 
         minAbsX < min(x, na.rm = TRUE))) {
        # all data values are outside [-minAbsX, minAbsX] -> ignore minAbsX
        cli_warn(paste0("All data values are outside [-minAbsX, minAbsX] - ",
                        "setting minAbsX to NULL"))
        minAbsX <- NULL
    }
    if (!is.null(minAbsX)) {
        n1 <- round(sum(x < -minAbsX, na.rm = TRUE) / nElements) * nElements
        n2 <- round(sum(x >  minAbsX, na.rm = TRUE) / nElements) * nElements
        x1 <- sort(x, decreasing = FALSE, na.last = NA)[seq_len(n1)]
        x2 <- sort(x, decreasing = TRUE,  na.last = NA)[seq_len(n2 + 1)]
        bin.breaks <- c(
            if (n1 > 0) {
                quantile(x1, seq(0, 1, length.out = n1 / nElements + 1))
            } else {
                min(x, na.rm = TRUE)
            },
            if (n2 > 0) {
                quantile(x2, seq(0, 1, length.out = n2 / nElements + 1))
            } else {
                max(x, na.rm = TRUE)
            }
        )
        attr(bin.breaks, "bin0") <- ceiling(n1 / nElements + 1)
    } else {
        bin.breaks <- quantile(
            x, seq(0, 1, length.out = round(length(x) / nElements) + 1L)
        )
        attr(bin.breaks, "bin0") <- NA
    }
    bin.breaks
}

# get bin boundaries for bin(x, binmode="equalWidth", ...)
.breaksEqualWidth <- function(x, nBins, minAbsX) {
    if (!is.null(minAbsX) && 
        ((-minAbsX) > max(x, na.rm = TRUE) || 
         minAbsX < min(x, na.rm = TRUE))) {
        # all data values are outside [-minAbsX, minAbsX] -> ignore minAbsX
        cli_warn(paste0("All data values are outside [-minAbsX, minAbsX] - ",
                        "setting minAbsX to NULL"))
        minAbsX <- NULL
    }
    if (!is.null(minAbsX)) {
        e1 <- sum(x < -minAbsX, na.rm = TRUE)
        e2 <- sum(x >  minAbsX, na.rm = TRUE)
        b1 <- round((nBins - 1) * e1 / (e1 + e2))
        b2 <- nBins - 1 - b1
        bw12 <- c((-minAbsX - min(x, na.rm = TRUE)) / b1,
                  (max(x, na.rm = TRUE) - minAbsX) / b2)
        bw <- max(bw12[is.finite(bw12)])
        almostOne <- (length(x) - 1) / length(x)
        bin.breaks <- c(
            if (b1 > 0) {
                rev(seq(-minAbsX, min(x, na.rm = TRUE) - almostOne * bw,
                        by = -bw))
            } else {
                min(x, na.rm = TRUE)
            },
            if (b2 > 0) {
                seq(minAbsX, max(x, na.rm = TRUE) + almostOne * bw, by = bw)
            } else {
                max(x, na.rm = TRUE)
            }
        )
        attr(bin.breaks, "bin0") <- b1 + 1
    } else {
        bin.breaks <- seq(min(x, na.rm = TRUE), max(x, na.rm = TRUE),
                          length.out = nBins + 1)
        attr(bin.breaks, "bin0") <- NA
    }
    bin.breaks
}

#' @title Bin elements of \code{x}.
#'
#' @description \code{bin} groups elements of \code{x} into bins with either a
#'   constant number of elements per bin, a constant bin width or according to
#'   user-provided bin boundaries.
#'
#' @param x A numerical vector with the values used for binning.
#' @param binmode The algorithm to be used for binning. Possible values are:
#'   "equalN" (default), "equalWidth" or "breaks" (see Details).
#' @param nElements The number of elements per bin (only for
#'   \code{binmode="equalN"}). The width of bins is adjusted accordingly.
#' @param nBins The number of bins (only for \code{binmode="equalWidth"}). The
#'   number of elements per bin will be variable.
#' @param minAbsX The minimal absolute value in \code{x} for elements to be
#'   binned using the \code{binmode="equalN"} or \code{binmode="equalWidth"}
#'   (ignored for other values of \code{binmode}). Elements with \code{x} values
#'   in \code{[-minAbsX,minAbsX]} will be collected in a single bin.
#' @param breaks Numerical vector with bin boundaries (only for
#'   \code{binmode="breaks"}). \code{breaks} has to be ordered and strictly
#'   increasing, and has to be of length (number of bins) + 1.
#' @param ... Further arguments to be passed to \code{cut(x, breaks,
#'   include.lowest = TRUE, ...)}, such as \code{labels=FALSE}.
#'
#' @details Elements are binned according to the values in \code{x} depending on
#'   \code{binmode}:
#'   \describe{
#'   \item{equalN}{Items are grouped into a variable
#'   number of bins with \code{nElements} elements each. If \code{minAbsX} is
#'   not \code{NULL}, elements with \code{x}-values in \code{[-minAbsX,minAbsX]}
#'   will first be collected in a single bin before binning the remaining
#'   elements. The boundaries of this single bin may be slightly adjusted in
#'   order to respect the \code{nElements} elements in the other bins.}
#'   \item{equalWidth}{Items are group into \code{nBins} bins with a variable
#'   number of elements each.}
#'   \item{breaks}{Items are grouped into bins using
#'   \code{cut(x, breaks, include.lowest = TRUE)}}
#'   }
#'
#' @seealso \code{\link{cut}} which is used internally.
#'
#' @return The return value from \code{cut(x, ...)}, typically a factor of the
#'   same length as \code{x}. Binning mode, bin boundaries and the "neutral" bin
#'   are available from \code{attr(..., "binmode")}, \code{attr(..., "breaks")}
#'   and \code{attr(..., "bin0")}. For \code{binmode = "breaks"}, the latter
#'   will be \code{NA}.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' summary(bin(x, "equalN", nElements=10))
#' summary(bin(x, "equalN", nElements=10, minAbsX=0.5))
#' summary(bin(x, "equalWidth", nBins=5))
#' summary(bin(x, "breaks", breaks=c(-10,-1,0,1,10)))
#'
#' @export
bin <- function(x, binmode = c("equalN", "equalWidth", "breaks"),
                nElements = round(length(x)/5), nBins = NULL, minAbsX = NULL,
                breaks = NULL, ...) {
    stopifnot(is.numeric(x) && length(x) > 1)
    binmode <- match.arg(binmode)
    stopifnot(is.null(nElements) ||
                  (is.numeric(nElements) && length(nElements) == 1))
    stopifnot(is.null(nBins) || (is.numeric(nBins) && length(nBins) == 1))
    stopifnot(is.null(minAbsX) ||
                  (is.numeric(minAbsX) && length(minAbsX) == 1 && minAbsX > 0))
    breaks <- switch(binmode,
                     "equalN" = .breaksEqualN(x, nElements, minAbsX),
                     "equalWidth" = .breaksEqualWidth(x, nBins, minAbsX),
                     "breaks" = breaks)
    res <- cut(x, breaks = breaks, include.lowest = TRUE, ...)
    attr(res, "binmode") <- binmode
    attr(res, "breaks") <- unname(breaks)
    res <- setZeroBin(res, ifelse(binmode == "breaks",
                                  NA, attr(breaks, "bin0")))
    if (!is.na(getZeroBin(res)) &&
        any(abs(attr(res, "breaks")[getZeroBin(res) + c(0, 1)] -
                c(-1, 1) * minAbsX) > 0.2 * minAbsX)) {
        warning("Zero-bin breaks ",  levels(res)[getZeroBin(res)],
                " have been adjusted by more than 20% compared to `minAbsX` ",
                "to best respect `binmode`.\n",
                'Please use `bin(..., binmode = "breaks", breaks = X)` and ',
                "optionally `setZeroBin(...)` to enforce breaks as defined by `X`.")
    }
    res
}

#' Get and set the zero bin manually
#'
#' @param bins Factor, typically the return value of
#'   \code{\link[monaLisa]{bin}}.
#' @param zeroBin Numeric or character scalar indicating the level to use as
#'   the zero bin, or NA.
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(100)
#' bins <- bin(x, "equalN", nElements = 10, minAbsX = 0.5)
#' getZeroBin(bins)
#' bins <- setZeroBin(bins, 2)
#'
#' @return
#' For \code{getZeroBin}, the index of the level representing the zero bin.
#' For \code{setZeroBin}, a modified factor with the zero bin set to the
#' provided value.
#'
#' @name getSetZeroBin
NULL

#' @export
#' @rdname getSetZeroBin
getZeroBin <- function(bins) {
    attr(bins, "bin0")
}

#' @importFrom cli cli_abort
#' @export
#' @rdname getSetZeroBin
setZeroBin <- function(bins, zeroBin) {
    .assertVector(x = bins, type = "factor")
    if (is.na(zeroBin) && length(zeroBin) == 1L) {
        attr(bins, "bin0") <- NA
    } else if (is.numeric(zeroBin)) {
        .assertScalar(x = zeroBin, type = "numeric",
                      validValues = seq_len(nlevels(bins)))
        attr(bins, "bin0") <- as.integer(zeroBin)
    } else if (is.character(zeroBin)) {
        .assertScalar(x = zeroBin, type = "character",
                      validValues = levels(bins))
        attr(bins, "bin0") <- match(zeroBin, levels(bins))
    } else {
        cli_abort("{.arg zeroBin} must be of type {.cls character}, {.cls numeric} or {.code NA}")
    }
    bins
}

test_that("bin() works properly", {
    # normal distribution
    set.seed(1)
    x <- rnorm(1000)

    b1 <- bin(x, binmode = "equalN", nElements = 100)
    expect_equal(nlevels(b1), 10L)
    expect_true(all(table(b1) == 100))
    expect_equal(getZeroBin(b1), NA)

    b2 <- bin(x, binmode = "equalN", nElements = 50, minAbsX = 0.6)
    expect_true(table(b2)[getZeroBin(b2)] == 400L)
    expect_equal(getZeroBin(b2), 7)
    b2p <- setZeroBin(b2, 3)
    expect_true(table(b2p)[getZeroBin(b2p)] == 50L)
    expect_equal(getZeroBin(b2p), 3)

    b3 <- bin(x, binmode = "equalWidth", nBins = 5)
    expect_equal(nlevels(b3), 5L)
    expect_equal(diff(attr(b3, "breaks")), rep(1.363665, 5L), tolerance = 1e-6)

    b4 <- bin(x, binmode = "equalWidth", nBins = 5, minAbsX = 0.6)
    expect_true(table(b4)[getZeroBin(b4)] == 440L)

    expect_warning(b5 <- bin(x, binmode = "equalN", nBins = 5, minAbsX = 3))

    b6 <- bin(x = seq(-20, 10), binmode = "equalWidth", nBins = 5, minAbsX = 10)
    expect_equal(nlevels(b6), 5L)
    expect_equal(diff(attr(b6, "breaks")), c(rep(2.5, 4L), 20), tolerance = 1e-6)
    
    # uniform distribution, all negative values
    u1 <- bin(seq(-20, -10), binmode = "equalWidth", nBins = 5)
    expect_type(u1, "integer")
    expect_true(all(c("binmode", "breaks", "bin0") %in% names(attributes(u1))))
    
    # uniform distribution, all negative values, set minAbsX
    expect_warning({
        u2 <- bin(seq(-20, -10), binmode = "equalWidth", nBins = 5, minAbsX = 5)
    }, "All data values are outside")
    expect_type(u2, "integer")
    expect_true(all(c("binmode", "breaks", "bin0") %in% names(attributes(u2))))
    u3 <- bin(seq(-20, -10), binmode = "equalWidth", nBins = 5, minAbsX = NULL)
    expect_identical(u2, u3)

    # uniform distribution, all negative values, set minAbsX (equalN)
    expect_warning({
        u2 <- bin(seq(-20, -10), binmode = "equalN", nBins = 5, minAbsX = 5)
    }, "All data values are outside")
    expect_type(u2, "integer")
    expect_true(all(c("binmode", "breaks", "bin0") %in% names(attributes(u2))))
    u3 <- bin(seq(-20, -10), binmode = "equalN", nBins = 5, minAbsX = NULL)
    expect_identical(u2, u3)
    
    # asymmetric distribution
    set.seed(2)
    x <- c(rnorm(225, 0.006424305, 0.0792525),
           rnorm(775, 0.735741802, 0.5800667))

    a1 <- bin(x, binmode = "equalN", nElements = 100)
    expect_equal(nlevels(a1), 10L)
    expect_true(all(table(a1) == 100))

    expect_warning(a2 <- bin(x, binmode = "equalN", nElements = 50, minAbsX = 0.6))
    expect_true(table(a2)[getZeroBin(a2)] == 550L)

    a3 <- bin(x, binmode = "equalWidth", nBins = 5)
    expect_equal(nlevels(a3), 5L)
    expect_equal(diff(attr(a3, "breaks")), rep(0.6648299, 5L), tolerance = 1e-6)

    expect_warning(a4 <- bin(x, binmode = "equalWidth", nBins = 5, minAbsX = 0.6))
    expect_true(table(a4)[getZeroBin(a4)] == 526L)
})

test_that("getZeroBin() and setZeroBin() work properly", {
    set.seed(1)
    x <- rnorm(1000)

    b1 <- bin(x, nElements = 100)
    b2 <- bin(x, nElements = 100, minAbsX = 0.5)
    b3 <- cut(x, breaks = 10)

    expect_true(is.na(getZeroBin(b1)))
    expect_identical(getZeroBin(b2), 4L)
    expect_true(is.null(getZeroBin(b3)))

    expect_error(setZeroBin(b1, FALSE))
    expect_error(setZeroBin(b1, 2000))
    expect_error(setZeroBin(b1, "error"))

    expect_type(b4 <- setZeroBin(b1, 6), "integer")
    expect_type(b5 <- setZeroBin(b1, "(-0.0353,0.245]"), "integer")
    expect_type(b6 <- setZeroBin(b1, NA), "integer")

    expect_type(getZeroBin(b4), "integer")
    expect_identical(getZeroBin(b4), getZeroBin(b5))
    expect_true(is.na(getZeroBin(b6)))
})

#' @importFrom Biostrings matchPWM DNA_BASES DNAStringSet fasta.seqlengths
#'   reverseComplement
#' @importFrom IRanges IRanges start width
#' @importFrom GenomicRanges GRanges
#' @importFrom TFBSTools Matrix PWMatrix PWMatrixList ID name
#' @importFrom methods .valueClassTest
#' @importFrom utils strcapture
#' @importFrom S4Vectors Rle queryHits subjectHits mcols
#' @importFrom BSgenome getSeq
#' @importFrom BiocParallel bplapply SerialParam bpnworkers
NULL

# internal function:  dump PWMatrixList to file in homer2 format
# - homer2 needs the matrix as base probabilities
#   --> convert pwm from log2-odds scores to base probabilities
#   --> convert cutoff scores to natural log
.dumpPWMsToHomer2File <- function(pwmL, fname, relscore=0.8, absscore=NULL) {
    stopifnot(inherits(pwmL, "PWMatrixList"))
    stopifnot(is.null(absscore) || is.numeric(absscore))
    if (is.numeric(absscore)) {
        absscore <- absscore / log2(exp(1))
        if (length(absscore) == 1L)
            absscore <- rep(absscore, length(pwmL))
    }
    fh <- file(fname, "wb")
    for (i in seq_along(pwmL)) {
        x <- pwmL[[i]]
        pwm <- (2^TFBSTools::Matrix(x) / TFBSTools::bg(x))
        pwm <- sweep(pwm, 2, colSums(pwm), "/")
        scorecut <- NA
        if (is.null(absscore)) {
            # same definition of relative score as in TFBSTools::searchSeq
            tmp <- TFBSTools::Matrix(x) / log2(exp(1)) # convert to natural log
            tmprng <- c(Biostrings::minScore(tmp), Biostrings::maxScore(tmp))
            scorecut <- tmprng[1] + relscore * diff(tmprng)
        } else {
            scorecut <- absscore[i]
        }

        cat(sprintf(
            ">%s\t%s\t%.6f\n",
            paste(apply(pwm, 2, function(x) rownames(pwm)[which.max(x)]),
                  collapse = ""),
            paste0(ID(pwmL[[i]]), ":::", name(pwmL[[i]])), scorecut),
            file = fh, append = TRUE)
        write.table(file = fh, t(pwm), row.names = FALSE, col.names = FALSE,
                    sep = "\t", quote = FALSE, append = TRUE)
    }
    close(fh)
    return(fname)
}

# internal function:  read motifs from file in homer2 format into PWMatrixList
# - homer2 needs the matrix as base probabilities
#   --> convert from base probabilities to log2-odds scores
.readPWMsFromHomer2File <- function(fname) {
    stopifnot(is.character(fname) && length(fname) == 1L && file.exists(fname))
    lns <- readLines(fname)
    i <- grep("^>", lns)
    df <- strcapture(pattern = "^>([^\t]+)\t([^\t]+):::([^\t]+)\t([0-9.]+).*$",
                     x = lns[i], proto = data.frame(consensus = character(),
                                                    id = character(),
                                                    name = character(),
                                                    cutoffScore = numeric()))
    w <- diff(c(i, length(lns) + 1L)) - 1L
    mL <- split(lns[-i], rep(seq_along(i), w))
    names(mL) <- df$name
    mL <- lapply(mL, function(x) {
        m <- do.call(
            cbind, lapply(x, function(xx) as.numeric(
                unlist(strsplit(xx, "\t", fixed = TRUE)))))
        rownames(m) <- c("A", "C", "G", "T")
        log2((m + 1e-9) / (0.25 + 1e-9))
    })
    pwmL <- lapply(seq_along(mL), function(j) PWMatrix(ID = df[j, "id"],
                                                       name = df[j, "name"],
                                                       profileMatrix = mL[[j]]))
    pwmL <- do.call(PWMatrixList, pwmL)
    names(pwmL) <- df$name
    return(pwmL)
}

# internal function:  run matchPWM on concatenated queries
# - interface similar to matchPWM,DNAString-method, but:
#      * without arguments "with.score" and "..."
#      * "pwm" of class PWMatrixList (as opposed to matrix)
#      * "subject" of class DNAStringSet (as opposed to DNAString)
#      * new "BPPARAM" argument (parallelize over motifs in "pwm")
#      * returns a GRanges object with hits
# - concatenates the subject sequences for efficiency
# - intended to be used via findMotifHits
#' @importFrom TFBSTools ID name
#' @importFrom Biostrings matchPWM DNAStringSet reverseComplement
#' @importFrom GenomicRanges GRanges findOverlaps
#' @importFrom IRanges IRanges
#' @importFrom S4Vectors Rle queryHits subjectHits mcols
#' @importFrom BiocGenerics sort strand
#' @importFrom BiocParallel bplapply SerialParam
.matchPWM.concat <- function(pwm, subject, min.score = "80%",
                             BPPARAM = SerialParam()) {
    # concatenate subject
    snames <- if (is.null(names(subject))) {
        paste0("s", seq_along(subject))
    } else {
        names(subject)
    }
    pwmids <- TFBSTools::ID(pwm)
    pwmnames <- TFBSTools::name(pwm)
    pwmnames <- if (is.null(pwmnames)) paste0("m", seq_along(pwm)) else pwmnames
    concatsubject <- unlist(subject)

    # search pwm on both strands
    gr <- do.call(c, bplapply(seq_along(pwm), function(pi) {
        pwm1 <- Matrix(pwm[[pi]])
        pos <- matchPWM(pwm1, concatsubject,
                        min.score = min.score, with.score = TRUE)
        neg <- matchPWM(reverseComplement(pwm1), concatsubject,
                        min.score = min.score, with.score = TRUE)
        matches <- GRanges(
            rep("arbitrary_seqname", length(pos) + length(neg)),
            IRanges(start = c(start(pos), start(neg)),
                    width = c(width(pos), width(neg))),
            strand = Rle(factor(c("+", "-"),
                                levels = c("+", "-", "*")),
                         c(length(pos), length(neg))),
            matchedSeq = c(DNAStringSet(pos),
                           reverseComplement(DNAStringSet(neg))),
            pwmid = Rle(pwmids[pi], length(pos) + length(neg)),
            pwmname = Rle(pwmnames[pi], length(pos) + length(neg)),
            score = c(mcols(pos)$score, mcols(neg)$score)
        )

        # exclude overlap with boundaries and convert to original coordinates
        combgr <- GRanges(
            "arbitrary_seqname",
            IRanges(start = cumsum(c(1, width(subject)[-length(subject)])),
                    width = width(subject))
        )
        ov <- findOverlaps(matches, combgr, type = "within")
        GRanges(seqnames = snames[subjectHits(ov)],
                ranges = IRanges(
                    start = start(matches)[queryHits(ov)] -
                        start(combgr)[subjectHits(ov)] + 1,
                    width = width(matches)[queryHits(ov)]
                ),
                strand = strand(matches)[queryHits(ov)],
                mcols(matches)[queryHits(ov), , drop = FALSE],
                seqlengths = structure(width(subject), names = snames))
    }, BPPARAM = BPPARAM))

    # order by subject
    return(sort(gr))
}


#' @title Find motif matches in sequences.
#'
#' @description \code{findMotifHits} scans sequences (either provided
#' as a file, an R object or genomic coordinates)  for matches to
#' positional weight matrices (provided as a file or as R objects)
#'
#' @param query The motifs to search for, either a
#'     \describe{
#'         \item{\code{character(1)}}{ with the path and file name of a motif
#'               file with PWM in HOMER format (currently only
#'               supported for \code{method="homer2"})}
#'         \item{\code{PWMatrix}}{ with a single PWM}
#'         \item{\code{PWMatrixList}}{ with several PWMs to search for.}
#'      }
#'
#' @param subject The sequences to be searched, either a
#'     \describe{
#'         \item{\code{character}}{ with the path and file name of a sequence
#'               file with DNA sequences in FASTA format}
#'         \item{\code{DNAString}}{ with a single sequence}
#'         \item{\code{DNAStringSet}}{ with several sequences}
#'         \item{\code{GRanges}}{ object with the genomic coordinates
#'             of the sequences to be searched.}
#'     }
#'
#' @param min.score The minimum score for counting a match. Can be given as
#'     a character string containing a percentage (e.g. "85%") of  of the
#'     highest possible score or as a single number.
#'
#' @param method The internal method to use for motif searching. One of
#'     \describe{
#'         \item{\code{"matchPWM"}}{ using Biostrings::matchPWM (optimized)}
#'         \item{\code{"homer2"}}{ call to the homer2 binary}
#'     }
#'     Please note that the two methods might give slightly different results
#'     (see details).
#'
#' @param homerfile Path and file name of the \code{homer2} binary.
#'
#' @param BPPARAM An optional \code{\link[BiocParallel]{BiocParallelParam}}
#'     instance determining the parallel back-end to be used during evaluation.
#'
#' @param genome \code{BSgenome} object that is the reference genome of the
#'     subject. This argument is set to NULL by default and only used by the
#'     function when the subject is a \code{GRanges} object. It is then
#'     necessary to specify the genome so that the function can internally
#'     convert the genomic regions into a \code{DNAStringSet} object.
#'
#' @return A \code{GRanges} object with the matches to \code{query} in
#'     \code{subject}.
#'
#' @details The implemented methods (\code{matchPWM} and \code{homer2}) are
#'     there for convenience (\code{method="matchPWM"} calls
#'     \code{Biostrings::matchPWM} internally in an optimized fashion, and
#'     \code{method = "homer2"} calls the command line tool from Homer and
#'     therefore requires an installation of Homer).
#'
#'     In general, running \code{findMotifHits} with the same parameters using
#'     any of the methods generates identical results. Some minor differences
#'     could occur that result from rounding errors during the necessary
#'     conversion of PWMs (log2-odd scores) to the probability matrices needed
#'     by Homer, and the conversion of scores from and to the natural log scale
#'     used by Homer. These conversions are implemented transparently for the
#'     user, so that the arguments of \code{findMotifHits} do not have to be
#'     adjusted (e.g. the PWMs should always contain log2-odd scores, and
#'     \code{min.score} is always on the log2 scale).
#'
#'     If there are bases with frequencies of less than 0.001 in a motif, Homer
#'     will set them to 0.001 and adjust the other frequencies at that motif
#'     position accordingly so that they sum to 1.0. This may differ from the
#'     adjustment used when scanning a PWM with \code{matchPWM} (e.g. the
#'     \code{pseudocounts} argument in the \code{\link[TFBSTools]{toPWM}}
#'     function), and thus can give rise to differences in reported motif hits
#'     and hit scores (typically only low-scoring hits).
#'
#' @examples
#' seqs <- Biostrings::DNAStringSet(c(s1 = "GTCAGTCGATC", s2 = "CAGTCTAGCTG",
#'                                    s3 = "CGATCGTCAGT", s4 = "AGCTGCAGTCT"))
#' m <- rbind(A = c(2, 0, 0),
#'            C = c(1, 1, 0),
#'            G = c(0, 2, 0),
#'            T = c(0, 0, 3))
#' pwms <- TFBSTools::PWMatrixList(
#'     TFBSTools::PWMatrix(ID = "m1", profileMatrix = m),
#'     TFBSTools::PWMatrix(ID = "m2", profileMatrix = m[, 3:1])
#' )
#' findMotifHits(pwms, seqs, min.score = 7)
#'
#' @export
#' @docType methods
#' @rdname findMotifHits-methods
#' @importFrom cli cli_abort
setGeneric(name = "findMotifHits",
           def = function(query, subject, min.score,
                          method = c("matchPWM", "homer2"),
                          homerfile = findHomer("homer2"),
                          BPPARAM = SerialParam(),
                          genome = NULL) {
               standardGeneric("findMotifHits")
           },
           valueClass = "GRanges")

# method hierarchy:
# 1. findMotifHits,character,character
#    --> if method=="homer2", use homer2; else --> 9.
# 2. findMotifHits,character,DNAString
#    --> 3.
# 3. findMotifHits,character,DNAStringSet
#    --> if method=="homer2" --> 1.     ; else --> 9.
# 4. findMotifHits,PWMatrix,character
#    --> 7.
# 5. findMotifHits,PWMatrix,DNAString
#    --> 9.
# 6. findMotifHits,PWMatrix,DNAStringSet
#    --> 9.
# 7. findMotifHits,PWMatrixList,character
#    --> if method=="homer2" --> 1.     ; else --> 9.
# 8. findMotifHits,PWMatrixList,DNAString
#    --> 9.
# 9. findMotifHits,PWMatrixList,DNAStringSet
#    --> if method=="homer2" --> 1.     ; else --> use matchPWM
# 10. findMotifHits,PWMatrix,GRanges
#    --> 11.
# 11. findMotifHits,PWMatrixList,GRanges
#    --> 9.


# 1.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,character,character-method
setMethod("findMotifHits",
          c("character", "character"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              method <- match.arg(method)
              stopifnot(method == "matchPWM" ||
                        (method == "homer2" && is.character(homerfile) &&
                         length(homerfile) == 1L && file.exists(homerfile)))

              if (method == "matchPWM") {

                  pwmL <- .readPWMsFromHomer2File(query)
                  seqs <- Biostrings::readDNAStringSet(filepath = subject)
                  findMotifHits(query = pwmL, subject = seqs,
                                min.score = min.score, method = method,
                                BPPARAM = BPPARAM, genome = genome)

              } else if (method == "homer2") {

                  if (!length(query) == 1L || !file.exists(query)) {
                      cli_abort(paste0(
                          "{.arg query} must be either a {.cls character} scalar, ",
                          "a {.cls PWMatrix} object or a {.cls PWMatrixList} object"))
                  }

                  if (length(subject) != 1L || !file.exists(subject)) {
                      cli_abort(paste0(
                          "{.arg subject} must be a {.cls character} scalar with the name of ",
                           "a FASTA sequence file, or a {.cls DNAString}, {.cls DNAStringSet} ",
                           "or {.cls GRanges} object"))
                  }

                  # make sure sequences are not too long
                  # currently, homer2 only support sequences shorter than 1e6
                  # bases (see cpp/Motif2.h:#define MOTIF2_BUFFER 10000100
                  #  and also char* curSeq = new char[1000000];)
                  if (any(
                      tooLong <- ((sl <- fasta.seqlengths(subject)) >= 1e6))) {
                      cli_abort(paste0(
                          "For {.code method = 'homer2'}, {.arg subject} must only contain",
                          " sequences shorter than 1 Mb, the following",
                          " sequence{?s} {?is/are} too long: {names(sl)[tooLong]}"))
                  }

                  # run homer2
                  args <-
                      sprintf("find -i %s -m %s -offset 1 -strand both -p %d",
                              subject, query, bpnworkers(BPPARAM))
                  res <- system2(command = homerfile, args = args,
                                 stdout = TRUE, stderr = FALSE, wait = TRUE)

                  # check homer2 output
                  ok <- grepl("^.+\\t[0-9]+\\t[ACGT]+\\t.+\\t[+-]\\t[0-9.]+$",
                              res, perl = TRUE)
                  if (any(!ok))
                    warning(sum(!ok), " of ", length(ok), " hits reported by",
                            " Homer are malformed and will be ignored.",
                            " To ensure complete and correct results,",
                            " re-run Homer using 'BPPARAM = SerialParam()'.")

                  # parse output
                  con <- textConnection(res[ok])
                  resparsed <- scan(file = con,
                                    what = list(seqnames = "", start = 1L,
                                                matchedSeq = "", pwmidname = "",
                                                strand = "", score = 1.0),
                                    sep = "\t", quiet = TRUE)
                  close(con)
                  tmp <- strsplit(resparsed$pwmidname, ":::", fixed = TRUE)
                  pwmid <- unlist(lapply(tmp, "[", 1L))
                  pwmname <- unlist(lapply(tmp, "[", 2L))
                  hitstart <- ifelse(resparsed$strand == "+",
                                     resparsed$start,
                                     resparsed$start -
                                         nchar(resparsed$matchedSeq) + 1)
                  seqtemp <- DNAStringSet(resparsed$matchedSeq)
                  seqtemp[resparsed$strand != "+"] <-
                      reverseComplement(seqtemp[resparsed$strand != "+"])
                  gr <- GRanges(seqnames = resparsed$seqnames,
                                ranges = IRanges(
                                    start = hitstart,
                                    width = nchar(resparsed$matchedSeq)
                                ),
                                strand = resparsed$strand,
                                matchedSeq = seqtemp,
                                pwmid = Rle(pwmid),
                                pwmname = Rle(pwmname),
                                score = resparsed$score / log(2),
                                seqlengths = fasta.seqlengths(subject))
                  sort(gr)
              }
          })

# 2.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,character,DNAString-method
setMethod("findMotifHits",
          c("character", "DNAString"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              subjectSet <- Biostrings::DNAStringSet(subject)
              names(subjectSet) <-
                  if (is.null(names(subject))) "DNAString" else names(subject)
              findMotifHits(query, subjectSet, min.score,
                            method, homerfile, BPPARAM, genome)
          })

# 3.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,character,DNAStringSet-method
setMethod("findMotifHits",
          c("character", "DNAStringSet"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              method <- match.arg(method)

              if (method == "matchPWM") {

                  pwmL <- .readPWMsFromHomer2File(query)
                  findMotifHits(query = pwmL, subject = subject,
                                min.score = min.score,
                                method = method, homerfile = homerfile,
                                BPPARAM = BPPARAM, genome = genome)

              } else if (method == "homer2") {

                  # write sequences to file
                  if (is.null(names(subject))) {
                      names(subject) <- paste0("s", seq_along(subject))
                  }
                  tmpf <- tempfile(fileext = ".fa")
                  Biostrings::writeXStringSet(x = subject, filepath = tmpf,
                                              append = FALSE, compress = FALSE,
                                              format = "fasta")
                  res <- findMotifHits(query = query, subject = tmpf,
                                       min.score = min.score,
                                       method = method, homerfile = homerfile,
                                       BPPARAM = BPPARAM, genome = genome)
                  unlink(tmpf)
                  return(res)
              }
          })

# 4.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrix,character-method
setMethod("findMotifHits",
          c("PWMatrix", "character"),
          function(query, subject,
                   min.score, method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              queryList <- TFBSTools::PWMatrixList(query)
              names(queryList) <- name(query)
              findMotifHits(queryList, subject, min.score,
                            method, homerfile, BPPARAM, genome)
          })

# 5.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrix,DNAString-method
setMethod("findMotifHits",
          c("PWMatrix", "DNAString"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              queryList <- TFBSTools::PWMatrixList(query)
              names(queryList) <- name(query)
              subjectSet <- Biostrings::DNAStringSet(subject)
              names(subjectSet) <-
                  if (is.null(names(subject))) "DNAString" else names(subject)
              findMotifHits(queryList, subjectSet,
                            min.score, method, homerfile, BPPARAM, genome)
          })

# 6.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrix,DNAStringSet-method
setMethod("findMotifHits",
          c("PWMatrix", "DNAStringSet"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              queryList <- TFBSTools::PWMatrixList(query)
              names(queryList) <- name(query)
              findMotifHits(queryList, subject, min.score,
                            method, homerfile, BPPARAM, genome)
          })

# 7.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrixList,character-method
setMethod("findMotifHits",
          c("PWMatrixList", "character"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              method <- match.arg(method)

              if (method == "matchPWM") {

                  seqs <- Biostrings::readDNAStringSet(filepath = subject)
                  findMotifHits(query = query, subject = seqs,
                                min.score = min.score,
                                method = method, homerfile = homerfile,
                                BPPARAM = BPPARAM, genome = genome)

              } else if (method == "homer2") {

                  # write motifs to file
                  tmpf <- tempfile(fileext = ".motif")
                  if (is.character(min.score) &&
                      grepl(pattern = "^[0-9.]+[%]$", x = min.score)) {
                      .dumpPWMsToHomer2File(
                          pwmL = query, fname = tmpf,
                          relscore = as.numeric(sub("[%]$", "", min.score))/100
                      )
                  } else if (is.numeric(min.score)) {
                      .dumpPWMsToHomer2File(pwmL = query, fname = tmpf,
                                            absscore = min.score)
                  } else {
                      cli_abort(paste0(
                          "wrong type of {.arg min.score}: ",
                          "should be {.cls numeric} instead of {.cls {type(min.score)}}"))
                  }

                  res <- findMotifHits(query = tmpf, subject = subject,
                                       min.score = min.score,
                                       method = method, homerfile = homerfile,
                                       BPPARAM = BPPARAM, genome = genome)
                  unlink(tmpf)
                  return(res)
              }
          })

# 8.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrixList,DNAString-method
setMethod("findMotifHits",
          c("PWMatrixList", "DNAString"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              subjectSet <- Biostrings::DNAStringSet(subject)
              names(subjectSet) <-
                  if (is.null(names(subject))) "DNAString" else names(subject)
              findMotifHits(query, subjectSet, min.score,
                            method, homerfile, BPPARAM, genome)
          })

# 9.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrixList,DNAStringSet-method
setMethod("findMotifHits",
          c("PWMatrixList", "DNAStringSet"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              method <- match.arg(method)

              if (method == "matchPWM") {

                  gr <- .matchPWM.concat(pwm = query, subject = subject,
                                         min.score = min.score,
                                         BPPARAM = BPPARAM)
                  return(gr)

              } else if (method == "homer2") {

                  # write motifs to file
                  tmpf1 <- tempfile(fileext = ".motif")
                  if (is.character(min.score) &&
                      grepl(pattern = "^[0-9.]+[%]$", x = min.score)) {
                      .dumpPWMsToHomer2File(
                          pwmL = query, fname = tmpf1,
                          relscore = as.numeric(sub("[%]$", "", min.score))/100
                      )
                  } else if (is.numeric(min.score)) {
                      .dumpPWMsToHomer2File(pwmL = query, fname = tmpf1,
                                            absscore = min.score)
                  } else {
                      cli_abort(paste0(
                          "wrong type of {.arg min.score}: ",
                          "should be {.cls numeric} instead of {.cls {type(min.score)}}"))
                  }

                  # write sequences to file
                  tmpf2 <- tempfile(fileext = ".fa")
                  Biostrings::writeXStringSet(x = subject, filepath = tmpf2,
                                              append = FALSE, compress = FALSE,
                                              format = "fasta")
                  # call next method
                  res <- findMotifHits(query = tmpf1, subject = tmpf2,
                                       min.score = min.score, method = method,
                                       homerfile = homerfile, BPPARAM = BPPARAM,
                                       genome = genome)
                  unlink(c(tmpf1, tmpf2))
                  return(res)
              }
          })


# 10.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrix,GRanges-method
setMethod("findMotifHits",
          c("PWMatrix", "GRanges"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {
              queryList <- TFBSTools::PWMatrixList(query)
              names(queryList) <- name(query)
              findMotifHits(queryList, subject, min.score,
                            method, homerfile, BPPARAM, genome)
          })


# 11.
#' @rdname findMotifHits-methods
#' @aliases findMotifHits,PWMatrixList,GRanges-method
setMethod("findMotifHits",
          c("PWMatrixList", "GRanges"),
          function(query, subject, min.score,
                   method = c("matchPWM", "homer2"),
                   homerfile = findHomer("homer2"),
                   BPPARAM = SerialParam(),
                   genome = NULL) {

            if (is.null(genome)) {
                cli_abort("{.arg genome} must be provided for a {.cls GRanges} {.arg subject}.")
            }
            if (!is(genome, "BSgenome")) {
                cli_abort("{.arg genome} must be of class {.cls BSgenome}.")
            }

            seqs <- BSgenome::getSeq(genome, subject)
            names(seqs) <- if (is.null(names(subject))) {
                paste0("r", seq_along(subject))
            } else {
                names(subject)
            }

            findMotifHits(query, seqs, min.score,
                          method, homerfile, BPPARAM, genome = NULL)
          })

test_that("findMotifHits() works properly", {
    suppressPackageStartupMessages(
        library(GenomicRanges)
    )
    homerbin <- findHomer("homer2", dirs = "/Users/runner/work/monaLisa/monaLisa/homer/bin")
    if (is.na(homerbin)) {
        homerbin <- findHomer("homer2", dirs = "/work/gbioinfo/Appz/Homer/Homer-4.11/bin")
    }

    seq1 <- Biostrings::DNAString("CCCCCAAACCCCC")
    seqs <- Biostrings::DNAStringSet(c(seq1 = "CCCCCAAACCCCC", seq2 = "AAAGGGGGAAA"))
    gr <- GenomicRanges::GRanges("chr1", IRanges::IRanges(start = c(15927933, 3261215),
                                                          end = c(15927945, 3261225),
                                                          names = c("seq1", "seq2")),
                                 strand = "+")

    sf <- tempfile(fileext = ".fa")
    Biostrings::writeXStringSet(x = seqs, filepath = sf)

    M <- matrix(rep(c(.7,.1,.1,.1),3), nrow = 4, dimnames = list(c("A","C","G","T")))
    pwm <- TFBSTools::PWMatrix(ID = "mypwm", name = "mypwm", profileMatrix = log2(M / 0.25))
    pwmL <- TFBSTools::PWMatrixList(pwm)
    names(pwmL) <- "mypwm"

    tf <- tempfile(fileext = ".motif")
    monaLisa:::.dumpPWMsToHomer2File(pwmL, tf)

    tf.pwm <- monaLisa:::.readPWMsFromHomer2File(tf)

    expect_equal(TFBSTools::Matrix(pwmL[[1]]), TFBSTools::Matrix(tf.pwm[[1]]))

    # method = "matchPWM"
    ############################################################################
    expect_error(findMotifHits(pwmL, sf,   min.score = TRUE, method = "matchPWM"))
    expect_error(findMotifHits(pwmL, seqs, min.score = TRUE, method = "matchPWM"))

    res1c  <- findMotifHits(tf,           sf,   min.score = "90%", method = "matchPWM") # character,character
    res2c  <- findMotifHits(tf,           seq1, min.score = "90%", method = "matchPWM") # character,DNAString
    res3c  <- findMotifHits(tf,           seqs, min.score = "90%", method = "matchPWM") # character,DNAStringSet
    res4c  <- findMotifHits(pwm,          sf,   min.score = "90%", method = "matchPWM") # PWMatrix,character
    res5c  <- findMotifHits(pwm,          seq1, min.score = "90%", method = "matchPWM") # PWMatrix,DNAString
    res6c  <- findMotifHits(pwm,          seqs, min.score = "90%", method = "matchPWM") # PWMatrix,DNAStringSet
    res7c  <- findMotifHits(pwmL,         sf,   min.score = "90%", method = "matchPWM") # PWMatrixList,character
    res7cb <- findMotifHits(pwmL,         sf,   min.score = 4.456, method = "matchPWM") # PWMatrixList,character
    res8c  <- findMotifHits(pwmL,         seq1, min.score = "90%", method = "matchPWM") # PWMatrixList,DNAString
    res9c  <- findMotifHits(pwmL,         seqs, min.score = "90%", method = "matchPWM") # PWMatrixList,DNAStringSet
    res9cb <- findMotifHits(pwmL,         seqs, min.score = 4.456, method = "matchPWM") # PWMatrixList,DNAStringSet
    res10c <- findMotifHits(pwm,          gr,   min.score = "90%", method = "matchPWM", genome = BSgenome.Mmusculus.UCSC.mm10::BSgenome.Mmusculus.UCSC.mm10) # PWMatrix,GRanges
    res11c <- findMotifHits(pwmL,         gr,   min.score = "90%", method = "matchPWM", genome = BSgenome.Mmusculus.UCSC.mm10::BSgenome.Mmusculus.UCSC.mm10) # PWMatrixList,GRanges
    res12c <- findMotifHits(tf, unname(seqs),   min.score = "90%", method = "matchPWM") # character,DNAStringSet(unnamed)

    # correctness
    expect_true(inherits(res1c, "GRanges"))
    expect_length(res1c, 3L)
    expect_equal(as.character(res1c$pwmname), rep("mypwm",3))
    expect_equal(GenomicRanges::start(res1c), c(6, 1, 9))

    expect_true(inherits(res2c, "GRanges"))
    expect_length(res2c, 1L)
    expect_equal(as.character(res2c$pwmname), "mypwm")
    expect_equal(GenomicRanges::start(res2c), 6L)

    # consistency between methods
    expect_equal(res1c, res3c)
    expect_equal(res1c, res4c)
    expect_equal(res2c, res5c)
    expect_equal(res1c, res6c)
    expect_equal(res1c, res7c)
    expect_equal(res1c, res7cb)
    expect_equal(res2c, res8c)
    expect_equal(res1c, res9c)
    expect_equal(res1c, res9cb)
    expect_equal(res1c, res10c)
    expect_equal(res1c, res11c)
    expect_identical(GenomicRanges::ranges(res1c), GenomicRanges::ranges(res12c))

    # method = "homer2"
    if (!is.na(homerbin)) { # only test if homer2 binary was found
        expect_error(findMotifHits(tf, DNAString(paste(rep("A", 1e6), collapse = "")), method = "homer2", homerfile = homerbin))
        expect_error(findMotifHits("not-existing", sf, method = "homer2", homerfile = homerbin))
        expect_error(findMotifHits(tf, "not-existing", method = "homer2", homerfile = homerbin))
        expect_error(findMotifHits(tf, sf, method = "error"))
        expect_error(findMotifHits(pwm,  gr,   min.score = "90%", method = "homer2", homerfile = homerbin))
        expect_error(findMotifHits(pwm,  gr,   min.score = "90%", method = "homer2", homerfile = homerbin, genome = "error"))
        expect_s4_class(findMotifHits(pwmL, unname(gr), min.score = "90%", method = "homer2", homerfile = homerbin, genome = BSgenome.Mmusculus.UCSC.mm10::BSgenome.Mmusculus.UCSC.mm10), "GRanges")

        expect_error(findMotifHits(pwmL, sf,   min.score = TRUE, method = "homer2", homerfile = homerbin))
        expect_error(findMotifHits(pwmL, seqs, min.score = TRUE, method = "homer2", homerfile = homerbin))

        res1h  <- findMotifHits(tf,           sf,   min.score = "90%", method = "homer2", homerfile = homerbin) # character,character
        res2h  <- findMotifHits(tf,           seq1, min.score = "90%", method = "homer2", homerfile = homerbin) # character,DNAString
        res3h  <- findMotifHits(tf,           seqs, min.score = "90%", method = "homer2", homerfile = homerbin) # character,DNAStringSet
        res4h  <- findMotifHits(pwm,          sf,   min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrix,character
        res5h  <- findMotifHits(pwm,          seq1, min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrix,DNAString
        res6h  <- findMotifHits(pwm,          seqs, min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrix,DNAStringSet
        res7h  <- findMotifHits(pwmL,         sf,   min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrixList,character
        res7hb <- findMotifHits(pwmL,         sf,   min.score = 4.456, method = "homer2", homerfile = homerbin) # PWMatrixList,character
        res8h  <- findMotifHits(pwmL,         seq1, min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrixList,DNAString
        res9h  <- findMotifHits(pwmL,         seqs, min.score = "90%", method = "homer2", homerfile = homerbin) # PWMatrixList,DNAStringSet
        res9hb <- findMotifHits(pwmL,         seqs, min.score = 4.456, method = "homer2", homerfile = homerbin) # PWMatrixList,DNAStringSet
        res10h <- findMotifHits(pwm,          gr,   min.score = "90%", method = "homer2", homerfile = homerbin, genome = BSgenome.Mmusculus.UCSC.mm10::BSgenome.Mmusculus.UCSC.mm10) # PWMatrix,GRanges
        res11h <- findMotifHits(pwmL,         gr,   min.score = "90%", method = "homer2", homerfile = homerbin, genome = BSgenome.Mmusculus.UCSC.mm10::BSgenome.Mmusculus.UCSC.mm10) # PWMatrixList,GRanges
        res12h <- findMotifHits(tf, unname(seqs),   min.score = "90%", method = "homer2", homerfile = homerbin) # character,DNAStringSet(unnamed)

        # consistency between "matchPWM" and "homer2"
        expect_identical(ranges(res1c), ranges(res1h))
        expect_identical(ranges(res2c), ranges(res2h))
        expect_equal(res1c$score, res1h$score, tolerance = 1e-6)
        expect_equal(res2c$score, res2h$score, tolerance = 1e-6)

        # consistency between methods
        expect_equal(res1h, res3h)
        expect_equal(res1h, res4h)
        expect_equal(res2h, res5h)
        expect_equal(res1h, res6h)
        expect_equal(res1h, res7h)
        expect_equal(res1h, res7hb)
        expect_equal(res2h, res8h)
        expect_equal(res1h, res9h)
        expect_equal(res1h, res9hb)
        expect_equal(res1h, res10h)
        expect_equal(res1h, res11h)
        expect_identical(GenomicRanges::ranges(res1h), GenomicRanges::ranges(res12h))
    }

    unlink(c(sf, tf))
})

test_that("motifs can be written to/read from files", {
    # create dummy motif file and PWMatrixList
    m <- matrix(data = c(.1,.3,.3,.3,.01,.01,.01,.97,.5,.0,.0,.5), nrow = 4, dimnames = list(c("A","C","G","T"), NULL))
    pwm <- TFBSTools::PWMatrixList(TFBSTools::PWMatrix(ID = "CTA", name = "name", profileMatrix = log2((m+1e-9)/(.25+1e-9))))
    pwm <- pwm[c(1,1,1)]
    names(pwm) <- rep("name",3)
    tmpf1 <- tempfile()
    tmpf2 <- tempfile()
    tmpstr <- ">CTA\tCTA:::name\t4.80\n0.1\t0.3\t0.3\t0.3\n0.01\t0.01\t0.01\t0.97\n0.5\t0\t0\t0.5\n"
    cat(tmpstr[c(1,1,1)], file = tmpf1, sep = "")

    # read from file
    pwm.file <- monaLisa:::.readPWMsFromHomer2File(tmpf1)
    expect_equal(pwm, pwm.file)

    # write to file
    monaLisa:::.dumpPWMsToHomer2File(pwmL = pwm, fname = tmpf2, absscore = 6.93)
    lns <- readLines(tmpf2)
    expect_identical(">CTA\tCTA:::name\t4.803510", lns[1])
    m.file <- as.matrix(read.delim(tmpf2, header = FALSE, nrows = 3, skip = 1))
    expect_equal(m, t(m.file), ignore_attr = TRUE)

    # clean up
    unlink(x = c(tmpf1, tmpf2))
})

#' Plot diagnostics of binned sequences
#'
#' Plot various diagnostics of binned sequences. Three plot types are
#' available:
#' \describe{
#' \item{\code{length}}{ plots the distribution of sequence lengths within
#'   each bin.}
#' \item{\code{GCfrac}}{ plots the distribution of GC fractions within each
#'   bin.}
#' \item{\code{dinucfreq}}{ plots a heatmap of the relative frequency of each
#'   dinucleotide, averaged across the sequences within each bin. The values
#'   are centered for each dinucleotide to better highlight differences
#'   between the bins. The average relative frequency of each dinucleotide
#'   (across the bins) is indicated as well.}
#' }
#' @param seqs \code{\link[Biostrings]{DNAStringSet}} object with sequences.
#' @param bins Factor of the same length and order as \code{seqs}, indicating
#'   the bin for each sequence. Typically the return value of \code{bin}.
#' @param aspect The diagnostic to plot. Should be one of \code{"length"},
#'   \code{"GCfrac"} and \code{"dinucfreq"}, to plot the distribution of
#'   sequence lengths, the distribution of GC fractions and the average
#'   relative dinucleotide frequencies across the bins.
#' @param draw_quantiles For aspect=\code{"length"} or \code{"GCfrac"},
#'   draw vertical lines at the given quantiles of the density estimate.
#'   If \code{NULL}, no quantile lines will be drawn.
#' @param ... Additional argument passed to \code{getColsByBin}.
#'
#' @export
#'
#' @return For aspect=\code{"length"} or \code{"GCfrac"}, returns a
#'   \code{\link[ggplot2]{ggplot}} object. For aspect=\code{"dinucfreq"},
#'   returns (invisibly) a \code{\link[ComplexHeatmap]{Heatmap-class}} object.
#'
#' @examples
#' seqs <- Biostrings::DNAStringSet(
#'   vapply(1:250, function(i) paste(sample(x = c("A", "C", "G", "T"),
#'                                          size = round(stats::rnorm(1, 20, 5)),
#'                                          replace = TRUE), collapse = ""), "")
#' )
#' bins <- factor(rep(c("a", "b", "c", "d", "e"), each = 50))
#' plotBinDiagnostics(seqs, bins, aspect = "length")
#' plotBinDiagnostics(seqs, bins, aspect = "GCfrac", draw_quantiles = NULL)
#' plotBinDiagnostics(seqs, bins, aspect = "dinucfreq")
#'
#' @importFrom ggplot2 ggplot aes geom_violin scale_fill_manual
#'   scale_colour_manual labs theme_classic
#' @importFrom ComplexHeatmap Heatmap rowAnnotation
#' @importFrom circlize colorRamp2
#' @importFrom Biostrings oligonucleotideFrequency
#' @importFrom BiocGenerics width
#' @importFrom cli cli_abort
#' @importFrom rlang .data
plotBinDiagnostics <- function(seqs, bins,
                               aspect = c("length", "GCfrac", "dinucfreq"),
                               draw_quantiles = c(0.25, 0.5, 0.75),
                               ...) {
    .assertVector(x = seqs, type = "DNAStringSet")
    .assertVector(x = bins, type = "factor")
    if (length(seqs) != length(bins)) {
        cli_abort("{.arg seqs} and {.arg bins} must have equal length and order")
    }
    aspect <- match.arg(aspect)
    .assertVector(x = draw_quantiles, type = "numeric", rngIncl = c(0, 1),
                  allowNULL = TRUE)

    binCols <- getColsByBin(bins, ...)

    if (aspect %in% c("length", "GCfrac")) {
        pd <- data.frame(bin = bins)
        if (identical(aspect, "length")) {
            pd$xvalue <- width(seqs)
            xlab <- "Length (bp)"
        } else if (identical(aspect, "GCfrac")) {
            onf <- oligonucleotideFrequency(seqs, width = 1, as.prob = TRUE)
            pd$xvalue <- onf[, "G"] + onf[, "C"]
            xlab <- "GC fraction"
        }
        p <- ggplot(data = pd,
                    mapping = aes(.data$xvalue, .data$bin, fill = .data$bin)) +
            geom_violin(quantiles = draw_quantiles, quantile.linetype = "solid",
                        show.legend = FALSE) +
            scale_fill_manual(values = attr(binCols, "cols")) +
            labs(x = xlab, y = NULL) +
            theme_classic()
        return(p)
    } else if (aspect == "dinucfreq") {
        dnf <- Biostrings::oligonucleotideFrequency(seqs, width = 2,
                                                    as.prob = TRUE)
        dnfsplit <- lapply(split.data.frame(dnf, bins), colMeans)
        dnfmat <- t(do.call(rbind, dnfsplit))
        cols <- circlize::colorRamp2(breaks = range(rowMeans(dnfmat)),
                                     colors = c("white", "grey50"))
        hm <- ComplexHeatmap::Heatmap(
            t(scale(t(dnfmat), center = TRUE, scale = FALSE)),
            right_annotation = ComplexHeatmap::rowAnnotation(
                OverallFreq = rowMeans(dnfmat),
                col = list(OverallFreq = cols),
                show_annotation_name = FALSE,
                annotation_label = list(
                    OverallFreq = "Average\nrelative\nfrequency\nacross bins")),
            cluster_rows = TRUE,
            cluster_columns = FALSE,
            name = "Mean\nrelative\nfrequency\nin bin\n(centered)"
        )
        show(hm)
        return(invisible(hm))
    }
}

# compare two PFMs of any length (padd left/right with background positions)
# score := correlation of single base frequencies of aligned and padded matrices
# (internal function used by motifSimilarity)
#' @importFrom stats cor
#'
#' @keywords internal
.compareMotifPair <- function(m1, m2) {
    bestScore <- -2
    bestOffset <- 0
    bestDirection <- ""

    ## reverse complement
    rv2 <- rev(m2)
    attributes(rv2) <- attributes(m2)

    len1 <- ncol(m1)
    len2 <- ncol(m2)

    ## offset := start(m1) - start(m2)
    ##        == left-padding of m1 (if > 0)
    ##        == -1 * left-padding of m2 (if < 0)
    for (offset in seq(-len1 + 1L, len2 - 1L)) { # minimal overlap of 1
        # padding of matrices
        mm1 <- cbind(matrix(0.25, nrow = 4, ncol = max(0, offset)),
                     m1,
                     matrix(0.25, nrow = 4,
                            ncol = max(0, len2 - (len1 + offset))))
        mm2 <- cbind(matrix(0.25, nrow = 4, ncol = max(0, -offset)),
                     m2,
                     matrix(0.25, nrow = 4,
                            ncol = max(0, (len1 + offset) - len2)))
        mm2r <- cbind(matrix(0.25, nrow = 4, ncol = max(0, -offset)),
                      rv2,
                      matrix(0.25, nrow = 4,
                             ncol = max(0, (len1 + offset) - len2)))

        score <- cor(as.vector(mm1), as.vector(mm2))
        rvScore <- cor(as.vector(mm1), as.vector(mm2r))

        if (rvScore > bestScore) {
            bestScore <- rvScore
            bestOffset <- offset
            bestDirection <- "revcomp"
        }
        if (score > bestScore) {
            bestScore <- score
            bestOffset <- offset
            bestDirection <- "forward"
        }
    }

    return(list(bestScore = bestScore, bestOffset = bestOffset,
                bestDirection = bestDirection))
}

# compare a PFM to all k-mer of any length (padd left/right with
# background positions)
# score := maximal probability of observing k-mer under (potentially padded) PFM
# (internal function used by motifKmerSimilarity)
#'
#' @keywords internal
.compareMotifKmer <- function(m, kmers) {
    bestScore <- rep(-2, length(kmers))
    bestOffset <- rep(0, length(kmers))

    len1 <- ncol(m)
    len2 <- nchar(kmers[1])
    j <- seq.int(len2)

    ## transform k-mers into numeric indices
    kmersL <- strsplit(x = kmers, split = "", fixed = TRUE)
    kmersN <- utils::relist(match(unlist(kmersL), c("A","C","G","T")), kmersL)
    ## offset := start(m) - start(kmers[i])
    ##        == left-padding of m (if > 0)
    ##        == -1 * left-padding of kmers[i] (if < 0)
    for (offset in seq(-len1 + 1L, len2 - 1L)) {
        # minimal overlap of 1
        # padding of matrix and kmers
        mm <- cbind(matrix(0.25, nrow = 4, ncol = max(0, offset)),
                    m[, seq.int(min(len1 + offset,
                                    len2 - offset, len2)) + max(0, -offset)],
                    matrix(0.25, nrow = 4,
                           ncol = max(0, len2 - (len1 + offset))))
        score <- unlist(lapply(kmersN, function(i) prod(mm[cbind(i, j)])))
        b <- score > bestScore
        if (any(b)) {
            bestScore[b] <- score[b]
            bestOffset[b] <- offset
        }
    }

    return(list(bestScore = bestScore, bestOffset = bestOffset))
}

#' @title Calculate similarities between pairs of motifs.
#'
#' @description For each pair of motifs, calculate the similarity defined as the
#'   maximal Pearson's correlation coefficient between base frequencies over all
#'   possible shifts (relative positions of the two matrices with at least one
#'   overlapping position). If necessary matrices are padded on the sides with
#'   background base frequencies (assuming all bases to have a frequency of
#'   0.25) to enable comparison of all positions in both matrices.
#'
#' @param x Either a \code{\link[TFBSTools]{PFMatrixList}}, or a character
#'   scalar with a file containing motifs in HOMER format (used directly
#'   \code{method = "HOMER"}, loaded into a
#'   \code{\link[TFBSTools]{PFMatrixList}} by \code{\link{homerToPFMatrixList}}
#'   for \code{method = "R"}).
#' @param y Either a \code{\link[TFBSTools]{PFMatrixList}} or \code{NULL}
#'   (default). If \code{y = NULL}, then similarities will be calucalted for all
#'   pairs of motifs within \code{x}. Otherwise, \code{method} must be
#'   \code{"R"} and similarities will be calculated between any motif from
#'   \code{x} to any motif from \code{y}.
#' @param method A character scalar specifying the method for similarity
#'   calculations. Either \code{"R"} (pure R implementation) or \code{"HOMER"}
#'   (will call the \code{compareMotifs.pl} script from HOMER). Results are
#'   identical (apart from rounding errors), and the R implementation is
#'   usually faster and can be parallelized (\code{BPPARAM} argument).
#' @param homerfile Path to the HOMER script \code{compareMotifs.pl} (only used
#'   for \code{method = "HOMER"}.
#' @param homerOutfile A character scalar giving the file to save the similarity
#'   scores (only for \code{metho = "HOMER"}). If \code{NULL}, scores will be
#'   stored into a temporary file.
#' @param BPPARAM An optional \code{\link[BiocParallel]{BiocParallelParam}}
#'     instance determining the parallel back-end to be used during evaluation
#'     (only used for \code{method = "R"}).
#' @param verbose A logical scalar. If \code{TRUE}, report on progress.
#'
#' @return A matrix of Pearson's correlation coefficients for each pair of
#'   motifs.
#'
#' @examples
#' m <- rbind(A = c(12,  0,  0),
#'            C = c( 3,  2,  0),
#'            G = c( 0, 14,  0),
#'            T = c( 0,  0, 15))
#' pfms <- TFBSTools::PFMatrixList(
#'     TFBSTools::PFMatrix(name = "m1", profileMatrix = m),
#'     TFBSTools::PFMatrix(name = "m2", profileMatrix = m + 10),
#'     TFBSTools::PFMatrix(name = "m3", profileMatrix = m[, 3:1])
#' )
#' motifSimilarity(pfms)
#'
#' @seealso \code{\link[BiocParallel]{bplapply}} used for parallelization for
#'   \code{method = "R"},
#'   documentation of HOMER's \code{compareMotifs.pl} for details on
#'   \code{method = "HOMER"}.
#'
#' @importFrom BiocParallel bplapply SerialParam bpnworkers
#'
#' @export
motifSimilarity <- function(x, y = NULL, method = c("R", "HOMER"),
                            homerfile = findHomer("compareMotifs.pl"),
                            homerOutfile = NULL, BPPARAM = SerialParam(),
                            verbose = FALSE) {
    ## branch by method
    stopifnot(exprs = {is.logical(verbose); length(verbose) == 1L})
    method <- match.arg(method)
    if (method == "R") {
        ## pre-flight checks for "R"
        if (is.character(x) && length(x) == 1L && file.exists(x)) {
            .message("reading motifs from {.file {x}}", noTimer = TRUE)
            x <- homerToPFMatrixList(x)
        }
        stopifnot(exprs = {
            is(x, "PFMatrixList")
            is.null(y) || is(y, "PFMatrixList")
            is(BPPARAM, "BiocParallelParam")
        })

        if (bpnworkers(BPPARAM) > 2 && is.null(y)) {
            y <- x
        }

        xm <- lapply(TFBSTools::Matrix(x),
                     function(x) sweep(x, 2, colSums(x), "/"))

        if (is.null(y)) { # compare x to itself, n*(n-1)/2 comparisons
            .message("calculating {length(xm) * (length(xm) - 1) / 2} similarities")
            M <- matrix(NA, nrow = length(xm), ncol = length(xm),
                        dimnames = list(name(x), name(x)))
            diag(M) <- 1.0
            for (i in seq.int(length(x) - 1L)) {
                for (j in seq(i + 1, length(x))) {
                    M[i, j] <- M[j, i] <-
                        .compareMotifPair(xm[[i]], xm[[j]])$bestScore
                }
            }
        } else {#           compare x to y, n*m comparisons
            ym <- lapply(TFBSTools::Matrix(y),
                         function(x) sweep(x, 2, colSums(x), "/"))
            .message(paste0(
                "calculating {length(xm) * length(ym)} similarities using ",
                "{bpnworkers(BPPARAM)} core{?s}"))
            # exclude .compareMotifPair from coverage (tested separatelly)
            # nocov start
            if (bpnworkers(BPPARAM) > 1) {
                M <- do.call(rbind, bplapply(seq_along(xm), function(i) {
                    unlist(lapply(
                        seq_along(ym),
                        function(j) .compareMotifPair(xm[[i]],
                                                      ym[[j]])$bestScore
                    ))
                }, BPPARAM = BPPARAM))
                dimnames(M) <- list(name(x), name(y))
            } else { # nocov end
                M <- matrix(NA, nrow = length(xm), ncol = length(ym),
                            dimnames = list(name(x), name(y)))
                for (i in seq_along(xm)) {
                    for (j in seq_along(ym)) {
                        M[i, j] <- .compareMotifPair(xm[[i]], ym[[j]])$bestScore
                    }
                }
            }
        }

    } else if (method == "HOMER") {
        ## pre-flight checks for "HOMER"
        stopifnot(exprs = {is.character(x); length(x) == 1L; file.exists(x)})
        stopifnot(exprs = {!is.na(homerfile); is.character(homerfile);
            length(homerfile) == 1L; file.exists(homerfile)})
        if (is.null(homerOutfile)) {
            homerOutfile <- tempfile(fileext = ".simmat")
        }
        stopifnot(exprs = {is.character(homerOutfile);
            length(homerOutfile) == 1L; !file.exists(homerOutfile)})

        ## run
        .message("running compareMotifs.pl...")
        system2(command = homerfile,
                args = sprintf("%s test -matrix %s", x, homerOutfile),
                stdout = FALSE, stderr = FALSE)
        M <- as.matrix(read.delim(homerOutfile, row.names = 1))
    }
    return(M)
}


#' @title Calculate similarities between motifs and k-mers.
#'
#' @description For each motif, calculate it's similarity to all k-mers of
#'   length \code{kmerLen}, defined as the maximal probability of observing the
#'   k-mer given the base frequencies of the motif (the maximum is taken over
#'   for all possible ungapped alignments between motif and k-mer). If necessary
#'   matrices are padded on the sides with background base frequencies (assuming
#'   all bases to have a frequency of 0.25).
#'
#' @param x Either a \code{\link[TFBSTools]{PFMatrixList}}, or a character
#'   scalar with a file containing motifs in HOMER format (used directly
#'   \code{method = "HOMER"}, loaded into a
#'   \code{\link[TFBSTools]{PFMatrixList}} by \code{\link{homerToPFMatrixList}}
#'   for \code{method = "R"}).
#' @param kmerLen A \code{numeric} scalar giving the k-mer length.
#' @param kmers Either a character vector of k-mers for which to calculate
#'   the similarity to each motif, or \code{NULL}, in which case all k-mers
#'   of length \code{kmerLen} are used.
#' @param includeRevComp A \code{logical} scalar. If set to \code{TRUE}, each
#'   k-mer as well as its reverse complement is compared to each motif, and the
#'   larger of the two similarities is returned.
#' @param BPPARAM An optional \code{\link[BiocParallel]{BiocParallelParam}}
#'   instance determining the parallel back-end to be used during evaluation.
#' @param verbose A logical scalar. If \code{TRUE}, report on progress.
#'
#' @return A matrix of probabilties for each motif - k-mer pair.
#'
#' @examples
#' m <- rbind(A = c(12,  0,  0),
#'            C = c( 3,  2,  0),
#'            G = c( 0, 14,  0),
#'            T = c( 0,  0, 15))
#' pfms <- TFBSTools::PFMatrixList(
#'     TFBSTools::PFMatrix(name = "m1", profileMatrix = m),
#'     TFBSTools::PFMatrix(name = "m2", profileMatrix = m[, 3:1])
#' )
#' motifKmerSimilarity(pfms, kmerLen = 3)[, c("AGT", "TGA")]
#'
#' @seealso \code{\link[BiocParallel]{bplapply}} used for parallelization.
#'
#' @importFrom BiocParallel bplapply SerialParam bpnworkers
#' @importFrom Biostrings DNA_ALPHABET
#'
#' @export
motifKmerSimilarity <- function(x,
                                kmerLen = 5,
                                kmers = NULL,
                                includeRevComp = FALSE,
                                BPPARAM = SerialParam(),
                                verbose = FALSE) {
    ## pre-flight checks
    .assertScalar(x = verbose, type = "logical")
    .assertScalar(x = includeRevComp, type = "logical")
    if (is.character(x) && length(x) == 1L && file.exists(x)) {
        .message("reading motifs from {.file {x}}", noTimer = TRUE)
        x <- homerToPFMatrixList(x)
    }
    .assertScalar(x = kmerLen, type = "numeric", rngExcl = c(0, Inf))
    stopifnot(exprs = {
        is.null(kmers) ||
            (.assertVector(kmers, type = "character") &&
                 all(unlist(strsplit(kmers, "")) %in% Biostrings::DNA_ALPHABET))
    })
    stopifnot(exprs = {
        is(x, "PFMatrixList")
        round(kmerLen, 0L) == kmerLen
        is(BPPARAM, "BiocParallelParam")
    })

    xm <- lapply(TFBSTools::Matrix(x), function(x) sweep(x, 2, colSums(x), "/"))
    if (is.null(kmers)) {
        kmers <- Biostrings::mkAllStrings(c("A", "C", "G", "T"), kmerLen)
    }

    .message(paste0(
        "calculating {length(xm) * length(kmers)} similarities using ",
        "{bpnworkers(BPPARAM)} core{?s}"))

    if (includeRevComp) {
        kmersrevcomp <- as.character(Biostrings::reverseComplement(
            Biostrings::DNAStringSet(kmers)
        ))
        kmersall <- union(kmers, kmersrevcomp)
    } else {
        kmersall <- kmers
    }

    M0 <- do.call(rbind, bplapply(
        xm, function(m) .compareMotifKmer(m = m, kmers = kmersall)$bestScore,
        BPPARAM = BPPARAM))
    dimnames(M0) <- list(name(x), kmersall)

    ## Get the matrix for the originally specified k-mers
    M <- M0[, kmers, drop = FALSE]

    if (includeRevComp) {
        ## Get the matrix for the corresponding reverse complement k-mers,
        ## and take the maximum similarity for each motif
        Mrev <- M0[, kmersrevcomp, drop = FALSE]
        M <- pmax(M, Mrev)
    }

    return(M)
}

# create artifical motifs, PFMatrix and PFMatrixList
m1 <- matrix(data = c(.1,.3,.3,.3,.01,.01,.01,.97,.5,.0,.0,.5), nrow = 4, dimnames = list(c("A","C","G","T"), NULL))
m2 <- cbind(matrix(.25, nrow = 4, ncol = 2), m1[4:1, ][, 3:1])
rownames(m2) <- rownames(m1)
m3 <- cbind(m1[, c(1,1,1)], matrix(.25, nrow = 4, ncol = 5), m2[, c(5,3,3,1)])

pfm1 <- TFBSTools::PFMatrix(ID = "m1", name = "m1", profileMatrix = 100 * m1)
pfm2 <- TFBSTools::PFMatrix(ID = "m2", name = "m2", profileMatrix = 100 * m2)
pfm3 <- TFBSTools::PFMatrix(ID = "m3", name = "m3", profileMatrix = 100 * m3)

pfmL <- TFBSTools::PFMatrixList(pfm1, pfm2, pfm3)

FourMers <- Biostrings::mkAllStrings(c("A","C","G","T"), 4)


test_that(".compareMotifPair works as expected", {
    res1 <- .compareMotifPair(m1, m2)
    res2 <- .compareMotifPair(m1, m3)
    res3 <- .compareMotifPair(m2, m3)

    expect_equal(res1, list(bestScore = 1.0, bestOffset = 0L, bestDirection = "revcomp"))
    expect_equal(res2, list(bestScore = 0.63146007727884323479, bestOffset = 0L, bestDirection = "revcomp"))
    expect_equal(res3, list(bestScore = 0.63146007727884323479, bestOffset = 7L, bestDirection = "forward"))
})

test_that(".compareMotifKmer works as expected", {
    res1 <- .compareMotifKmer(m1, FourMers)
    res2 <- .compareMotifKmer(m2, FourMers)

    expect_type(res1, "list")
    expect_type(res2, "list")
    expect_length(res1, 2L)
    expect_length(res2, 2L)

    expect_length(b1 <- which(res1$bestScore == max(res1$bestScore)), 42L)
    expect_identical(unique(substr(FourMers[b1], start = 1 + res1$bestOffset[b1], stop = 3 + res1$bestOffset[b1])),
                     c("CTA","CTT","GTA","GTT","TTA","TTT"))

    expect_length(b2 <- which(res2$bestScore == max(res2$bestScore)), 42L)
    o2 <- pmin(5 + res2$bestOffset[b2], 4 - res2$bestOffset[b2], 4)
    expect_identical(unique(substr(FourMers[b2], start = 1, stop = o2)),
                     c("AAA","AAC","AAG",
                       "ATAA","ATAC","ATAG","CAAA","CAAC","CAAG","CTAA","CTAC","CTAG",
                       "GAAA","GAAC","GAAG","GTAA","GTAC","GTAG",
                       "TAA","TAC","TAG",
                       "TTAA","TTAC","TTAG"))
})

test_that("motifSimilarity works as expected", {
    # store motifs in file
    tmpf <- tempfile()
    fh <- file(tmpf, "wt")
    for (i in seq_along(pfmL)) {
        cat(sprintf(">%s\t%s\t5\n", TFBSTools::ID(pfmL[[i]]), TFBSTools::name(pfmL[[i]])),
            file = fh, append = TRUE)
            write.table(file = fh, t(TFBSTools::Matrix(pfmL[[i]])), row.names = FALSE, col.names = FALSE,
                        sep = "\t", quote = FALSE, append = TRUE)
    }
    close(fh)

    expect_error(motifSimilarity(numeric(0)))
    expect_error(motifSimilarity("error"))

    bpparams <- BiocParallel::SerialParam()
    if (!identical(.Platform$OS.type, "windows"))
        bpparams <- BiocParallel::MulticoreParam(2)

    suppressMessages(
        expect_message(
            expect_type(
                res1 <- motifSimilarity(x = pfmL, y = NULL, method = "R",
                                        BPPARAM = bpparams,
                                        verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res2 <- motifSimilarity(x = pfmL, y = NULL, method = "R",
                                        BPPARAM = bpparams,
                                        verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res3 <- motifSimilarity(x = pfmL, y = pfmL, method = "R",
                                        BPPARAM = bpparams,
                                        verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res4 <- motifSimilarity(x = pfmL, y = pfmL, method = "R",
                                        verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res5 <- motifSimilarity(x = tmpf, y = NULL, method = "R",
                                        verbose = TRUE),
                "double")
        )
    )
    expect_equal(res1[c(4,7,8)], c(1.0, 0.63146007727884323479,
                                   0.63146007727884323479))
    expect_equal(res1, res2)
    expect_equal(res1, res3)
    expect_equal(res1, res4)
    expect_equal(res1, res5)

    homerfile <- findHomer("compareMotifs.pl", dirs = "/Users/runner/work/monaLisa/monaLisa/homer/bin")
    if (is.na(homerfile)) {
        homerfile <- findHomer("compareMotifs.pl", dirs = "/work/gbioinfo/Appz/Homer/Homer-4.11/bin")
    }
    if (!is.na(homerfile)) { # only test at home
        suppressMessages(
            expect_message(
                expect_type(
                    res6 <- motifSimilarity(x = tmpf, y = NULL, method = "HOMER",
                                            homerfile = homerfile, verbose = TRUE),
                    "double")
            )
        )
        expect_equal(res1, res6)
    }

    # clean up
    unlink(x = tmpf)
})

test_that("motifKmerSimilarity works as expected", {
    # store motifs in file
    tmpf <- tempfile()
    fh <- file(tmpf, "wt")
    for (i in seq_along(pfmL)) {
        cat(sprintf(">%s\t%s\t5\n", TFBSTools::ID(pfmL[[i]]), TFBSTools::name(pfmL[[i]])),
            file = fh, append = TRUE)
        write.table(file = fh, t(TFBSTools::Matrix(pfmL[[i]])),
                    row.names = FALSE, col.names = FALSE,
                    sep = "\t", quote = FALSE, append = TRUE)
    }
    close(fh)

    bpparams <- BiocParallel::SerialParam()
    if (!identical(.Platform$OS.type, "windows"))
        bpparams <- BiocParallel::MulticoreParam(2)

    expect_error(motifKmerSimilarity(1L))
    expect_error(motifKmerSimilarity("error"))
    expect_error(motifKmerSimilarity(pfmL, kmerLen = "error"))
    expect_error(motifKmerSimilarity(pfmL, kmerLen = 2:3))
    expect_error(motifKmerSimilarity(pfmL, kmerLen = 2.5))
    expect_error(motifKmerSimilarity(pfmL, kmerLen = -3))

    suppressMessages(
        expect_message(
            expect_type(
                res1 <- motifKmerSimilarity(x = pfmL, kmerLen = 4,
                                            verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res2 <- motifKmerSimilarity(
                    x = tmpf, kmerLen = 4L,
                    BPPARAM = bpparams, verbose = TRUE),
                "double")
        )
    )
    suppressMessages(
        expect_message(
            expect_type(
                res3 <- motifKmerSimilarity(x = pfmL, kmers = FourMers,
                                            verbose = TRUE),
                "double")
        )
    )
    expect_identical(res1, res2)
    expect_identical(res1, res3)
    expect_identical(dim(res1), c(3L, 256L))
    expect_identical(dimnames(res1), list(name(pfmL), FourMers))
    expect_identical(which.max(res1), 2L)
    expect_identical(max(res1), prod(m2[1,-1]))

    # test with subset of 4-mers
    FourMersSub <- c("AAAA", "GGCG", "TCGT", "ACTA")
    FourMersSubRevComp <- c("TTTT", "CGCC", "ACGA", "TAGT")
    suppressMessages(
        expect_message(
            expect_type(
                res4 <- motifKmerSimilarity(x = pfmL, kmers = FourMersSub,
                                            verbose = TRUE),
                "double")
        )
    )
    expect_identical(dim(res4), c(3L, 4L))
    expect_identical(res1[, FourMersSub], res4)

    # test with reverse complements
    suppressMessages(
        expect_message(
            expect_type(
                res5 <- motifKmerSimilarity(x = pfmL, kmers = FourMersSub,
                                            includeRevComp = TRUE,
                                            verbose = TRUE),
                "double")
        )
    )
    expect_identical(dim(res5), c(3L, 4L))
    expect_identical(pmax(res1[, FourMersSub], res1[, FourMersSubRevComp]),
                     res5)

    # test with a single 4-mer
    suppressMessages(
        expect_message(
            expect_type(
                res6 <- motifKmerSimilarity(x = pfmL, kmers = "ACGT",
                                            verbose = TRUE),
                "double")
        )
    )
    expect_identical(dim(res6), c(3L, 1L))
    expect_identical(res1[, "ACGT", drop = FALSE], res6)

    # clean up
    unlink(x = tmpf)
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.width = 7,
    fig.height = 5,
    out.width = "80%",
    fig.align = "center",
    crop = NULL # suppress "The magick package is required to crop" issue
)
library(BiocStyle)

## ----eval=FALSE---------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("monaLisa")

## ----quick, eval=FALSE--------------------------------------------------------
# # load package
# library(monaLisa)
# 
# # bin regions
# # - peak_change is a numerical vector
# # - peak_change needs to be created by the user to run this code
# peak_bins <- bin(x = peak_change, binmode = "equalN", nElement = 400)
# 
# # calculate motif enrichments
# # - peak_seqs is a DNAStringSet, pwms is a PWMatrixList
# # - peak_seqs and pwms need to be created by the user to run this code
# se <- calcBinnedMotifEnrR(seqs = peak_seqs,
#                           bins = peak_bins,
#                           pwmL = pwms)

## ----loadlib, message=FALSE---------------------------------------------------
library(GenomicRanges)
library(SummarizedExperiment)
library(JASPAR2020)
library(TFBSTools)
library(BSgenome.Mmusculus.UCSC.mm10)
library(monaLisa)
library(ComplexHeatmap)
library(circlize)

## ----loadLMRs-----------------------------------------------------------------
lmrfile <- system.file("extdata", "LMRsESNPmerged.gr.rds", 
                       package = "monaLisa")
lmr <- readRDS(lmrfile)
lmr

## ----alternativeInputs, eval=FALSE--------------------------------------------
# # starting from a bed file
# #   import as `GRanges` using `rtracklayer::import`
# #   remark: if the bed file also contains scores (5th column), these will be
# #           also be imported and available in the "score" metadata column,
# #           in this example in `lmr$score`
# lmr <- rtracklayer::import(con = "file.bed", format = "bed")
# 
# # starting from sequences in a FASTA file
# #   import as `DNAStringSet` using `Biostrings::readDNAStringSet`
# #   remark: contrary to the coordinates in a `GRanges` object like `lmr` above,
# #           the sequences in `lmrseqs` can be directly used as input to
# #           monaLisa::calcBinnedMotifEnrR (no need to extract sequences from
# #           the genome, just skip that step below)
# lmrseqs <- Biostrings::readDNAStringSet(filepath = "myfile.fa", format = "fasta")

## ----deltameth----------------------------------------------------------------
hist(lmr$deltaMeth, 100, col = "gray", main = "",
     xlab = "Change of methylation (NP - ES)", ylab = "Number of LMRs")

## ----lmrsel-------------------------------------------------------------------
set.seed(1)
lmrsel <- lmr[ sample(x = length(lmr), size = 10000, replace = FALSE) ]

## ----binlmrs------------------------------------------------------------------
bins <- bin(x = lmrsel$deltaMeth, binmode = "equalN", nElement = 800, 
            minAbsX = 0.3)
table(bins)

## -----------------------------------------------------------------------------
# find the index of the level representing the zero bin 
levels(bins)
getZeroBin(bins)

## ----plotbins-----------------------------------------------------------------
plotBinDensity(lmrsel$deltaMeth, bins)

## ----getmotifs----------------------------------------------------------------
pwms <- getMatrixSet(JASPAR2020,
                     opts = list(matrixtype = "PWM",
                                 tax_group = "vertebrates"))

## ----makewidthequal-----------------------------------------------------------
summary(width(lmrsel))
lmrsel <- trim(resize(lmrsel, width = median(width(lmrsel)), fix = "center"))
summary(width(lmrsel))

## ----getseqs------------------------------------------------------------------
lmrseqs <- getSeq(BSgenome.Mmusculus.UCSC.mm10, lmrsel)

## ----bindiag------------------------------------------------------------------
plotBinDiagnostics(seqs = lmrseqs, bins = bins, aspect = "GCfrac")
plotBinDiagnostics(seqs = lmrseqs, bins = bins, aspect = "dinucfreq")

## ----runbinned, eval=FALSE----------------------------------------------------
# se <- calcBinnedMotifEnrR(seqs = lmrseqs, bins = bins, pwmL = pwms)

## ----getresults---------------------------------------------------------------
se <- readRDS(system.file("extdata", "results.binned_motif_enrichment_LMRs.rds",
                          package = "monaLisa"))

## ----summarizedexperiment-----------------------------------------------------
# summary
se
dim(se) # motifs-by-bins

# motif info
rowData(se)
head(rownames(se))

# bin info
colData(se)
head(colnames(se))

# assays: the motif enrichment results
assayNames(se)
assay(se, "log2enr")[1:5, 1:3]

## ----plottfs, fig.height=10---------------------------------------------------
# select strongly enriched motifs
sel <- apply(assay(se, "negLog10Padj"), 1, 
             function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel)
seSel <- se[sel, ]

# plot
plotMotifHeatmaps(x = seSel, which.plots = c("log2enr", "negLog10Padj"), 
                  width = 2.0, cluster = TRUE, maxEnr = 2, maxSig = 10, 
                  show_motif_GC = TRUE)

## ----selsigvariants-----------------------------------------------------------
# significantly enriched in bin 8
levels(bins)[8]
sel.bin8 <- assay(se, "negLog10Padj")[, 8] > 4.0
sum(sel.bin8, na.rm = TRUE)

# significantly enriched in any "non-zero" bin
getZeroBin(bins)
sel.nonZero <- apply(
    assay(se, "negLog10Padj")[, -getZeroBin(bins), drop = FALSE], 1,
    function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel.nonZero)

## ----wmclustering-------------------------------------------------------------
SimMatSel <- motifSimilarity(rowData(seSel)$motif.pfm)
range(SimMatSel)

## ----plottfsclustered, fig.height=10, fig.width=8-----------------------------
# create hclust object, similarity defined by 1 - Pearson correlation
hcl <- hclust(as.dist(1 - SimMatSel), method = "average")
plotMotifHeatmaps(x = seSel, which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, cluster = hcl, maxEnr = 2, maxSig = 10,
                  show_dendrogram = TRUE, show_seqlogo = TRUE,
                  width.seqlogo = 1.2)

## -----------------------------------------------------------------------------
# get PFMs from JASPAR2020 package (vertebrate subset)
pfms <- getMatrixSet(JASPAR2020,
                     opts = list(matrixtype = "PFM",
                                 tax_group = "vertebrates"))

# convert PFMs to PWMs
pwms <- toPWM(pfms)

# convert JASPAR2020 PFMs (vertebrate subset) to Homer motif file
tmp <- tempfile()
convert <- dumpJaspar(filename = tmp,
                      pkg = "JASPAR2020",
                      pseudocount = 0,
                      opts = list(tax_group = "vertebrates"))

# convert Homer motif file to PFMatrixList
pfms_ret <- homerToPFMatrixList(filename = tmp, n = 100L)

# compare the first PFM
# - notice the different magnitude of counts (controlled by `n`)
# - notice that with the default (recommended) value of `pseudocount = 1.0`,
#   there would be no zero values in pfms_ret matrices, making
#   pfms and pfms_ret even more different
as.matrix(pfms[[1]])
as.matrix(pfms_ret[[1]])

# compare position probability matrices with the original PFM 
round(sweep(x = as.matrix(pfms[[1]]), MARGIN = 2, 
            STATS = colSums(as.matrix(pfms[[1]])), FUN = "/"), 3)
round(sweep(x = as.matrix(pfms_ret[[1]]), MARGIN = 2, 
            STATS = colSums(as.matrix(pfms_ret[[1]])), FUN = "/"), 3)

## ----defineSetsBinary---------------------------------------------------------
lmr.unchanged <- lmrsel[abs(lmrsel$deltaMeth) < 0.05]
length(lmr.unchanged)

lmr.up <- lmrsel[lmrsel$deltaMeth > 0.6]
length(lmr.up)

## ----fuseSetsBinary-----------------------------------------------------------
# combine the two sets or genomic regions
lmrsel2 <- c(lmr.unchanged, lmr.up)

# extract sequences from the genome
lmrseqs2 <- getSeq(BSgenome.Mmusculus.UCSC.mm10, lmrsel2)

## ----createBins2--------------------------------------------------------------
# define binning vector
bins2 <- rep(c("unchanged", "up"), c(length(lmr.unchanged), length(lmr.up)))
bins2 <- factor(bins2)
table(bins2)

## ----enrBinary----------------------------------------------------------------
se2 <- calcBinnedMotifEnrR(seqs = lmrseqs2, bins = bins2,
                           pwmL = pwms[rownames(seSel)])
se2

## ----plotBinary, fig.height=6, fig.width=8------------------------------------
sel2 <- apply(assay(se2, "negLog10Padj"), 1, 
             function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel2)

plotMotifHeatmaps(x = se2[sel2,], which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, cluster = TRUE, maxEnr = 2, maxSig = 10,
                  show_seqlogo = TRUE)

## ----singleBinSeqs------------------------------------------------------------
lmrseqs3 <- lmrseqs[bins == levels(bins)[1]]
length(lmrseqs3)

se3 <- calcBinnedMotifEnrR(seqs = lmrseqs3,
                           pwmL = pwms[rownames(seSel)],
                           background = "genome",
                           genome = BSgenome.Mmusculus.UCSC.mm10,
                           genome.regions = NULL, # sample from full genome
                           genome.oversample = 2, 
                           BPPARAM = BiocParallel::SerialParam(RNGseed = 42),
                           verbose = TRUE)

## ----singleBinResult----------------------------------------------------------
ncol(se3)

## ----plotSingleBin, fig.height=8, fig.width=8---------------------------------
sel3 <- assay(se3, "negLog10Padj")[, 1] > 4.0
sum(sel3)

plotMotifHeatmaps(x = se3[sel3,], which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, maxEnr = 2, maxSig = 10,
                  show_seqlogo = TRUE)

# analyzed HOX motifs
grep("HOX", rowData(se3)$motif.name, value = TRUE)

# significant HOX motifs
grep("HOX", rowData(se3)$motif.name[sel3], value = TRUE)

## ----compareGenomeVsBinned, fig.width=7, fig.height=6-------------------------
cols <- rep("gray", nrow(se3))
cols[grep("HOX", rowData(se3)$motif.name)] <- "#DF536B"
cols[grep("KLF|Klf", rowData(se3)$motif.name)] <- "#61D04F"
par(mar = c(5, 5, 2, 2) + .1, mgp = c(1.75, 0.5, 0), cex = 1.25)
plot(assay(seSel, "log2enr")[,1], assay(se3, "log2enr")[,1],
     col = cols, pch = 20, asp = 1,
     xlab = "Versus other bins (log2 enr)",
     ylab = "Versus genome (log2 enr)")
legend("topleft", c("HOX family","KLF family","other"), pch = 20, bty = "n",
       col = c("#DF536B", "#61D04F", "gray"))
abline(a = 0, b = 1)
abline(h = 0, lty = 3)
abline(v = 0, lty = 3)

## ----binnedkmerenr, eval=FALSE------------------------------------------------
# sekm <- calcBinnedKmerEnr(seqs = lmrseqs, bins = bins, kmerLen = 6,
#                           includeRevComp = TRUE)

## ----binnedkmerenr-load-------------------------------------------------------
sekm <- readRDS(system.file(
    "extdata", "results.binned_6mer_enrichment_LMRs.rds",
    package = "monaLisa"
))

## -----------------------------------------------------------------------------
sekm

## -----------------------------------------------------------------------------
selkm <- apply(assay(sekm, "negLog10Padj"), 1, 
               function(x) max(abs(x), 0, na.rm = TRUE)) > 4
sum(selkm)
sekmSel <- sekm[selkm, ]

## ----fig.width=10, fig.height=10----------------------------------------------
pfmSel <- rowData(seSel)$motif.pfm
sims <- motifKmerSimilarity(x = pfmSel,
                            kmers = rownames(sekmSel),
                            includeRevComp = TRUE)
dim(sims)

maxwidth <- max(sapply(TFBSTools::Matrix(pfmSel), ncol))
seqlogoGrobs <- lapply(pfmSel, seqLogoGrob, xmax = maxwidth)
hmSeqlogo <- rowAnnotation(logo = annoSeqlogo(seqlogoGrobs, which = "row"),
                           annotation_width = unit(1.5, "inch"), 
                           show_annotation_name = FALSE
)
Heatmap(sims, 
        show_row_names = TRUE, row_names_gp = gpar(fontsize = 8),
        show_column_names = TRUE, column_names_gp = gpar(fontsize = 8),
        name = "Similarity", column_title = "Selected TFs and enriched k-mers",
        col = colorRamp2(c(0, 1), c("white", "red")), 
        right_annotation = hmSeqlogo)

## ----findMotifs, warning=FALSE------------------------------------------------
# get sequences of promoters as a DNAStringSet
# (the `subject` of `findMotifHits` could also be a single DNAString,
#  or the name of a fasta file)
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
gr <- trim(promoters(TxDb.Mmusculus.UCSC.mm10.knownGene,
                     upstream = 1000, downstream = 500)[c(1, 4, 5, 10)])
library(BSgenome.Mmusculus.UCSC.mm10)
seqs <- getSeq(BSgenome.Mmusculus.UCSC.mm10, gr)
seqs

# get motifs as a PWMatrixList
# (the `query` of `findMotifHits` could also be a single PWMatrix,
#  or the name of a motif file)
library(JASPAR2020)
library(TFBSTools)
pfms <- getMatrixByID(JASPAR2020, c("MA0885.1", "MA0099.3", "MA0033.2", 
                                    "MA0037.3", "MA0158.1"))
pwms <- toPWM(pfms)
pwms
name(pwms)

# predict hits in sequences
res <- findMotifHits(query = pwms,
                     subject = seqs,
                     min.score = 6.0,
                     method = "matchPWM",
                     BPPARAM = BiocParallel::SerialParam())
res

# create hit matrix:
# number of sites of each motif per sequence
m <- table(factor(seqnames(res), levels = names(seqs)),
           factor(res$pwmname, levels = name(pwms)))
m

## ----session------------------------------------------------------------------
sessionInfo()

# Overview: 
#   Here, we show how the ATAC-seq dataset in monaLisa was generated
#     starting from the peaks as a GRanges object, and the quantified
#     reads across these peaks, per sample. 
#
# Dataset: 
#   The ATAC-seq samples coming from mice at P0 were downloaded from Encode 
#   and consist of two conditions: liver and lung tissues. Each condition had
#   two replicates, and the corresponding bam files were downloaded.
#   The files have the following IDs: 
#     liver: 
#       - replicate 1: ENCFF146ZCO
#       - replicate 2: ENCFF109LQF
#     lung: 
#       - replicate 1: ENCFF203DOC
#       - replicate 2: ENCFF823PTD
#   
# Processed data:
#   Peak calling was then done per condition, using MACS2 (version 2.2.6). Only 
#   autosomal and distal (at least 1kb away from any TSS) peaks were kept, 
#   followed by merging the peaks from both conditions into one set of peaks. 
#   The reads were quantified across the peaks fro each sample, using QuasR
#
# In this script: 
#   Here, we demonstrate how we produced the example dataset used in monaLisa
#   starting from the distal autosomal peaks, and teh corresponding count table
#   across the samples.
#

## wdir
setwd("/tungstenfs/groups/gbioinfo/machdani/vignette_stabsel_dataSet_for_monaLisa_package/monaLisa_inst_scripts/")

## load peaks and cnt table
peaks <- readRDS("../RData/03_autosomal_distal_peaks.rds")
cnt <- readRDS("../RData/03_autosomal_distal_peaks_cnt.rds")

head(peaks)
# GRanges object with 6 ranges and 0 metadata columns:
#            seqnames          ranges strand
#               <Rle>       <IRanges>  <Rle>
#     peak_1     chr1 3119574-3120615      *
#     peak_2     chr1 3416179-3416430      *
#     peak_3     chr1 3455551-3455813      *
#     peak_4     chr1 4077136-4077336      *
#     peak_5     chr1 4077446-4077701      *
#     peak_6     chr1 4282189-4282805      *
#     -------
#     seqinfo: 19 sequences from an unspecified genome; no seqlengths

head(cnt)
#       width liver_rep1 liver_rep2 lung_rep1 lung_rep2
# peak_1  1042         60         29       237       122
# peak_2   252         26         34         8         9
# peak_3   263         26         24         7         8
# peak_4   201          0          1        22        26
# peak_5   256          3          2        28        41
# peak_6   617          6         14       134        96

all(names(peaks)==rownames(cnt))
# [1] TRUE

## calculate average log2 CPMs per condition
cpm <- sweep(x = cnt[, -1], MARGIN = 2, STATS = colSums(cnt[, -1]), FUN = "/")*1e6
log2_cpm <- log2(cpm + 1)
iByS <- split(colnames(cpm), gsub(".{5}$", "", colnames(cpm)))
avr_cpm <- do.call(cbind, lapply(iByS, function(x){rowMeans(cpm[, x, drop=FALSE])}))
log2_avr_cpm <- log2(avr_cpm + 1)
head(log2_avr_cpm)
#           liver      lung
# peak_1 2.5975953 4.1000557
# peak_2 2.2917217 0.8369844
# peak_3 2.0356378 0.7606035
# peak_4 0.1105451 1.6889044
# peak_5 0.3745536 2.0777416
# peak_6 1.2565505 3.5192534

## calculate log2-fold changes
gr <- peaks
gr$logFC_liver_vs_lung <- log2_avr_cpm[, "liver"] -  log2_avr_cpm[, "lung"]
head(gr)
# GRanges object with 6 ranges and 1 metadata column:
#        seqnames          ranges strand | logFC_liver_vs_lung
#           <Rle>       <IRanges>  <Rle> |           <numeric>
# peak_1     chr1 3119574-3120615      * |            -1.50246
# peak_2     chr1 3416179-3416430      * |             1.45474
# peak_3     chr1 3455551-3455813      * |             1.27503
# peak_4     chr1 4077136-4077336      * |            -1.57836
# peak_5     chr1 4077446-4077701      * |            -1.70319
# peak_6     chr1 4282189-4282805      * |            -2.26270
# -------
#     seqinfo: 19 sequences from an unspecified genome; no seqlengths


## randomly sample 10000 peaks (out of 125933)
n <- 10000
set.seed(123)
keep <- sample(x = 1:length(gr), size = n, replace = FALSE)
gr <- gr[keep]


## save for monaLisa
saveRDS(gr, paste0("atac_liver_vs_lung.rds"))


## Session
date()
# [1] "Thu Sep  9 14:13:57 2021"
sessionInfo()
# R version 4.0.5 (2021-03-31)
# Platform: x86_64-pc-linux-gnu (64-bit)
# Running under: CentOS Linux 7 (Core)
# 
# Matrix products: default
# BLAS/LAPACK: /tungstenfs/groups/gbioinfo/Appz/easybuild/software/OpenBLAS/0.3.7-GCC-8.3.0/lib/libopenblas_skylakex-r0.3.7.so
# 
# locale:
#     [1] LC_CTYPE=en_US.UTF-8       LC_NUMERIC=C              
# [3] LC_TIME=en_US.UTF-8        LC_COLLATE=en_US.UTF-8    
# [5] LC_MONETARY=en_US.UTF-8    LC_MESSAGES=en_US.UTF-8   
# [7] LC_PAPER=en_US.UTF-8       LC_NAME=C                 
# [9] LC_ADDRESS=C               LC_TELEPHONE=C            
# [11] LC_MEASUREMENT=en_US.UTF-8 LC_IDENTIFICATION=C       
# 
# attached base packages:
#     [1] parallel  stats4    stats     graphics  grDevices utils     datasets 
# [8] methods   base     
# 
# other attached packages:
#     [1] GenomicRanges_1.42.0 GenomeInfoDb_1.26.7  IRanges_2.24.1      
# [4] S4Vectors_0.28.1     BiocGenerics_0.36.1 
# 
# loaded via a namespace (and not attached):
#     [1] zlibbioc_1.36.0        compiler_4.0.5         tools_4.0.5           
# [4] XVector_0.30.0         GenomeInfoDbData_1.2.4 RCurl_1.98-1.3        
# [7] bitops_1.0-7          

# Coordinates for an A-polygon (internal)
letterA <- function(x.pos, y.pos, ht, wt) {
    x <- 0.1 * c(0, 4, 6, 10, 8, 6.8, 3.2, 2, 0, 3.6, 5, 6.4, 3.6)
    y <- 0.1 * c(0, 10, 10, 0, 0, 3, 3, 0, 0, 4, 7.5, 4, 4)
    x <- x.pos + wt * x
    y <- y.pos + ht * y
    id <- c(rep(1, 9), rep(2, 4))
    list(x = x, y = y, id = id, fill = c("#4DAF4A", "white"))
}

# Coordinates for an C-polygon (internal)
letterC <- function(x.pos, y.pos, ht, wt) {
    angle1 <- seq(0.3 + pi/2, pi, length = 100)
    angle2 <- seq(pi, 1.5 * pi, length = 100)
    x.l1 <- 0.5 + 0.5 * sin(angle1)
    y.l1 <- 0.5 + 0.5 * cos(angle1)
    x.l2 <- 0.5 + 0.5 * sin(angle2)
    y.l2 <- 0.5 + 0.5 * cos(angle2)
    x.l <- c(x.l1, x.l2)
    y.l <- c(y.l1, y.l2)
    x <- c(x.l, rev(x.l))
    y <- c(y.l, 1 - rev(y.l))
    x.i1 <- 0.5 + 0.35 * sin(angle1)
    y.i1 <- 0.5 + 0.35 * cos(angle1)
    x.i1 <- x.i1[y.i1 <= max(y.l1)]
    y.i1 <- y.i1[y.i1 <= max(y.l1)]
    y.i1[1] <- max(y.l1)
    x.i2 <- 0.5 + 0.35 * sin(angle2)
    y.i2 <- 0.5 + 0.35 * cos(angle2)
    x.i <- c(x.i1, x.i2)
    y.i <- c(y.i1, y.i2)
    x1 <- c(x.i, rev(x.i))
    y1 <- c(y.i, 1 - rev(y.i))
    x <- c(x, rev(x1))
    y <- c(y, rev(y1))
    x <- x.pos + wt * x
    y <- y.pos + ht * y
    id <- rep(1, length(x))
    list(x = x, y = y, id = id, fill = "#377EB8")
}

# Coordinates for an G-polygon (internal)
letterG <- function(x.pos, y.pos, ht, wt) {
    angle1 <- seq(0.3 + pi/2, pi, length = 100)
    angle2 <- seq(pi, 1.5 * pi, length = 100)
    x.l1 <- 0.5 + 0.5 * sin(angle1)
    y.l1 <- 0.5 + 0.5 * cos(angle1)
    x.l2 <- 0.5 + 0.5 * sin(angle2)
    y.l2 <- 0.5 + 0.5 * cos(angle2)
    x.l <- c(x.l1, x.l2)
    y.l <- c(y.l1, y.l2)
    x <- c(x.l, rev(x.l))
    y <- c(y.l, 1 - rev(y.l))
    x.i1 <- 0.5 + 0.35 * sin(angle1)
    y.i1 <- 0.5 + 0.35 * cos(angle1)
    x.i1 <- x.i1[y.i1 <= max(y.l1)]
    y.i1 <- y.i1[y.i1 <= max(y.l1)]
    y.i1[1] <- max(y.l1)
    x.i2 <- 0.5 + 0.35 * sin(angle2)
    y.i2 <- 0.5 + 0.35 * cos(angle2)
    x.i <- c(x.i1, x.i2)
    y.i <- c(y.i1, y.i2)
    x1 <- c(x.i, rev(x.i))
    y1 <- c(y.i, 1 - rev(y.i))
    x <- c(x, rev(x1))
    y <- c(y, rev(y1))
    h1 <- max(y.l1)
    r1 <- max(x.l1)
    h1 <- 0.4
    x.add <- c(r1, 0.5, 0.5, r1 - 0.2, r1 - 0.2, r1, r1)
    y.add <- c(h1, h1, h1 - 0.1, h1 - 0.1, 0, 0, h1)
    id <- c(rep(1, length(x)), rep(2, length(x.add)))
    x <- c(rev(x), x.add)
    y <- c(rev(y), y.add)
    x <- x.pos + wt * x
    y <- y.pos + ht * y
    list(x = x, y = y, id = id, fill = c("#FFA500", "#FFA500"))
}

# Coordinates for an T-polygon (internal)
letterT <- function(x.pos, y.pos, ht, wt) {
    x <- 0.1 * c(0, 10, 10, 6, 6, 4, 4, 0)
    y <- 0.1 * c(10, 10, 9, 9, 0, 0, 9, 9)
    x <- x.pos + wt * x
    y <- y.pos + ht * y
    id <- rep(1, 8)
    list(x = x, y = y, id = id, fill = "#E41A1C")
}

# Add coordinates for a new base polygon to the coordinaes in 'letters' 
# (internal)
addLetter <- function(letters, which = c("A", "C", "G", "T"),
                      x.pos, y.pos, ht, wt) {
    which <- match.arg(which)
    letter <- switch(which,
                     "A" = letterA(x.pos, y.pos, ht, wt),
                     "C" = letterC(x.pos, y.pos, ht, wt),
                     "G" = letterG(x.pos, y.pos, ht, wt),
                     "T" = letterT(x.pos, y.pos, ht, wt))
    letters$x <- c(letters$x, letter$x)
    letters$y <- c(letters$y, letter$y)
    lastID <- ifelse(is.null(letters$id), 0, max(letters$id))
    letters$id <- c(letters$id, lastID + letter$id)
    letters$fill <- c(letters$fill, letter$fill)
    letters
}

# Calculate the information content for each position in a PFMatrix (internal)
pfm2ic <- function(pfm) {
    ic <- vapply(X = seq_len(ncol(pfm)),
                 FUN = function(i) 2 + sum(ifelse(pfm[, i] > 0,
                                                  pfm[, i] * log2(pfm[, i]),
                                                  0)),
                 FUN.VALUE = 0)
    ic
}

#' @title Create a simple sequence logo grob.
#'
#' @description Create a simple sequence logo grob (grid-graphics object) for a
#'     transcription factor from a position frequency matrix. The logo drawing
#'     code is a simplified version from \code{\link[seqLogo]{seqLogo}} and for
#'     example can be used to embedd sequence logos within other plots.
#'
#' @param x A \code{\link[TFBSTools]{PFMatrix}} object
#' @param xmax A numeric scalar with the maximal width for the logo 
#'     (in base-pairs). A value of \code{NULL} will scale the logo to the 
#'     full width of the viewport.
#' @param ymax A numeric scalar with the maximal height for the logo (in bits)
#'     A value of \code{NULL} will scale the logo to the full height of the
#'     viewport.
#' @param xjust A character scalar specifying the horizontal adjustment of the
#'     sequence log withint the viewport; one of \code{"left"}, \code{"center"} 
#'     or \code{"right"}.
#'
#' @return A polygon grob.
#'
#' @examples
#' if (require(JASPAR2020) && require(TFBSTools) && require(gridExtra)) {
#'     pfm1 <- getMatrixByID(JASPAR2020, "MA0139")
#'     pfm2 <- getMatrixByID(JASPAR2020, "MA0531")
#'
#'     g1 <- seqLogoGrob(pfm1)
#'     g2 <- seqLogoGrob(pfm2)
#'
#'     gridExtra::grid.arrange(g1, g2)
#' }
#'
#' @seealso \code{\link[seqLogo]{seqLogo}} for the original, more flexible 
#'     version of this function.
#'
#' @importFrom grid polygonGrob gpar
#'
#' @export
seqLogoGrob <- function(x, xmax = NULL, ymax = 2.0, 
                        xjust = c("left", "center", 'right')) {
    stopifnot(is(x, "PFMatrix"))
    stopifnot(is.null(xmax) || 
                  (is.numeric(xmax) && length(xmax) == 1L && xmax > 0))
    stopifnot(is.null(ymax) || 
                  (is.numeric(ymax) && length(ymax) == 1L && ymax > 0))
    xjust <- match.arg(xjust)

    xm <- TFBSTools::Matrix(x)
    xm <- sweep(xm, MARGIN = 2, colSums(xm), "/")
    xm[is.nan(xm)] <- 0.25
    chars <- c("A", "C", "G", "T")
    letters <- list(x = NULL, y = NULL, id = NULL, fill = NULL)
    npos <- ncol(xm)
    facs <- pfm2ic(xm)
    wt <- 1
    x.pos <- 0
    for (j in seq_len(npos)) {
        hts <- 0.95 * xm[, j] * facs[j]
        letterOrder <- order(hts)
        y.pos <- 0
        for (i in seq_len(4)) {
            letter <- chars[letterOrder[i]]
            ht <- hts[letterOrder[i]]
            if (ht > 0)
                letters <- addLetter(letters, letter, x.pos, y.pos, ht, wt)
            y.pos <- y.pos + ht + 0.01
        }
        x.pos <- x.pos + wt
    }

    if (is.null(xmax)) {
        xmax <- max(letters$x) # use full width of viewport
    }
    if (is.null(ymax)) {
        ymax <- max(letters$y) # use full height of viewport
    }
    xoff <- switch(xjust,
                   left = 0,
                   center = (xmax - max(letters$x)) / 2,
                   right = (xmax - max(letters$x)))

    x <- unit((letters$x + xoff) / xmax, "npc")
    y <- unit(letters$y / ymax, "npc")
    grid::polygonGrob(x = x, y = y, id = letters$id, 
                      name = as.character(ncol(xm)),
                      gp = grid::gpar(fill = letters$fill, col = "transparent"))
}

#' @title Sequence logo annotation
#'
#' @description Create an annotation for a \code{\link[ComplexHeatmap]{Heatmap}}
#'   containing sequence logos.
#'
#' @param grobL A \code{list} of sequence logo grobs, typically created using
#'   \code{\link{seqLogoGrob}}.
#' @param which Whether it is a column annotation or a row annotation?
#' @param space The space around the image to the annotation grid borders. The
#'   value should be a unit object.
#' @param width Width of the annotation. The value should be an absolute unit.
#'   Width is not allowed to be set for column annotation.
#' @param height Height of the annotation. The value should be an absolute unit.
#'   Height is not allowed to be set for row annotation.
#' @param gp Graphic parameters for annotation grids. Can be used to control the
#'   background color in the annotation grids.
#'
#' @return An annotation function which can be used in
#'   \code{\link[ComplexHeatmap]{HeatmapAnnotation}}.
#'
#' @examples
#' if (require(JASPAR2020) && require(TFBSTools) && require(gridExtra)) {
#'     pfm1 <- getMatrixByID(JASPAR2020, "MA0139")
#'
#'     g1 <- seqLogoGrob(pfm1)
#'
#'     anno <- annoSeqlogo(list(g1))
#' }
#' 
#' @importFrom grid unit grid.rect viewport pushViewport popViewport grid.draw
#' @importFrom ComplexHeatmap AnnotationFunction subset_gp
#'
#' @export 
annoSeqlogo <- function(grobL, which = c("column", "row"),
                        space = unit(0.5, "mm"), width = NULL, height = NULL,
                        gp = gpar(fill = NA, col = NA)) {
    stopifnot(is(grobL, "list"))
    stopifnot(all(vapply(grobL, function(x) is(x, "grob"), FALSE)))

    .recycle_gp <- function(gp, n = 1) {
        for (i in seq_along(gp)) {
            x <- gp[[i]]
            gp[[i]] <- c(rep(x, floor(n / length(x))), 
                         x[seq_len(n %% length(x))])
        }
        return(gp)
    }

    n_seqlogo <- length(grobL)
    which <- match.arg(which)[1]
    space <- space[1]
    anno_size <- switch(
        which,
        column = list(height = if (is.null(height)) unit(1, "cm")  else height,
                      width  = if (is.null(width))  unit(1, "npc") else width),
        row    = list(height = if (is.null(height)) unit(1, "npc") else height,
                      width  = if (is.null(width))  unit(1, "cm")  else width)
    )
    gp <- .recycle_gp(gp, n_seqlogo)
    column_fun <- function(index) {
        n <- length(index)
        pushViewport(viewport())
        grid.rect(x = (seq_len(n) - 0.5) / n, width = 1 / n,
                  gp = subset_gp(gp, index))
        for (i in seq_len(n)) {
            height <- unit(1, "npc") - space * 2
            width  <- unit(1 / n, "npc") - space * 2
            pushViewport(viewport(x = (i - 0.5)/n, width = width, 
                                  height = height))
            grid.draw(grobL[[index[i]]])
            popViewport()
        }
        popViewport()
    }
    row_fun <- function(index) {
        n <- length(index)
        pushViewport(viewport())
        grid.rect(y = (n - seq_len(n) + 0.5) / n, height = 1 / n,
                  gp = subset_gp(gp, index))
        for (i in seq_len(n)) {
            height <- unit(1 / n, "npc") - space * 2
            width  <- unit(1, "npc") - space * 2
            pushViewport(viewport(y = (n - i + 0.5) / n,
                                  width = width, height = height))
            grid.draw(grobL[[index[i]]])
            popViewport()
        }
        popViewport()
    }
    fun <- switch(which,
                  row = row_fun,
                  column = column_fun)
    anno <- AnnotationFunction(
        fun = fun, fun_name = "annoSeqlogo", which = which,
        width = anno_size$width, height = anno_size$height,
        n = n_seqlogo, data_scale = c(0.5, 1.5),
        var_import = list(gp, space, grobL),
        subset_rule = list(gp = ComplexHeatmap::subset_gp,
                           grobL = ComplexHeatmap::subset_vector), 
        subsettable = TRUE
    )
    return(anno)
}

m <- matrix(data = c(.1,.3,.3,.3,.01,.01,.01,.97,.5,.0,.0,.5), nrow = 4,
            dimnames = list(c("A","C","G","T"), NULL))
pfm <- TFBSTools::PFMatrix(ID = "test", name = "name", profileMatrix = 100 * m)

test_that("letter adding functions work as expected", {
    rA <- letterA(x.pos = 0, y.pos = 0, ht = 1, wt = 1)
    rC <- letterC(x.pos = 0, y.pos = 0, ht = 1, wt = 1)
    rG <- letterG(x.pos = 0, y.pos = 0, ht = 1, wt = 1)
    rT <- letterT(x.pos = 0, y.pos = 0, ht = 1, wt = 1)

    expect_type(rA, "list")
    expect_type(rC, "list")
    expect_type(rG, "list")
    expect_type(rT, "list")

    expect_identical(names(rA), c("x", "y", "id", "fill"))
    expect_identical(names(rA), names(rC))
    expect_identical(names(rA), names(rG))
    expect_identical(names(rA), names(rT))

    expect_identical(unname(lengths(rA)), c( 13L,  13L,  13L, 2L))
    expect_identical(unname(lengths(rC)), c(778L, 778L, 778L, 1L))
    expect_identical(unname(lengths(rG)), c(785L, 785L, 785L, 2L))
    expect_identical(unname(lengths(rT)), c(  8L,   8L,   8L, 1L))

    expect_identical(addLetter(letters = list(), which = "A", x.pos = 0, y.pos = 0, ht = 1, wt = 1), rA)
})

test_that("information content in a  weight matrix is calculated correctly", {
    expect_identical(pfm2ic(m), TFBSTools::totalIC(TFBSTools::toICM(pfm, pseudocounts = 0)))
})

test_that("sequence logo can be drawn", {
    g0 <- seqLogoGrob(pfm, xmax = NULL, ymax = NULL)
    g1 <- seqLogoGrob(pfm, xmax = 5L)
    g2 <- seqLogoGrob(pfm, xmax = 5L, xjust = "center")
    g3 <- seqLogoGrob(pfm, xmax = 5L, xjust = "right")
    hmr <- annoSeqlogo(list(g0, g1, g2, g3), which = "row")
    hmc <- annoSeqlogo(list(g0, g1, g2, g3), which = "column")

    expect_s3_class(g0, "polygon")
    expect_s3_class(g1, "polygon")
    expect_s3_class(g2, "polygon")
    expect_s3_class(g3, "polygon")
    expect_s4_class(hmr, "AnnotationFunction")
    expect_s4_class(hmc, "AnnotationFunction")

    tf <- tempfile(fileext = ".pdf")
    pdf(file = tf)

    expect_null(ComplexHeatmap::draw(hmr, test = "Test"))
    expect_null(ComplexHeatmap::draw(hmc, test = "Test"))

    dev.off()
    unlink(tf)
})

#' monaLisa - MOtif aNAlysis with Lisa.
#'
#' \pkg{monaLisa} is a collection of tools that simplify motif enrichment
#' analyses in genomic regions of interest.
#'
#' She makes use of her father Homer (http://homer.ucsd.edu/homer/index.html)
#' and other algorithms to search for motif hits and look for enriched motifs in
#' sets of genomic regions, compared to all other regions.
#'
#' Known motifs can for example be obtained from a collection of transcription
#' factor binding site specificities, such as \pkg{JASPAR2020}.
#'
#' @author Dania Machlab, Lukas Burger, Charlotte Soneson and Michael Stadler
#'
#' @aliases monaLisa monaLisa-package
#' @name monaLisa-package
#'
#' @keywords internal
"_PACKAGE"

---
title: "monaLisa - MOtif aNAlysis with Lisa"
author: "Dania Machlab, Lukas Burger, Charlotte Soneson, Michael Stadler"
date: "`r Sys.Date()`"
bibliography: monaLisa-refs.bib
output: 
  BiocStyle::html_document: 
    toc_float: true
vignette: >
  %\VignetteIndexEntry{monaLisa - MOtif aNAlysis with Lisa}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.width = 7,
    fig.height = 5,
    out.width = "80%",
    fig.align = "center",
    crop = NULL # suppress "The magick package is required to crop" issue
)
library(BiocStyle)
```

<img src="monaLisa_logo_v1.png" style="display: block; margin-left: auto;
margin-right: auto; width: 50%; border: 0" />


# Introduction

`r Biocpkg("monaLisa")` is a collection of functions for working with 
biological sequences
and motifs that represent the binding preferences of transcription factors or
nucleic acid binding proteins.

For example, `r Biocpkg("monaLisa")` can be used to conveniently find motif 
hits in sequences (see section \@ref(findhits)), or to identify motifs that 
are likely associated with observed experimental data. Such analyses are 
supposed to provide potential answers to the question "Which transcription 
factors are the drivers of my observed changes in 
expression/methylation/accessibility?".

Several other approaches have been described that also address this problem,
among them REDUCE [@reduce], AME [@ame] and ISMARA [@ismara]. In 
`r Biocpkg("monaLisa")`, we aim to provide a flexible implementation that
integrates well with other Bioconductor resources, makes use of the sequence
composition correction developed for Homer [@homer] or stability selection
[@StabSel] and provides several alternative ways to study the relationship
between experimental measurements and sequence motifs.

You can use known motifs from collections of transcription factor binding 
specificities such as `r Biocpkg("JASPAR2020")`, also available from 
Bioconductor. Genomic regions could be for example promoters, enhancers or 
accessible regions for which experimental data is available.

Two independent approaches are implemented to identify interesting motifs:

- In the **binned motif enrichment analysis** (`calcBinnedMotifEnrR`, see section
\@ref(binned)), genomic regions are grouped into bins according to a numerical
value assigned to each region, such as the change in expression, accessibility
or methylation. Motif enrichments are then calculated for each bin, normalizing
for differences in sequence composition in a very similar way as originally done
by [Homer](http://homer.ucsd.edu/homer/index.html) [@homer]. As a special case,
the approach can also be used to do a simple two set comparison (foreground
against background sequences, see section \@ref(binary)) or to determine motif
enrichments in a single set of sequences compared to a suitably matched genomic
background set (see section \@ref(vsgenome)). The binned motif enrichment
approach was first introduced in @ginno2018 and subsequently applied in 
e.g. @barisic2019. To see more details on how `calcBinnedMotifEnrR` resembles
`Homer`, check the function help page. We recommend using this function to do
the binned motif enrichment analysis, since it corrects for sequence composition
differences similarly to `Homer`, but is implemented more efficiently.
`calcBinnedMotifEnrHomer` implements the same analysis using Homer and therefore
requires a local [installation of
Homer](http://homer.ucsd.edu/homer/introduction/install.html), and
`calcBinnedKmerEnr`(see section \@ref(binnedkmers)) implements the analysis for
k-mers instead of motifs, to study sequence enrichments without the requirement
of known motifs.

- **Randomized Lasso stability selection** (`randLassoStabSel`, see
`r Biocpkg("monaLisa", vignette="selecting_motifs_with_randLassoStabSel.html", label="the stability selection vignette")`
in `r Biocpkg("monaLisa")`) uses a robust regression approach (stability
selection, @StabSel) to predict what transcription factors can explain
experimental measurements, for example changes in chromatin accessibility
between two conditions. Also this approach allows to correct for sequence
composition. In addition, similar motifs have to "compete" with each other to be
selected.

For both approaches, functions that allow visualization of obtained results
are provided.

If you prefer to jump right in, you can continue with section \@ref(quick) that
shows a quick hypothetical example of how to run a binned motif enrichment
analysis. If you prefer to actually compute enrichments on real data, you can
find below a detailed example for a binned motif enrichment analysis (section
\@ref(binned)). The special cases of analyzing just two sets of sequences
(binary motif enrichment analysis) or a single set of sequences (comparing it
to a suitable background sampled from the genome) are illustrated in section 
\@ref(nobins).

# Installation

`r Biocpkg("monaLisa")` can be installed from Bioconductor via the 
`r CRANpkg("BiocManager")` package:

```{r, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("monaLisa")
```


# Quick example: Identify enriched motifs in bins{#quick}

The quick example below, which we do not run, illustrates how a binned motif
enrichment analysis can be performed in `r Biocpkg("monaLisa")`. We assume that
you already have a set of peaks. The sequences of the peak regions are stored in
a `Biostrings::DNAStringSet` object (`peak_seqs`), and additionally each peak is
associated with a numeric value (e.g., the change of methylation between two
conditions, stored in the `peak_change` vector), that will be used to bin the
regions before finding motifs enriched in each bin.

```{r, quick, eval=FALSE}
# load package
library(monaLisa)

# bin regions
# - peak_change is a numerical vector
# - peak_change needs to be created by the user to run this code
peak_bins <- bin(x = peak_change, binmode = "equalN", nElement = 400)

# calculate motif enrichments
# - peak_seqs is a DNAStringSet, pwms is a PWMatrixList
# - peak_seqs and pwms need to be created by the user to run this code
se <- calcBinnedMotifEnrR(seqs = peak_seqs,
                          bins = peak_bins,
                          pwmL = pwms)
```

The returned `se` is a `SummarizedExperiment` with `assays` *negLog10P*, 
*negLog10Padj*, *pearsonResid*, *expForegroundWgt*, *log2enr*, 
*sumForegroundWgtWithHits* and *sumBackgroundWgtWithHits*, each containing a 
matrix with motifs (rows) by bins (columns). The values are:  

- *negLog10P*: the raw P value ($-\log_{10} p$) of a given motif enrichment in 
  a given bin. Each P value results from an enrichment calculation comparing 
  occurrences of each motif in the bin to its occurrences in background 
  sequences, defined by the `background` argument (by default: sequences in 
  all other bins).  
- *negLog10Padj*: Same as *negLog10P* but adjusted for multiple testing using 
  the method provided in the `p.adjust.method` argument, by default: 
  Benjamini and Hochberg, 1995 (`p.adjust(..., method="fdr")`).  
- *pearsonResid*: Standardized Pearson residuals, a measure of motif enrichment
  akin to a z-score for the number of regions in the bin containing the motif. 
  The standardized Pearson residuals are given by $resid = (o - \mu)/\sigma$, 
  where $\mu$ is the expected count and $\sigma$ the standard deviation of the 
  expression in the numerator, under the null hypothesis that the probability 
  of containing a motif is independent of whether the sequence is in the 
  foreground or the background (see e.g. @agresti2007, section \@ref(runBinned)). 
- *expForegroundWgtWithHits*: The expected number of regions in the bin 
  containing a given motif. 
- *log2enr*: Motif enrichments, calculated as: 
  $log2enr = log2((o + c)/(e + c))$, where $o$ and $e$ are the observed and 
  expected numbers of regions in the bin containing a given motif, respectively, 
  and $c$ is a pseudocount defined by the `pseudocount.log2enr` argument.  
- *sumForegroundWgtWithHits* and *sumBackgroundWgtWithHits* are the sum of
  foreground and background sequences that have at least one occurrence of the
  motif, respectively. The background sequences are weighted in order to
  adjust for differences in sequence composition between foreground and
  background.

In addition, `rowData(se)` and `colData(se)` give information about the used 
motifs and bins, respectively. In `metadata(se)` you can find information 
about parameter values.

# Binned motif enrichment analysis with multiple sets of sequences (more than two): Finding TFs enriched in differentially methylated regions{#binned}

This section illustrates the use of `r Biocpkg("monaLisa")` to analyze regions
or sequences with associated numerical values (here: changes of DNA
methylation), grouped into several bins according to these values. The
special cases of just two sets of sequences (binary motif enrichment analysis)
or a single set of sequences (comparing it to a suitable background sampled from
the genome) are illustrated in section \@ref(nobins).

This example is based on experimental data from an *in vitro* differentiation
system, in which mouse embryonic stem (ES) cells are differentiated into
neuronal progenitors (NP). In an earlier study [@LMRs], we have analyzed the
genome-wide CpG methylation patterns in these cell types and identified so
called *low methylated regions* (LMRs), that have reduced methylation levels and
correspond to regions bound by transcription factors.

We also developed a tool that systematically identifies such regions from
genome-wide methylation data [@MethylSeekR]. Interestingly, a change in 
methylation of LMRs is indicative of altered transcription factor binding. We 
will therefore use these regions to identify transcription factor motifs that 
are enriched or depleted in LMRs that change their methylation between ES and 
NP cell states.


## Load packages

We start by loading the needed packages:  

```{r loadlib, message=FALSE}
library(GenomicRanges)
library(SummarizedExperiment)
library(JASPAR2020)
library(TFBSTools)
library(BSgenome.Mmusculus.UCSC.mm10)
library(monaLisa)
library(ComplexHeatmap)
library(circlize)
```


## Genomic regions or sequences of interest

`r Biocpkg("monaLisa")` provides a file with genomic coordinates (mouse mm10
assembly) of LMRs, with the respective changes of methylation. We load this
`GRanges` object into `R`.

```{r loadLMRs}
lmrfile <- system.file("extdata", "LMRsESNPmerged.gr.rds", 
                       package = "monaLisa")
lmr <- readRDS(lmrfile)
lmr
```

Alternatively, the user may also start the analysis with genomic regions
contained in a `bed` file, or directly with sequences in a `FASTA` file.
The following example code illustrates how to do this, but should not be
run if you are following the examples in this vignette.

```{r alternativeInputs, eval=FALSE}
# starting from a bed file
#   import as `GRanges` using `rtracklayer::import`
#   remark: if the bed file also contains scores (5th column), these will be
#           also be imported and available in the "score" metadata column,
#           in this example in `lmr$score`
lmr <- rtracklayer::import(con = "file.bed", format = "bed")

# starting from sequences in a FASTA file
#   import as `DNAStringSet` using `Biostrings::readDNAStringSet`
#   remark: contrary to the coordinates in a `GRanges` object like `lmr` above,
#           the sequences in `lmrseqs` can be directly used as input to
#           monaLisa::calcBinnedMotifEnrR (no need to extract sequences from
#           the genome, just skip that step below)
lmrseqs <- Biostrings::readDNAStringSet(filepath = "myfile.fa", format = "fasta")
```

We can see there are `r length(lmr)` LMRs, most of which gain methylation 
between ES and NP stages:

```{r deltameth}
hist(lmr$deltaMeth, 100, col = "gray", main = "",
     xlab = "Change of methylation (NP - ES)", ylab = "Number of LMRs")
```

In order to keep the computation time reasonable, we'll select 10,000 of the 
LMRs randomly:  

```{r lmrsel}
set.seed(1)
lmrsel <- lmr[ sample(x = length(lmr), size = 10000, replace = FALSE) ]
```


## Bin genomic regions

Now let's bin our LMRs by how much they change methylation, using the `bin`
function from `r Biocpkg("monaLisa")`. We are not interested in small changes of
methylation, say less than 0.3, so we'll use the `minAbsX` argument to create a
*no-change* bin in [-0.3, 0.3). The remaining LMRs are put into bins of 800
each:

```{r binlmrs}
bins <- bin(x = lmrsel$deltaMeth, binmode = "equalN", nElement = 800, 
            minAbsX = 0.3)
table(bins)
```

Generally speaking, we recommend a minimum of ~100 sequences per bin as fewer
sequences may lead to small motif counts and thus either small or unstable
enrichments.

We can see which bin has been set to be the zero bin using `getZeroBin`, or set
it to a different bin using `setZeroBin`:

```{r}
# find the index of the level representing the zero bin 
levels(bins)
getZeroBin(bins)
```


Because of the asymmetry of methylation changes, there is only a single bin
with LMRs that lost methylation and many that gained: 

```{r plotbins}
plotBinDensity(lmrsel$deltaMeth, bins)
```

Note that the bin breaks around the *no-change* bin are not exactly -0.3 to 0.3.
They have been adjusted to have the required 800 LMRs per bin below and above
it. `r Biocpkg("monaLisa")` will give a warning if the adjusted bin breaks are
strongly deviating from the requested `minAbsX` value, and `bin(..., model =
"breaks")` can be used in cases where exactly defined bin boundaries are
required.


## Prepare motif enrichment analysis

Next we prepare the motif enrichment analysis. We first need known motifs
representing transcription factor binding site preferences. We extract all
vertebrate motifs from the `r Biocpkg("JASPAR2020")` package as positional
weight matrices (PWMs):  

```{r getmotifs}
pwms <- getMatrixSet(JASPAR2020,
                     opts = list(matrixtype = "PWM",
                                 tax_group = "vertebrates"))
```

Furthermore, we need the sequences corresponding to our LMRs. As sequences
in one bin are compared to the sequences in other bins, we would not want
differences of sequence lengths or composition between bins that might bias
our motif enrichment results.

In general, we would recommend to use regions of similar or even equal lengths
to avoid a length bias, for example by using a fixed-size region around the
midpoint of each region of interest using `GenomicRanges::resize`. In addition, 
the resized regions may have to be constrained to the chromosome boundaries 
using trim:

```{r makewidthequal}
summary(width(lmrsel))
lmrsel <- trim(resize(lmrsel, width = median(width(lmrsel)), fix = "center"))
summary(width(lmrsel))
```

We can now directly extract the corresponding sequences from the
`r Biocpkg("BSgenome.Mmusculus.UCSC.mm10")` package (assuming you have started
the analysis with genomic regions - if you already have sequences, just skip
this step)  

```{r getseqs}
lmrseqs <- getSeq(BSgenome.Mmusculus.UCSC.mm10, lmrsel)
```

and check for differences in sequence composition between bins using
the `plotBinDiagnostics` function. "GCfrac" will plot the 
distributions of the fraction of G+C bases, and "dinucfreq" creates a 
heatmap of average di-nucleotide frequencies in each bin, relative to 
the overall average.

```{r bindiag}
plotBinDiagnostics(seqs = lmrseqs, bins = bins, aspect = "GCfrac")
plotBinDiagnostics(seqs = lmrseqs, bins = bins, aspect = "dinucfreq")
```

From these plots, we can see that LMRs with lower methylation in NP cells
compared to ES cells (bin `r levels(bins)[1]`) tend to be GC-poorer than
LMRs in other bins. A strong bias of this kind could give rise to false
positives in that bin, e.g. enrichments of AT-rich motifs.

At this point in the analysis, it is difficult to decide if this bias should be
addressed here (for example by subsampling sequences of more comparable GC
composition), or if the bias can be ignored because the built-in sequence
composition correction in `calcBinnedMotifEnrR` will be able to
account for it. Our recommendation would be to take a mental note at this point
and remember that sequences in the `r levels(bins)[1]` bin tend to be GC-poorer.
Later, we should check if AT-rich motifs are specifically enriched in that bin,
and if that is the case, we should critically assess if that result is robust
and can be reproduced in an analysis that uses more balanced sequences in all
bins, or an analysis with `background = "genome"`. The `show_motif_GC` and
`show_seqlogo` arguments of `plotMotifHeatmaps` can help to visually
identify motif sequence composition in an enrichment result (see below).

## Run motif enrichment analysis{#runBinned}

Finally, we run the binned motif enrichment analysis.

This step will take a while, and typically you would use the `BPPARAM`
argument to run it with parallelization using `n` cores as follows: 
`calcBinnedMotifEnrR(..., BPPARAM = BiocParallel::MulticoreParam(n)))`. 
For this example however, you can skip over the next step and just load the
pre-computed results as shown further below.  

```{r runbinned, eval=FALSE}
se <- calcBinnedMotifEnrR(seqs = lmrseqs, bins = bins, pwmL = pwms)
```

In case you did not run the above code, let's now read in the results:  

```{r getresults}
se <- readRDS(system.file("extdata", "results.binned_motif_enrichment_LMRs.rds",
                          package = "monaLisa"))
```

`se` is a `SummarizedExperiment` object which nicely keeps motifs, bins and
corresponding metadata together:  

```{r summarizedexperiment}
# summary
se
dim(se) # motifs-by-bins

# motif info
rowData(se)
head(rownames(se))

# bin info
colData(se)
head(colnames(se))

# assays: the motif enrichment results
assayNames(se)
assay(se, "log2enr")[1:5, 1:3]
```

We can plot the results using the `plotMotifHeatmaps` function, e.g. selecting
all transcription factor motifs that have a $-log_{10} FDR$ of at least 4.0 in
any bin (corresponding to an $FDR < 10^{-4}$). FDR values are stored in the
`negLog10Padj` assay:

```{r plottfs, fig.height=10}
# select strongly enriched motifs
sel <- apply(assay(se, "negLog10Padj"), 1, 
             function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel)
seSel <- se[sel, ]

# plot
plotMotifHeatmaps(x = seSel, which.plots = c("log2enr", "negLog10Padj"), 
                  width = 2.0, cluster = TRUE, maxEnr = 2, maxSig = 10, 
                  show_motif_GC = TRUE)
```

In order to select only motifs with significant enrichments in a specific
bin, or in any bin except the "zero" bin, you could use:  
```{r selsigvariants}
# significantly enriched in bin 8
levels(bins)[8]
sel.bin8 <- assay(se, "negLog10Padj")[, 8] > 4.0
sum(sel.bin8, na.rm = TRUE)

# significantly enriched in any "non-zero" bin
getZeroBin(bins)
sel.nonZero <- apply(
    assay(se, "negLog10Padj")[, -getZeroBin(bins), drop = FALSE], 1,
    function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel.nonZero)
```

Setting `cluster = TRUE` in `plotMotifHeatmaps` has re-ordered the rows using
hierarchical clustering of the `pearsonResid` assay. As many transcription
factor binding motifs  are similar to each other, it is also helpful to show the
enrichment heatmap clustered by motif similarity. To this end, we first
calculate all pairwise motif similarities (measured as the maximum Pearson
correlation of all possible  shifted alignments). This can be quickly calculated
for the few selected motifs using the `motifSimilarity` function. For many
motifs, this step may take a while, and it may be useful to parallelize it using
the `BPPARAM` argument (e.g. to run on `n` parallel threads using the multi-core
backend, you can use: `motifSimilarity(..., BPPARAM =
BiocParallel::MulticoreParam(n))`).

```{r wmclustering}
SimMatSel <- motifSimilarity(rowData(seSel)$motif.pfm)
range(SimMatSel)
```

The order of the TFs in the resulting matrix is consistent with the elements of
`seSel`, and the maximal similarity between any pair of motifs is 1.0. By
subtracting these similarities from 1.0, we obtain distances that we use
to perform a hierarchical clustering with the `stats::hclust` function. The 
returned object (`hcl`) is then passed to the `cluster` argument of
`plotMotifHeatmaps` to define the order of the rows in the heatmap. The plotting
of the dendrogram is controlled by the argument `show_dendrogram`, and we also
display the motifs as sequence logos using `show_seqlogo`:

```{r plottfsclustered, fig.height=10, fig.width=8}
# create hclust object, similarity defined by 1 - Pearson correlation
hcl <- hclust(as.dist(1 - SimMatSel), method = "average")
plotMotifHeatmaps(x = seSel, which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, cluster = hcl, maxEnr = 2, maxSig = 10,
                  show_dendrogram = TRUE, show_seqlogo = TRUE,
                  width.seqlogo = 1.2)
```

We have seen above that sequences in the `r levels(bins)[1]` bin (first column
from the left in the heatmap) were GC-poorer than the sequences in other bins.
While some of the enriched motifs in that bin are not GC-poor (for example RARA,
NR2F1 and similar motifs), other more weakly enriched motifs are clearly AT-rich
(for example HOX family motifs). To verify that these are not false positive
results, the motif analysis should be repeated after sequences have been
subsampled in each bin to have similar GC composition in all bins, or with
`calcBinnedMotifEnrR(..., background = "genome")`. The latter is illustrated in
section \@ref(vsgenome).

## Convert between motif text file for `Homer` and motif objects in `R` {#motifConvert}

`r Biocpkg("monaLisa")` provides two functions for performing binned motif
enrichment analysis (`calcBinnedMotifEnrR` and `calcBinnedMotifEnrHomer`).
`calcBinnedMotifEnrR` implements the binned motif enrichment analysis in `R`,
similarly to `Homer`, and does not require the user to have the `Homer` tool
pre-installed. For more information on that function and how it resembles the
`Homer` tool see the function documentation.

A simple way to represent a DNA sequence motif that assumes independence of 
positions in the motif is a matrix with four rows (for the bases A, C, G and T) 
and `n` columns for the `n` positions in the motif. The values in that matrix 
can represent the sequence preferences of a binding protein in several 
different ways:  

- **Position frequency matrices (PFM)** contain values that correspond to the
number of times (frequency) that a given base has been observed in at a given
position of the motif. It is usually obtained from a set of known, aligned
binding site sequences, and depending on the number of sequences, the values
will be lower or higher. In `R`, PFMs are often represented using
`TFBSTools::PFMatrix` (single motif) or `TFBSTools::PFMatrixList` (set of
motifs) objects. This is the rawest way to represent a sequence motif and can be
converted into any other representation.
- **Position probability matrices (PPM)** are obtained by dividing the counts 
in each column of a PFM by their sum. The values now give a probability of 
observing a given base at that position of the motif and sum up to one in each 
column. This is the representation used in motif text files for `Homer`. A PPM 
can only be converted back to a PFM by knowing or assuming how many binding 
site sequences were observed (see argument `n` in `homerToPFMatrixList`).  
- **Position weight matrices (PWM)** (also known as position specific scoring
matrices, PSSM) are obtained by comparing the base probabilities in a PPM to the
probabilities of observing each base outside of a binding site (background base
probabilities), for example by calculating log-odds scores (see
`TFBSTools::toPWM` for details). This is a useful representation for scanning
sequences for motif matches. In `R`, PWMs are often represented using
`TFBSTools::PWMatrix` (single motif) or `TFBSTools::PWMatrixList` (set of
motifs).

`calcBinnedMotifEnrR` takes PWMs as a `TFBSTools::PWMatrixList` object to scan
for motif hits. `calcBinnedMotifEnrHomer` on the other hand takes a motif text
file with PPMs, and requires the user to have `Homer` installed to use it for
the binned motif enrichment analysis. Here, we show how one can get motif PFMs
from `r Biocpkg("JASPAR2020")` and convert them to a `Homer`-compatible text
file with PPMs (`dumpJaspar`) and vice versa (`homerToPFMatrixList`), and how
to convert a `TFBSTools::PFMatrixList` to a `TFBSTools::PWMatrixList` for use
with `calcBinnedMotifEnrR` or `findMotifHits`:

```{r}
# get PFMs from JASPAR2020 package (vertebrate subset)
pfms <- getMatrixSet(JASPAR2020,
                     opts = list(matrixtype = "PFM",
                                 tax_group = "vertebrates"))

# convert PFMs to PWMs
pwms <- toPWM(pfms)

# convert JASPAR2020 PFMs (vertebrate subset) to Homer motif file
tmp <- tempfile()
convert <- dumpJaspar(filename = tmp,
                      pkg = "JASPAR2020",
                      pseudocount = 0,
                      opts = list(tax_group = "vertebrates"))

# convert Homer motif file to PFMatrixList
pfms_ret <- homerToPFMatrixList(filename = tmp, n = 100L)

# compare the first PFM
# - notice the different magnitude of counts (controlled by `n`)
# - notice that with the default (recommended) value of `pseudocount = 1.0`,
#   there would be no zero values in pfms_ret matrices, making
#   pfms and pfms_ret even more different
as.matrix(pfms[[1]])
as.matrix(pfms_ret[[1]])

# compare position probability matrices with the original PFM 
round(sweep(x = as.matrix(pfms[[1]]), MARGIN = 2, 
            STATS = colSums(as.matrix(pfms[[1]])), FUN = "/"), 3)
round(sweep(x = as.matrix(pfms_ret[[1]]), MARGIN = 2, 
            STATS = colSums(as.matrix(pfms_ret[[1]])), FUN = "/"), 3)
```

# Motif enrichment analysis with only one or two sets of sequences{#nobins}

In some cases, we are interested in identifying enriched motifs between just two
sets of sequences (binary motif enrichment), for example between ATAC peaks with
increased and decreased accessibility. Numerical values that could be used for
grouping the regions in multiple bins may not be available. Or we may be
interested in analyzing just a single set of sequences (for example a set of
ChIP-seq peaks), relative to some neutral background. In this section, we show
how such binary or single-set motif enrichment analyses can be performed using
`r Biocpkg("monaLisa")`.

## Binary motif enrichment analysis: comparing two sets of sequences{#binary}

The binary motif enrichment analysis is a simple special case of the general
binned motif analysis described in section \@ref(binned), where the two sets
to be compared are defining the two bins.

Let's re-use the DNA methylation data from section \@ref(binned) and assume that
we just want to compare the sequences that don't show large changes in their
methylation levels (`lmr.unchanged`, changes smaller than 5%) to those that
gain more than 60% methylation (`lmr.up`):

```{r defineSetsBinary}
lmr.unchanged <- lmrsel[abs(lmrsel$deltaMeth) < 0.05]
length(lmr.unchanged)

lmr.up <- lmrsel[lmrsel$deltaMeth > 0.6]
length(lmr.up)
```

As before, we need a single sequence object (`lmrseqs2`, which is a
`DNAStringSet`) that we obtain by combining these two groups into a single
`GRanges` object (`lmrsel2`) and extract the corresponding sequences from the
genome (`lmrseqs2`). If you already have two sequence objects, they can be just
concatenated using `lmrseqs2 <- c(seqs.group1, seqs.group2)`.
```{r fuseSetsBinary}
# combine the two sets or genomic regions
lmrsel2 <- c(lmr.unchanged, lmr.up)

# extract sequences from the genome
lmrseqs2 <- getSeq(BSgenome.Mmusculus.UCSC.mm10, lmrsel2)
```

Finally, we manually create a binning factor (`bins2`) that defines the group
membership for each element in `lmrseqs2`:
```{r createBins2}
# define binning vector
bins2 <- rep(c("unchanged", "up"), c(length(lmr.unchanged), length(lmr.up)))
bins2 <- factor(bins2)
table(bins2)
```

Now we can run the binned motif enrichment analysis. To keep the calculation
time short, we will just run it on the motifs that we had selected above in
`seSel`:
```{r enrBinary}
se2 <- calcBinnedMotifEnrR(seqs = lmrseqs2, bins = bins2,
                           pwmL = pwms[rownames(seSel)])
se2
```

We visualize the results for motifs that are enriched in one of the
two groups with an adjusted p value of less than $10^{-4}$ (the order of the
columns in the heatmap is defined by the order of the factor levels in `bins2`,
given by `levels(bins2)` and can also be obtained from `colnames(se2)`; here it
is `r levels(bins2)`):
```{r plotBinary, fig.height=6, fig.width=8}
sel2 <- apply(assay(se2, "negLog10Padj"), 1, 
             function(x) max(abs(x), 0, na.rm = TRUE)) > 4.0
sum(sel2)

plotMotifHeatmaps(x = se2[sel2,], which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, cluster = TRUE, maxEnr = 2, maxSig = 10,
                  show_seqlogo = TRUE)
```

## Single set motif enrichment analysis: comparing a set of sequences to a suitable background{#vsgenome}

Motif enrichments can also be obtained from a single set of genomic regions or
sequences (foreground set), by comparing it to a suitable background set. A
suitable background set could be for example sequences with a similar sequence
composition that are randomly selected from the same genome, or sequences
obtained by randomization of the foreground sequences by shuffling or
permutation.

A noteworthy package in this context is `r Biocpkg("nullranges")` that focuses
on the selection of such background ranges (representing the null hypothesis),
for example controlling for confounding covariates like GC composition. After
a suitable background set has been identified using `r Biocpkg("nullranges")`,
a binary motif enrichment analysis as described in section \@ref(binary) can
be performed. Manually defining the background set is recommended to control for
covariates other than GC composition and to get access to the selected
background sequences, for example to verify if they are indeed similar to the
foreground sequences for those covariates.

A quick alternative with less flexibility in the background set definition is
available directly in `r Biocpkg("monaLisa")`, by using
`calcBinnedMotifEnrR(..., background = "genome")`. This will select the
background set by randomly sampling sequences from the genome (given by the
`genome` argument, optionally restricted to the intervals defined in the
`genome.regions` argument). For each foreground sequence, `genome.oversample`
background sequences of the same size (on average) are sampled. From these, one
per foreground sequence is selected trying to best match its G+C composition.

We apply this simple approach here to check if the motif enrichments identified
in section \@ref(binned) could be in part false positives due to the GC-poor
first bin (`r levels(bins)[1]`, see above).

Let's first obtain the sequences from that bin (`lmrseqs3`), and then run
`calcBinnedMotifEnrR` comparing to a genome background. In order to
make the sampling reproducible, we are seeding the random number generator
inside the `BPPARAM` object. Also, to speed up the calculation, we will only
include the motifs we had selected above in `seSel`:
```{r singleBinSeqs}
lmrseqs3 <- lmrseqs[bins == levels(bins)[1]]
length(lmrseqs3)

se3 <- calcBinnedMotifEnrR(seqs = lmrseqs3,
                           pwmL = pwms[rownames(seSel)],
                           background = "genome",
                           genome = BSgenome.Mmusculus.UCSC.mm10,
                           genome.regions = NULL, # sample from full genome
                           genome.oversample = 2, 
                           BPPARAM = BiocParallel::SerialParam(RNGseed = 42),
                           verbose = TRUE)
```

Note that we did not have to provide a `bins` argument, and that the result will
only have a single column, corresponding to the single set of sequences that we
analyzed:
```{r singleBinResult}
ncol(se3)
```

When we visualize motifs that are enriched with an adjusted p value of less than
$10^{-4}$, we still find AT-rich motifs significantly enriched, including the
HOX family motifs that were weakly enriched in `seSel` but for which it was
unclear if their enrichment was driven by the AT-rich (GC-poor) sequences in
that specific bin. The fact that this motif family is still robustly identified
when using a GC-matched genomic background supports that it may be a real
biological signal.
```{r plotSingleBin, fig.height=8, fig.width=8}
sel3 <- assay(se3, "negLog10Padj")[, 1] > 4.0
sum(sel3)

plotMotifHeatmaps(x = se3[sel3,], which.plots = c("log2enr", "negLog10Padj"), 
                  width = 1.8, maxEnr = 2, maxSig = 10,
                  show_seqlogo = TRUE)

# analyzed HOX motifs
grep("HOX", rowData(se3)$motif.name, value = TRUE)

# significant HOX motifs
grep("HOX", rowData(se3)$motif.name[sel3], value = TRUE)
```

A comparison of log2 motif enrichments between the `background = "otherBins"`
and `background = "genome"` analyses also supports this conclusion: The HOX
family motifs (shown in red) are similarly enriched in both analyses, while the
depletion of GC-rich KLF family motifs (shown in green) is less pronounced in
`background = "genome"` and thus more sensitive to the used background. The
depletion of KLF family motifs may thus be an example of an incorrect result,
although note that the depletion was not significant in either of the two
analyses:
```{r compareGenomeVsBinned, fig.width=7, fig.height=6}
cols <- rep("gray", nrow(se3))
cols[grep("HOX", rowData(se3)$motif.name)] <- "#DF536B"
cols[grep("KLF|Klf", rowData(se3)$motif.name)] <- "#61D04F"
par(mar = c(5, 5, 2, 2) + .1, mgp = c(1.75, 0.5, 0), cex = 1.25)
plot(assay(seSel, "log2enr")[,1], assay(se3, "log2enr")[,1],
     col = cols, pch = 20, asp = 1,
     xlab = "Versus other bins (log2 enr)",
     ylab = "Versus genome (log2 enr)")
legend("topleft", c("HOX family","KLF family","other"), pch = 20, bty = "n",
       col = c("#DF536B", "#61D04F", "gray"))
abline(a = 0, b = 1)
abline(h = 0, lty = 3)
abline(v = 0, lty = 3)
```


# Binned k-mer enrichment analysis{#binnedkmers}

In some situations it may be beneficial to perform the enrichment analysis in 
a more 'unbiased' way, using k-mers rather than annotated motifs. Here, we 
will illustrate the process using the same LMR data set as used for the 
motif enrichment analysis above in section \@ref(binned). Similarly to the motif
enrichment, this step takes a while to perform, and we can also skip over the
next step and load the processed object directly.

```{r binnedkmerenr, eval=FALSE}
sekm <- calcBinnedKmerEnr(seqs = lmrseqs, bins = bins, kmerLen = 6, 
                          includeRevComp = TRUE)
```

```{r binnedkmerenr-load}
sekm <- readRDS(system.file(
    "extdata", "results.binned_6mer_enrichment_LMRs.rds",
    package = "monaLisa"
))
```

Just as for the motif enrichment analysis, the return value is a 
`SummarizedExperiment` object, with the same set of assays and annotations. 

```{r}
sekm
```

As for the motif enrichment, we can extract any k-mer that is enriched in any 
of the bins.

```{r}
selkm <- apply(assay(sekm, "negLog10Padj"), 1, 
               function(x) max(abs(x), 0, na.rm = TRUE)) > 4
sum(selkm)
sekmSel <- sekm[selkm, ]
```

Next, let's compare the enriched k-mers to the motifs that were found earlier.
This can be done using the `motifKmerSimilarity` function. By showing the
similarity between the enriched k-mers and motifs, we can see whether, e.g.,
strongly enriched k-mers do not seem to correspond to an annotated motif.

```{r, fig.width=10, fig.height=10}
pfmSel <- rowData(seSel)$motif.pfm
sims <- motifKmerSimilarity(x = pfmSel,
                            kmers = rownames(sekmSel),
                            includeRevComp = TRUE)
dim(sims)

maxwidth <- max(sapply(TFBSTools::Matrix(pfmSel), ncol))
seqlogoGrobs <- lapply(pfmSel, seqLogoGrob, xmax = maxwidth)
hmSeqlogo <- rowAnnotation(logo = annoSeqlogo(seqlogoGrobs, which = "row"),
                           annotation_width = unit(1.5, "inch"), 
                           show_annotation_name = FALSE
)
Heatmap(sims, 
        show_row_names = TRUE, row_names_gp = gpar(fontsize = 8),
        show_column_names = TRUE, column_names_gp = gpar(fontsize = 8),
        name = "Similarity", column_title = "Selected TFs and enriched k-mers",
        col = colorRamp2(c(0, 1), c("white", "red")), 
        right_annotation = hmSeqlogo)
```



# Use `r Biocpkg("monaLisa")` to annotate genomic regions with predicted motifs{#findhits}

As mentioned, `r Biocpkg("monaLisa")` can also be used to scan sequences for
motifs. For a quick description of motif representations see 
section \@ref(motifConvert). Here is an example (just on a few 
sequences/motifs for illustration):

```{r findMotifs, warning=FALSE}
# get sequences of promoters as a DNAStringSet
# (the `subject` of `findMotifHits` could also be a single DNAString,
#  or the name of a fasta file)
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
gr <- trim(promoters(TxDb.Mmusculus.UCSC.mm10.knownGene,
                     upstream = 1000, downstream = 500)[c(1, 4, 5, 10)])
library(BSgenome.Mmusculus.UCSC.mm10)
seqs <- getSeq(BSgenome.Mmusculus.UCSC.mm10, gr)
seqs

# get motifs as a PWMatrixList
# (the `query` of `findMotifHits` could also be a single PWMatrix,
#  or the name of a motif file)
library(JASPAR2020)
library(TFBSTools)
pfms <- getMatrixByID(JASPAR2020, c("MA0885.1", "MA0099.3", "MA0033.2", 
                                    "MA0037.3", "MA0158.1"))
pwms <- toPWM(pfms)
pwms
name(pwms)

# predict hits in sequences
res <- findMotifHits(query = pwms,
                     subject = seqs,
                     min.score = 6.0,
                     method = "matchPWM",
                     BPPARAM = BiocParallel::SerialParam())
res

# create hit matrix:
# number of sites of each motif per sequence
m <- table(factor(seqnames(res), levels = names(seqs)),
           factor(res$pwmname, levels = name(pwms)))
m
```

The transformation of sequence and PWM names to factors with defined levels
in the creation of the hit matrix above is not strictly needed, but it ensures
that even sequences or motifs without any hits are reported in the matrix,
and that the order of sequences (rows) and motifs (columns) is identical to
the order in `seqs` and `pwms`.



# Session info and logo
The monaLisa logo uses a drawing that was obtained from 
http://vectorish.com/lisa-simpson.html under the Creative Commons attribution 
- non-commercial 3.0 license: https://creativecommons.org/licenses/by-nc/3.0/.

This vignette was built using:  

```{r, session}
sessionInfo()
```

# References

---
title: "Regression Based Approach for Motif Selection"
author: "Dania Machlab, Lukas Burger, Charlotte Soneson, Michael Stadler"
date: "`r Sys.Date()`"
bibliography: monaLisa-refs.bib
output: 
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{selecting_motifs_with_randLassoStabSel}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.width = 7,
    fig.height = 5,
    out.width = "80%",
    fig.align = "center",
    crop = NULL # suppress "The magick package is required to crop" issue
)
library(BiocStyle)
```

<img src="monaLisa_logo_v1.png" style="display: block; margin-left: auto;
margin-right: auto; width: 50%; border: 0" />

# Introduction

Identifying important transcription factor (TF) motifs, as shown in 
`r Biocpkg("monaLisa", vignette="monaLisa.html", label="the main vignette")`, 
could also be done using a regression-based approach, where motifs have to
compete against each other for selection. In this framework, the response vector
can be the observed experimental measure of interest, e.g. log-fold changes of
accessibility for a set of regions, and the predictors consist of the TF motif
hits across those regions. In `r Biocpkg("monaLisa")`, we implement the
randomized lasso stability selection proposed by @StabSel with the improved
error bounds introduced by @compStabs. We have modified the
`stabs::glmnet.lasso` function used by `stabs::stabsel` from the 
`r CRANpkg("stabs")` package to implement the randomized lasso.

Lasso stability selection performs the lasso regression multiple times on
subsamples of the data, and returns a selection probability for each predictor
(number of times selected divided by number of regressions done). With the
randomized lasso, a weakness parameter is additionally used  to vary the lasso
penalty term $\lambda$ to a randomly chosen value between [$\lambda$,
$\lambda$/weakness] for each predictor. This type of regularization has
advantages in cases where the number of predictors exceeds the number of
observations, in selecting variables consistently, demonstrating better error
control and not depending strongly on the penalization parameter [@StabSel].

With this approach, TF motifs compete against each other to explain the 
response vector, and we can also include additional predictors like GC content 
to compete against the TF motifs for selection. This is especially useful if 
the response is biased by sequence composition, for example if regions with 
higher GC content tend to have higher response values.

It is worth noting that, as with any regression analysis, the interpretability 
of the results depends strongly on the quality of the predictors. Hence, 
increasing the size of the motif database is not, in itself, a guarantee for 
more interpretable results, since the added motifs may be unrelated to the 
signal of interest. In addition, as discussed in section \@ref(collinearity), a 
high level of redundancy, resulting in strong correlations among the motifs, 
may result in more ambiguous selection probabilities in the regression 
approach. In fact, also for the binned approach, although the motifs are 
evaluated independently for association with the outcome, a high degree of 
redundancy can lead to large collections of very similar motifs showing
significant enrichments, complicating interpretability of the results. 


# Motif selection with Randomized Lasso Stability Selection{#stabsel}

In the example below, we select for TF motifs explaining log-fold changes in 
chromatin accessibility (ATAC-seq) across the enhancers between mouse liver and 
lung tissue at P0, but this can be applied to other data types as well 
(ChIP-seq, RNA-seq, methylation etc.). Positive log2-fold changes indicate 
more accessibility in the liver tissue, whereas negative values indicate 
more accessibility in the lung tissue.

## Load packages

We start by loading the needed packages: 

```{r libs, message=FALSE}
library(monaLisa)
library(JASPAR2020)
library(TFBSTools)
library(BSgenome.Mmusculus.UCSC.mm10)
library(Biostrings)
library(SummarizedExperiment)
library(ComplexHeatmap)
library(circlize)
library(ggrepel)
```

## Load dataset

In this example dataset from ENCODE [@encode2012], and available in 
`r Biocpkg("monaLisa")`, we have quantified ATAC-seq reads on enhancers in mouse P0
lung and liver tissues. The log2-fold change (our response vector in this
example) is for liver vs lung chromatin accessibility. We are using a set of
10,000 randomly sampled enhancers to illustrate how randomized lasso stability
selection can be used to select TF motifs.

```{r loadData}
# load GRanges object with logFC and peaks
gr_path <- system.file("extdata", "atac_liver_vs_lung.rds", 
                       package = "monaLisa")
gr <- readRDS(gr_path)
```


## Get TFBS per motif and peak

We will now construct the transcription factor binding site (TFBS) matrix for
known motifs (from a database like `r Biocpkg("JASPAR2020")`) in the given peak
regions. We use the `findMotifHits` function to scan for TF motif hits. This
matrix will be the predictor matrix in our regression. This step may take a
while, and it may be useful to parallelize it using the `BPPARAM` argument (e.g.
to run on `n` parallel threads using the multi-core backend, you can use:
`findMotifHits(..., BPPARAM = BiocParallel::MulticoreParam(n))`).

As mentioned, this framework offers the flexibility to add additional 
predictors to compete against the TF motifs for selection. Here, we add the 
fraction of G+C and CpG observed/expected ratio as predictors, to ensure that 
selected TF motifs are not just detecting a simple trend in GC or CpG 
composition.

```{r predictorMatrix, warning=FALSE}
# get PFMs (vertebrate TFs from Jaspar)
pfms <- getMatrixSet(JASPAR2020, list(matrixtype = "PFM", 
                                      tax_group = "vertebrates"))

# randomly sample 300 PFMs for illustration purposes (for quick runtime)
set.seed(4563)
pfms <- pfms[sample(length(pfms), size = 300)]

# convert PFMs to PWMs
pwms <- toPWM(pfms)

# get TFBS on given GRanges (peaks)
# suppress warnings generated by matchPWM due to the presence of Ns 
# in the sequences
peakSeq <- getSeq(BSgenome.Mmusculus.UCSC.mm10, gr)
suppressWarnings({
  hits <- findMotifHits(query = pwms, subject = peakSeq, min.score = 10.0,
                        BPPARAM = BiocParallel::SerialParam())
})

# get TFBS matrix
TFBSmatrix <- unclass(table(factor(seqnames(hits), levels = seqlevels(hits)),
                            factor(hits$pwmname, levels = name(pwms))))
TFBSmatrix[1:6, 1:6]

# remove TF motifs with 0 binding sites in all regions
zero_TF <- colSums(TFBSmatrix) == 0
sum(zero_TF)
TFBSmatrix <- TFBSmatrix[, !zero_TF]

# calculate G+C and CpG obs/expected
fMono <- oligonucleotideFrequency(peakSeq, width = 1L, as.prob = TRUE)
fDi <- oligonucleotideFrequency(peakSeq, width = 2L, as.prob = TRUE)
fracGC <- fMono[, "G"] + fMono[, "C"]
oeCpG <- (fDi[, "CG"] + 0.01) / (fMono[, "G"] * fMono[, "C"] + 0.01)

# add GC and oeCpG to predictor matrix
TFBSmatrix <- cbind(fracGC, oeCpG, TFBSmatrix)
TFBSmatrix[1:6, 1:6]
```

### A note on collinearity{#collinearity}
At this point it is useful for the user to get an overall feeling of the
collinearity structure in the TFBS matrix. Motifs that share a lot of similar
binding sites across the peaks will be highly correlated. High collinearity
between predictors is a well known problem in linear regression. It particularly
manifests itself in the lasso regression for example, where if variables are
equally highly correlated with the response, not all are co-selected as
predictors (if they are signal variables). Instead, one is arbitrarily chosen
while the others’ coefficients are set to zero. The rationale is that the
non-selected correlated predictors do not provide much additional information to
explain the response. It is good to be aware of these properties of regression,
and to place more weight on the meaning of the selected motif itself, rather
than the specific TF name when interpreting the results.

If many cases of high correlations exist and this is a concern, one may consider
selecting a representative set of predictors to use. This may for example be
achieved by clustering the weight matrices beforehand and using only one
representative motif per cluster for running the regression, using tools such as
for example RSAT [@RSAT]. RSAT-derived clusters of Jaspar weight matrices can be
found at https://jaspar.genereg.net/matrix-clusters/vertebrates/.

If the user is interested in working with all correlated motifs, the binned
approach is preferable as the motifs are independently tested for significance
(see the `r Biocpkg("monaLisa", vignette="monaLisa.html", label="binned
enrichment vignette")`). In the regression-based approach on the other hand, we
can more clearly understand the relative contributions of TF motifs to the
response in the context of each other.


## Identify important TFs

We can now run randomized lasso stability selection to identify TFs that are
likely to explain the log-fold changes in accessibility. The exact choice of
parameter values for this approach will depend largely on how stringent the user
wishes to be and how much signal there is in the data. For example, for more
stringent selections, one may decrease the value of the `weakness` parameter
which will make it harder for a variable to get selected. The user is in control
of false discoveries with the `PFER` parameter, which indicates the number of
falsely selected variables. As for the selection probability cutoff, @StabSel argue that
values in the range of [0.6, 0.9] should give similar results. See the
`randLassoStabSel` function for more details and default parameter values as
well as the `stabs::stabsel` function for the default assumptions on the
stability selection implementation by @compStabs.

```{r stabSelTFs}
## randLassoStabSel() is stochastic, so if we run with parallelization
##   (`mc.cores` argument), we must select a random number generator that can
##   provide multiple streams of random numbers used in the `parallel` package
##   and set its seed for reproducible results
# RNGkind("L'Ecuyer-CMRG")
# set.seed(123)
# se <- randLassoStabSel(x = TFBSmatrix, y = gr$logFC_liver_vs_lung, 
#                        cutoff = 0.8, mc.preschedule = TRUE, 
#                        mc.set.seed = TRUE, mc.cores = 2L)

# if not running in parallel mode, it is enough to use set.seed() before 
#   the call to ensure reproducibility (`mc.sores = 1`)
set.seed(123)
se <- randLassoStabSel(x = TFBSmatrix, y = gr$logFC_liver_vs_lung, 
                       cutoff = 0.8)
se

# selected TFs
colnames(se)[se$selected]
```


The stability paths visualize how predictors get selected over decreasing 
regularization stringency (from left to right): 

```{r plotStabilityPaths, fig.width=8, fig.height=4}
plotStabilityPaths(se)
```

Each line corresponds to a predictor, and we can see the selection 
probabilities as a function of the regularization steps, corresponding to 
decreasing values for the lambda regularization parameter in lasso. The 
predictor (TF motif) selection happens at the last step, given the specified 
minimum probability.

We can additionally show the labels of the predictors which were selected. Note 
that if predictors have the same y-value at the last regularization step, they
are shown in a random order. To reproduce the plot, you will need to set a seed.

```{r plotStabilityPathsWithSelLabels, fig.width=10, fig.height=4}
set.seed(123)
plotStabilityPaths(se, labelPaths = TRUE)
```


Alternatively, we can visualize specific predictors, regardless of whether or 
not they were selected.

```{r plotStabilityPathsWithLabels, fig.width=8, fig.height=4}
set.seed(123)
plotStabilityPaths(se, labelPaths = TRUE, labelNudgeX = 3,
                   labels = c("ISL2", "NR2C2", "NR2F1", "GATA4"))
```

We can also visualize the selection probabilities of the selected TF motifs,
optionally multiplied by the sign of the correlation to the response vector, to
know how the TF relates to the change of accessibility (`directional`
parameter). In our example, positive correlations to the response vector
indicate a correlation with enhancers more accessible in the liver, whereas
negative ones indicate a correlation with enhancers more accessible in the lung.
Note that although one can vary the `selProbMinPlot` argument which sets the
selection probability cutoff, it is best to re-run randomized lasso stability
selection with the new cutoff, as this influences other parameter choices the
model uses internally. See @StabSel for more details.

```{r plotSelProbs, fig.width=10, fig.height=5}
plotSelectionProb(se, directional = TRUE, ylimext = 0.5)
```

Next, we visualize the correlation structure of the selected TF motifs within
the TFBS matrix. While the collinearity of predictors is a general issue in
regression-based approaches, randomized lasso stability selection normally does
better at co-selecting intermediately correlated predictors. In practice, we see
it select predictors with correlations as high as 0.9. However, it is good to
keep in mind that this can be an issue, and that predictors that are highly
correlated with each other might not end up being co-selected (see section
\@ref(collinearity)).

```{r TFBScor_selected, fig.width=10, fig.height=7}
# subset the selected TFs
sel <- colnames(se)[se$selected]
se_sub <- se[, sel]

# exclude oeCpG and fracGC
excl <- colnames(se_sub) %in% c("oeCpG", "fracGC")
se_sub <- se_sub[, !excl]

# correlation matrix 
TFBSmatrixCorSel <- cor(TFBSmatrix[, colnames(se_sub)], method = "pearson")

# heatmap
pfmsSel <- pfms[match(colnames(TFBSmatrixCorSel), name(pfms))]
maxwidth <- max(sapply(TFBSTools::Matrix(pfmsSel), ncol))
seqlogoGrobs <- lapply(pfmsSel, seqLogoGrob, xmax = maxwidth)

hmSeqlogo <- rowAnnotation(logo = annoSeqlogo(seqlogoGrobs, which = "row"),
                           annotation_width = unit(2, "inch"), 
                           show_annotation_name = FALSE
)

colAnn <- HeatmapAnnotation(AUC = se_sub$selAUC, selProb = se_sub$selProb,
                            show_legend = TRUE, 
                            show_annotation_name = TRUE,
                            col = list(
                              AUC = colorRamp2(c(0, 1), 
                                               c("white", "brown")),
                              selProb = colorRamp2(c(0, 1), 
                                                   c("white", "steelblue")))
)

Heatmap(TFBSmatrixCorSel, 
        show_row_names = TRUE, 
        show_column_names = TRUE, 
        name = "Pear. Cor.", column_title = "Selected TFs",
        col = colorRamp2(c(-1, 0, 1), c("blue", "white", "red")), 
        right_annotation = hmSeqlogo,
        top_annotation = colAnn)
```

\  

We can examine the peaks that have hits for a selected TF motif of interest, 
ordered by absolute accessibility changes.

```{r topPeaks}
TF <- sel[2]
TF

i <- which(assay(se, "x")[, TF] > 0) # peaks that contain TF hits...
nm <- names(sort(abs(gr$logFC_liver_vs_lung[i]), 
                 decreasing = TRUE)) # ... order by |logFC|

gr[nm]
```


# Session info and logo
The monaLisa logo uses a drawing that was obtained from 
http://vectorish.com/lisa-simpson.html
under the Creative Commons attribution - non-commercial 3.0 license: 
https://creativecommons.org/licenses/by-nc/3.0/.

This vignette was built using:  
```{r, session}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pfm_comparison.R
\name{motifSimilarity}
\alias{motifSimilarity}
\title{Calculate similarities between pairs of motifs.}
\usage{
motifSimilarity(
  x,
  y = NULL,
  method = c("R", "HOMER"),
  homerfile = findHomer("compareMotifs.pl"),
  homerOutfile = NULL,
  BPPARAM = SerialParam(),
  verbose = FALSE
)
}
\arguments{
\item{x}{Either a \code{\link[TFBSTools]{PFMatrixList}}, or a character
scalar with a file containing motifs in HOMER format (used directly
\code{method = "HOMER"}, loaded into a
\code{\link[TFBSTools]{PFMatrixList}} by \code{\link{homerToPFMatrixList}}
for \code{method = "R"}).}

\item{y}{Either a \code{\link[TFBSTools]{PFMatrixList}} or \code{NULL}
(default). If \code{y = NULL}, then similarities will be calucalted for all
pairs of motifs within \code{x}. Otherwise, \code{method} must be
\code{"R"} and similarities will be calculated between any motif from
\code{x} to any motif from \code{y}.}

\item{method}{A character scalar specifying the method for similarity
calculations. Either \code{"R"} (pure R implementation) or \code{"HOMER"}
(will call the \code{compareMotifs.pl} script from HOMER). Results are
identical (apart from rounding errors), and the R implementation is
usually faster and can be parallelized (\code{BPPARAM} argument).}

\item{homerfile}{Path to the HOMER script \code{compareMotifs.pl} (only used
for \code{method = "HOMER"}.}

\item{homerOutfile}{A character scalar giving the file to save the similarity
scores (only for \code{metho = "HOMER"}). If \code{NULL}, scores will be
stored into a temporary file.}

\item{BPPARAM}{An optional \code{\link[BiocParallel]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation
(only used for \code{method = "R"}).}

\item{verbose}{A logical scalar. If \code{TRUE}, report on progress.}
}
\value{
A matrix of Pearson's correlation coefficients for each pair of
  motifs.
}
\description{
For each pair of motifs, calculate the similarity defined as the
  maximal Pearson's correlation coefficient between base frequencies over all
  possible shifts (relative positions of the two matrices with at least one
  overlapping position). If necessary matrices are padded on the sides with
  background base frequencies (assuming all bases to have a frequency of
  0.25) to enable comparison of all positions in both matrices.
}
\examples{
m <- rbind(A = c(12,  0,  0),
           C = c( 3,  2,  0),
           G = c( 0, 14,  0),
           T = c( 0,  0, 15))
pfms <- TFBSTools::PFMatrixList(
    TFBSTools::PFMatrix(name = "m1", profileMatrix = m),
    TFBSTools::PFMatrix(name = "m2", profileMatrix = m + 10),
    TFBSTools::PFMatrix(name = "m3", profileMatrix = m[, 3:1])
)
motifSimilarity(pfms)

}
\seealso{
\code{\link[BiocParallel]{bplapply}} used for parallelization for
  \code{method = "R"},
  documentation of HOMER's \code{compareMotifs.pl} for details on
  \code{method = "HOMER"}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{dumpJaspar}
\alias{dumpJaspar}
\title{Dump Jaspar motifs into a HOMER motif file.}
\usage{
dumpJaspar(
  filename,
  pkg = "JASPAR2020",
  opts = list(tax_group = "vertebrates"),
  pseudocount = 1,
  relScoreCutoff = 0.8,
  verbose = FALSE
)
}
\arguments{
\item{filename}{Name of the output file to be created.}

\item{pkg}{Name of the Jaspar package to use (default: \code{JASPAR2020}).}

\item{opts}{A list with search options used in
\code{\link[TFBSTools]{getMatrixSet}}. By default, only vertebrate motifs
are included in the output using
\code{opts = list(tax_group = "vertebrates")}.}

\item{pseudocount}{A numerical scalar with the pseudocount to be added to
each element of the position frequency matrix extracted from Jaspar,
before its conversion to a position probability matrix (default: 1.0).}

\item{relScoreCutoff}{Currently ignored. numeric(1) in [0,1] that sets the
default motif log-odds score cutof to relScoreCutoff * maximal score for
each PWM (default: 0.8).}

\item{verbose}{A logical scalar. If \code{TRUE}, print progress messages.}
}
\value{
\code{TRUE} if successful.
}
\description{
Get motifs from a Jaspar database package (e.g.
    \code{JASPAR2020}) and write them into a HOMER-compatible motif file
    as positional probability matrices.
}
\examples{
dumpJaspar(filename = tempfile(), pkg = "JASPAR2020",
           opts = list(ID = c("MA0006.1")))

}
\seealso{
\code{\link[TFBSTools]{getMatrixSet}} for details on the argument
    \code{opts}. \code{\link{homerToPFMatrixList}} to read a file with
    HOMER-formatted motifs into a \code{\link[TFBSTools]{PFMatrixList}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.checkDfValidity}
\alias{.checkDfValidity}
\title{Check if seqinfo DataFrame is valid}
\usage{
.checkDfValidity(df)
}
\arguments{
\item{df}{Input object to be checked. It should have an attribute \code{err}
and columns:
\describe{
  \item{\code{seqs}}{: a \code{DNAStringSet} object.}
  \item{\code{isForeground}}{ that indicates if a sequence is in the
                              foreground group.}
  \item{\code{GCfrac}}{: the fraction of G+C bases per sequence.}
  \item{\code{GCbin}}{: the GC bin for each sequence.}
  \item{\code{GCwgt}}{: the sequence weight to adjust for GC
    differences between foreground and background sequences.}
  \item{\code{seqWgt}}{: the sequence weight to adjust for k-mer
    differences between foreground and background sequences.}
}}
}
\value{
\code{TRUE} (invisibly) if \code{df} is valid, otherwise it
  raises an exception using \code{cli::cli_abort()}
}
\description{
Check if the \code{DataFrame} with sequence information is 
  valid, i.e. is of the correct object type (\code{DataFrame}) and has all 
  expected columns and attributes.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBinDiagnostics.R
\name{plotBinDiagnostics}
\alias{plotBinDiagnostics}
\title{Plot diagnostics of binned sequences}
\usage{
plotBinDiagnostics(
  seqs,
  bins,
  aspect = c("length", "GCfrac", "dinucfreq"),
  draw_quantiles = c(0.25, 0.5, 0.75),
  ...
)
}
\arguments{
\item{seqs}{\code{\link[Biostrings]{DNAStringSet}} object with sequences.}

\item{bins}{Factor of the same length and order as \code{seqs}, indicating
the bin for each sequence. Typically the return value of \code{bin}.}

\item{aspect}{The diagnostic to plot. Should be one of \code{"length"},
\code{"GCfrac"} and \code{"dinucfreq"}, to plot the distribution of
sequence lengths, the distribution of GC fractions and the average
relative dinucleotide frequencies across the bins.}

\item{draw_quantiles}{For aspect=\code{"length"} or \code{"GCfrac"},
draw vertical lines at the given quantiles of the density estimate.
If \code{NULL}, no quantile lines will be drawn.}

\item{...}{Additional argument passed to \code{getColsByBin}.}
}
\value{
For aspect=\code{"length"} or \code{"GCfrac"}, returns a
  \code{\link[ggplot2]{ggplot}} object. For aspect=\code{"dinucfreq"},
  returns (invisibly) a \code{\link[ComplexHeatmap]{Heatmap-class}} object.
}
\description{
Plot various diagnostics of binned sequences. Three plot types are
available:
\describe{
\item{\code{length}}{ plots the distribution of sequence lengths within
  each bin.}
\item{\code{GCfrac}}{ plots the distribution of GC fractions within each
  bin.}
\item{\code{dinucfreq}}{ plots a heatmap of the relative frequency of each
  dinucleotide, averaged across the sequences within each bin. The values
  are centered for each dinucleotide to better highlight differences
  between the bins. The average relative frequency of each dinucleotide
  (across the bins) is indicated as well.}
}
}
\examples{
seqs <- Biostrings::DNAStringSet(
  vapply(1:250, function(i) paste(sample(x = c("A", "C", "G", "T"),
                                         size = round(stats::rnorm(1, 20, 5)),
                                         replace = TRUE), collapse = ""), "")
)
bins <- factor(rep(c("a", "b", "c", "d", "e"), each = 50))
plotBinDiagnostics(seqs, bins, aspect = "length")
plotBinDiagnostics(seqs, bins, aspect = "GCfrac", draw_quantiles = NULL)
plotBinDiagnostics(seqs, bins, aspect = "dinucfreq")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sample_random_regions.R
\name{sampleRandomRegions}
\alias{sampleRandomRegions}
\title{Sample random regions of fixed length.}
\usage{
sampleRandomRegions(allowedRegions = NULL, N = 100L, regWidth = 200L)
}
\arguments{
\item{allowedRegions}{An unstranded \code{GRanges} object of the "allowed" 
of the genome, usually the mappable regions.}

\item{N}{Number of regions to sample.}

\item{regWidth}{Region width.}
}
\value{
A \code{GRanges} object with randomly sampled mappable regions of 
    width \code{regWidth} with \code{fractionCGI} coming from CpG islands.
}
\description{
Sample random regions from the mappable parts of the genome with
    a given fraction from CpG islands.
}
\details{
In order to make the results deterministic, set the random
    number seed before calling \code{sampleRandomRegions} using 
    \code{set.seed}.
}
\examples{
regs <- GenomicRanges::GRanges(
  seqnames = rep(c("chr1", "chr2"), each = 2), 
  ranges = IRanges::IRanges(start = 1:4, end = 5:8))
set.seed(123)
sampleRandomRegions(regs, N = 2, regWidth = 3L)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{findHomer}
\alias{findHomer}
\title{Find HOMER script file.}
\usage{
findHomer(homerfile = "findMotifsGenome.pl", dirs = NULL)
}
\arguments{
\item{homerfile}{Name of the script file to search.}

\item{dirs}{Directory names to look for \code{homerfile}. If
\code{dirs=NULL}, all directories listed in the \code{PATH} environment
variable will be searched.}
}
\value{
Absolute path to \code{homerfile}, or \code{NA} if none or several
  were found.
}
\description{
Find absolute path to HOMER script file.
}
\details{
In addition to \code{dirs}, \code{findHomer} will also look in the
    directory provided in the environment variable \code{MONALISA_HOMER}.
}
\examples{
homer_path <- findHomer()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotBinDensity}
\alias{plotBinDensity}
\title{Density plot of binned elements.}
\usage{
plotBinDensity(
  x,
  b,
  xlab = deparse(substitute(x, env = as.environment(-1))),
  ylab = "Density",
  main = "",
  legendPosition = "right",
  legend = NULL,
  legend.cex = NULL,
  ...
)
}
\arguments{
\item{x}{A numerical vector with the values used for binning.}

\item{b}{A factor that groups elements of \code{x} into bins (typically the
output of \code{\link{bin}}).}

\item{xlab, ylab, main}{\code{character} scalars that set the x-axis label,
y-axis label and the main title. Use \code{""} to suppress the label.}

\item{legendPosition}{A \code{character} scalar.
If not \code{"none"}, draw a legend with binning information. The value
is used to control the legend position and will be passed to
\code{theme(legend.position = legendPosition)}.}

\item{legend}{Deprecated (ignored). Please use \code{legendPosition} to
control the drawing and position of the legend.}

\item{legend.cex}{Deprecated (ignored). You can use
\code{\link[ggplot2]{theme}} to set legend and other graphical
parameters.}

\item{...}{Further arguments passed to \code{\link{getColsByBin}}.}
}
\value{
The generated density plot as a \code{ggplot} object.
}
\description{
Plot the density of binned elements with binning information.
}
\examples{
set.seed(1)
x <- rnorm(100)
b <- bin(x, "equalN", nElements = 10)
plotBinDensity(x, b)

}
\seealso{
\code{\link{getColsByBin}}, \code{\link[ggplot2]{geom_density}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{getColsByBin}
\alias{getColsByBin}
\title{Get colors by bin.}
\usage{
getColsByBin(
  b,
  col1 = c("#003C30", "#01665E", "#35978F", "#80CDC1", "#C7EAE5"),
  col2 = c("#F6E8C3", "#DFC27D", "#BF812D", "#8C510A", "#543005"),
  col0 = "#F5F5F5"
)
}
\arguments{
\item{b}{A factor that groups elements into bins (typically the output of
\code{\link{bin}}).}

\item{col1}{First color.}

\item{col2}{Second color.}

\item{col0}{Neutral color.}
}
\value{
A character vector with colors for the elements in \code{b}.
}
\description{
Get colors for elements according to their bin.
    Colors are assigned to bins forming a gradient from \code{col1}
    to \code{col2} in the order of \code{levels{b}}. \code{col0} is assigned
    to the neutral bin (attribute \code{""}) if available.
}
\examples{
set.seed(1)
x <- rnorm(100)
b <- bin(x, "equalN", nElements = 10)
cols <- getColsByBin(b)

}
\seealso{
\code{\link{bin}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_finding.R
\docType{methods}
\name{findMotifHits}
\alias{findMotifHits}
\alias{findMotifHits,character,character-method}
\alias{findMotifHits,character,DNAString-method}
\alias{findMotifHits,character,DNAStringSet-method}
\alias{findMotifHits,PWMatrix,character-method}
\alias{findMotifHits,PWMatrix,DNAString-method}
\alias{findMotifHits,PWMatrix,DNAStringSet-method}
\alias{findMotifHits,PWMatrixList,character-method}
\alias{findMotifHits,PWMatrixList,DNAString-method}
\alias{findMotifHits,PWMatrixList,DNAStringSet-method}
\alias{findMotifHits,PWMatrix,GRanges-method}
\alias{findMotifHits,PWMatrixList,GRanges-method}
\title{Find motif matches in sequences.}
\usage{
findMotifHits(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{character,character}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{character,DNAString}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{character,DNAStringSet}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrix,character}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrix,DNAString}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrix,DNAStringSet}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrixList,character}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrixList,DNAString}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrixList,DNAStringSet}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrix,GRanges}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)

\S4method{findMotifHits}{PWMatrixList,GRanges}(
  query,
  subject,
  min.score,
  method = c("matchPWM", "homer2"),
  homerfile = findHomer("homer2"),
  BPPARAM = SerialParam(),
  genome = NULL
)
}
\arguments{
\item{query}{The motifs to search for, either a
\describe{
    \item{\code{character(1)}}{ with the path and file name of a motif
          file with PWM in HOMER format (currently only
          supported for \code{method="homer2"})}
    \item{\code{PWMatrix}}{ with a single PWM}
    \item{\code{PWMatrixList}}{ with several PWMs to search for.}
 }}

\item{subject}{The sequences to be searched, either a
\describe{
    \item{\code{character}}{ with the path and file name of a sequence
          file with DNA sequences in FASTA format}
    \item{\code{DNAString}}{ with a single sequence}
    \item{\code{DNAStringSet}}{ with several sequences}
    \item{\code{GRanges}}{ object with the genomic coordinates
        of the sequences to be searched.}
}}

\item{min.score}{The minimum score for counting a match. Can be given as
a character string containing a percentage (e.g. "85%") of  of the
highest possible score or as a single number.}

\item{method}{The internal method to use for motif searching. One of
\describe{
    \item{\code{"matchPWM"}}{ using Biostrings::matchPWM (optimized)}
    \item{\code{"homer2"}}{ call to the homer2 binary}
}
Please note that the two methods might give slightly different results
(see details).}

\item{homerfile}{Path and file name of the \code{homer2} binary.}

\item{BPPARAM}{An optional \code{\link[BiocParallel]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation.}

\item{genome}{\code{BSgenome} object that is the reference genome of the
subject. This argument is set to NULL by default and only used by the
function when the subject is a \code{GRanges} object. It is then
necessary to specify the genome so that the function can internally
convert the genomic regions into a \code{DNAStringSet} object.}
}
\value{
A \code{GRanges} object with the matches to \code{query} in
    \code{subject}.
}
\description{
\code{findMotifHits} scans sequences (either provided
as a file, an R object or genomic coordinates)  for matches to
positional weight matrices (provided as a file or as R objects)
}
\details{
The implemented methods (\code{matchPWM} and \code{homer2}) are
    there for convenience (\code{method="matchPWM"} calls
    \code{Biostrings::matchPWM} internally in an optimized fashion, and
    \code{method = "homer2"} calls the command line tool from Homer and
    therefore requires an installation of Homer).

    In general, running \code{findMotifHits} with the same parameters using
    any of the methods generates identical results. Some minor differences
    could occur that result from rounding errors during the necessary
    conversion of PWMs (log2-odd scores) to the probability matrices needed
    by Homer, and the conversion of scores from and to the natural log scale
    used by Homer. These conversions are implemented transparently for the
    user, so that the arguments of \code{findMotifHits} do not have to be
    adjusted (e.g. the PWMs should always contain log2-odd scores, and
    \code{min.score} is always on the log2 scale).

    If there are bases with frequencies of less than 0.001 in a motif, Homer
    will set them to 0.001 and adjust the other frequencies at that motif
    position accordingly so that they sum to 1.0. This may differ from the
    adjustment used when scanning a PWM with \code{matchPWM} (e.g. the
    \code{pseudocounts} argument in the \code{\link[TFBSTools]{toPWM}}
    function), and thus can give rise to differences in reported motif hits
    and hit scores (typically only low-scoring hits).
}
\examples{
seqs <- Biostrings::DNAStringSet(c(s1 = "GTCAGTCGATC", s2 = "CAGTCTAGCTG",
                                   s3 = "CGATCGTCAGT", s4 = "AGCTGCAGTCT"))
m <- rbind(A = c(2, 0, 0),
           C = c(1, 1, 0),
           G = c(0, 2, 0),
           T = c(0, 0, 3))
pwms <- TFBSTools::PWMatrixList(
    TFBSTools::PWMatrix(ID = "m1", profileMatrix = m),
    TFBSTools::PWMatrix(ID = "m2", profileMatrix = m[, 3:1])
)
findMotifHits(pwms, seqs, min.score = 7)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pfm_comparison.R
\name{motifKmerSimilarity}
\alias{motifKmerSimilarity}
\title{Calculate similarities between motifs and k-mers.}
\usage{
motifKmerSimilarity(
  x,
  kmerLen = 5,
  kmers = NULL,
  includeRevComp = FALSE,
  BPPARAM = SerialParam(),
  verbose = FALSE
)
}
\arguments{
\item{x}{Either a \code{\link[TFBSTools]{PFMatrixList}}, or a character
scalar with a file containing motifs in HOMER format (used directly
\code{method = "HOMER"}, loaded into a
\code{\link[TFBSTools]{PFMatrixList}} by \code{\link{homerToPFMatrixList}}
for \code{method = "R"}).}

\item{kmerLen}{A \code{numeric} scalar giving the k-mer length.}

\item{kmers}{Either a character vector of k-mers for which to calculate
the similarity to each motif, or \code{NULL}, in which case all k-mers
of length \code{kmerLen} are used.}

\item{includeRevComp}{A \code{logical} scalar. If set to \code{TRUE}, each
k-mer as well as its reverse complement is compared to each motif, and the
larger of the two similarities is returned.}

\item{BPPARAM}{An optional \code{\link[BiocParallel]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation.}

\item{verbose}{A logical scalar. If \code{TRUE}, report on progress.}
}
\value{
A matrix of probabilties for each motif - k-mer pair.
}
\description{
For each motif, calculate it's similarity to all k-mers of
  length \code{kmerLen}, defined as the maximal probability of observing the
  k-mer given the base frequencies of the motif (the maximum is taken over
  for all possible ungapped alignments between motif and k-mer). If necessary
  matrices are padded on the sides with background base frequencies (assuming
  all bases to have a frequency of 0.25).
}
\examples{
m <- rbind(A = c(12,  0,  0),
           C = c( 3,  2,  0),
           G = c( 0, 14,  0),
           T = c( 0,  0, 15))
pfms <- TFBSTools::PFMatrixList(
    TFBSTools::PFMatrix(name = "m1", profileMatrix = m),
    TFBSTools::PFMatrix(name = "m2", profileMatrix = m[, 3:1])
)
motifKmerSimilarity(pfms, kmerLen = 3)[, c("AGT", "TGA")]

}
\seealso{
\code{\link[BiocParallel]{bplapply}} used for parallelization.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stability_selection.R
\name{randLassoStabSel}
\alias{randLassoStabSel}
\title{Randomized Lasso Stability Selection}
\usage{
randLassoStabSel(
  x,
  y,
  weakness = 0.8,
  cutoff = 0.8,
  PFER = 2,
  mc.cores = 1L,
  glmnet.args = list(),
  ...
)
}
\arguments{
\item{x}{The predictor matrix.}

\item{y}{The response vector. This should be a numeric vector (also for 
the binomial case - in this case it will be converted to a factor 
internally by \code{glmnet}).}

\item{weakness}{Value between 0 and 1 (default = 0.8).
It affects how strict the method will be in selecting predictors. The
closer it is to 0, the more stringent the selection. A weakness value
of 1 is identical to performing lasso stability selection (not the
randomized version).}

\item{cutoff}{Value between 0 and 1 (default = 0.8) which is the cutoff
for the selection probability. Any variable with a selection probability
that is higher than the set cutoff will be selected.}

\item{PFER}{Integer (default = 2) representing the absolute number of
false positives that we allow for in the final list of selected
variables. For details see Meinshausen and Bühlmann (2010).}

\item{mc.cores}{Integer (default = 1) specifying the number of cores to
use in \code{\link[parallel]{mclapply}}, which is the default way
\code{\link[stabs]{stabsel}} does parallelization.}

\item{glmnet.args}{Named list with additional arguments to the internal 
\code{.glmnetRandomizedLasso} function (beyond \code{x}, 
\code{y} and \code{weakness}, which are determined automatically, and 
\code{q}, which should not be specified (it will be determined from 
\code{cutoff} and \code{PFER}). 
The available arguments to \code{.glmnetRandomizedLasso} are the same as 
the ones for \code{\link[stabs]{glmnet.lasso}}. A typical use case would 
be to define the \code{family} argument to \code{\link[glmnet]{glmnet}} 
(currently "gaussian" and "binomial" are supported).}

\item{...}{Additional parameters that can be passed on to
\code{\link[stabs]{stabsel}}.}
}
\value{
A \code{SummarizedExperiment} object where the rows are the
    observations and the columns the predictors (same dimnames as the
    predictor matrix \code{x}).
    It contains: \describe{
      \item{assays}{: \describe{
        \item{x}{: the predictor matrix.}
        }
      }
      \item{rowData}{: a \code{DataFrame} with columns: \describe{
        \item{y}{: the response vector.}
        }
      }
      \item{colData}{: a \code{DataFrame} with columns: \describe{
        \item{selProb}{: the final selection probabilities for the
          predictors (from the last regularization step).}
        \item{selected}{: logical indicating the predictors that made
          the selection with the specified cutoff.}
        \item{selAUC}{: the normalized area under the seletion curve
          (mean of selection probabilities over regulatization steps).}
        \item{reg'\code{i}'}{: columns containing the selection
          probabilities for regularization step i. }
        }
      }
      \item{metadata}{: a list of output returned from
        \code{\link[stabs]{stabsel}} and \code{randLassoStabSel}: \describe{
        \item{stabsel.params.cutoff}{: probability cutoff set for selection
          of predictors (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.selected}{: elements with maximal selection
          probability greater \code{cutoff}
          (see \code{\link[stabs]{stabsel}}). }
        \item{stabsel.params.max}{: maximum of selection probabilities
          (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.q}{: average number of selected variables
          used (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.PFER}{: (realized) upper bound for the
          per-family error rate (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.specifiedPFER}{: specified upper bound for
          the per-family error rate (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.p}{: the number of effects subject to
          selection (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.B}{: the number of subsamples (see
          \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.sampling.type}{: the sampling type used for
          stability selection (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.assumption}{: the assumptions made on the
          selection probabilities (see \code{\link[stabs]{stabsel}}).}
        \item{stabsel.params.call}{: \code{\link[stabs]{stabsel}} the call.}
        \item{randStabsel.params.weakness}{: the weakness parameter in the
          randomized lasso stability selection.}
        }
      }

    }
}
\description{
This function runs randomized lasso stability selection as
    presented by Meinshausen and Bühlmann (2010) and with the improved
    error bounds introduced by Shah and Samworth (2013). The function
    uses the \code{\link[stabs]{stabsel}} function from the \code{stabs}
    package, but implements the randomized lasso version.
}
\details{
Randomized lasso stability selection runs a randomized lasso
    regression several times on subsamples of the response variable and
    predictor matrix. N/2 elements from the response variable are randomly
    chosen in each regression, where N is the length of the vector. The
    corresponding section of the predictor matrix is also chosen, and the
    internal \code{.glmnetRandomizedLasso} function is applied.
    Stability selection results in selection probabilities for each
    predictor. The probability of a specific predictor is the number of
    times it was selected divided by the total number of subsamples that
    were done (total number of times the regression was performed).

    We made use of the \code{stabs} package that implements lasso stability
    selection, and adapted it to run randomized lasso stability selection.
}
\examples{
## create data set
Y <- rnorm(n = 500, mean = 2, sd = 1)
X <- matrix(data = NA, nrow = length(Y), ncol = 50)
for (i in seq_len(ncol(X))) {
  X[ ,i] <- runif(n = 500, min = 0, max = 3)
}
s_cols <- sample(x = seq_len(ncol(X)), size = 10,
  replace = FALSE)
for (i in seq_along(s_cols)) {
  X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
}

## reproducible randLassoStabSel() with 1 core
set.seed(123)
ss <- randLassoStabSel(x = X, y = Y)

## reproducible randLassoStabSel() in parallel mode
## (only works on non-windows machines)
if (.Platform$OS.type == "unix") {
    RNGkind("L'Ecuyer-CMRG")
    set.seed(123)
    ss <- randLassoStabSel(x = X, y = Y, mc.preschedule = TRUE,
                           mc.set.seed = TRUE, mc.cores = 2L)
}

}
\references{
N. Meinshausen and P. Bühlmann (2010), Stability Selection,
    \emph{Journal of the Royal Statistical Society: Series B
    (Statistical Methodology)}, \strong{72}, 417–73. \cr
    R.D. Shah and R.J. Samworth (2013), Variable Selection with Error
    Control: Another Look at Stability Selection,
    \emph{Journal of the Royal Statistical Society: Series B
    (Statistical Methodology)}, \strong{75}, 55–80. \cr
    B. Hofner, L. Boccuto, and M. Göker (2015), Controlling False
    Discoveries in High-Dimensional Situations: Boosting with Stability
    Selection, \emph{BMC Bioinformatics}, \strong{16} 144.
}
\seealso{
\code{\link[stabs]{stabsel}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.checkIfSeqsAreEqualLength}
\alias{.checkIfSeqsAreEqualLength}
\title{Check if elements of `x` are have equal lengths}
\usage{
.checkIfSeqsAreEqualLength(x)
}
\arguments{
\item{x}{An object that implements a \code{width} method, typically a
\code{GRanges} or \code{DNAStringSet} object.}
}
\value{
\code{NULL} (invisibly). The function is called for its side-effect
  of generating a warning if elements of the input are not of equal lengths.
}
\description{
Check if the elements of `x` are all equally long.
  If not, generate a warning.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stability_selection.R
\name{.glmnetRandomizedLasso}
\alias{.glmnetRandomizedLasso}
\title{Randomized Lasso}
\usage{
.glmnetRandomizedLasso(
  x,
  y,
  q,
  weakness = 1,
  type = c("conservative", "anticonservative"),
  ...
)
}
\arguments{
\item{x}{The predictor matrix. Passed to \code{x}
of \code{glmnet.lasso} from \code{stabs} package.}

\item{y}{The response vector. Passed to \code{y}
of \code{glmnet.lasso} from \code{stabs} package.}

\item{q}{The number of variables that are selected on each subsample.
Passed to \code{q} of \code{glmnet.lasso} from \code{stabs} package.}

\item{weakness}{Weakness parameter used in randomized lasso (see details).}

\item{type}{Parameter passed to \code{type} of \code{glmnet.lasso} from
\code{stabs} package. It is a character vector specifying how much the
PFER should be controlled. If type is "conservative" (default), then the
number of selected variables per subsample is <= q. If type is
"anticonservative" then the number of selected variables per subsample
is >= q.}

\item{...}{Additional parameters for \code{glmnet}.}
}
\value{
The regression output which consists of a list of length 2. The
    list contains the following:
    \describe{
    \item{selected}{ - a logical vector of length equal to the total number
        of predictors. The predictors that were chosen have a value of TRUE.}
    \item{path}{ - a logical matrix containing the regularization steps as
        columns and the predictors as rows. An entry of TRUE indicates
        selection.}
    }
}
\description{
This function performs randomized lasso using the \code{glmnet}
    package. The function present in the \code{stabs} package that runs the
    lasso version was adapted for the randomized lasso here. Randomized
    lasso stability selection uses this function repeatedly
    to select predictors.
}
\details{
This function is identical to \code{glmnet.lasso} from the
    \code{stabs} package. The only addition/modification is the weakness
    parameter which has been added when calling the
    \code{glmnet} function by setting
    penalty.factor = 1/runif(ncol(x), weakness, 1),
    where ncol(x) is the number of predictors.
}
\seealso{
\code{\link[stabs]{glmnet.lasso}} and \code{\link[glmnet]{glmnet}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqlogo.R
\name{annoSeqlogo}
\alias{annoSeqlogo}
\title{Sequence logo annotation}
\usage{
annoSeqlogo(
  grobL,
  which = c("column", "row"),
  space = unit(0.5, "mm"),
  width = NULL,
  height = NULL,
  gp = gpar(fill = NA, col = NA)
)
}
\arguments{
\item{grobL}{A \code{list} of sequence logo grobs, typically created using
\code{\link{seqLogoGrob}}.}

\item{which}{Whether it is a column annotation or a row annotation?}

\item{space}{The space around the image to the annotation grid borders. The
value should be a unit object.}

\item{width}{Width of the annotation. The value should be an absolute unit.
Width is not allowed to be set for column annotation.}

\item{height}{Height of the annotation. The value should be an absolute unit.
Height is not allowed to be set for row annotation.}

\item{gp}{Graphic parameters for annotation grids. Can be used to control the
background color in the annotation grids.}
}
\value{
An annotation function which can be used in
  \code{\link[ComplexHeatmap]{HeatmapAnnotation}}.
}
\description{
Create an annotation for a \code{\link[ComplexHeatmap]{Heatmap}}
  containing sequence logos.
}
\examples{
if (require(JASPAR2020) && require(TFBSTools) && require(gridExtra)) {
    pfm1 <- getMatrixByID(JASPAR2020, "MA0139")

    g1 <- seqLogoGrob(pfm1)

    anno <- annoSeqlogo(list(g1))
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.filterSeqs}
\alias{.filterSeqs}
\title{Filter Sequences}
\usage{
.filterSeqs(
  seqs,
  maxFracN = 0.7,
  minLength = 5L,
  maxLength = 100000L,
  verbose = FALSE
)
}
\arguments{
\item{seqs}{A \code{DNAStringSet} object.}

\item{maxFracN}{A numeric scalar with the maximal fraction of N bases allowed
in a sequence (defaults to 0.7).}

\item{minLength}{The minimum sequence length (default from Homer).
Sequences shorter than this will be filtered out.}

\item{maxLength}{The maximum sequence length (default from Homer).
Sequences bigger than this will be filtered out.}

\item{verbose}{A logical scalar. If \code{TRUE}, report on filtering.}
}
\value{
A logical vector of the same length as \code{seqs} with \code{TRUE}
  indicated to keep the sequence and \code{FALSE} to filter it out.
}
\description{
Filter sequences that are unlikely to be useful for motif
  enrichment analysis. The current defaults are based on HOMER
  (version 4.11).
}
\details{
The filtering logic is based on \code{removePoorSeq.pl} from Homer.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_kmers.R
\name{.calcKmerEnrichment}
\alias{.calcKmerEnrichment}
\title{Calculate k-mer enrichment}
\usage{
.calcKmerEnrichment(k, df, test = c("fisher", "binomial"), verbose = FALSE)
}
\arguments{
\item{k}{Numeric scalar giving the length of k-mers to analyze.}

\item{df}{A \code{DataFrame} with sequence information as returned by
\code{.iterativeNormForKmers()}.}

\item{test}{Type of motif enrichment test to perform.}

\item{verbose}{A logical scalar. If \code{TRUE}, report on progress.}
}
\value{
A \code{data.frame} containing the motifs as rows and the columns:
  \describe{
    \item{motifName}{: the motif name}
    \item{logP}{: the log p-value for enrichment (natural logarithm).
       If \code{test="binomial"} (default), this log p-value is identical to
       the one returned by Homer.}
    \item{sumForegroundWgtWithHits}{: the weighted number of k-mer hits in
       foreground sequences.}
    \item{sumBackgroundWgtWithHits}{: the weighted number of k-mer hits in
       background sequences.}
    \item{totalWgtForeground}{: the total sum of weights of foreground
       sequences.}
    \item{totalWgtBackground}{: the total sum of weights of background
       sequences.}
  }
}
\description{
Given sequences, foreground/background labels and
  weights, calculate the enrichment of each k-mer
  in foreground compared to background. This function is called by
  \code{calcBinnedKmerEnr()} for each bin if \code{background != "model"}.

  The default type of test is \code{"fisher"}.
  Alternatively, a binomial test can be used by \code{test = "binomial"}.
  Using Fisher's exact test has the advantage that special cases such as
  zero background counts are handled without ad-hoc adjustments to the
  k-mer frequencies.

  For \code{test = "fisher"}, \code{fisher.test} is used with
  \code{alternative = "greater"}, making it a one-sided test for enrichment,
  as is the case with the binomial test.
}
\details{
The function works in ZOOPS mode, which means only one
  or zero occurrences of a k-mer are considered per sequence. This is helpful
  to reduce the impact of simple sequence repeats occurring in few sequences.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{homerToPFMatrixList}
\alias{homerToPFMatrixList}
\title{Read a HOMER motif file and create a PFMatrixList}
\usage{
homerToPFMatrixList(filename, n = 100L)
}
\arguments{
\item{filename}{Name of the input file with HOMER-formatted motifs.}

\item{n}{The number of observations (multiplied with base frequencies to
create the number of observed bases at each position).}
}
\value{
A \code{\link[TFBSTools]{PFMatrixList}} with motifs from the file.
}
\description{
Read motifs from a file in HOMER format and create
    a PFMatrixList from them.
}
\examples{
library(JASPAR2020)
optsL <- list(ID = c("MA0006.1"))
pfm1 <- TFBSTools::getMatrixSet(JASPAR2020, opts = optsL)
TFBSTools::Matrix(pfm1)

tmpfn <- tempfile()
dumpJaspar(filename = tmpfn, pkg = "JASPAR2020", opts = optsL)
pfm2 <- homerToPFMatrixList(tmpfn)
TFBSTools::Matrix(pfm2)

unlink(tmpfn)

}
\seealso{
\code{\link{dumpJaspar}} for writing motifs from a Jaspar database
    package into a file in HOMER format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_kmers.R
\name{calcBinnedKmerEnr}
\alias{calcBinnedKmerEnr}
\title{Calculate k-mer enrichment in bins of sequences.}
\usage{
calcBinnedKmerEnr(
  seqs,
  bins = NULL,
  kmerLen = 5,
  background = c("otherBins", "allBins", "zeroBin", "genome", "model"),
  MMorder = 1,
  test = c("fisher", "binomial"),
  includeRevComp = TRUE,
  maxFracN = 0.7,
  maxKmerSize = 3L,
  GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.6, 0.7, 0.8),
  pseudocount.kmers = 1,
  pseudocount.log2enr = 8,
  p.adjust.method = "BH",
  genome = NULL,
  genome.regions = NULL,
  genome.oversample = 2,
  BPPARAM = SerialParam(),
  verbose = FALSE
)
}
\arguments{
\item{seqs}{\code{\link[Biostrings]{DNAStringSet}} object with sequences to
test}

\item{bins}{Factor of the same length and order as \code{seqs}, indicating
the bin for each sequence. Typically the return value of
\code{\link[monaLisa]{bin}}. For \code{background = "genome"} or
\code{background = "model"}, \code{bins} can be omitted.}

\item{kmerLen}{A \code{numeric} scalar giving the k-mer length.}

\item{background}{A \code{character} scalar specifying the background
sequences to use. One of \code{"otherBins"} (default), \code{"allBins"},
\code{"zeroBin"}, \code{"genome"} or \code{"model"} (see "Details").}

\item{MMorder}{A \code{numeric} scalar giving the order of the Markov model
used to calculate the expected frequencies for \code{background = "model"}.}

\item{test}{A \code{character} scalar specifying the type of enrichment test
to perform. One of \code{"fisher"} (default) or \code{"binomial"}. The
enrichment test is one-sided (enriched in foreground).}

\item{includeRevComp}{A \code{logical} scalar. If \code{TRUE} (default),
count k-mer occurrences in both \code{seqs} and their reverse-complement,
by concatenating \code{seqs} and their reverse-complemented versions
before the counting. This is useful if motifs can be expected to occur
on any strand (e.g. DNA sequences of ChIP-seq peaks). If motifs are only
expected on the forward strand (e.g. RNA sequences of CLIP-seq peaks),
\code{includeRevComp = FALSE} should be used. Note that \code{bins}
will be recycled for the reverse complemented sequences, which means that
each reverse-complemented sequence will be assigned to the same bib as the
corresponding forward sequence.}

\item{maxFracN}{A numeric scalar with the maximal fraction of N bases allowed
in a sequence (defaults to 0.7). Sequences with higher fractions are
excluded from the analysis.}

\item{maxKmerSize}{The maximum k-mer size to consider, when adjusting
background sequence weights for k-mer composition compared to the
foreground sequences. The default value (3) will correct for mono-, di-
and tri-mer composition.}

\item{GCbreaks}{The breaks between GC bins. The default value is based on
the hard-coded bins used in Homer.}

\item{pseudocount.kmers}{A \code{numeric} scalar - will be added to the
observed and expected counts for each k-mer to avoid zero values.}

\item{pseudocount.log2enr}{A numerical scalar with the pseudocount to add to
foreground and background counts when calculating log2 motif enrichments}

\item{p.adjust.method}{A character scalar selecting the p value adjustment
method (used in \code{\link[stats]{p.adjust}}).}

\item{genome}{A \code{BSgenome} or \code{DNAStringSet} object with the
genome sequence. Only used for \code{background = "genome"} for extracting
background sequences.}

\item{genome.regions}{An optional \code{\link[GenomicRanges]{GRanges}} object
defining the intervals in \code{genome} from which background sequences are
sampled for \code{background = "genome"}. If \code{NULL}, background
sequences are sampled randomly from \code{genome}.}

\item{genome.oversample}{A \code{numeric} scalar of at least 1.0 defining how
many background sequences will be sampled per foreground sequence for
\code{background = "genome"}. Larger values will take longer but improve
the sequence composition similarity between foreground and background
(see \code{"Details"}).}

\item{BPPARAM}{An optional \code{\link[BiocParallel]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation.}

\item{verbose}{A \code{logical} scalar. If \code{TRUE}, report on progress.}
}
\value{
A \code{\link[SummarizedExperiment]{SummarizedExperiment}} object
  with motifs in rows and bins in columns, containing seven assays: \describe{
  \item{negLog10P}{: -log10 P values}
  \item{negLog10Padj}{: -log10 adjusted P values}
  \item{pearsonResid}{: k-mer enrichments as Pearson residuals}
  \item{expForegroundWgtWithHits}{: expected number of foreground
    sequences with motif hits}
  \item{log2enr}{: k-mer enrichments as log2 ratios}
  \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
    in a bin that have k-mer occurrences}
  \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
    in a bin that have k-mer occurrences}
}
#' The \code{rowData} of the object contains annotations (name, PFMs, PWMs
and GC fraction) for the k-mers, while the \code{colData} slot contains
summary information about the bins.
}
\description{
Given a set of sequences and corresponding bins, identify
  enriched k-mers (n-grams) in each bin. The sequences can be given either
  directly or as genomic coordinates.
}
\details{
This function implements a binned k-mer enrichment analysis. In each
  enrichment analysis, the sequences in a specific bin are used as foreground
  sequences to test for k-mer enrichments comparing to background sequences
  (defined by \code{background}, see below), similarly as in done for motifs
  in \code{\link{calcBinnedMotifEnrR}}. Sequences are weighted to correct for
  GC and shorter k-mer composition differences between fore- and background
  sets.

  The background sequences are defined according to the value of the
  \code{background} argument:
  \describe{
    \item{otherBins}{: sequences from all other bins (excluding the current
      bin)}
    \item{allBins}{: sequences from all bins (including the current bin)}
    \item{zeroBin}{: sequences from the "zero bin", defined by the
      \code{maxAbsX} argument of \code{\link[monaLisa]{bin}}. If \code{bins}
      does not define a "zero bin", for example because it was created by
      \code{bin(..., maxAbsX = NULL)}, selecting this background definition
      will abort with an error.}
    \item{genome}{: sequences randomly sampled from the genome (or the
      intervals defined in \code{genome.regions} if given). For each
      foreground sequence, \code{genome.oversample} background sequences
      of the same size are sampled (on average). From these, one per
      foreground sequence is selected trying to match the G+C composition.
      In order to make the sampling deterministic, a seed number needs to be
      provided to the \code{RNGseed} parameter in
      \code{\link[BiocParallel]{SerialParam}}
      or \code{\link[BiocParallel]{MulticoreParam}} when creating the
      \code{BiocParallelParam} instance in \code{BPPARAM}.}
    \item{model}{: a Markov model of the order \code{MMorder} is estimated
      from the foreground sequences and used to estimate expected k-mer
      frequencies. K-mer enrichments are then calculated comparing observed
      to these expected frequencies. In order to make the process
      deterministic, a seed number needs to be provided to the
      \code{RNGseed} parameter in \code{\link[BiocParallel]{SerialParam}} or
      \code{\link[BiocParallel]{MulticoreParam}} when creating the
      \code{BiocParallelParam} instance in \code{BPPARAM}.}
  }

  For each k-mer, the weights of sequences is multiplied with the number
  of k-mer occurrences in each sequence and summed, separately for foreground
  (\code{sumForegroundWgtWithHits}) and background
  (\code{sumBackgroundWgtWithHits}) sequences. The function works in ZOOPS
  (Zero-Or-One-Per-Sequence) mode, so at most one occurrence per
  sequence is counted, which helps reduce the impact of sequence repeats.
  The total foreground (\code{totalWgtForeground}) and background
  (\code{totalWgtBackground}) sum of sequence weights is also calculated. If
  a k-mer has zero \code{sumForegroundWgtWithHits} and
  \code{sumBackgroundWgtWithHits}, then any values (p-values and enrichment)
  that are calculated using these two numbers are set to NA.

  Two statistical tests for the calculation of enrichment log p-value are
  available: \code{test = "fisher"} (default) to perform Fisher's exact
  tests, or \code{test = "binomial"} to perform binomial tests, using:
  \describe{
    \item{fisher}{: \code{fisher.test(x = tab, alternative =
      "greater")}, where \code{tab} is the contingency table with the summed
      weights of sequences in foreground or background sets (rows), and with
      or without a occurrences of a particular k-mer (columns).}
    \item{binomial}{: \code{pbinom(q = sumForegroundWgtWithHits - 1, size =
      totalWgtForeground,
      prob = sumBackgroundWgtWithHits / totalWgtBackground,
      lower.tail = FALSE, log.p = TRUE)}}
  }
}
\examples{
seqs <- Biostrings::DNAStringSet(c("GCATGCATGC", "CATGCGCATG"))
bins <- factor(1:2)
calcBinnedKmerEnr(seqs = seqs, bins = bins, kmerLen = 3)

}
\seealso{
\code{\link{getKmerFreq}} used to calculate k-mer enrichments;
  \code{\link[BSgenome]{getSeq,BSgenome-method}} which is used to extract
  sequences from \code{genomepkg} if \code{x} is a \code{GRanges} object;
  \code{\link[BiocParallel]{bplapply}} that is used for parallelization;
  \code{\link{bin}} for binning of regions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotSelectionProb}
\alias{plotSelectionProb}
\title{Plot selection probabilities of predictors}
\usage{
plotSelectionProb(
  se,
  directional = TRUE,
  selProbMin = metadata(se)$stabsel.params.cutoff,
  selProbMinPlot = 0.4,
  showSelProbMin = TRUE,
  selColor = "cadetblue",
  notSelColor = "grey",
  selProbCutoffColor = "firebrick",
  method = c("pearson", "kendall", "spearman"),
  ylimext = 0.2
)
}
\arguments{
\item{se}{The \code{SummarizedExperiment} object with the results from
stability selection (typically returned by \code{\link{randLassoStabSel}}).}

\item{directional}{A logical scalar. If \code{TRUE}, selection probabilities
are plotted with the sign of the marginal correlation between a predictor
and the response.}

\item{selProbMin}{A numerical scalar in [0,1]. Predictors with a selection
probability greater than \code{selProbMin} are considered selected and
colored by the input from \code{selColor}. By default, \code{selProbMin} is
extracted from the parameters stored in \code{se}.}

\item{selProbMinPlot}{A numerical scalar in [0,1] less than
\code{selProbMin}. Predictors with a selection probability greater
than \code{selProbMinPlot} but less than \code{selProbMin} are shown as
bars with color defined in \code{notSelColor}. \code{selProbMinPlot} is
useful in order to include additional predictors in the barplot, that were
not selected according to \code{selProbMin} but may be close to that cutoff
or are simply nice to visualize alongside the selected predictors. Setting
\code{selProbMinPlot = 0} will include all predictors.}

\item{showSelProbMin}{A logical scalar. If \code{TRUE}, the value of
\code{selProbMin} is shown by a horizontal line with the color defined
by \code{selProbCutoffColor}.}

\item{selColor}{Color for the selected predictors which have a selection
probability greater than \code{selProbMin}.}

\item{notSelColor}{Color for the rest of the (unselected) predictors which
will be show in the barplot.}

\item{selProbCutoffColor}{Color for the line depicting the selection
probability cutoff.}

\item{method}{A character scalar with the correlation method to use in the
calculation of predictor-response marginal correlations. One of "pearson",
"kendall" or "spearman" (see \code{\link[stats]{cor}}).}

\item{ylimext}{A numeric scalar defining how much the y axis limits should be
expanded beyond the plotted probabilities to allow for space for the
bar labels. This value can be increased if the predictor names above the
bars are too long and not showing in the plot.}
}
\value{
a \code{ggplot2} object.
}
\description{
This function plots the selection probabilities of predictors
  (for example the selected motifs), optionally multiplied with either +1 or
  -1 to give a sense of both the strength and the directionality of the
  associated effects. The directionality is estimated from the sign of the
  correlation coefficient between each predictor and the response vector.
}
\details{
This function creates a bar plot with \code{ggplot}.
  Each bar corresponds to a predictor (motif) and the colors correspond to
  whether or not it was selected. The y-axis shows the selection
  probabilities (\code{directional=FALSE}) or selection probabilities with
  the sign of the marginal correlation to the response
  (\code{directional=TRUE}).
}
\examples{
## create data set
set.seed(321)
Y <- rnorm(n = 500, mean = 2, sd = 1)
X <- matrix(data = NA, nrow = length(Y), ncol = 50)
for (i in seq_len(ncol(X))) {
  X[ ,i] <- runif(n = 500, min = 0, max = 3)
}
s_cols <- sample(x = seq_len(ncol(X)), size = 10,
  replace = FALSE)
for (s in s_cols) {
  X[ ,s] <- X[, s] + (Y + rnorm(500, 0, 4)) * ifelse(s \%\% 2, -1, 1)
}

## reproducible randLassoStabSel() with 1 core
set.seed(123)
ss <- randLassoStabSel(x = X, y = Y)
plotSelectionProb(ss)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.calculateGCweight}
\alias{.calculateGCweight}
\title{Get background sequence weights for GC bins}
\usage{
.calculateGCweight(
  df,
  GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.6, 0.7, 0.8),
  verbose = FALSE
)
}
\arguments{
\item{df}{A \code{DataFrame} with sequence information.}

\item{GCbreaks}{The breaks between GC bins. The default value is based on
the hard-coded bins used in Homer.}

\item{verbose}{A logical scalar. If \code{TRUE}, report on GC weight
calculation.}
}
\value{
A \code{DataFrame} of the same dimensions as the input \code{df},
  with the columns \code{GCfrac}, \code{GCbin} and \code{GCwgt}
  filled in with the sequence GC content, assigned GC bins and weights to
  correct differences in GC distributions between foreground and background
  sequences.
}
\description{
The logic is based on Homer (version 4.11). All sequences
  binned depending on GC content (\code{GCbreaks}). The numbers of
  foreground and background sequences in each bin are counted, and weights
  for background sequences in bin i are defined as:
  weight_i = (number_fg_seqs_i / number_bg_seqs_i) * (number_bg_seqs_total /
  number_fg_seqs_total)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{parseHomerOutput}
\alias{parseHomerOutput}
\title{Load output from HOMER findMotifsGenome.pl into R}
\usage{
parseHomerOutput(infiles, pseudocount.log2enr = 8, p.adjust.method = "BH")
}
\arguments{
\item{infiles}{HOMER output files to be parsed.}

\item{pseudocount.log2enr}{A numerical scalar with the pseudocount to add to
foreground and background counts when calculating log2 motif enrichments}

\item{p.adjust.method}{A character scalar selecting the p value adjustment
method (used in \code{\link[stats]{p.adjust}}).}
}
\value{
A list of nine components (\code{negLog10P}, \code{negLog10Padj},
    \code{pearsonResid}, \code{expForegroundWgtWithHits}, \code{log2enr},
    \code{sumForegroundWgtWithHits} and \code{sumBackgroundWgtWithHits}),
    seven containing each a motif (rows) by bin (columns) matrix with raw
    -log10 P values, -log10 adjusted P values, the expected number of
    foreground sequences with hits, the observed number of foreground and
    background sequences with hits,
    and motif enrichments as Pearson residuals (\code{pearsonResid}) and as
    log2 ratios (\code{log2enr}), and two containing the total foreground
    and background weight (\code{totalWgtForeground},
    \code{totalWgtBackground}).
}
\description{
Parse HOMER output files into R data structures.
}
\examples{
outfile <- system.file("extdata", "homer_output.txt.gz",
                       package = "monaLisa")
res <- parseHomerOutput(infiles = c(bin1 = outfile))
head(res$negLog10P)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_monaLisa.R
\name{calcBinnedMotifEnrR}
\alias{calcBinnedMotifEnrR}
\title{Binned Motif Enrichment Analysis with \code{monaLisa}}
\usage{
calcBinnedMotifEnrR(
  seqs,
  bins = NULL,
  pwmL = NULL,
  background = c("otherBins", "allBins", "zeroBin", "genome"),
  test = c("fisher", "binomial"),
  maxFracN = 0.7,
  maxKmerSize = 3L,
  min.score = 10,
  matchMethod = "matchPWM",
  GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.6, 0.7, 0.8),
  pseudocount.log2enr = 8,
  p.adjust.method = "BH",
  genome = NULL,
  genome.regions = NULL,
  genome.oversample = 2,
  BPPARAM = SerialParam(),
  verbose = FALSE,
  ...
)
}
\arguments{
\item{seqs}{\code{\link[Biostrings]{DNAStringSet}} object with sequences to
test}

\item{bins}{Factor of the same length and order as \code{seqs}, indicating
the bin for each sequence. Typically the return value of
\code{\link[monaLisa]{bin}}. For \code{background = "genome"}, \code{bins}
can be omitted.}

\item{pwmL}{\code{PWMatrixList} with motifs for which to calculate 
enrichments.}

\item{background}{A \code{character} scalar specifying the background
sequences to use. One of \code{"otherBins"} (default), \code{"allBins"},
\code{"zeroBin"} or \code{"genome"} (see "Details").}

\item{test}{A \code{character} scalar specifying the type of enrichment test
to perform. One of \code{"fisher"} (default) or \code{"binomial"}. The
enrichment test is one-sided (enriched in foreground).}

\item{maxFracN}{A numeric scalar with the maximal fraction of N bases allowed
in a sequence (defaults to 0.7). Sequences with higher fractions are
excluded from the analysis.}

\item{maxKmerSize}{The maximum k-mer size to consider, when adjusting
background sequence weights for k-mer composition compared to the
foreground sequences. The default value (3) will correct for mono-, di-
and tri-mer composition.}

\item{min.score}{The minimal score for motif hits, used in
\code{\link[monaLisa]{findMotifHits}}.}

\item{matchMethod}{The method used to scan for motif hits, passed to the
\code{method} parameter in \code{\link[monaLisa]{findMotifHits}}.}

\item{GCbreaks}{The breaks between GC bins. The default value is based on
the hard-coded bins used in Homer.}

\item{pseudocount.log2enr}{A numerical scalar with the pseudocount to add to
foreground and background counts when calculating log2 motif enrichments}

\item{p.adjust.method}{A character scalar selecting the p value adjustment
method (used in \code{\link[stats]{p.adjust}}).}

\item{genome}{A \code{BSgenome} or \code{DNAStringSet} object with the
genome sequence. Only used for \code{background = "genome"} for extracting
background sequences.}

\item{genome.regions}{An optional \code{\link[GenomicRanges]{GRanges}} object
defining the intervals in \code{genome} from which background sequences are
sampled for \code{background = "genome"}. If \code{NULL}, background
sequences are sampled randomly from \code{genome}.}

\item{genome.oversample}{A \code{numeric} scalar of at least 1.0 defining how
many background sequences will be sampled per foreground sequence for
\code{background = "genome"}. Larger values will take longer but improve
the sequence composition similarity between foreground and background
(see \code{"Details"}).}

\item{BPPARAM}{An optional \code{\link[BiocParallel]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation.}

\item{verbose}{A logical scalar. If \code{TRUE}, print progress messages.}

\item{...}{Additional arguments for  \code{\link[monaLisa]{findMotifHits}}.}
}
\value{
A \code{\link[SummarizedExperiment]{SummarizedExperiment}} object
  with motifs in rows and bins in columns, containing seven assays: \describe{
  \item{negLog10P}{: -log10 P values}
  \item{negLog10Padj}{: -log10 adjusted P values}
  \item{pearsonResid}{: motif enrichments as Pearson residuals}
  \item{expForegroundWgtWithHits}{: expected number of foreground
    sequences with motif hits}
  \item{log2enr}{: motif enrichments as log2 ratios}
  \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
    in a bin that have motif hits}
  \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
    in a bin that have motif hits}
}
The \code{rowData} of the object contains annotations (name, PFMs, PWMs
and GC fraction) for the motifs, while the \code{colData} slot contains
summary information about the bins.
}
\description{
This function performs a motif enrichment analysis on bins of
  sequences. For each bin, the sequences in all other bins are used as
  background.
}
\details{
This function implements a binned motif enrichment analysis. In each
  enrichment analysis, the sequences in a specific bin are used as foreground
  sequences to test for motif enrichments comparing to background sequences
  (defined by \code{background}, see below). The logic follows the
  \code{findMotifsGenome.pl} tool from \code{Homer} version 4.11, with
  \code{-size given -nomotif -mknown} and additionally \code{-h} if using
  \code{test = "fisher"}, and gives very similar results. As in the
  \code{Homer} tool, sequences are weighted to correct for GC and k-mer
  composition differences between fore- and background sets.

  The background sequences are defined according to the value of the
  \code{background} argument:
  \describe{
    \item{otherBins}{: sequences from all other bins (excluding the current
      bin)}
    \item{allBins}{: sequences from all bins (including the current bin)}
    \item{zeroBin}{: sequences from the "zero bin", defined by the
      \code{maxAbsX} argument of \code{\link[monaLisa]{bin}}. If \code{bins}
      does not define a "zero bin", for example because it was created by
      \code{bin(..., maxAbsX = NULL)}, selecting this background definition
      will abort with an error.}
    \item{genome}{: sequences randomly sampled from the genome (or the
      intervals defined in \code{genome.regions} if given). For each
      foreground sequence, \code{genome.oversample} background sequences
      of the same size are sampled (on average). From these, one per
      foreground sequence is selected trying to match the G+C composition.
      In order to make the sampling deterministic, a seed number needs to be
      provided to the \code{RNGseed} parameter in
      \code{\link[BiocParallel]{SerialParam}}
      or \code{\link[BiocParallel]{MulticoreParam}} when creating the
      \code{BiocParallelParam} instance in \code{BPPARAM}.}
  }

  Motif hits are predicted using \code{\link[monaLisa]{findMotifHits}} and
  multiple hits per sequence are counted as just one hit (ZOOPS mode). For
  each motif, the weights of sequences that have a hit are summed separately
  for foreground (\code{sumForegroundWgtWithHits}) and background
  (\code{sumBackgroundWgtWithHits}). The total foreground
  (\code{totalWgtForeground}) and background (\code{totalWgtBackground})
  sum of sequence weights is also calculated. If a motif has zero
  \code{sumForegroundWgtWithHits} and \code{sumBackgroundWgtWithHits},
  then any values (p-values and enrichment) that are calculated using
  these two numbers are set to NA.

  Two statistical tests for the calculation of enrichment log p-value are
  available: \code{test = "fisher"} (default) to perform Fisher's exact
  tests, or \code{test = "binomial"} to perform binomial tests
  (default in \code{Homer}), using:
  \describe{
    \item{fisher}{: \code{fisher.test(x = tab, alternative =
      "greater")}, where \code{tab} is the contingency table with the summed
      weights of sequences in foreground or background sets (rows), and with
      or without a hit for a particular motif (columns).}
    \item{binomial}{: \code{pbinom(q = sumForegroundWgtWithHits - 1, size =
      totalWgtForeground,
      prob = sumBackgroundWgtWithHits / totalWgtBackground,
      lower.tail = FALSE, log.p = TRUE)}}
  }
}
\examples{
seqs <- Biostrings::DNAStringSet(c("GTCAGTCGATC", "CAGTCTAGCTG",
                                   "CGATCGTCAGT", "AGCTGCAGTCT"))
bins <- factor(rep(1:2, each = 2))
m <- rbind(A = c(2, 0, 0),
           C = c(1, 1, 0),
           G = c(0, 2, 0),
           T = c(0, 0, 3))
pwms <- TFBSTools::PWMatrixList(
    TFBSTools::PWMatrix(ID = "m1", profileMatrix = m),
    TFBSTools::PWMatrix(ID = "m2", profileMatrix = m[, 3:1])
)
calcBinnedMotifEnrR(seqs = seqs, bins = bins, pwmL = pwms,
                    min.score = 3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binning.R
\name{getSetZeroBin}
\alias{getSetZeroBin}
\alias{getZeroBin}
\alias{setZeroBin}
\title{Get and set the zero bin manually}
\usage{
getZeroBin(bins)

setZeroBin(bins, zeroBin)
}
\arguments{
\item{bins}{Factor, typically the return value of
\code{\link[monaLisa]{bin}}.}

\item{zeroBin}{Numeric or character scalar indicating the level to use as
the zero bin, or NA.}
}
\value{
For \code{getZeroBin}, the index of the level representing the zero bin.
For \code{setZeroBin}, a modified factor with the zero bin set to the
provided value.
}
\description{
Get and set the zero bin manually
}
\examples{
set.seed(1)
x <- rnorm(100)
bins <- bin(x, "equalN", nElements = 10, minAbsX = 0.5)
getZeroBin(bins)
bins <- setZeroBin(bins, 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binning.R
\name{bin}
\alias{bin}
\title{Bin elements of \code{x}.}
\usage{
bin(
  x,
  binmode = c("equalN", "equalWidth", "breaks"),
  nElements = round(length(x)/5),
  nBins = NULL,
  minAbsX = NULL,
  breaks = NULL,
  ...
)
}
\arguments{
\item{x}{A numerical vector with the values used for binning.}

\item{binmode}{The algorithm to be used for binning. Possible values are:
"equalN" (default), "equalWidth" or "breaks" (see Details).}

\item{nElements}{The number of elements per bin (only for
\code{binmode="equalN"}). The width of bins is adjusted accordingly.}

\item{nBins}{The number of bins (only for \code{binmode="equalWidth"}). The
number of elements per bin will be variable.}

\item{minAbsX}{The minimal absolute value in \code{x} for elements to be
binned using the \code{binmode="equalN"} or \code{binmode="equalWidth"}
(ignored for other values of \code{binmode}). Elements with \code{x} values
in \code{[-minAbsX,minAbsX]} will be collected in a single bin.}

\item{breaks}{Numerical vector with bin boundaries (only for
\code{binmode="breaks"}). \code{breaks} has to be ordered and strictly
increasing, and has to be of length (number of bins) + 1.}

\item{...}{Further arguments to be passed to \code{cut(x, breaks,
include.lowest = TRUE, ...)}, such as \code{labels=FALSE}.}
}
\value{
The return value from \code{cut(x, ...)}, typically a factor of the
  same length as \code{x}. Binning mode, bin boundaries and the "neutral" bin
  are available from \code{attr(..., "binmode")}, \code{attr(..., "breaks")}
  and \code{attr(..., "bin0")}. For \code{binmode = "breaks"}, the latter
  will be \code{NA}.
}
\description{
\code{bin} groups elements of \code{x} into bins with either a
  constant number of elements per bin, a constant bin width or according to
  user-provided bin boundaries.
}
\details{
Elements are binned according to the values in \code{x} depending on
  \code{binmode}:
  \describe{
  \item{equalN}{Items are grouped into a variable
  number of bins with \code{nElements} elements each. If \code{minAbsX} is
  not \code{NULL}, elements with \code{x}-values in \code{[-minAbsX,minAbsX]}
  will first be collected in a single bin before binning the remaining
  elements. The boundaries of this single bin may be slightly adjusted in
  order to respect the \code{nElements} elements in the other bins.}
  \item{equalWidth}{Items are group into \code{nBins} bins with a variable
  number of elements each.}
  \item{breaks}{Items are grouped into bins using
  \code{cut(x, breaks, include.lowest = TRUE)}}
  }
}
\examples{
set.seed(1)
x <- rnorm(100)
summary(bin(x, "equalN", nElements=10))
summary(bin(x, "equalN", nElements=10, minAbsX=0.5))
summary(bin(x, "equalWidth", nBins=5))
summary(bin(x, "breaks", breaks=c(-10,-1,0,1,10)))

}
\seealso{
\code{\link{cut}} which is used internally.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/monaLisa-package.R
\docType{package}
\name{monaLisa-package}
\alias{monaLisa-package}
\alias{monaLisa}
\title{monaLisa - MOtif aNAlysis with Lisa.}
\description{
\pkg{monaLisa} is a collection of tools that simplify motif enrichment
analyses in genomic regions of interest.
}
\details{
She makes use of her father Homer (http://homer.ucsd.edu/homer/index.html)
and other algorithms to search for motif hits and look for enriched motifs in
sets of genomic regions, compared to all other regions.

Known motifs can for example be obtained from a collection of transcription
factor binding site specificities, such as \pkg{JASPAR2020}.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/fmicompbio/monaLisa}
  \item \url{https://bioconductor.org/packages/monaLisa/}
  \item \url{https://fmicompbio.github.io/monaLisa/}
  \item Report bugs at \url{https://github.com/fmicompbio/monaLisa/issues}
}

}
\author{
Dania Machlab, Lukas Burger, Charlotte Soneson and Michael Stadler
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.defineBackground}
\alias{.defineBackground}
\title{Define background sequence set for a single motif enrichment
  calculation}
\usage{
.defineBackground(
  sqs,
  bns,
  bg,
  currbn,
  gnm,
  gnm.regions,
  gnm.oversample,
  maxFracN = 0.7,
  GCbreaks = c(0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.6, 0.7, 0.8)
)
}
\arguments{
\item{sqs, bns, bg}{The \code{seqs}, \code{bins} and \code{background}
arguments from \code{calcBinnedMotifEnrR}.}

\item{currbn}{An \code{integer} scalar with the current bin defining the
foreground sequences.}

\item{gnm, gnm.regions, gnm.oversample}{The \code{genome},
\code{genome.regions} and \code{genome.oversample} arguments from
\code{calcBinnedMotifEnrR}.}

\item{maxFracN}{The \code{maxFracN} argument from \code{calcBinnedMotifEnrR}.}

\item{GCbreaks}{The breaks between GC bins. The default value is based on
the hard-coded bins used in Homer.}
}
\value{
A \code{DataFrame} with sequences represented by rows and columns
  \code{seqs}, \code{isForeground}, \code{GCfrac}, \code{GCbin}, \code{GCwgt}
  and \code{seqWgt}. Only the first three are already filled in.
}
\description{
Define the background set for the motif enrichment calculation
  in a single bin, depending on the background mode and given foreground
  sequences.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.iterativeNormForKmers}
\alias{.iterativeNormForKmers}
\title{Adjust for k-mer composition (multiple iterations)}
\usage{
.iterativeNormForKmers(
  df,
  maxKmerSize = 3L,
  minSeqWgt = 0.001,
  maxIter = 160L,
  verbose = FALSE
)
}
\arguments{
\item{df}{A \code{DataFrame} with sequence information as returned by
\code{.calculateGCweight}.}

\item{maxKmerSize}{Integer scalar giving the maximum k-mer size to
consider. The default is set to 3 (like in \code{HOMER}), meaning that
k-mers of size 1, 2 and 3 are considered.}

\item{minSeqWgt}{Numeric scalar greater than zero giving the
minimal weight of a sequence. The default value (0.001) was also used by
\code{HOMER} (HOMER_MINIMUM_SEQ_WEIGHT  constant in Motif2.h).}

\item{maxIter}{An integer scalar giving the maximum number if
times to run \code{.normForKmers}. the default is set to 160 (as in
\code{HOMER}).}

\item{verbose}{A logical scalar. If \code{TRUE}, report on k-mer composition
adjustment.}
}
\value{
A \code{DataFrame} containing: \describe{ \item{sequenceWeights}{: a
  \code{dataframe} containing the sequence GC content, GC bins they were
  assigned to, the weight to correct for GC differences between foreGround
  and background sequences, the weight to adjust for kmer composition, and
  the the error term} \item{sequenceNucleotides}{: a \code{DNAStringSet}
  object containing the raw sequences} }
}
\description{
Here we run `.normForKmers` multiple times to converge to
  the final weights that will be used to correct the background
  sequences for k-mer composition differences compared to the foreground. We
  closely follow \code{HOMER}'s \code{normalizeSequence()} function found in
  \code{Motif2.cpp}. Note that \code{HOMER} runs the
  \code{normalizeSequence()} one last time after going through all iterations
  or reaching a low error, which we do not do here.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotMotifHeatmaps}
\alias{plotMotifHeatmaps}
\title{Heatmap of motif enrichments.}
\usage{
plotMotifHeatmaps(
  x,
  which.plots = c("negLog10P", "pearsonResid", "negLog10Padj", "log2enr"),
  width = 4,
  col.enr = c("#053061", "#2166AC", "#4393C3", "#92C5DE", "#D1E5F0", "#F7F7F7",
    "#FDDBC7", "#F4A582", "#D6604D", "#B2182B", "#67001F"),
  col.sig = c("#F0F0F0", "#D9D9D9", "#BDBDBD", "#969696", "#737373", "#525252",
    "#252525", "#000000"),
  col.gc = c("#F7FCF5", "#E5F5E0", "#C7E9C0", "#A1D99B", "#74C476", "#41AB5D", "#238B45",
    "#006D2C", "#00441B"),
  maxEnr = NULL,
  maxSig = NULL,
  highlight = NULL,
  cluster = FALSE,
  show_dendrogram = FALSE,
  show_motif_GC = FALSE,
  show_seqlogo = FALSE,
  show_bin_legend = FALSE,
  width.seqlogo = 1.5,
  use_raster = FALSE,
  na_col = "white",
  doPlot = TRUE,
  ...
)
}
\arguments{
\item{x}{A \code{\link[SummarizedExperiment]{SummarizedExperiment}} with
numerical matrices (motifs-by-bins) in its \code{assays()}, typically
the return value of \code{\link{calcBinnedMotifEnrR}} or
\code{\link{calcBinnedMotifEnrHomer}}.}

\item{which.plots}{Selects which heatmaps to plot (one or several from
\code{"negLog10P"}, \code{"negLog10Padj"}, \code{"pearsonResid"} and
\code{"log2enr"}).}

\item{width}{The width (in inches) of each individual heatmap, without
legend.}

\item{col.enr}{Colors used for enrichment heatmap ("pearsonResid" and
"log2enr").}

\item{col.sig}{Colors used for significance hetmaps ("negLog10P" and
"negLog10Padj").}

\item{col.gc}{Colors used for motif GC content (for
\code{show_motif_GC = TRUE}).}

\item{maxEnr}{Cap color mapping at enrichment = \code{maxEnr}
(default: 99.5th percentile).}

\item{maxSig}{Cap color mapping at -log10 P value or -log10 FDR =
\code{maxSig} (default: 99.5th percentile).}

\item{highlight}{A logical vector indicating motifs to be highlighted.}

\item{cluster}{If \code{TRUE}, the order of transcription factors will be
determined by hierarchical clustering of the \code{"pearsonResid"}
component. Alternatively, an \code{hclust}-object can be supplied which
will determine the motif ordering.
No reordering is done for \code{cluster = FALSE}.}

\item{show_dendrogram}{If \code{cluster != FALSE}, controls whether to show
a row dendrogram for the clustering of motifs. Ignored for
\code{cluster = FALSE}.}

\item{show_motif_GC}{If \code{TRUE}, show a column with the percent G+C of
the motif as part of the heatmap.}

\item{show_seqlogo}{If \code{TRUE}, show a sequence logo next to each motif
label. This will likely only make sense for a heatmap with a low number
of motifs.}

\item{show_bin_legend}{If \code{TRUE}, show a legend for the bin labels.
If FALSE (default), the bin legend will be hidden.}

\item{width.seqlogo}{The width (in inches) for the longest sequence logo
(shorter logos are drawn to scale).}

\item{use_raster}{\code{TRUE} or \code{FALSE} (default). Passed to
\code{use_raster} of \code{\link[ComplexHeatmap]{Heatmap}}.}

\item{na_col}{"white" (default). Passed to \code{na_col} of
\code{\link[ComplexHeatmap]{Heatmap}}.}

\item{doPlot}{If \code{TRUE} (default), plot the generated heatmap(s)
using \code{Reduce(ComplexHeatmap::add_heatmap, heatmapList)}. If
\code{FALSE}, just return the list of heatmap(s) (\code{heatmapList}) in
example before), allowing to modify them further before plotting.}

\item{...}{Further arguments passed to \code{\link[ComplexHeatmap]{Heatmap}}
when creating the main heatmaps selected by \code{which.plots}. For
example, the following will set the font size of the motif names:
\code{plotMotifHeatmaps(..., row_names_gp = gpar(fontsize = 12))}}
}
\value{
A list of \code{ComplexHeatmap::Heatmap} objects.
}
\description{
Plot motif enrichments (e.g. significance or magnitude) as a
    heatmap.
}
\details{
The heatmaps are created using the \pkg{ComplexHeatmap} package
    and plotted side-by-side.

    Each heatmap will be \code{width} inches wide, so the total plot needs a
    graphics device with a width of at least
    \code{length(which.plots) * width} plus the space used for motif names
    and legend. The height will be auto-adjusted to the graphics device.
}
\examples{
se <- readRDS(system.file("extdata",
                          "results.binned_motif_enrichment_LMRs.rds",
                          package = "monaLisa"))
i <- which(SummarizedExperiment::assay(se, "negLog10Padj")[, 8] > 4)
plotMotifHeatmaps(se[i, ], which.plots = "pearsonResid",
                  width = 2, show_seqlogo = TRUE)

}
\references{
Gu, Z. Complex heatmaps reveal patterns and correlations in
    multidimensional genomic data. Bioinformatics 2016.
}
\seealso{
\code{\link{bin}}, \code{\link[ComplexHeatmap]{Heatmap}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotBinScatter}
\alias{plotBinScatter}
\title{Scatter plot (xy-plot) of binned elements.}
\usage{
plotBinScatter(
  x,
  y,
  b,
  cols = NULL,
  xlab = deparse(substitute(x, env = as.environment(-1))),
  ylab = deparse(substitute(y, env = as.environment(-1))),
  main = "",
  legendPosition = "right",
  legend = NULL,
  legend.cex = NULL,
  ...
)
}
\arguments{
\item{x}{A numerical vector with x values.}

\item{y}{A numerical vector with y values (the values used for binning).}

\item{b}{A factor that groups elements of \code{x,y} into bins (typically
the output of \code{\link{bin}(y)}).}

\item{cols}{\code{NULL} or a color vector defining the colors of points.
If \code{NULL}, the colors will be computed based on \code{b} using
\code{\link{getColsByBin}(b)}).}

\item{xlab}{Label for x-axis.}

\item{ylab}{Label for y-axis.}

\item{main}{Main title.}

\item{legendPosition}{A \code{character} scalar.
If not \code{"none"}, draw a legend with binning information. The value
is used to control the legend position and will be passed to
\code{theme(legend.position = legendPosition)}.}

\item{legend}{Deprecated (ignored). Please use \code{legendPosition} to
control the drawing and position of the legend.}

\item{legend.cex}{Deprecated (ignored). You can use
\code{\link[ggplot2]{theme}} to set legend and other graphical
parameters.}

\item{...}{Further arguments passed to \code{\link{getColsByBin}} (only used
if \code{cols} is \code{NULL}).}
}
\value{
The generated scatter plot as a \code{ggplot} object.
}
\description{
Plot a scatter (xy-plot) of binned elements with binning
    information.
}
\examples{
set.seed(1)
x <- rnorm(100)
y <- rnorm(100)
b <- bin(y, "equalN", nElements = 10)
plotBinScatter(x, y, b)

}
\seealso{
\code{\link{bin}}, \code{\link{getColsByBin}},
    \code{\link[ggplot2]{geom_point}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_monaLisa.R
\name{.calcMotifEnrichment}
\alias{.calcMotifEnrichment}
\title{Calculate motif enrichment}
\usage{
.calcMotifEnrichment(
  motifHitMatrix,
  df,
  test = c("fisher", "binomial"),
  verbose = FALSE
)
}
\arguments{
\item{motifHitMatrix}{Matrix with 0 and 1 entries for absence or presence of
motif hits in each sequence.}

\item{df}{A \code{DataFrame} with sequence information as returned by
\code{.iterativeNormForKmers()}.}

\item{test}{Type of motif enrichment test to perform.}

\item{verbose}{A logical scalar. If \code{TRUE}, report on progress.}
}
\value{
A \code{data.frame} containing the motifs as rows and the columns:
  \describe{
    \item{motifName}{: the motif name}
    \item{logP}{: the log p-value for enrichment (natural logarithm).
       If \code{test="binomial"} (default), this log p-value is identical to
       the one returned by Homer.}
    \item{sumForegroundWgtWithHits}{: the sum of the weights of the
       foreground sequences that have at least one instance of a specific
       motif (ZOOPS mode).}
    \item{sumBackgroundWgtWithHits}{: the sum of the weights of the
       background sequences that have at least one instance of a specific
       motif (ZOOPS mode).}
    \item{totalWgtForeground}{: the total sum of weights of foreground
       sequences.}
    \item{totalWgtBackground}{: the total sum of weights of background
       sequences.}
  }
}
\description{
Given motif counts, foreground/background labels and
  weights for a set of sequences, calculate the enrichment of each motif
  in foreground compared to background. This function is called by
  \code{calcBinnedMotifEnrR()} for each bin.

  The default type of test is \code{"fisher"}, which is also what
  \code{Homer} uses if "-h" is specified for a hypergeometric test.
  Alternatively, a binomial test can be used by \code{test = "binomial"}
  (what \code{Homer} does by default). Using Fisher's exact test has
  the advantage that special cases such as zero background counts are
  handled without ad-hoc adjustments to the frequencies.

  For \code{test = "fisher"}, \code{fisher.test} is used with
  \code{alternative = "greater"}, making it a one-sided test for enrichment,
  as is the case with the binomial test.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{prepareHomer}
\alias{prepareHomer}
\title{Prepare input files for HOMER motif enrichment analysis.}
\usage{
prepareHomer(
  gr,
  b,
  genomedir,
  outdir,
  motifFile,
  homerfile = findHomer(),
  regionsize = "given",
  Ncpu = 2L,
  verbose = FALSE
)
}
\arguments{
\item{gr}{A \code{GRanges} object (or an object that can be coerced to one)
with the genomic regions to analyze.}

\item{b}{A vector of the same length as \code{gr} that groups its elements
into bins (typically a factor).}

\item{genomedir}{Directory containing sequence files in Fasta format (one
per chromosome).}

\item{outdir}{A path specifying the folder into which the output files (two
files per unique value of \code{b}) will be written.}

\item{motifFile}{A file with HOMER formatted PWMs to be used in the
enrichment analysis.}

\item{homerfile}{Path and file name of the \code{findMotifsGenome.pl} HOMER
script.}

\item{regionsize}{The peak size to use in HOMER (\code{"given"} keeps the
coordinate region, an integer value will keep only that many bases in
the region center).}

\item{Ncpu}{Number of parallel threads that HOMER can use.}

\item{verbose}{A logical scalar. If \code{TRUE}, print progress messages.}
}
\value{
The path and name of the script file to run the HOMER motif
    enrichment analysis.
}
\description{
For each bin, write genomic coordinates for foreground and
    background regions into files for HOMER motif enrichment analysis.
}
\details{
For each bin (unique value of \code{b}) this functions creates two
    files in \code{outdir} (\code{outdir/bin_N_foreground.tab} and
    \code{outdir/bin_N_background.tab}, where \code{N} is the number of the
    bin and foreground/background correspond to the ranges that are/are not
    within the current bin). The files are in the HOMER peak file format
    (see http://homer.ucsd.edu/homer/ngs/peakMotifs.html for details).

    In addition, a shell script file is created containing the shell commands
    to run the HOMER motif enrichment analysis.
}
\examples{
# prepare genome directory (here: one dummy chromosome)
genomedir <- tempfile()
dir.create(genomedir)
writeLines(c(">chr1", "ATGCATGCATCGATCGATCGATCGTACGTA"),
           file.path(genomedir, "chr1.fa"))

# prepare motif file, regions and bins
motiffile <- tempfile()
dumpJaspar(filename = motiffile, pkg = "JASPAR2020",
           opts = list(ID = c("MA0006.1")))
gr <- GenomicRanges::GRanges("chr1", IRanges::IRanges(1:4, width = 4))
b <- bin(1:4, nElements = 2)

# create dummy file (should point to local Homer installation)
homerfile <- file.path(tempdir(), "findMotifsGenome.pl")
writeLines("dummy", homerfile)

# run prepareHomer
outdir <- tempfile()
prepareHomer(gr = gr, b = b, genomedir = genomedir,
             outdir = outdir, motifFile = motiffile,
             homerfile = homerfile, verbose = TRUE)
list.files(outdir)

# clean up example
unlink(c(genomedir, motiffile, homerfile, outdir))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_enrichment.R
\name{.normForKmers}
\alias{.normForKmers}
\title{Adjust for k-mer composition (single iteration)}
\usage{
.normForKmers(
  kmerFreq,
  goodKmers,
  kmerRC,
  seqWgt,
  isForeground,
  minSeqWgt = 0.001,
  maxSeqWgt = 1000
)
}
\arguments{
\item{kmerFreq}{A \code{list} with of matrices. The matrix at index \code{i}
in the list contains the probability of k-mers of length \code{i}, for each
k-mer (columns) and sequence (rows).}

\item{goodKmers}{A \code{list} of \code{numeric} vectors; the element at
index \code{i} contains the number of good (non-N-containing) k-mers of
length \code{i} for each sequence.}

\item{kmerRC}{A \code{list} of character vectors; the element at index
\code{i} contains the reverse complement sequences of all k-mers of length
\code{i}.}

\item{seqWgt}{A \code{numeric} vector with starting sequence weights
at the beginning of the iteration.}

\item{isForeground}{Logical vector of the same length as \code{seqs}.
\code{TRUE} indicates that the sequence is from the foreground,
\code{FALSE} that it is a background sequence.}

\item{minSeqWgt}{Numeric scalar greater than zero giving the
minimal weight of a sequence. The default value (0.001) is based on
\code{Homer} (HOMER_MINIMUM_SEQ_WEIGHT constant in Motif2.h).}

\item{maxSeqWgt}{Numeric scalar greater than zero giving the
maximal weight of a sequence. The default value (1000) is based on
\code{HOMER} (1 / HOMER_MINIMUM_SEQ_WEIGHT constant in Motif2.h).}
}
\value{
A named \code{list} with elements \code{seqWgt} (updated
  weights) and \code{err} (error measuring difference of foreground
  and weighted background sequence compositions).
}
\description{
Adjust background sequence weights for differences in k-mer
  composition compared to the foreground sequences. This function
  implements a single iteration, and is called iteratively by
  \code{.iterativeNormForKmers} to get to the final set of adjusted
  weights, which will be the result of adjusting for GC and k-mer
  composition. The logic is based on Homer's
  \code{normalizeSequenceIteration()} function found in \code{Motif2.cpp}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_HOMER.R
\name{calcBinnedMotifEnrHomer}
\alias{calcBinnedMotifEnrHomer}
\title{Prepare and run HOMER motif enrichment analysis.}
\usage{
calcBinnedMotifEnrHomer(
  gr,
  b,
  genomedir,
  outdir,
  motifFile,
  homerfile = findHomer(),
  regionsize = "given",
  pseudocount.log2enr = 8,
  p.adjust.method = "BH",
  Ncpu = 2L,
  verbose = FALSE,
  verbose.Homer = FALSE
)
}
\arguments{
\item{gr}{A \code{GRanges} object (or an object that can be coerced to one)
with the genomic regions to analyze.}

\item{b}{A vector of the same length as \code{gr} that groups its elements
into bins (typically a factor, such as the one returned by
\code{\link{bin}}).}

\item{genomedir}{Directory containing sequence files in Fasta format
(one per chromosome).}

\item{outdir}{A path specifying the folder into which the output files will
be written.}

\item{motifFile}{A file with HOMER formatted PWMs to be used in the
enrichment analysis.}

\item{homerfile}{Path and file name of the \code{findMotifsGenome.pl}
HOMER script.}

\item{regionsize}{The peak size to use in HOMER (\code{"given"} keeps the
coordinate region, an integer value will keep only that many bases in
the region center).}

\item{pseudocount.log2enr}{A numerical scalar with the pseudocount to add to
foreground and background counts when calculating log2 motif enrichments}

\item{p.adjust.method}{A character scalar selecting the p value adjustment
method (used in \code{\link[stats]{p.adjust}}).}

\item{Ncpu}{Number of parallel threads that HOMER can use.}

\item{verbose}{A logical scalar. If \code{TRUE}, print progress messages.}

\item{verbose.Homer}{A logical scalar. If \code{TRUE}, print the console
output when running Homer.}
}
\value{
A \code{SummarizedExperiment} object with motifs in rows and bins
  in columns, containing seven assays: \describe{
  \item{negLog10P}{: -log10 P values}
  \item{negLog10Padj}{: -log10 adjusted P values}
  \item{pearsonResid}{: motif enrichments as Pearson residuals}
  \item{expForegroundWgtWithHits}{: expected number of foreground
    sequences with motif hits}
  \item{log2enr}{: motif enrichments as log2 ratios}
  \item{sumForegroundWgtWithHits}{: Sum of foreground sequence weights
    in a bin that have motif hits}
  \item{sumBackgroundWgtWithHits}{: Sum of background sequence weights
    in a bin that have motif hits}
}
The \code{rowData} of the object contains annotations (name, PFMs, PWMs
and GC fraction) for the motifs, while the \code{colData} slot contains
summary information about the bins.
}
\description{
Run complete HOMER motif enrichment analysis, consisting of
    calls to \code{\link{prepareHomer}}, \code{\link[base]{system2}} and
    \code{\link{parseHomerOutput}}. This function requires \code{HOMER}
    to be installed (see \url{http://homer.ucsd.edu/homer/index.html})
    and the path to the tool to be provided (\code{homerfile} argument).
}
\examples{
if (!is.na(findHomer())){

  # genome
  genome <-  system.file("extdata", "exampleGenome.fa", package = "monaLisa")

  # create motif file for Homer
  motiffile <- tempfile()
  motifIDs <- c("MA0139.1", "MA1102.1", "MA0740.1")
  dumpJaspar(filename = motiffile, pkg = "JASPAR2020",
             opts = list(ID = motifIDs))

  # GRanges of regions used in binned motif enrichment analysis
  gr <- GenomicRanges::tileGenome(
      seqlengths = c(chr1 = 10000L, chr2 = 10000L, chr3 = 10000L),
      tilewidth = 200, cut.last.tile.in.chrom = TRUE)

  # create bins (motif enrichment analysis will be per bin)
  bins <- factor(GenomicRanges::seqnames(gr))
  table(bins)

  # run calcBinnedMotifEnrHomer
  outdir <- tempfile()
  se <- calcBinnedMotifEnrHomer(gr = gr, b = bins, genomedir = genome,
      outdir = outdir, motifFile = motiffile)
  list.files(outdir)

  }

}
\seealso{
The functions that are wrapped: \code{\link{prepareHomer}},
    \code{\link[base]{system2}} and \code{\link{parseHomerOutput}},
    \code{\link{bin}} for binning of regions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_kmers.R
\name{.cons2matrix}
\alias{.cons2matrix}
\title{Create matrix from consensus sequence}
\usage{
.cons2matrix(x, n = 100L)
}
\arguments{
\item{x}{Character scalar with the motif the consensus sequence.}

\item{n}{Integer scalar giving the columns sums in the constructed
matrix (number of observed bases at each position).}
}
\value{
A positional frequency matrix.
}
\description{
Given a nucleotide sequence of A,C,G,T letter corresponding
  to a motif's consensus string, construct a positional frequency matrix.
  This matrix can for example be used as the \code{profileMatrix} argument
  in the constructor for a \code{TFBSTools::PFMatrix} object.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqlogo.R
\name{seqLogoGrob}
\alias{seqLogoGrob}
\title{Create a simple sequence logo grob.}
\usage{
seqLogoGrob(x, xmax = NULL, ymax = 2, xjust = c("left", "center", "right"))
}
\arguments{
\item{x}{A \code{\link[TFBSTools]{PFMatrix}} object}

\item{xmax}{A numeric scalar with the maximal width for the logo 
(in base-pairs). A value of \code{NULL} will scale the logo to the 
full width of the viewport.}

\item{ymax}{A numeric scalar with the maximal height for the logo (in bits)
A value of \code{NULL} will scale the logo to the full height of the
viewport.}

\item{xjust}{A character scalar specifying the horizontal adjustment of the
sequence log withint the viewport; one of \code{"left"}, \code{"center"} 
or \code{"right"}.}
}
\value{
A polygon grob.
}
\description{
Create a simple sequence logo grob (grid-graphics object) for a
    transcription factor from a position frequency matrix. The logo drawing
    code is a simplified version from \code{\link[seqLogo]{seqLogo}} and for
    example can be used to embedd sequence logos within other plots.
}
\examples{
if (require(JASPAR2020) && require(TFBSTools) && require(gridExtra)) {
    pfm1 <- getMatrixByID(JASPAR2020, "MA0139")
    pfm2 <- getMatrixByID(JASPAR2020, "MA0531")

    g1 <- seqLogoGrob(pfm1)
    g2 <- seqLogoGrob(pfm2)

    gridExtra::grid.arrange(g1, g2)
}

}
\seealso{
\code{\link[seqLogo]{seqLogo}} for the original, more flexible 
    version of this function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotStabilityPaths}
\alias{plotStabilityPaths}
\title{Plot Stability Paths}
\usage{
plotStabilityPaths(
  se,
  selProbMin = metadata(se)$stabsel.params.cutoff,
  selColor = "cadetblue",
  notSelColor = "grey",
  selProbCutoffColor = "firebrick",
  linewidth = 0.5,
  alpha = 1,
  ylim = c(0, 1),
  labelPaths = FALSE,
  labels = NULL,
  labelNudgeX = 8,
  labelSize = 3
)
}
\arguments{
\item{se}{The \code{SummarizedExperiment} object resulting from stability
selection, by running \code{\link[monaLisa]{randLassoStabSel}}.}

\item{selProbMin}{A numerical scalar in [0,1]. Predictors with a selection
probability greater than \code{selProbMin} are shown as colored lines. The
color is defined by the \code{col} argument.}

\item{selColor}{Color for the selected predictors which have a selection
probability greater than \code{selProbMin}.}

\item{notSelColor}{Color for the rest of the (un-selected) predictors.}

\item{selProbCutoffColor}{Color for the line depicting the selection
probability cutoff.}

\item{linewidth}{Line width.}

\item{alpha}{Line transparency of the stability paths.}

\item{ylim}{Limits for y-axis.}

\item{labelPaths}{If \code{TRUE}, the predictor labels will be shown at the
end of the stability paths. The predictor labels given in \code{labels}
will be shown. If unspecified, the labels corresponding to the selected
predictors will be added. If predictors have the same y-value in the last
regularization step, the labels will be shown in a random order. One
needs to use \code{set.seed} to reproduce the plot in this case.}

\item{labels}{If \code{labelPaths = TRUE}, the predictors which should be
labelled. If \code{NULL}, the selected predictors greater than
\code{metadata(se)$stabsel.params.cutoff} will be shown.}

\item{labelNudgeX}{If \code{labelPaths = TRUE}, how much to nudge the labels
to the right of the x-axis.}

\item{labelSize}{If \code{labelPaths = TRUE}, the size of the labels.}
}
\value{
a \code{ggplot2} object.
}
\description{
Plot the stability paths of each variable (predictor),
  showing the selection probability as a function of the regularization step.
}
\examples{
## create data set
Y <- rnorm(n = 500, mean = 2, sd = 1)
X <- matrix(data = NA, nrow = length(Y), ncol = 50)
for (i in seq_len(ncol(X))) {
  X[ ,i] <- runif(n = 500, min = 0, max = 3)
}
s_cols <- sample(x = seq_len(ncol(X)), size = 10,
  replace = FALSE)
for (i in seq_along(s_cols)) {
  X[ ,s_cols[i]] <- X[ ,s_cols[i]] + Y
}

## reproducible randLassoStabSel() with 1 core
set.seed(123)
ss <- randLassoStabSel(x = X, y = Y)
plotStabilityPaths(ss)

}
\seealso{
\code{\link[stabs]{stabsel}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motif_enrichment_kmers.R
\name{getKmerFreq}
\alias{getKmerFreq}
\title{Calculate observed and expected k-mer frequencies}
\usage{
getKmerFreq(
  seqs,
  kmerLen = 5,
  MMorder = 1,
  pseudocount = 1,
  zoops = TRUE,
  strata = rep(1L, length(seqs)),
  p.adjust.method = "BH",
  includeRevComp = TRUE
)
}
\arguments{
\item{seqs}{Set of sequences, either a \code{character} vector or a
\code{\link[Biostrings]{DNAStringSet}}.}

\item{kmerLen}{A \code{numeric} scalar giving the k-mer length.}

\item{MMorder}{A \code{numeric} scalar giving the order of the Markov model
used to calculate the expected frequencies.}

\item{pseudocount}{A \code{numeric} scalar - will be added to the observed
counts for each k-mer to avoid zero values.}

\item{zoops}{A \code{logical} scalar. If \code{TRUE} (the default), only one
or zero occurences of a k-mer are considered per sequence.}

\item{strata}{A \code{factor} or a \code{numeric} scalar defining the strata
of sequences. A separate Markov model and expected k-mer frequencies are
estimated for the set of sequences in each stratum (level in a
\code{strata} factor). If \code{strata} is a scalar value, it will be
interpreted as the number of strata to split the sequences into according
to their CpG observed-over-expected counts using
\code{kmeans(CpGoe, centers = strata)}.}

\item{p.adjust.method}{A character scalar selecting the p value adjustment
method (used in \code{\link[stats]{p.adjust}}).}

\item{includeRevComp}{A \code{logical} scalar. If \code{TRUE} (default),
count k-mer occurrences in both \code{seqs} and their reverse-complement,
by concatenating \code{seqs} and their reverse-complemented versions
before the counting. This is useful if motifs can be expected to occur
on any strand (e.g. DNA sequences of ChIP-seq peaks). If motifs are only
expected on the forward strand (e.g. RNA sequences of CLIP-seq peaks),
\code{includeRevComp = FALSE} should be used. Note that if \code{strata}
is a vector of the same length as \code{seqs}, each reverse-complemented
sequence will be assigned to the same stratum as the forward sequence.}
}
\value{
A \code{list} with observed and expected k-mer frequencies
  (\code{freq.obs} and \code{freq.exp}, respectively), and enrichment
  statistics for each k-mer.
}
\description{
Given a set of sequences, calculate observed and expected k-mer
  frequencies. Expected frequencies are based on a Markov model of order
  \code{MMorder}.
}
\examples{
res <- getKmerFreq(seqs = c("AAAAATT", "AAATTTT"), kmerLen = 3)
names(res)
head(res$freq.obs)
head(res$freq.exp)

}
